//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Bot.h
//	
//	[MEAN] Interface Wrapper for the Bots.
//
//.e	

//.b skip over if header has already been included.
#ifndef defMA_Bot_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
	#define defMA_Bot_h

	// Include all general definition files.
	#include "MB_Includes.h"
	#include "MA_Player.h"
	#include "MA_Sched.h"

	const int cinBotTeam_DEFAULT = cinTeam_Unknown;
	const int cinNumBots_DEFAULT = 4;
	const int cinNumBots_MAX = 10;
	const int cinNumBots_MIN = 4;
	const float cflBotHumanRatio = 1.75;

	// Fill server to min bots if there is only one humna player
	// on the server. When 2 or more connect, kick all bots off
	// for human vs human play.
	const int cinBotMode_NoBots				= 0; // no bots
	const int cinBotMode_BotsWhenXPlayers	= 1; // bots only when X players or less are in game.
	const int cinBotMode_BotsvsHumans		= 2; // bots vs humans
	const int cinBotMode_BotsFillServer		= 3; // bots keep server filled to a specific player count.
	const int cinBotMode_BotvsBot				= 4; // bots vs bots

//.!! The BotMode system does not work properly and needs to
//.!! be redone.

	// default probability of bot team switching after a map change.
	const	float cflSwitchProb_DEFAULT = .20; // x 100 = 20%
	const bool cboRandomBotTeamSwitch_DEFAULT = true;
	const bool cboRandomBotSkillSwitch_DEFAULT = true;
	const bool cboEnforceBotTeam_DEFAULT = false;

	const int cinBot_Unknown	=	0;
	const int cinBot_BOTT		=	1;
	const int cinBot_PLB			=	2;
	const int cinBot_JOE			=	3;
	const int cinBot_POD			=	4;
	const int cinBot_REAL		=	5;
	const int cinBot_REAL_AI   =	6;
	const int cinBot_BOC			=	7;
	const int cinBot_NN			=	8;
	const int cinBot_CB			=	9;
	const int cinBot_RACC		= 10;
	const int cinBot_WBOT		= 11;
	const int cinBot_AKIMBOT	= 12;
	const int cinBot_POX			= 13;
	const int cinBot_EPOD		= 14;
	const int cinBot_MEAN		= 15;
	const int cinBot_REAL_MM   = 16;
	const int cinBot_PODMM		= 17;
	const int cinBot_PLPODmix	= 100;
	const int cinBot_CBPODmix	= 101;
	const int cinBot_PLJOEmix	= 102;
	const int cinBot_CBJOEmix	= 102;
	const int cinBot_PLCBmix	= 104;

	const string ctxBotName_Unknown	= "unknown";
	const string ctxBotName_PLB		= "plbot";
	const string ctxBotName_JOE		= "joebot";
	const string ctxBotName_POD		= "podbot";
	const string ctxBotName_PODMM		= "podbot_mm";
	const string ctxBotName_REAL		= "realbot";
	const string ctxBotName_RBAI		= "realbot_ai"; 
	const string ctxBotName_RBMM		= "realbot_mm"; 
	const string ctxBotName_BOC		= "bocbot";
	const string ctxBotName_NN			= "nnbot";
	const string ctxBotName_CB       = "cbbot";
	const string ctxBotName_RACC     = "raccbot";
	const string ctxBotName_WBOT		= "wbot";
	const string ctxBotName_AKIMBOT	= "akimbot";
	const string ctxBotName_POX		= "poxbot";
	const string ctxBotName_EPOD		= "epodbot";
	const string ctxBotName_MEAN		= "meanbot";
	const string ctxBotName_PLPODmix = "plpodmix";
	const string ctxBotName_CBPODmix = "cbpodmix";
	const string ctxBotName_PLJOEmix = "pljoemix";
	const string ctxBotName_CBJOEmix = "cbjoemix";
	const string ctxBotName_PLCBmix  = "plcbmix";
	

// WARNING: Changing these values may impact routines
// that set the bot skill randomly.
	
	const int cinSkillHighest = -7;
	const int cinSkillInsane  = -6;
	const int cinSkillRand    = -5;
	const int cinSkillNotSet  = -4;
	const int cinSkillLow	  = -3;
	const int cinSkillMed	  = -2;
	const int cinSkillHigh	  = -1;
	const int cinSkillLowest  =  0;

	const int cinSkillRange_Low_Min =  1;
	const int cinSkillRange_Low_Max = 33;

	const int cinSkillRange_Med_Min = cinSkillRange_Low_Max + 1;
	const int cinSkillRange_Med_Max = 66;

	const int cinSkillRange_High_Min = cinSkillRange_Med_Max + 1;
	const int cinSkillRange_High_Max = 100;

	const int cinSkillMin	 = cinSkillHighest;
	const int cinSkillMax	 = cinSkillRange_High_Max;

	const int cinSkill_Fixed_DEFAULT = cinSkillHighest;
	const int cinSkill_variable_MinDEFAULT = cinSkillRange_High_Max;
	const int cinSkill_variable_MaxDEFAULT = cinSkillRange_High_Max;

	const string ctxSkillLow		= "low";
	const string ctxSkillLowest	= "lowest";
	const string ctxSkillMed		= "medium";
	const string ctxSkillHigh		= "high";
	const string ctxSkillHighest	= "highest";
	const string ctxSkillInsane	= "insane";
	const string ctxSkillRand		= "random";
	const string ctxSkillNotSet	= "default";
	const string ctxSkillInvalid	= "invalid";

	class tclBot 
	{
		private:
			bool  vboAutoKillAllBots;
			bool	vboBotsInGame;
			bool	vboBombWasPlanted;
			bool	vboHostagesAreBeingRescued;

		public:

			int	vinBotSkill_Variable_Min;
			int	vinBotSkill_Variable_Max;
			int	vinBotSkill_Fixed;
			bool	fboBotsInGame( ){ return vboBotsInGame; };
			void	fvoSetBotsInGame( bool pboBotsInGame ){ vboBotsInGame = pboBotsInGame; };
			int	vinBotMode;
			bool	vboBalanceBots;

			bool  vboEnforceBotTeam;
			int	vinCurrentBotTeam;

			bool	vboRandomBotTeamSwitch;
			bool	vboRandomBotSkillSwitch;
			float vflProbOfBotSkillSwitch;
			float vflProbOfBotTeamSwitch;
			int	vinMinBots;
			int	vinMaxBots;
			int	vinBotsWhenMinPlayers;
			float vflBotHumanRatio;
			int	vinBotSystem;
			string vtxBotSystem;
			bool vboStatsProtection;
			bool vboPODBotFixProtection;
			bool vboBotHitEffectIsOn;
			bool vboBotHitSoundsIsOn;
			bool vboBotHitSparksIsOn;
			bool vboKickDupoBotsIsOn;

			tclBot ( void );
			
			bool	fboAssignBotSystem			( string ptxBotName );
			string ftxGetBotSystem				( );
			int    finGetBotSystem				( );
			int	finGetBotMode					( void );
			void	fvoSetBotMode					( int pinBotMode );
			int	finGetHumanTeam				( void );
			int	finGetBotTeam					( void );
			bool	fboAddBot						( int pinTeam );
			int	finAddBots						( int pinTeam, int pinNum );
			int	finAddBots						( int pinNum );
			int	finKillAllBots					( int pinTeam = cinTeam_Any, bool pboSuicide = true );
			int	finKickAllBots					( void );
			int	finKickSpectatorBots			( void );
			int	finKickAllBotsOffTeam		( int pinBotTeam );
			int	finKickAllAliveBotsOffTeam ( int pinBotTeam );
			int	finKickBotsByLivingStatus	( int pinTeam, int pinNum, bool pboAlive );
			int	finKickDeadBots				( int pinTeam, int pinNum );
			int	finKickAliveBots				( int pinTeam, int pinNum );
			int	finKickBots						( int vinTeam, int pinNum );
			bool	fboKickBot						( int vinTeam );
			bool	vboSkillChangeSupported    ( );
			bool	vboBotSkillIsValid_Range	( int pinSkill );
			bool	vboBotSkillIsValid_Fixed	( int pinSkill );
			bool	vboBotSkillIsValid_Variable( int pinSkill_Fixed, int pinSkill_Variable_Min, int pinSkill_Variable_Max );
			bool	fboSetBotSkill					( int pinSkill );
//			int	finGetBotSkill_Variable		( void ){ return vinBotSkill_Variable; };
			int	finGetBotSkill_Fixed			( void ){ return vinBotSkill_Fixed; };
			string ftxGetActualBotSkill		( );
			string ftxGetActualBotSkill		( int pinBotSystem );
			string ftxGetBotSkill				( );
			void	fvoBalanceBots					( void );
			void	fvoFillServerWithBots		( void );
			bool  fboSwitchBotTeam				( void );
			bool  fboSwitchBotTeamRandomly	( );
			bool  fboSwitchBotSkillRandomly	( );
			bool  fboSetBotTeam	   			( int pinNewTeam );
			void  fvoKillAllHumansOnBotTeam  ( string ptxReason );
			void  fvoSwitchAllHumansOnBotTeam( string ptxReason );
			void  fvoEnforceBotTeam				( void );
			bool  fboEmitSoundFromBot			( int pinPlayerIndex, string ptxSoundFile );
			bool	fboEmitSoundFromABot			( string ptxSoundFile );
			bool	fboBotYell						( void );
			bool	fboBotSpeak						( void ); 
			bool	fboStatsProtectionIsOn		( void ) { return vboStatsProtection; };
			void	fvoSetStatsProtection		( bool pboSwitch ) { vboStatsProtection = pboSwitch; };
			bool	fboPODBotFixProtectionIsOn ( void ) { return vboPODBotFixProtection; };
			bool	fboBotHitEffectIsOn			( void ) { return vboBotHitEffectIsOn; };
			bool	fboBotHitSoundsIsOn			( void ) { return vboBotHitEffectIsOn && vboBotHitSoundsIsOn; };
			bool	fboBotHitSparksIsOn			( void ) { return vboBotHitEffectIsOn && vboBotHitSparksIsOn; };
			void	fvoSetPODBotFixProtection	( bool pboSwitch ) { vboPODBotFixProtection = pboSwitch; };
			void	fvoCheckStatsProtection		( void );
			void	fvoCheckPODBotFixProtection( void );
			bool	fboPODBotIsLoaded				( );
			bool  fboKickDupBotsIsOn			( void ) { return vboKickDupoBotsIsOn; };
			void  fvoSetKickDupBots( bool pboSwitch ) { vboKickDupoBotsIsOn = pboSwitch; };
			int	finRemoveDupNamedBots( );

			bool fboAutoKillAllBotsIsOn( ){ return vboAutoKillAllBots; };
			void fvoSetAutoKillAllBots( bool pboSwitch ){ vboAutoKillAllBots = pboSwitch; };

			void fvoBombWasPlanted( bool pboBombWasPlanted ) { vboBombWasPlanted = pboBombWasPlanted; };
			void fvoHostagesAreBeingRescued( bool pboHostagesAreBeingRescued ) { vboHostagesAreBeingRescued = pboHostagesAreBeingRescued; };
			bool fboBombWasPlanted( ) { return vboBombWasPlanted; };
			bool fboHostagesAreBeingRescued( ) { return vboHostagesAreBeingRescued; };

	}; // tclBot

// Make globally available the instance of the bot wrapper object.
	extern tclBot vclBot; 

// Event Functions
	 void fvoMA_BOT_Event_fvoDisplayBotTeam( tclArgList& pclArgList );
	 void fvoMA_BOT_Event_fvoRandomBotSpeak( tclArgList& pclArgList );
	 void fvoMA_BOT_Event_fvoCheckStatsProtection( tclArgList& pclArgList );
	 void fvoMA_BOT_Event_fvoCheckPODBotFixProtection( tclArgList& pclArgList );
	 void fvoMA_BOT_Event_fvoKickDupBots( tclArgList& pclArgList );
	 void fvoMA_Bot_Event_AutoKillBots_Start(  );
#endif //e. defMA_Bot_h

