//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Control.cpp
//	
//	[MEAN] Alternate control for bots
//
//.e	

#include "MB_Includes.h"	
#include "MG_Lib.h"
#include "MA_EngDLLCmd.h"
#include "MA_GlobalVars.h"
#include "MA_BotControl.h"
#include "MA_Bot.h"


#define FOV_NORMAL 90
#define FOV_ZOOMED 55
#define FOV_SCOPED_SHORT 40
#define FOV_SCOPED_FAR 15 // AWP is the exception, it can scope down to 10 degrees

// player model bone numbers for Counter-Strike 
#define PLAYERBONE_PELVIS 1 
#define PLAYERBONE_SPINE 2 
#define PLAYERBONE_SPINE1 3 
#define PLAYERBONE_SPINE2 4 
#define PLAYERBONE_SPINE3 5 
#define PLAYERBONE_NECK 6 
#define PLAYERBONE_HEAD 7 
#define PLAYERBONE_L_CLAVICLE 9 
#define PLAYERBONE_L_UPPERARM 10 
#define PLAYERBONE_L_FOREARM 11 
#define PLAYERBONE_L_HAND 12 
#define PLAYERBONE_L_FINGER0 13 
#define PLAYERBONE_L_FINGER01 14 
#define PLAYERBONE_L_FINGER1 15 
#define PLAYERBONE_L_FINGER11 16 
#define PLAYERBONE_L_THIGH 40 
#define PLAYERBONE_L_CALF 41 
#define PLAYERBONE_L_FOOT 42 
#define PLAYERBONE_R_CLAVICLE 23 
#define PLAYERBONE_R_UPPERARM 24 
#define PLAYERBONE_R_FOREARM 25 
#define PLAYERBONE_R_HAND 26 
#define PLAYERBONE_R_FINGER0 27 
#define PLAYERBONE_R_FINGER01 28 
#define PLAYERBONE_R_FINGER1 29 
#define PLAYERBONE_R_FINGER11 30 
#define PLAYERBONE_R_THIGH 46 
#define PLAYERBONE_R_CALF 47 
#define PLAYERBONE_R_FOOT 48 

const unsigned short cinBtnAttack1		= (1 << 0);
const unsigned short cinBtnJump			= (1 << 1);
const unsigned short cinBtnDuck			= (1 << 2);
const unsigned short cinBtnForward		= (1 << 3);
const unsigned short cinBtnBack			= (1 << 4);
const unsigned short cinBtnUse			= (1 << 5);
const unsigned short cinBtnCancel		= (1 << 6);
const unsigned short cinBtnLeft			= (1 << 7);
const unsigned short cinBtnRight			= (1 << 8);
const unsigned short cinBtnMoveLeft		= (1 << 9);
const unsigned short cinBtnMoveRight	= (1 << 10);
const unsigned short cinBtnAttack2		= (1 << 11);
const unsigned short cinBtnRun			= (1 << 12);
const unsigned short cinBtnReload		= (1 << 13);
const unsigned short cinBtnAlt1			= (1 << 14);
const unsigned short cinBtnScore			= (1 << 15);



//.!! Should be moved elsewhere
cvar_t vstAutoBalanceDisply = { const_cast< char* >( ctxCVAR_AutoBalanceDisply.c_str( ) )	, "on", FCVAR_EXTDLL };
cvar_t vstBotDamageAffects	= { const_cast< char* >( ctxCVar_BotDamageAffects.c_str( ) ), "off", FCVAR_EXTDLL };
cvar_t vstBotsThrowSparks	= { const_cast< char* >( ctxCVar_BotsThrowSparks.c_str( ) ), "on", FCVAR_EXTDLL };
cvar_t vstBotsMakeDamageSounds	= { const_cast< char* >( ctxCVar_BotsMakeDamageSounds.c_str( ) ), "on", FCVAR_EXTDLL };
cvar_t vstWeaponBanPenalty	= { const_cast< char* >( ctxCVar_WeaponBanPenalty.c_str( ) ), "off", FCVAR_EXTDLL };
cvar_t vstWeaponBanPenalty_Amount = { const_cast< char* >( ctxCVar_WeaponBanPenalty_Amount.c_str( ) ), "0", FCVAR_EXTDLL };

cvar_t vstTKBan				= { const_cast< char* >( ctxCVar_TKBan.c_str( ) ), "3", FCVAR_EXTDLL };
cvar_t vstTKBotBan			= { const_cast< char* >( ctxCVar_TKBotBan.c_str( ) ), "on", FCVAR_EXTDLL };
cvar_t vstTKHumanBan			= { const_cast< char* >( ctxCVar_TKHumanBan.c_str( ) )	, "on", FCVAR_EXTDLL };
cvar_t vstTKBotsShootBack	= { const_cast< char* >( ctxCVar_TKBotsShootBack.c_str( ) )	, "60", FCVAR_EXTDLL };
cvar_t vstTKBotsInsult		= { const_cast< char* >( ctxCVar_TKBotsInsult.c_str( ) )	, "50", FCVAR_EXTDLL };
cvar_t vstTKTKBotPunish		= { const_cast< char* >( ctxCVar_TKBotPunish.c_str( ) )	, "on", FCVAR_EXTDLL };
cvar_t vstTKTKHumanPunish	= { const_cast< char* >( ctxCVar_TKHumanPunish.c_str( ) )	, "on", FCVAR_EXTDLL };

//.!!

cvar_t vstWeapomSelectBan	= { const_cast< char* >( ctxCVar_WeapomSelectBan.c_str( ) )	, "off", FCVAR_EXTDLL };
cvar_t vstPODFixes			= { const_cast< char* >( ctxCVar_PODFixes.c_str( ) )			, "off", FCVAR_EXTDLL };
cvar_t vstPODHostageFix		= { const_cast< char* >( ctxCVar_PODHostageFix.c_str( ) )	, "on" , FCVAR_EXTDLL };
cvar_t vstBotBombFix			= { const_cast< char* >( ctxCVar_BotBombFix.c_str( ) )		, "on" , FCVAR_EXTDLL };
cvar_t vstBotJumpFix			= { const_cast< char* >( ctxCVar_BotJumpFix.c_str( ) )		, "on" , FCVAR_EXTDLL };
cvar_t vstBotAimFix			= { const_cast< char* >( ctxCVar_BotAimFix.c_str( ) )			, "on" , FCVAR_EXTDLL };	
cvar_t vstBotScopeFix		= { const_cast< char* >( ctxCVar_BotScopeFix.c_str( ) )		, "on" , FCVAR_EXTDLL };
cvar_t vstBotZoomDelay		= { const_cast< char* >( ctxCVar_BotZoomDelay.c_str( ) )		, "0.15", FCVAR_EXTDLL };
cvar_t vstBotScopeDelay		= { const_cast< char* >( ctxCVar_BotScopeDelay.c_str( ) )	, "0.25", FCVAR_EXTDLL };
cvar_t vstBotScopeDelay_awp= { const_cast< char* >( ctxCVar_BotScopeDelay_awp.c_str( ) ), "0.35", FCVAR_EXTDLL };

cvar_t vstBotKnifeFix		= { const_cast< char* >( ctxCVar_BotKnifeFix.c_str( ) )		, "on" , FCVAR_EXTDLL };
cvar_t vstBotNadeFix			= { const_cast< char* >( ctxCVar_BotNadeFix.c_str( ) )		, "on" , FCVAR_EXTDLL };
cvar_t vstBotNadeThrowDelay= { const_cast< char* >( ctxCVar_BotNadeThrowDelay.c_str( ) ), "0.015" , FCVAR_EXTDLL };
cvar_t vstBotFieldOfView   = { const_cast< char* >( ctxCVar_FieldOfView.c_str( ) ), "0.0" , FCVAR_EXTDLL };

cvar_t vstBotLogFix			= { const_cast< char* >( ctxCVar_BotLogFix.c_str( ) )			, "off" , FCVAR_EXTDLL };
cvar_t vstBotCombatFix		= { const_cast< char* >( ctxCVar_BotCombatFix.c_str( ) )		, "on", FCVAR_EXTDLL };
cvar_t vstBotsShootThroughWalls	= { const_cast< char* >( ctxCVar_BotsShootThroughWalls.c_str( ) )	, "on", FCVAR_EXTDLL };


cvar_t vstBotSkillDelay		= { const_cast< char* >( ctxCVar_BotSkillDelay.c_str( ) )	, "0.25", FCVAR_EXTDLL };
cvar_t vstBotTargetFrameScanRate= { const_cast< char* >( ctxCVar_BotTargetFrameScanRate.c_str( ) )	, "1", FCVAR_EXTDLL };
cvar_t vstBotTargetPlayerScanRate= { const_cast< char* >( ctxCVar_BotTargetPlayerScanRate.c_str( ) )	, "5", FCVAR_EXTDLL };

cvar_t vstBotsBuyDefuseKit	= { const_cast< char* >( ctxCVar_BotsBuyDefuseKit.c_str( ) ), "on" , FCVAR_EXTDLL };
cvar_t vstBotsBuyHENade		= { const_cast< char* >( ctxCVar_BotsBuyHENade.c_str( ) )	, "off" , FCVAR_EXTDLL };
cvar_t vstBotsBuyFlashNade	= { const_cast< char* >( ctxCVar_BotsBuyFlashNade.c_str( ) ), "off" , FCVAR_EXTDLL };
cvar_t vstBotsBuySmokeNade	= { const_cast< char* >( ctxCVar_BotsBuySmokeNade.c_str( ) ), "off" , FCVAR_EXTDLL };
cvar_t vstBotBuyDelay		= { const_cast< char* >( ctxCVar_BotBuyDelay.c_str( ) )		, "1.5", FCVAR_EXTDLL };

cvar_t vstBotSilentWalk		= { const_cast< char* >( ctxCVar_BotSilentWalk.c_str( ) )	, "on" , FCVAR_EXTDLL };  
cvar_t vstBotWalkSpeed		= { const_cast< char* >( ctxCVar_BotWalkSpeed.c_str( ) )		, "134", FCVAR_EXTDLL };	 
cvar_t vstBotRunSpeed		= { const_cast< char* >( ctxCVar_BotRunSpeed.c_str( ) )		, "0", FCVAR_EXTDLL };	 
cvar_t vstBotRushTimeMin	= { const_cast< char* >( ctxCVar_BotRushTimeMin.c_str( ) )	, "40" , FCVAR_EXTDLL };	 
cvar_t vstBotRushTimeMax	= { const_cast< char* >( ctxCVar_BotRushTimeMax.c_str( ) )	, "80" , FCVAR_EXTDLL };
cvar_t vstBotWalkTimeMin	= { const_cast< char* >( ctxCVar_BotWalkTimeMin.c_str( ) )	, "5"	 , FCVAR_EXTDLL };	 
cvar_t vstBotWalkTimeMax	= { const_cast< char* >( ctxCVar_BotWalkTimeMax.c_str( ) )	, "90" , FCVAR_EXTDLL };
cvar_t vstBotRunTimeMin		= { const_cast< char* >( ctxCVar_BotRunTimeMin.c_str( ) )	, "1"	 , FCVAR_EXTDLL };	 
cvar_t vstBotRunTimeMax		= { const_cast< char* >( ctxCVar_BotRunTimeMax.c_str( ) )	, "15" , FCVAR_EXTDLL };
cvar_t vstBotFightTimeMin	= { const_cast< char* >( ctxCVar_BotFightTimeMin.c_str( ) )	, "5"	 , FCVAR_EXTDLL };	 
cvar_t vstBotFightTimeMax	= { const_cast< char* >( ctxCVar_BotFightTimeMax.c_str( ) )	, "15" , FCVAR_EXTDLL };

cvar_t vstBotBurstFireFix	 = { const_cast< char* >( ctxCVar_BotBurstFireFix.c_str( ) )	, "on" , FCVAR_EXTDLL };
cvar_t vstBotBurstFireOnMin = { const_cast< char* >( ctxCVar_BotBurstFireOnMin.c_str( ) )	, ".10"	 , FCVAR_EXTDLL };
cvar_t vstBotBurstFireOnMax = { const_cast< char* >( ctxCVar_BotBurstFireOnMax.c_str( ) )	, ".25"	 , FCVAR_EXTDLL };
cvar_t vstBotBurstFireOffMin= { const_cast< char* >( ctxCVar_BotBurstFireOffMin.c_str( ) ), ".10"	 , FCVAR_EXTDLL };
cvar_t vstBotBurstFireOffMax= { const_cast< char* >( ctxCVar_BotBurstFireOffMax.c_str( ) ), ".35"	 , FCVAR_EXTDLL };
//####
//cvar_t vstBotBurstFireDistMin = { const_cast< char* >( ctxCVar_BotBurstFireDistMin.c_str( ) ), "400"	 , FCVAR_EXTDLL };
//cvar_t vstBotBurstFireDistMax = { const_cast< char* >( ctxCVar_BotBurstFireDistMin.c_str( ) ), "400"	 , FCVAR_EXTDLL };

//cvar_t vstBotJumpOnMin = { const_cast< char* >( ctxCVar_BotJumpOnMin.c_str( ) )	, "5.00"	 , FCVAR_EXTDLL };	 
//cvar_t vstBotJumpOnMax = { const_cast< char* >( ctxCVar_BotJumpOnMax.c_str( ) )	, "10.00" , FCVAR_EXTDLL };	 
//cvar_t vstBotJumpOffMin= { const_cast< char* >( ctxCVar_BotJumpOffMin.c_str( ) )	, "0.50"	 , FCVAR_EXTDLL };	 
//cvar_t vstBotJumpOffMax= { const_cast< char* >( ctxCVar_BotJumpOffMax.c_str( ) )	, "1.00"	 , FCVAR_EXTDLL };	 

//cvar_t vstBotDuckOnMin = { const_cast< char* >( ctxCVar_BotDuckOnMin.c_str( ) )	, "0.25"	 , FCVAR_EXTDLL };	 
//cvar_t vstBotDuckOnMax = { const_cast< char* >( ctxCVar_BotDuckOnMax.c_str( ) )	, "3.00"	 , FCVAR_EXTDLL };	 
//cvar_t vstBotDuckOffMin= { const_cast< char* >( ctxCVar_BotDuckOffMin.c_str( ) )	, "0.25"	 , FCVAR_EXTDLL };	 
//cvar_t vstBotDuckOffMax= { const_cast< char* >( ctxCVar_BotDuckOffMax.c_str( ) )	, "2.00"	 , FCVAR_EXTDLL };	 

//cvar_t vstBotStopOnMin = { const_cast< char* >( ctxCVar_BotStopOnMin.c_str( ) )	, "0.25"	 , FCVAR_EXTDLL };	 
//cvar_t vstBotStopOnMax = { const_cast< char* >( ctxCVar_BotStopOnMax.c_str( ) )	, "1.50"	 , FCVAR_EXTDLL };	 
//cvar_t vstBotStopOffMin= { const_cast< char* >( ctxCVar_BotStopOffMin.c_str( ) )	, "0.50"	 , FCVAR_EXTDLL };	 
//cvar_t vstBotStopOffMax= { const_cast< char* >( ctxCVar_BotStopOffMax.c_str( ) )	, "2.00"	 , FCVAR_EXTDLL };	 

#ifdef defDebug_Bot
	void fvoDebugBot( edict_t* pst_ptrEdict, string ptxMsg )
	{
		string vtxName = "DEBUG ";
		if ( pst_ptrEdict != NULL )
		{
			fvoExecFakeClientCommand( pst_ptrEdict, "say", ptxMsg );
			vtxName += vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );
			ptxMsg = vtxName + " " + ptxMsg;
		}
		vclDebugTrace.fvoWriteEventInfo( ptxMsg );
	} // fvoDebugBot

	#ifdef defDebug_Bombing
	void fvoDebugBot_Bombing( edict_t* pst_ptrEdict, string ptxMsg )
	{
		fvoDebugBot( pst_ptrEdict, ptxMsg );
	} // fvoDebugBot_Bombing
	#endif

	#ifdef defDebug_Zooming
	void fvoDebugBot_Zooming( edict_t* pst_ptrEdict, string ptxMsg )
	{
		fvoDebugBot( pst_ptrEdict, ptxMsg );
	} // fvoDebugBot_Zooming
	#endif

	#ifdef defDebug_Nade
	void fvoDebugBot_Nade( edict_t* pst_ptrEdict, string ptxMsg )
	{
		fvoDebugBot( pst_ptrEdict, ptxMsg );
	} // fvoDebugBot_Nade
	#endif

	#ifdef defDebug_WeaponSelect
	void fvoDebugBot_WeaponSelect( edict_t* pst_ptrEdict, string ptxMsg )
	{
		fvoDebugBot( pst_ptrEdict, ptxMsg );
	} // fvoDebugBot_WeaponSelect
	#endif

	#ifdef defDebug_BoneIndex
	void fvoDebugBot_BoneIndex( edict_t* pst_ptrEdict, string ptxMsg )
	{
		fvoDebugBot( pst_ptrEdict, ptxMsg );
	} // defDebug_BoneIndex
	#endif

	#ifdef defDebug_ShieldCheck
	void fvoDebugBot_ShieldCheck( edict_t* pst_ptrEdict, string ptxMsg )
	{
		fvoDebugBot( pst_ptrEdict, ptxMsg );
	} // defDebug_ShieldCheck
	#endif

#endif // defDebug_Bot

void fvoMA_BotControl_Event_GetCVars( tclArgList& pclArgList )
{
	short vinNext = vclBotControl.finGetGameSettings( pclArgList.finGetArg_Short( 0 ) );

	if ( vclEventSched.fboCreateEvent( ) )
	{
		vclEventSched.fboCreateArgList( 1 );
		vclEventSched.fvoSetArg_Short( 0, vinNext );
		vclEventSched.fvoSetEventFunc( fvoMA_BotControl_Event_GetCVars );
		vclEventSched.fvoSetDelayInSecs( cflUpdateCVarsInSec ); 
		vclEventSched.fboSendEvent( );
	}

} // fvoMA_BotControl_Event_GetCVars

float UTIL_WrapAngle( float angle_to_wrap )
{
   float angle = angle_to_wrap;

   // check for wraparound of angle
   if (angle > 180)
      angle -= 360 * ((int) (angle / 360) + 1);
   if (angle < -180)
      angle += 360 * ((int) (angle / 360) + 1);

   return angle;

} // UTIL_WrapAngle

float UTIL_AngleOfVectors( Vector v1, Vector v2 )
{
   if ( ( v1.Length () == 0 ) || ( v2.Length( ) == 0 ) )
      return 0; // avoid zero divide

   return ( UTIL_WrapAngle( acos( DotProduct( v1, v2 ) / ( v1.Length( ) * v2.Length( ) ) ) * 180 / M_PI ) );

} // UTIL_AngleOfVectors

Vector UTIL_WrapAngles( Vector angles_to_wrap )
{
   Vector angles = angles_to_wrap;

   // check for wraparound of angles
   if (angles.x > 180)
      angles.x -= 360 * ((int) (angles.x / 360) + 1);
   if (angles.x < -180)
      angles.x += 360 * ((int) (angles.x / 360) + 1);
   if (angles.y > 180)
      angles.y -= 360 * ((int) (angles.y / 360) + 1);
   if (angles.y < -180)
      angles.y += 360 * ((int) (angles.y / 360) + 1);
   if (angles.z > 180)
      angles.z -= 360 * ((int) (angles.z / 360) + 1);
   if (angles.z < -180)
      angles.z += 360 * ((int) (angles.z / 360) + 1);

   return angles;
} // UTIL_WrapAngles

void fvoTraceEdict_v( edict_t *pst_ptrEdict )
{
	vclDebugTrace.fvoWriteEventInfo( "BEGIN " + vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.speed          : " + ftxFloatToString( pst_ptrEdict->v.speed ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.maxspeed       : " + ftxFloatToString( pst_ptrEdict->v.maxspeed ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.movetype       : " + ftxIntToString( pst_ptrEdict->v.movetype ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.flTimeStepSound: " + ftxFloatToString( pst_ptrEdict->v.flTimeStepSound ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.bInDuck        : " + ftxIntToString( pst_ptrEdict->v.bInDuck ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.button         : " + ftxIntToString( pst_ptrEdict->v.button ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.sequence       : " + ftxIntToString( pst_ptrEdict->v.sequence ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.gaitsequence   : " + ftxIntToString( pst_ptrEdict->v.gaitsequence ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.ltime          : " + ftxFloatToString( pst_ptrEdict->v.ltime ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.starttime      : " + ftxFloatToString( pst_ptrEdict->v.starttime ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.flDuckTime     : " + ftxFloatToString( pst_ptrEdict->v.flDuckTime ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.frags          : " + ftxFloatToString( pst_ptrEdict->v.frags ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.takedamage     : " + ftxFloatToString( pst_ptrEdict->v.takedamage ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.max_health     : " + ftxFloatToString( pst_ptrEdict->v.max_health ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.dmg_take       : " + ftxFloatToString( pst_ptrEdict->v.dmg_take ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.dmg_save       : " + ftxFloatToString( pst_ptrEdict->v.dmg_save ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.dmg            : " + ftxFloatToString( pst_ptrEdict->v.dmg ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.dmgtime        : " + ftxFloatToString( pst_ptrEdict->v.dmgtime ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.fov            : " + ftxFloatToString( pst_ptrEdict->v.fov ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.weaponmodel    : " + ftxIntToString( pst_ptrEdict->v.weaponmodel ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.iuser1         : " + ftxIntToString( pst_ptrEdict->v.iuser1 ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.iuser2         : " + ftxIntToString( pst_ptrEdict->v.iuser2 ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.iuser3         : " + ftxIntToString( pst_ptrEdict->v.iuser3 ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.iuser4         : " + ftxIntToString( pst_ptrEdict->v.iuser4 ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.fuser1         : " + ftxFloatToString( pst_ptrEdict->v.fuser1 ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.fuser2         : " + ftxFloatToString( pst_ptrEdict->v.fuser2 ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.fuser3         : " + ftxFloatToString( pst_ptrEdict->v.fuser3 ) );
	vclDebugTrace.fvoWriteEventInfo( "  pst_ptrEdict->v.fuser4         : " + ftxFloatToString( pst_ptrEdict->v.fuser4 ) );

	vclDebugTrace.fvoWriteEventInfo( "END" );
} // fvoTraceEdict_v

bool fboHasShieldUp( edict_t* pst_ptrTarget )
{
	if ( pst_ptrTarget == NULL )
		return false;

	string vtxWeapon = vclGlobalGameInfo.ftxGetSring( pst_ptrTarget->v.weaponmodel );

	#ifdef defDebug_ShieldCheck
	if ( vclPlayer.fboPlayerIsHumanByEdict( pst_ptrTarget ) )
	{
		fvoDebugBot_ShieldCheck( pst_ptrTarget, "DEBUG (fboHasShieldUp) Model Full: " + vtxWeapon );
	}
	#endif

	vtxWeapon = ftxWeaponRemovePath( vtxWeapon );
//	vtxWeapon = ftxConvertShieldModel( vtxWeapon );

	#ifdef defDebug_ShieldCheck
	if ( vclPlayer.fboPlayerIsHumanByEdict( pst_ptrTarget ) )
	{
		fvoDebugBot_ShieldCheck( pst_ptrTarget, "DEBUG (fboHasShieldUp) Model Path removed: " + vtxWeapon );
	}
	#endif

	if ( !fboModelIsShield( vtxWeapon ) ) 
	{
		#ifdef defDebug_ShieldCheck
		if ( vclPlayer.fboPlayerIsHumanByEdict( pst_ptrTarget ) )
		{
			fvoDebugBot_ShieldCheck( pst_ptrTarget, "DEBUG (fboHasShieldUp) No shield" );
		}
		#endif

		return false; 
	}

	#ifdef defDebug_ShieldCheck
	if ( vclPlayer.fboPlayerIsHumanByEdict( pst_ptrTarget ) )
	{
		fvoDebugBot_ShieldCheck( pst_ptrTarget, "DEBUG (fboHasShieldUp) Animation is " + ftxIntToString( pst_ptrTarget->v.weaponanim ) );
	}
	#endif

	if ( pst_ptrTarget->v.weaponanim == 5 || pst_ptrTarget->v.weaponanim == 6 ) 
	{
		#ifdef defDebug_ShieldCheck
		if ( vclPlayer.fboPlayerIsHumanByEdict( pst_ptrTarget ) )
		{
			fvoDebugBot_ShieldCheck( pst_ptrTarget, "DEBUG (fboHasShieldUp) Shield is UP" );
		}
		#endif

		return true; // 6: already put up, 7: putting up, 8: putting down 
	}

	#ifdef defDebug_ShieldCheck
	if ( vclPlayer.fboPlayerIsHumanByEdict( pst_ptrTarget ) )
	{
		fvoDebugBot_ShieldCheck( pst_ptrTarget, "DEBUG (fboHasShieldUp) Shield is DOWN" );
	}
	#endif

	return false; 

} // fboHasShieldUp

bool fboHasShieldUp( int pinTarget_ENT_Idx )
{
	return fboHasShieldUp( fst_ptrGetEntityByIndex( pinTarget_ENT_Idx ) );
} // fboHasShieldUp

tclBotControl vclBotControl;

/*
float tstBotStatus::fflGetMaxSpeed( )
{
	if ( vflMaxSpeed > 0 )
		return vflMaxSpeed;
	else
		return vclBotControl.vflMaxSpeed;

} // tstBotStatus::fflGetMaxSpeed
*/
/*
float tstBotStatus::fflGetMaxSpeed_ORIG( )
{ 
	return vclBotControl.vflMaxSpeed_ORIG;
} // tstBotStatus::fflGetMaxSpeed_ORIG
*/

bool tstBotStatus::fboIsTargeting( ) 
{ 
	if ( vclLastTargetTimer.fboTimedOut( ) && ( vinLastTargetIdx > 0 ) )
	{
		fvoHasLostTarget( );
	}
	return ( vinLastTargetIdx > 0 ); 
} // tstBotStatus::fboIsTargeting

void tstBotStatus::fvoHasLostTarget( ) 
{ 
	vclLastTargetTimer.fvoStop( ); 
	vclAttackTimer.fvoStop( );
	vinLastTargetIdx = 0; 
	fvoBoneIndex( -1 );
	fvoSwitchBurstFireOff( );
} // tstBotStatus::fvoHasLostTarget

void tstBotStatus::fvoSetNewTarget( edict_t* pst_ptrBot, edict_t *pst_ptrTarget ) 
{ 
	int vinIdx = finGetIndexOfEdict( pst_ptrTarget );

	if ( vinIdx < cinMinPlayerIndex )
	{
		fvoHasLostTarget( );
		return;
	}

	if ( vinLastTargetIdx == vinIdx )
	{
		// keep tracking same target;
		vclLastTargetTimer.fvoStart( fflRandomFloat( vflMinTrackTime, vflMaxTrackTime ) ); 
		return;
	}

	int vinHeadShotMode = vclPlayer.finGetHeadShotMode( );

	if ( ( vinHeadShotMode == cinHeadShot_Human ) 
				||
		  ( vinHeadShotMode == cinHeadShot_Clan )
				||
	     ( vinHeadShotMode == cinHeadShot_World )
				||
	     ( vinHeadShotMode == cinHeadShot_All )
		)
	{
		fvoBoneIndex( PLAYERBONE_HEAD );
	}
	else
	{
		// PLAYERBONE_SPINE3 = 5 
		// PLAYERBONE_NECK   = 6 
		// PLAYERBONE_HEAD   = 7 
		if ( finBoneIndex( ) < 1 )
		{
			// it is important that the bone index not be reset in here;
			fvoBoneIndex( finRandom( PLAYERBONE_SPINE3, PLAYERBONE_HEAD ) );
		}
	}

	vinLastTargetIdx = vinIdx; 

//	if ( vinBotSkill < cinSkillHigh )
//		vclAttackTimer.fvoStart( ( 100 - vinBotSkill ) / 200 );

	vclLastTargetTimer.fvoStart( fflRandomFloat( vflMinTrackTime, vflMaxTrackTime ) ); 
	vclBotAngle_Vector = fstWrapAngles( pst_ptrBot->v.v_angle );
	fvoSwitchBurstFireOff( );

} // tstBotStatus::fvoSetNewTarget

edict_t* tstBotStatus::fst_ptrGetTarget( )
{
	if ( !fboIsTargeting( ) )
		return NULL;

	edict_t* vst_ptrTarget = fst_ptrGetEntityByIndex( vinLastTargetIdx );

	if ( vst_ptrTarget == NULL )
	{
		fvoHasLostTarget( );
		return NULL;
	}

	string vtxClassName = vclGlobalGameInfo.ftxGetSring( vst_ptrTarget->v.classname );

	if ( vtxClassName == "player" )
	{
		if ( !vclPlayer.fboPlayerIsAliveByEdict( vst_ptrTarget ) )
		{
			fvoHasLostTarget( );
			return NULL;
		}
	}
	return vst_ptrTarget;

} // tstBotStatus::fst_ptrGetTarget

bool tstBotStatus::fboTargetHasShieldUp( )
{
	edict_t* vst_ptrTarget = fst_ptrGetTarget( );
	return fboHasShieldUp( vst_ptrTarget );

/*
	if ( vst_ptrTarget == NULL )
		return false;

	if ( vst_ptrTarget->v.weaponanim == 5 || vst_ptrTarget->v.weaponanim == 6 ) 
	{
		return true; // 6: already put up, 7: putting up, 8: putting down 
	}
	
	return false;
*/

} // tstBotStatus::fboTargetHasShieldUp

bool tstBotStatus::fboTargetHasShieldUpCanShoot( )
{
	edict_t* vst_ptrTarget = fst_ptrGetTarget( );
	if ( vst_ptrTarget == NULL )
		return false;

	// 6: already put up, 7: putting up, 8: putting down 
	if ( vst_ptrTarget->v.weaponanim == 5 || vst_ptrTarget->v.weaponanim == 6 ) 
	{
		edict_t* vst_ptrThisBot = fst_ptrThisBot( );
		if ( vst_ptrThisBot == NULL )
			return false;

		float vflAngleDelta = fabs( UTIL_WrapAngle( vst_ptrTarget->v.v_angle.y - vst_ptrThisBot->v.v_angle.y ) );
   	// bot can get past shield
		// vclDebugTrace.fvoWriteEventInfo( "vflAngleDelta: " + ftxFloatToString( vflAngleDelta ) );

		if ( vflAngleDelta < 120 )
		{
			return true; 
		}

	}
	
	return false;

} // tstBotStatus::fboTargetHasShieldUpCanShoot

bool tstBotStatus::fboWaitForRescope( )
{ 
	if ( vst_ptrWeapon == NULL ) 
		return false; 
	return ( ( vst_ptrWeapon->fflRescopeDelay( ) > 0.0 ) && vboAllowRescope ); 
} // tstBotStatus::fboWaitForRescope

void tstBotStatus::fvoSwitchBurstFireOff( )
{
	vboIgnoreBotMovement = false;
	vboActionBurstFire = false;
	vboBurstFire_State = 0;
} // tstBotStatus::fvoSwitchBurstFireOff

void tstBotStatus::fvoSwitchBurstFireOn( 
	float pflBR_OnMin, float pflBR_OnMax, float pflBR_OffMin, float pflBR_OffMax )
{
	fvoSetBurstFireTiming( pflBR_OnMin, pflBR_OnMax, pflBR_OffMin, pflBR_OffMax );
	vboActionBurstFire = true;
	vboBurstFire_State = 0;
} // tstBotStatus::fvoSwitchBurstFireOn

void tstBotStatus::fvoCycleBurstFire( )
{
	if ( fboBurstFire_StateOn( ) && vclBurstFireTimer.fboTimedOut( ) )
		fvoSetBurstFireStateOff( );
	else
	if ( fboBurstFire_StateOff( ) && vclBurstFireTimer.fboTimedOut( ) )
		fvoSetBurstFireStateOn( );

} // tstBotStatus::fvoCycleBurstFire

void tstBotStatus::fvoSetBurstFireStateOn( ) 
{ 
	vboBurstFire_State = 0; 
	vclBurstFireTimer.fvoStart( 
		fflRandomFloat( vflBurstRate_OnMin, vflBurstRate_OnMax ) ); 

} // tstBotStatus::fvoSetBurstFireStateOn

void tstBotStatus::fvoSetBurstFireStateOff( ) 
{ 
	vboBurstFire_State = 1; 
	vclBurstFireTimer.fvoStart( 
		fflRandomFloat( vflBurstRate_OffMin, vflBurstRate_OffMax ) ); 

} // tstBotStatus::fvoSetBurstFireStateOff

void tstBotStatus::fvoSetBurstFireTiming( 
	float pflBR_OnMin, float pflBR_OnMax, float pflBR_OffMin, float pflBR_OffMax )
{ 
	vflBurstRate_OnMin = pflBR_OnMin; 
	vflBurstRate_OnMax = pflBR_OnMax; 
	vflBurstRate_OffMin = pflBR_OffMin; 
	vflBurstRate_OffMax = pflBR_OffMax; 

} // tstBotStatus::fvoSetBurstFireTiming

bool tstBotStatus::fboHasNade( ) 
{ 
	if ( vst_ptrWeapon == NULL ) 
		return false;  
	
	return ( vst_ptrWeapon->fboIsNade( ) ); 

} // tstBotStatus::fboHasNade

bool tstBotStatus::fboHasPistol( ) 
{ 
	if ( vst_ptrWeapon == NULL ) 
		return false;  
	
	return ( vst_ptrWeapon->fboIsSideArm( ) ); 

} // tstBotStatus::fboHasPistol

bool tstBotStatus::fboHasZoomable( ) 
{ 
	if ( vst_ptrWeapon == NULL ) 
	{ 
		#ifdef defDebug_Zooming
		fvoDebugBot_Zooming( NULL, "(tstBotStatus::fboHasZoomable) vst_ptrWeapon is NULL." ); 
		#endif
		return false; 
	} 
	
	return ( vst_ptrWeapon->fboIsZoomable( ) ); 

} // tstBotStatus::fboHasZoomable

void tstBotStatus::fvoStartScopeDelay( )
{ 
	if ( vst_ptrWeapon != NULL ) 
	{ 
		float vflBotScopeDelay; 
		
		if ( fboHasScope( ) )
		{
			if ( vtxWeaponModel_Compact == ctxModel_awp )
			{
				// give AWP slighlty more time to stabalize than other weapons;
				vflBotScopeDelay = vclBotControl.vflScopeDelay_awp;
				#ifdef defDebug_Zooming
				fvoDebugBot_Zooming( NULL, "(tstBotStatus::fvoStartScopeDelay) vflScopeDelay_awp = " + ftxFloatToString( vflBotScopeDelay ) ); 
				#endif
			}
			else // is all other scoping rifles;
			{
				vflBotScopeDelay = vclBotControl.vflScopeDelay;
				#ifdef defDebug_Zooming
				fvoDebugBot_Zooming( NULL, "(tstBotStatus::fvoStartScopeDelay) vflScopeDelay = " + ftxFloatToString( vflBotScopeDelay ) ); 
				#endif
			}
		}
		else // is a zoomable rifle;
		{
			vflBotScopeDelay = vclBotControl.vflZoomDelay;
			#ifdef defDebug_Zooming
			fvoDebugBot_Zooming( NULL, "(tstBotStatus::fvoStartScopeDelay) vflZoomDelay = " + ftxFloatToString( vflBotScopeDelay ) ); 
			#endif
		}
		
		vclScopeDelayTimer.fvoStart( vflBotScopeDelay );
		vclZoomedTimer.fvoStart( vflBotScopeDelay + 0.01 );
	} 

} // tstBotStatus::fvoStartScopeDelay

void tstBotStatus::fvoStartRescopeDelay( )
{ 
	if ( vst_ptrWeapon != NULL ) 
	{ 
		#ifdef defDebug_Zooming
		fvoDebugBot_Zooming( NULL, "(tstBotStatus::fvoStartRescopeDelay) Rescope Delay is " + ftxFloatToString( vst_ptrWeapon->fflRescopeDelay( ) ) );
		#endif
		vclScopeDelayTimer.fvoStart( vst_ptrWeapon->fflRescopeDelay( ) ); 
	} 
	#ifdef defDebug_Zooming
	else
		fvoDebugBot_Zooming( NULL, "(tstBotStatus::fvoStartRescopeDelay) vst_ptrWeapon is NULL." );
	#endif

} // tstBotStatus::fvoStartRescopeDelay

void tstBotStatus::fvoSetWeaponModel( string ptxWeaponModel_Full )
{
	if ( vtxWeaponModel_Full == ptxWeaponModel_Full )
	// same weapon so nothing to do;
		return;

	vtxWeaponModel_Full = ptxWeaponModel_Full;

	#ifdef defDebug_WeaponSelect
		fvoDebugBot_WeaponSelect( NULL, "(tstBotStatus::fvoSetWeaponModel) Weapon model differs - reinitializing." );
		fvoDebugBot_WeaponSelect( NULL, "(tstBotStatus::fvoSetWeaponModel) previous weapon was '" + vtxWeaponModel_Compact + "' New weapon is '" + ftxWeaponRemovePath( ptxWeaponModel_Full ) + "'" );
	#endif
	
	vtxWeaponModel_Compact = ftxWeaponRemovePath( ptxWeaponModel_Full );
	vinWeaponIndex = vclWeapon.finFindWeaponByModel( vtxWeaponModel_Compact );

	vst_ptrWeapon = vclWeapon.fst_ptrGetWeaponPtr( vinWeaponIndex );
	if ( vst_ptrWeapon == NULL )
	{
		if ( !ptxWeaponModel_Full.empty( ) )
		{
			// This is an error condition - weapon did exist but was not found.
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tstBotStatus::fvoSetWeaponModel) Weapon not found. Details:" );
			vclDebugTrace.fvoWriteEventInfo( "Full Model Name : " + ptxWeaponModel_Full );
			vclDebugTrace.fvoWriteEventInfo( "   Compact Name : " + vtxWeaponModel_Compact );
		}

		vinWeaponIndex = -1;
		return;
	}

	fvoSwitchBurstFireOff( );
	vboIgnoreBotMovement = false;
	vclScopeDelayTimer.fboTimedOut( );
	vflMinTrackTime = vst_ptrWeapon->vflMinTrackTime;
	vflMaxTrackTime = vst_ptrWeapon->vflMaxTrackTime;

} // tstBotStatus::fvoSetWeaponModel

edict_t* tstBotStatus::fst_ptrFindVisibleTarget( edict_t* pst_ptrSource )
{

	if ( pst_ptrSource == NULL )
		return NULL;

	if ( vclInterfaceL1.vlgFrameCounter % vclBotControl.vinFrameScanRate != 0 )
		return NULL;

	edict_t* vst_ptrTarget;
	
	int vinTeam = vclPlayer.finGetPlayerTeamByEdict( pst_ptrSource );
	int vinCurBoneIndex;
	int vinMaxPlayers = vclGlobalGameInfo.finGetMaxPlayers( );
	int vinPlayersScanned = 0;
		
	locRepeat:
	{
		vinScanIndex++;

		if ( ( vinScanIndex > vinMaxPlayers ) 
					|| 
			  ( vinScanIndex < cinMinPlayerIndex )
			)
			vinScanIndex = cinMinPlayerIndex;

		vst_ptrTarget = INDEXENT( vinScanIndex );

		if ( vst_ptrTarget == NULL )
		{
			// skip over empty slots;
			// goto locRepeat;
			goto locNextPlayer;
		}

		if ( !vclPlayer.fboPlayerIsAliveByEdict( vst_ptrTarget ) )
			goto locNextPlayer;

		if ( vinTeam == vclPlayer.finGetPlayerTeamByEdict( vst_ptrTarget ) )
			goto locNextPlayer;

		if ( vclBotControl.fboPlayerIsVisible_Quick( vinBotIdx, pst_ptrSource, vst_ptrTarget, vinCurBoneIndex ) )
		{
			// set index to visible bone;
			fvoBoneIndex( vinCurBoneIndex );

		//	fvoExecFakeClientCommand( pst_ptrSource, "say", "I have seen an enemy target" );

			return vst_ptrTarget;
		}

		locNextPlayer:
		{
			vinPlayersScanned++;

			if ( ( vinPlayersScanned >= vclBotControl.vinPlayerScanRate )
					    || 
				  ( vinPlayersScanned >= vinMaxPlayers )
					    || 
				  ( vinPlayersScanned >= cinMaxPlayerIndex ) // ensure termination no matter what!

				)
			{
				return NULL;			
			}

			goto locRepeat;
			
		}

	} // locRepeat

} // tstBotStatus::fst_ptrFindVisibleTarget

bool tstBotStatus::fboReactionSkillDelay( ) 
{ 
	if ( !vclAttackTimer.fboTimedOut( ) ) 
		return true;

	if ( random( 100 ) >= vinBotSkill )
	{
		vclAttackTimer.fvoStart( 0.25 );
		return true;
	}

	return false;

} // tstBotStatus::fboReactionSkillDelay

tclBotControl::tclBotControl( )
{
	vboBotAimIsOn			   = false; 
	vboBotCombatIsOn			= false; 
	vboBotsShootThroughWallsIsOn = false;
	vboBotBurstFireIsOn		= false;
	vboBotKnifeFixIsOn		= false;
	vboBotNadeFixIsOn			= false;
	vboSilentWalkIsOn			= false; 
	vboPODFixesAreOn			= false;
	vboPODHostageFixIsOn		= false;
	vboBotBombFixIsOn			= false;
	vboBotLogFixIsOn			= false;
	vboBotJumpFixIsOn			= false;
	fvoResetBotStatus( );
	vinFrameScanRate			= cinBotTargetFrameScanRateMin;
	vinPlayerScanRate			= cinBotTargetPlayerScanRateMin;
	for ( int vinBotIdx = 0; vinBotIdx < cinMaxPlayers; vinBotIdx++ )
	{
		vstBotStatus[ vinBotIdx ].vinBotIdx = vinBotIdx;
	}

} // tclBotControl::tclBotControl

void tclBotControl::fvoResetBotStatus( )
{
	vboSyncActionWalk = false;
	vclSyncWalkTimer.fvoStop( );
	vclSyncJumpTimer.fvoStop( );
	for ( int vinIdx = 0; vinIdx < cinMaxPlayers; vinIdx++ )
		fvoResetBotStatus( vinIdx );

} // tclBotControl::fvoResetBotStatus

void tclBotControl::fvoResetBotStatus( int pinIdx )
{
	if ( ( pinIdx < 0 ) || ( pinIdx >= cinMaxPlayers ) )
	// index out of bounds exit;
		return;
	vstBotStatus[ pinIdx ].vinScanIndex			= 0;
	vstBotStatus[ pinIdx ].vflPrevHealth		= 100;
	vstBotStatus[ pinIdx ].vflDistance			= 0.0;
	vstBotStatus[ pinIdx ].vboActionWalk		= false;
	vstBotStatus[ pinIdx ].vboActionDuck		= false;
	vstBotStatus[ pinIdx ].vboActionNoJump		= false;
	vstBotStatus[ pinIdx ].vboActionNoMove		= false;
	vstBotStatus[ pinIdx ].vboActionBurstFire = false;
	vstBotStatus[ pinIdx ].vboActionHasKnife	= false;
	vstBotStatus[ pinIdx ].vboActionHasNade	= false;
	vstBotStatus[ pinIdx ].vboPlantBomb			= false;
	vstBotStatus[ pinIdx ].vboActionZoom		= false;
	vstBotStatus[ pinIdx ].vboHasTarget			= false;
	vstBotStatus[ pinIdx ].vboZoomReady			= false;
	vstBotStatus[ pinIdx ].vboAllowRescope		= false;
	vstBotStatus[ pinIdx ].vboIgnoreBotMovement = false;
	vstBotStatus[ pinIdx ].vinKnifeAttack				= 0;
	vstBotStatus[ pinIdx ].vinNadeAttack		= 0;
	vstBotStatus[ pinIdx ].vtxWeaponModel_Full    = "";
	vstBotStatus[ pinIdx ].vtxWeaponModel_Compact = "";
	vstBotStatus[ pinIdx ].vinWeaponIndex		= -1;
	vstBotStatus[ pinIdx ].vst_ptrWeapon		= NULL;
	vstBotStatus[ pinIdx ].vflMinTrackTime		= 0.10;
	vstBotStatus[ pinIdx ].vflMaxTrackTime		= 5.00;

	vstBotStatus[ pinIdx ].vclWalkTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vclNadeTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vclAttackTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vclNoJumpTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vclDuckTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vclNoMoveTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vclBurstFireTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vclZoomedTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vclLastTargetTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vclScopeDelayTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vclFlashedTimer.fvoStop( );
	vstBotStatus[ pinIdx ].vinLastTargetIdx = 0;
	vstBotStatus[ pinIdx ].fvoBoneIndex( 0 ); 
//	vstBotStatus[ pinIdx ].fvoSetMaxSpeed( 320 ); 
	vstBotStatus[ pinIdx ].fvoSetMaxSpeed_ORIG( 320 ); 

	//vstBotStatus[ pinIdx ].vinMoney = 0;

} // tclBotControl::fvoResetBotStatus

void tclBotControl::fvoRoundStart( )
{
	fvoResetBotStatus( );
	vclBot.fvoBombWasPlanted( false );
	vclBot.fvoHostagesAreBeingRescued( false );

	// tell all bots not to walk for a random interval between the minimum
	// and maximum rush time inclusive;
	vclSyncWalkTimer.fvoStart( finRandom( vinBotRushTimeMin, vinBotRushTimeMax ) );

	if ( fboBotJumpFixIsOn( ) )
		vclSyncJumpTimer.fvoStart( fflCVarGetFloat( "mp_freezetime" ) );

	// force bot to buy a non-banned weapon;

//	if ( vclWeapon.vinWeaponMode != cinWeaponMode_RegularWar )
	{
		edict_t* vstEdict_Bot;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= vclPlayer.finGetMaxPlayers( ); 
				vinIdx++ )
		{

			if ( !vclPlayer.fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			vstEdict_Bot = vclPlayer.fst_ptrGetPlayerByIndex( vinIdx );
			//vclWeapon.fvoForceWeaponBuy( vstEdict_Bot, 1.00, ALLARMS );
			vclWeapon.fvoCheckWeapons( vstEdict_Bot, vinIdx );

		} // for
	}

	// DebugTrace.fvoWriteEventInfo( "Round Start" ); 

} // tclBotControl::fvoRoundStart

void tclBotControl::fvoSetCVars( )
{
	//.!! should be moved.
	CVAR_REGISTER( &vstAutoBalanceDisply ); 
	CVAR_REGISTER( &vstBotDamageAffects );
	CVAR_REGISTER( &vstBotsThrowSparks );
	CVAR_REGISTER( &vstBotsMakeDamageSounds );
	CVAR_REGISTER( &vstWeaponBanPenalty );
	CVAR_REGISTER( &vstWeaponBanPenalty_Amount );

	CVAR_REGISTER( &vstTKBan ); 
	CVAR_REGISTER( &vstTKBotBan ); 
	CVAR_REGISTER( &vstTKHumanBan );
	CVAR_REGISTER( &vstTKBotsShootBack );
	CVAR_REGISTER( &vstTKBotsInsult );
	CVAR_REGISTER( &vstTKTKBotPunish );
	CVAR_REGISTER( &vstTKTKHumanPunish );

	//.!!
	CVAR_REGISTER( &vstWeapomSelectBan );
	CVAR_REGISTER( &vstPODFixes );
	CVAR_REGISTER( &vstPODHostageFix );
	CVAR_REGISTER( &vstBotBombFix );
	CVAR_REGISTER( &vstBotJumpFix );
	CVAR_REGISTER( &vstBotAimFix );
	CVAR_REGISTER( &vstBotScopeFix );
	CVAR_REGISTER( &vstBotZoomDelay );
	CVAR_REGISTER( &vstBotScopeDelay );
	CVAR_REGISTER( &vstBotScopeDelay_awp );
	CVAR_REGISTER( &vstBotBurstFireFix );
	CVAR_REGISTER( &vstBotKnifeFix );
	CVAR_REGISTER( &vstBotNadeFix );
	CVAR_REGISTER( &vstBotNadeThrowDelay );
	CVAR_REGISTER( &vstBotFieldOfView );
	CVAR_REGISTER( &vstBotLogFix );
	CVAR_REGISTER( &vstBotCombatFix );
	CVAR_REGISTER( &vstBotsShootThroughWalls );
	CVAR_REGISTER( &vstBotsBuyDefuseKit );
	CVAR_REGISTER( &vstBotsBuyHENade );
	CVAR_REGISTER( &vstBotsBuyFlashNade );
	CVAR_REGISTER( &vstBotsBuySmokeNade );
	CVAR_REGISTER( &vstBotBuyDelay );
	CVAR_REGISTER( &vstBotSkillDelay );
	CVAR_REGISTER( &vstBotTargetFrameScanRate );
	CVAR_REGISTER( &vstBotTargetPlayerScanRate );
	CVAR_REGISTER( &vstBotSilentWalk );
	CVAR_REGISTER( &vstBotWalkSpeed );
	CVAR_REGISTER( &vstBotRunSpeed );
	CVAR_REGISTER( &vstBotRushTimeMin );
	CVAR_REGISTER( &vstBotRushTimeMax );
	CVAR_REGISTER( &vstBotWalkTimeMin );
	CVAR_REGISTER( &vstBotWalkTimeMax );
	CVAR_REGISTER( &vstBotRunTimeMin );
	CVAR_REGISTER( &vstBotRunTimeMax );
	CVAR_REGISTER( &vstBotFightTimeMin );
	CVAR_REGISTER( &vstBotFightTimeMax );
	CVAR_REGISTER( &vstBotBurstFireOnMin );
	CVAR_REGISTER( &vstBotBurstFireOnMax );
	CVAR_REGISTER( &vstBotBurstFireOffMin );
	CVAR_REGISTER( &vstBotBurstFireOffMax );

//	CVAR_REGISTER( &vstBotJumpOnMin );
//	CVAR_REGISTER( &vstBotJumpOnMax );
//	CVAR_REGISTER( &vstBotJumpOffMin );
//	CVAR_REGISTER( &vstBotJumpOffMax );

//	CVAR_REGISTER( &vstBotDuckOnMin );
//	CVAR_REGISTER( &vstBotDuckOnMax );
//	CVAR_REGISTER( &vstBotDuckOffMin );
//	CVAR_REGISTER( &vstBotDuckOffMax );

//	CVAR_REGISTER( &vstBotStopOnMin );
//	CVAR_REGISTER( &vstBotStopOnMax );
//	CVAR_REGISTER( &vstBotStopOffMin );
//	CVAR_REGISTER( &vstBotStopOffMax );

	if ( vclEventSched.fboCreateEvent( ) )
	{
		vclEventSched.fboCreateArgList( 1 );
		vclEventSched.fvoSetArg_Short( 0, 1 );
		vclEventSched.fvoSetEventFunc( fvoMA_BotControl_Event_GetCVars );
		vclEventSched.fvoSetDelayInSecs( cflUpdateCVarsInSec ); 
		vclEventSched.fboSendEvent( );
	}

} // tclBotControl::fvoSetCVars

short tclBotControl::finGetGameSettings( short pinGroup )
{
	// update every timeout rather than on each frame to keep
	// the lag down.

	if ( pinGroup == 1 )
	{
		vflMaxSpeed					= fflCVarGetFloat_Bounded( ctxCVar_BotRunSpeed, cflRunSpeedMin, cflRunSpeedMax );
//		vflMaxSpeed					= fflCVarGetFloat( "sv_maxspeed" );
		vboBotAimIsOn				= fboCVarGetBool( ctxCVar_BotAimFix );
		vboBotScopeFireIsOn		= fboCVarGetBool( ctxCVar_BotScopeFix );
		vboBotBurstFireIsOn		= fboCVarGetBool( ctxCVar_BotBurstFireFix );
		vboBotKnifeFixIsOn		= fboCVarGetBool( ctxCVar_BotKnifeFix );
		vboBotNadeFixIsOn			= fboCVarGetBool( ctxCVar_BotNadeFix );
		vboBotLogFixIsOn			= fboCVarGetBool( ctxCVar_BotLogFix );
		vboBotCombatIsOn			= fboCVarGetBool( ctxCVar_BotCombatFix );
		vboBotsShootThroughWallsIsOn	= fboCVarGetBool( ctxCVar_BotsShootThroughWalls );
		vboSilentWalkIsOn			= fboCVarGetBool( ctxCVar_BotSilentWalk );
		vboPODFixesAreOn			= fboCVarGetBool( ctxCVar_PODFixes );
		vboPODHostageFixIsOn		= fboCVarGetBool( ctxCVar_PODHostageFix );
		vboBotBombFixIsOn			= fboCVarGetBool( ctxCVar_BotBombFix );
		vboBotJumpFixIsOn			= fboCVarGetBool( ctxCVar_BotJumpFix );
		pinGroup = 2;
	}
	else
	if ( pinGroup == 2 ) 
	{
		vflBotWalkSpeed		= fflCVarGetFloat_Bounded( ctxCVar_BotWalkSpeed, cflWalkSpeedMin, cflWalkSpeedMax );
		vinBotRushTimeMin		= finCVarGetInt_Bounded( ctxCVar_BotRushTimeMin, cinBotRushTimeMin, cinBotRushTimeMax );
		vinBotRushTimeMax		= finCVarGetInt_Bounded( ctxCVar_BotRushTimeMax, cinBotRushTimeMin, cinBotRushTimeMax  );
		fvoOrderMinMax_Int( vinBotRushTimeMin, vinBotRushTimeMax );
		
		vinBotWalkTimeMin		= finCVarGetInt_Bounded( ctxCVar_BotWalkTimeMin, cinBotWalkTimeMin, cinBotWalkTimeMax );
		vinBotWalkTimeMax		= finCVarGetInt_Bounded( ctxCVar_BotWalkTimeMax, cinBotWalkTimeMin, cinBotWalkTimeMax );
		fvoOrderMinMax_Int( vinBotWalkTimeMin, vinBotWalkTimeMax );

		vinBotRunTimeMin		= finCVarGetInt_Bounded( ctxCVar_BotRunTimeMin, cinBotRunTimeMin, cinBotRunTimeMax );
		vinBotRunTimeMax		= finCVarGetInt_Bounded( ctxCVar_BotRunTimeMax, cinBotRunTimeMin, cinBotRunTimeMax );
		fvoOrderMinMax_Int( vinBotRunTimeMin, vinBotRunTimeMax );

		vinBotFightTimeMin	= finCVarGetInt_Bounded( ctxCVar_BotFightTimeMin, cinBotFightTimeMin, cinBotFightTimeMax );
		vinBotFightTimeMax	= finCVarGetInt_Bounded( ctxCVar_BotFightTimeMax, cinBotFightTimeMin, cinBotFightTimeMax );
		fvoOrderMinMax_Int( vinBotFightTimeMin, vinBotFightTimeMax );

		vinFrameScanRate = finCVarGetInt_Bounded( ctxCVar_BotTargetFrameScanRate, cinBotTargetFrameScanRateMin, cinBotTargetFrameScanRateMax );
		vinPlayerScanRate = finCVarGetInt_Bounded( ctxCVar_BotTargetPlayerScanRate, cinBotTargetPlayerScanRateMin, cinBotTargetPlayerScanRateMax );

		pinGroup = 3;
   }
	else
	if ( pinGroup == 3 )
	{
		vflBotBurstFireOnMin	= fflCVarGetFloat_Bounded( ctxCVar_BotBurstFireOnMin, cflBotBurstFireOnMin, cflBotBurstFireOnMax );
		vflBotBurstFireOnMax	= fflCVarGetFloat_Bounded( ctxCVar_BotBurstFireOnMax, cflBotBurstFireOnMin, cflBotBurstFireOnMax );
		vflBotBurstFireOffMin= fflCVarGetFloat_Bounded( ctxCVar_BotBurstFireOffMin, cflBotBurstFireOffMin, cflBotBurstFireOffMax );
		vflBotBurstFireOffMax= fflCVarGetFloat_Bounded( ctxCVar_BotBurstFireOffMax, cflBotBurstFireOffMin, cflBotBurstFireOffMax );
		fvoOrderMinMax_Float( vflBotBurstFireOnMin, vflBotBurstFireOnMax );
		fvoOrderMinMax_Float( vflBotBurstFireOffMin, vflBotBurstFireOffMax );

		vflBotSkillDelay = fflCVarGetFloat_Bounded( ctxCVar_BotSkillDelay, cflBotSkillDelayMin, cflBotSkillDelayMax );

//		vflBotJumpOnMin	= fflCVarGetFloat_Bounded( ctxCVar_BotJumpOnMin, cflBotJumpOnMin, cflBotJumpOnMax );
//		vflBotJumpOnMax	= fflCVarGetFloat_Bounded( ctxCVar_BotJumpOnMax, cflBotJumpOnMin, cflBotJumpOnMax );
//		vflBotJumpOffMin	= fflCVarGetFloat_Bounded( ctxCVar_BotJumpOffMin, cflBotJumpOffMin, cflBotJumpOffMax );
//		vflBotJumpOffMax	= fflCVarGetFloat_Bounded( ctxCVar_BotJumpOffMax, cflBotJumpOffMin, cflBotJumpOffMax );
//		fvoOrderMinMax_Float( vflBotJumpOnMin, vflBotJumpOnMax );
//		fvoOrderMinMax_Float( vflBotJumpOffMin, vflBotJumpOffMax );
		pinGroup = 4;
	} 
	else // 4
	{
//		vflBotDuckOnMin	= fflCVarGetFloat_Bounded( ctxCVar_BotDuckOnMin, cflBotDuckOnMin, cflBotDuckOnMax );
//		vflBotDuckOnMax	= fflCVarGetFloat_Bounded( ctxCVar_BotDuckOnMax, cflBotDuckOnMin, cflBotDuckOnMax );
//		vflBotDuckOffMin	= fflCVarGetFloat_Bounded( ctxCVar_BotDuckOffMin, cflBotDuckOffMin, cflBotDuckOffMax );
//		vflBotDuckOffMax	= fflCVarGetFloat_Bounded( ctxCVar_BotDuckOffMax, cflBotDuckOffMin, cflBotDuckOffMax );
//		fvoOrderMinMax_Float( vflBotDuckOnMin, vflBotDuckOnMax );
//		fvoOrderMinMax_Float( vflBotDuckOffMin, vflBotDuckOffMax );

//		vflBotStopOnMin	= fflCVarGetFloat_Bounded( ctxCVar_BotStopOnMin, cflBotStopOnMin, cflBotStopOnMax );
//		vflBotStopOnMax	= fflCVarGetFloat_Bounded( ctxCVar_BotStopOnMax, cflBotStopOnMin, cflBotStopOnMax );
//		vflBotStopOffMin	= fflCVarGetFloat_Bounded( ctxCVar_BotStopOffMin, cflBotStopOffMin, cflBotStopOffMax );
//		vflBotStopOffMax	= fflCVarGetFloat_Bounded( ctxCVar_BotStopOffMax, cflBotStopOffMin, cflBotStopOffMax );
//		fvoOrderMinMax_Float( vflBotStopOnMin, vflBotStopOnMax );
//		fvoOrderMinMax_Float( vflBotStopOffMin, vflBotStopOffMax );
		
		vflZoomDelay		= fflCVarGetFloat_Bounded( ctxCVar_BotZoomDelay, cflBotScopeDelayMin, cflBotScopeDelayMax );
		vflScopeDelay		= fflCVarGetFloat_Bounded( ctxCVar_BotScopeDelay, cflBotScopeDelayMin, cflBotScopeDelayMax );
		vflScopeDelay_awp	= fflCVarGetFloat_Bounded( ctxCVar_BotScopeDelay_awp, cflBotScopeDelayMin, cflBotScopeDelayMax );
		vflBotNadeDelay	= fflCVarGetFloat_Bounded( ctxCVar_BotNadeThrowDelay, cflBotNadeDelayMin, cflBotNadeDelayMax );
		vflFieldOfView    = fflCVarGetFloat_Bounded( ctxCVar_FieldOfView, cflFieldOfViewMin, cflFieldOfViewMax );
		pinGroup = 1;

	}  

	return pinGroup;

} // tclBotControl::finGetGameSettings

int tclBotControl::finControlBot( edict_t *pst_ptrEdict )
{
	if ( pst_ptrEdict == NULL ) return -1;

	int vinIdx = finGetIndexOfEdict( pst_ptrEdict );

	if ( vinIdx < cinMinPlayers || vinIdx > vclGlobalGameInfo.finGetMaxPlayers( ) )
	{
		// This is an error condition;
		vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::finControlBot): Invalid Edict Index (" + ftxIntToString( vinIdx ) + ")" );
		return -1;
	}

	// scale to zero based array index;
	vinIdx--;

	if ( fboSilentWalkIsOn( ) )
		fvoUpdateSilentWalk( pst_ptrEdict, vinIdx );

	if ( fboBotBombFixIsOn( ) || fboBotAimIsOn( ) )
		fvoUpdateBotBombFix( pst_ptrEdict, vinIdx );

	return vinIdx;

} // finControlBot

bool IsShootableBreakable( edict_t *pst_ptrEdict )
{
	return( pst_ptrEdict->v.impulse == 0
					&& 
			  pst_ptrEdict->v.takedamage > 0
					&& 
			  pst_ptrEdict->v.health < 1000.0 
					&& 
		     !FBitSet( pst_ptrEdict->v.spawnflags, SF_BREAK_TRIGGER_ONLY ) 
		    );

} // IsShootableBreakable

/*
void WaypointDrawBeam(edict_t *pEntity, Vector start, Vector end, int width,
        int noise, int red, int green, int blue, int brightness, int speed)
{
  // MESSAGE_BEGIN(MSG_ONE, SVC_TEMPENTITY, NULL, pEntity);
	//MESSAGE_BEGIN( MSG_BROADCAST, SVC_TEMPENTITY, NULL, pEntity );	
	MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pEntity->v.origin );
   WRITE_BYTE( TE_BEAMPOINTS);
   WRITE_COORD(start.x);
   WRITE_COORD(start.y);
   WRITE_COORD(start.z);
   WRITE_COORD(end.x);
   WRITE_COORD(end.y);
   WRITE_COORD(end.z);
   WRITE_SHORT( m_spriteTexture );
   WRITE_BYTE( 1 ); // framestart
   WRITE_BYTE( 10 ); // framerate
   WRITE_BYTE( 10 ); // life in 0.1's
   WRITE_BYTE( width ); // width
   WRITE_BYTE( noise );  // noise

   WRITE_BYTE( red );   // r, g, b
   WRITE_BYTE( green );   // r, g, b
   WRITE_BYTE( blue );   // r, g, b

   WRITE_BYTE( brightness );   // brightness
   WRITE_BYTE( speed );    // speed
   MESSAGE_END();
}
*/

void tclBotControl::fvoUpdateBotTarget( edict_t *pst_ptrEdict, TraceResult *pst_ptrTR, int pinIdx )
{

	//
	// NOTE: This function assumes that IsTargeting is always FALSE;
	//

	if ( pinIdx < 0 )
	{
		// This is an error condition.
		vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::fvoUpdateBotTarget) Unavailable Bot Index!" );
		return;
	}

	// attempt to establish lock on new target;

	vstBotStatus[ pinIdx ].vboHasTarget = false;

	if ( pst_ptrTR == NULL )
		return; 

	if ( pst_ptrTR->pHit == NULL )
		return;

	edict_t* vst_ptrTarget;
	string vtxClassName;

	vst_ptrTarget = pst_ptrTR->pHit;
	vtxClassName = vclGlobalGameInfo.ftxGetSring( vst_ptrTarget->v.classname );

	if ( vtxClassName != "player" )
		return;

	if ( vstBotStatus[ pinIdx ].fboIsTargeting( ) )
	{
		// no additional checks are needed since we are already targeting;
		// NOTE: target has also been confirmed to be visible!
		vstBotStatus[ pinIdx ].vboHasTarget = true;
		return;
	}

	if ( vclPlayer.finGetPlayerTeamByEdict( vst_ptrTarget ) 
				== 
		  vclPlayer.finGetPlayerTeamByEdict( pst_ptrEdict ) 
		)
		return; // bot is aiming at a freindly;

	vstBotStatus[ pinIdx ].vboHasTarget = true;
	vstBotStatus[ pinIdx ].fvoSetNewTarget( pst_ptrEdict, vst_ptrTarget );

} // tclBotControl::fvoUpdateBotTarget

void tclBotControl::fvoUpdateBotControl( edict_t *pst_ptrEdict, int pinIdx )
{
	if ( pinIdx < 0 )
	{
		// This is an error condition.
		vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::fvoUpdateBotControl) Unavailable Entity Index!" );
		return;
	}

	string vtxWeaponModel_Full = vclGlobalGameInfo.ftxGetSring( pst_ptrEdict->v.weaponmodel );
	#ifdef defDebug_WeaponSelect
	fvoDebugBot_WeaponSelect( pst_ptrEdict, "(tclBotControl::fvoUpdateBotControl) Weapon model: " + vtxWeaponModel_Full );
	#endif
	vstBotStatus[ pinIdx ].fvoSetWeaponModel( vtxWeaponModel_Full );

	TraceResult vstTR;
	edict_t *vst_ptrTarget;
	string vtxClassName;
	bool fboThrowNade = true;

	vst_ptrTarget = vstBotStatus[ pinIdx ].fst_ptrGetTarget( );

	if ( vst_ptrTarget == NULL )
	{
		vstBotStatus[ pinIdx ].vboHasTarget = false;
		goto locNewTarget;
	}

	// continue tracking existing target;
	goto locTargeting; 

	// attempt to establish a lock on new target;
	locNewTarget: 
	{
		if ( fboBotAimIsOn( ) )
		{
			vst_ptrTarget = vstBotStatus[ pinIdx ].fst_ptrFindVisibleTarget( pst_ptrEdict );

			if ( vst_ptrTarget != NULL )
				goto locTargetFound;
		}

	   TRACE_LINE
			( pst_ptrEdict->v.origin + pst_ptrEdict->v.view_ofs,
			  pst_ptrEdict->v.origin + pst_ptrEdict->v.view_ofs + gpGlobals->v_forward * 9999,
          dont_ignore_monsters, pst_ptrEdict, &vstTR );

		vstBotStatus[ pinIdx ].vboHasTarget = false;

		if ( vstTR.pHit == NULL )
			return;

		vst_ptrTarget = vstTR.pHit;
		vtxClassName = vclGlobalGameInfo.ftxGetSring( vst_ptrTarget->v.classname );

		if ( vtxClassName == "player" )
		{
			if ( vclPlayer.finGetPlayerTeamByEdict( vst_ptrTarget ) == vclPlayer.finGetPlayerTeamByEdict( pst_ptrEdict ) )
				return; // bot is aiming at a freindly;
		}
		else
		{
			if ( !IsShootableBreakable( vst_ptrTarget ) )
				return;

			if ( vtxClassName == "hostage_entity" )
				return;

			// do not throw nades at inanimate objects;
			fboThrowNade = false;
		}
		
		locTargetFound:

		// WaypointDrawBeam(pentToSkip, pentToSkip->v.origin, ptr->pHit->v.origin, 30, 0,255, 0, 0, 250, 5);
		vstBotStatus[ pinIdx ].vboHasTarget = true;
		vstBotStatus[ pinIdx ].fvoSetNewTarget( pst_ptrEdict, vst_ptrTarget );
	}

	locTargeting:

	if ( vstBotStatus[ pinIdx ].vboActionWalk )
	{
		// We just spotted the enemy - get ready to fight by disengaging silent walk;
		fvoBotWalkStop_Force( pst_ptrEdict, pinIdx, finRandom( vinBotFightTimeMin, vinBotFightTimeMax ) ); 
	}

	vstBotStatus[ pinIdx ].vflDistance = ( vst_ptrTarget->v.origin - pst_ptrEdict->v.origin ).Length( );

//	string vtxWeaponModel_Full = vclGlobalGameInfo.ftxGetSring( pst_ptrEdict->v.weaponmodel );
//	
//	#ifdef defDebug_WeaponSelect
//	fvoDebugBot_WeaponSelect( pst_ptrEdict, "(tclBotControl::fvoUpdateBotControl) Weapon model: " + vtxWeaponModel_Full );
//	#endif
//
//	vstBotStatus[ pinIdx ].fvoSetWeaponModel( vtxWeaponModel_Full );

	if ( fboBotNadeFixIsOn( ) && fboThrowNade )
		fvoUseNade( pst_ptrEdict, pinIdx );

	if ( fboBotBurstFireIsOn( ) ) 
		fvoUpdateBotBurstFire( pst_ptrEdict, pinIdx );

	if ( fboBotScopeFireIsOn( ) ) 
		fvoUpdateBotScopeFire( pst_ptrEdict, pinIdx );

	if ( fboBotKnifeFixIsOn( ) )
		fvoUseKnife( pst_ptrEdict, pinIdx );

} // tclBotControl::fvoUpdateBotControl

void tclBotControl::fvoBotWalkStart_Ask( edict_t *pst_ptrEdict, int pinIdx, float pflUntil )
{
	if ( !vstBotStatus[ pinIdx ].vclWalkTimer.fboTimedOut( ) )
	{
		// bot is either walking or not walking for a reason - do not change this;
		return;
	}

	// force bot to start walking;
	fvoBotWalkStart_Force( pst_ptrEdict, pinIdx, pflUntil );
	// fvoExecFakeClientCommand( pst_ptrEdict, "say", "I am now walking" );

} // tclBotControl::fvoBotWalkStart_Ask

void tclBotControl::fvoBotWalkStop_Ask( edict_t *pst_ptrEdict, int pinIdx, float pflUntil )
{
	if ( !vstBotStatus[ pinIdx ].vclWalkTimer.fboTimedOut( ) )
	{
		// bot is either walking or not walking for a reason - do not change this;
		return;
	}

	// force bot to stop walking;
	fvoBotWalkStop_Force( pst_ptrEdict, pinIdx, pflUntil );
	// fvoExecFakeClientCommand( pst_ptrEdict, "say", "I am now running" );

} // tclBotControl::fvoBotWalkStop_Ask

void tclBotControl::fvoBotWalkStart_Force( edict_t *pst_ptrEdict, int pinIdx, float pflUntil )
{
	// force bot to start walking;
	vstBotStatus[ pinIdx ].vboActionWalk = true;
	vstBotStatus[ pinIdx ].vclWalkTimer.fvoStart( pflUntil );

} // tclBotControl::fvoBotWalkStart_Force

void tclBotControl::fvoBotWalkStop_Force( edict_t *pst_ptrEdict, int pinIdx, float pflUntil )
{
	// force bot to stop walking;
	vstBotStatus[ pinIdx ].vboActionWalk = false;
	vstBotStatus[ pinIdx ].vclWalkTimer.fvoStart( pflUntil );
	
} // tclBotControl::fvoBotWalkStop_Force

void tclBotControl::fvoBotWalkStop_Force_CT( float pflUntil )
{
	// force bot to stop walking;
//	vclBotControl.vboSyncActionWalk = false;
//	vclBotControl.vclSyncWalkTimer.fvoStart( pflUntil );

	for ( int vinIdx = 0; vinIdx < vclGlobalGameInfo.finGetMaxPlayers( ); vinIdx++ )
	{

		// vinIdx must be scaled up to a "1" base array index;
		if ( vclPlayer.finGetPlayerTeamByIndex( vinIdx + 1 ) != cinTeam_CT )
			continue;

		vstBotStatus[ vinIdx ].vboActionWalk = false;
		vstBotStatus[ vinIdx ].vclWalkTimer.fvoStart( pflUntil );
	}

} // tclBotControl::fvoBotWalkStop_Force_CT

void tclBotControl::fvoUpdateSilentWalk( edict_t *pst_ptrEdict, int pinIdx )
{
	if ( !vboSyncActionWalk && vclSyncWalkTimer.fboTimedOut( ) )
	{  // a no walk period has just ended; start a walk period;
		vboSyncActionWalk = true;
		vclSyncWalkTimer.fvoStart( finRandom( vinBotWalkTimeMin, vinBotWalkTimeMax ) );
		// fvoExecFakeClientCommand( pst_ptrEdict, "say", "A walking period has just started." );
	}
   else
	if ( vboSyncActionWalk && vclSyncWalkTimer.fboTimedOut( ) )
	{  // a walk period has just ended; start a no walk period;
		vboSyncActionWalk = false;
		vclSyncWalkTimer.fvoStart( finRandom( vinBotRunTimeMin, vinBotRunTimeMax ) );
		// fvoExecFakeClientCommand( pst_ptrEdict, "say", "A no walking period has just started." );
	}

	if ( vstBotStatus[ pinIdx ].vboActionWalk )
	{	// bot is currently walking;

		if ( vstBotStatus[ pinIdx ].vflPrevHealth > pst_ptrEdict->v.health )
		{	// bot is taking damage - it's a good idea to stop walking and 
		   // release the bot out of a walking state so it can fight back 
			// optimally;
			
			fvoBotWalkStop_Force( pst_ptrEdict, pinIdx, finRandom( vinBotFightTimeMin, vinBotFightTimeMax ) ); 
			// fvoExecFakeClientCommand( pst_ptrEdict, "say", "Taking damage - run like mad!" );
		}
		else
		if ( vstBotStatus[ pinIdx ].vclWalkTimer.fboTimedOut( ) )
			vstBotStatus[ pinIdx ].vboActionWalk = false;
	}

	// update health for next damage check; we must update health
	// no matter if bot is walking or not walking;
	vstBotStatus[ pinIdx ].vflPrevHealth = pst_ptrEdict->v.health;

	if ( vboSyncActionWalk )
	{  // a walk period is in progress - ask it to start walking; Bot will 
	   // honor the request only if it is not already under control by a 
		// previous request;
		fvoBotWalkStart_Ask( pst_ptrEdict, pinIdx, vclSyncWalkTimer.fflTimeLeft( ) );
	}
   else
	{  // a no walk period is in progress - ask it to stop walking; Bot will 
	   // honor the request only if it is not already under control by a 
		// previous request;
		fvoBotWalkStop_Ask( pst_ptrEdict, pinIdx, vclSyncWalkTimer.fflTimeLeft( ) );
	}

} // tclBotControl::fvoUpdateSilentWalk

void tclBotControl::fvoUpdateBotBombFix( edict_t* pst_ptrEdict, int pinIdx )
{
	if ( vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_c4 )
	{
		#ifdef defDebug_Bombing
		fvoDebugBot_Bombing( pst_ptrEdict, "(tclBotControl::fvoUpdateBotBombFix) I have the bomb out." );
		#endif
		// attempt to plant bomb right away and don't stop until the bomb is gone;
		vstBotStatus[ pinIdx ].vboPlantBomb = true;
	}
	else
		vstBotStatus[ pinIdx ].vboPlantBomb = false;

} // tclBotControl::fvoUpdateBotBombFix

void tclBotControl::fvoUseKnife( edict_t *pst_ptrEdict, int pinIdx )
{

	if ( !fboBotKnifeFixIsOn( ) || pst_ptrEdict == NULL )
		return;

	if ( vstBotStatus[ pinIdx ].vtxWeaponModel_Compact != ctxModel_knife )
	{
		vstBotStatus[ pinIdx ].vboActionHasKnife = false;
		return;
	}
	
	vstBotStatus[ pinIdx ].vboActionHasKnife = true;
	vstBotStatus[ pinIdx ].vboIgnoreBotMovement = true;
	
	if ( vstBotStatus[ pinIdx ].vflDistance <= 100 )
	{
		// vclDebugTrace.fvoWriteEventInfo( "In hand: weapon knife" );
		// vstBotStatus[ pinIdx ].vclKnifeTimer.fvoStart( 3.0 );
		if ( vstBotStatus[ pinIdx ].vflDistance <= 50 )
			vstBotStatus[ pinIdx ].vinKnifeAttack = 2;
		else
		if ( vstBotStatus[ pinIdx ].vflDistance <= 75 )
			vstBotStatus[ pinIdx ].vinKnifeAttack = random( 2 ) + 1;
		else
			vstBotStatus[ pinIdx ].vinKnifeAttack = 1;
	}
	else
	//!!.b - test code
	{
		//fvoExecFakeClientCommand( pst_ptrEdict, ctxWeapon_knife );
	}
   //!!.e

} // tclBotControl::fvoUseKnife

void tclBotControl::fvoUseNade( 
	edict_t *pst_ptrEdict, int pinIdx  )
{
	// will only work if BotAim is "ON"!

	// execute only if nade fixes are enabled;
	if ( !fboBotNadeFixIsOn( ) || pst_ptrEdict == NULL )
		return;

	if ( !vstBotStatus[ pinIdx ].fboHasNade( ) )
	{
		locMoNade:
		vstBotStatus[ pinIdx ].vboActionHasNade = false;
		vstBotStatus[ pinIdx ].vinNadeAttack = 0;
		vstBotStatus[ pinIdx ].vclNadeTimer.fvoStop( );
		return;
	}

  // Bot is holding a nade in hand - get rid of it now!
		
	#ifdef defDebug_Nade
	fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoUseNade) I have a nade!" );
	#endif

	vstBotStatus[ pinIdx ].vboActionHasNade = true;
	vstBotStatus[ pinIdx ].vboIgnoreBotMovement = true;

	if ( vstBotStatus[ pinIdx ].vclNadeTimer.fboTimedOut( ) )
	{
		if ( vstBotStatus[ pinIdx ].vinNadeAttack == 0 )
		{
			#ifdef defDebug_Nade
			fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoUseNade) I will start throwing the nade." );
			#endif
			// hold attack button based on distance to target, then throw the damn thing!
			// vstBotStatus[ pinIdx ].vclNadeTimer.fvoStart( fflMaxOf( 0.1, ( pflDistance ) / 1000 ) );
			vstBotStatus[ pinIdx ].vinNadeAttack = 1;
			vstBotStatus[ pinIdx ].vclNadeTimer.fvoStart( vflBotNadeDelay );
		}
		else
		if ( vstBotStatus[ pinIdx ].vinNadeAttack == 1 )
		{
			#ifdef defDebug_Nade
			fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoUseNade) I will now release the nade." );
			#endif
			vstBotStatus[ pinIdx ].vinNadeAttack = 2;
			vstBotStatus[ pinIdx ].vclNadeTimer.fvoStart( 0.1 );
		}
		else
		if ( vstBotStatus[ pinIdx ].vinNadeAttack == 2 )
		{
			vstBotStatus[ pinIdx ].vboActionHasNade = false;
			#ifdef defDebug_Nade
			fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoUseNade) I have thrown the nade." );
			#endif
			vstBotStatus[ pinIdx ].vinNadeAttack = 0;
		}
		else
		{
			// this is an error condition;
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::fvoUseNade) Invalid NadeAttack setting while the attack has timed out = " +  ftxIntToString( vstBotStatus[ pinIdx ].vinNadeAttack ) );
			goto locMoNade;
		}
	}
	else
	{
		if ( vstBotStatus[ pinIdx ].vinNadeAttack == 1 )
		{
			#ifdef defDebug_Nade
			fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoUseNade) I will continue throwing the nade." );
			#endif
			vstBotStatus[ pinIdx ].vinNadeAttack = 1;
		}
		else
		if ( vstBotStatus[ pinIdx ].vinNadeAttack == 2 )
		{
			#ifdef defDebug_Nade
			fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoUseNade) I will continue to release the nade." );
			#endif
			vstBotStatus[ pinIdx ].vinNadeAttack = 2;
		}
		else
		{
			// this is an error condition;
			vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::fvoUseNade) Invalid NadeAttack setting while the attack has not yet timed out = " +  ftxIntToString( vstBotStatus[ pinIdx ].vinNadeAttack ) );
			goto locMoNade;
		}
	}

} // tclBotControl::fvoUseNade

void tclBotControl::fvoUpdateBotScopeFire( edict_t *pst_ptrEdict, int pinIdx )
{
	#ifdef defDebug_Zooming
	fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoUpdateBotScopeFire) Start of routine." );
	#endif
	if ( !fboBotScopeFireIsOn( ) )
	{
		#ifdef defDebug_Zooming
		fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoUpdateBotScopeFire) Scope fire is off." );
		#endif
		return;
	}

	if ( pst_ptrEdict == NULL )
	{
		// This is an error condition;
		vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::fvoUpdateBotScopeFire) Entity is NULL!" );
		return;
	}

	if ( !vstBotStatus[ pinIdx ].fboHasZoomable( ) )
	{
		#ifdef defDebug_Zooming
		fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoUpdateBotScopeFire) Weapon is NOT zoomable." );
		#endif
		return;
	}

	#ifdef defDebug_Zooming
	fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoUpdateBotScopeFire) Weapon is zoomable." );
	#endif

	// if we get here then ( vboHasScope || vboHasZoom ) is true; 
	// try and stay zoomed if appropriate;

	vstBotStatus[ pinIdx ].vboIgnoreBotMovement = false;

	float vflZoomRange_Min;	
	float vflZoomRange_Short;
	float vflZoomRange_Rescope;
	float vflFOV;

	// -1 = no rescoping needed;

	if ( vstBotStatus[ pinIdx ].fboHasZoom( ) )
	{
		vflZoomRange_Min   = 400;
		vflZoomRange_Short = vflZoomRange_Min; // MUST always be set equal!!!
		vflZoomRange_Rescope = 600; 
	}
	else
	if ( vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_awp )
	{
		vflZoomRange_Min   = 100;
		vflZoomRange_Short = 3000;
		vflZoomRange_Rescope = vflZoomRange_Min;
	}
	else
	if ( ( vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_g3sg1 ) 
				|| 
		  ( vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_sg550 )
		)
	{
		vflZoomRange_Min   = 400;
		vflZoomRange_Short = 3000;
		vflZoomRange_Rescope = 800; 
	}
	else // scout
	{
		vflZoomRange_Min	 = 300;
		vflZoomRange_Short = 2500;
		vflZoomRange_Rescope = 1000;
	}

	if (  ( vstBotStatus[ pinIdx ].vflDistance > vflZoomRange_Rescope ) 
		       && 
		   ( vflZoomRange_Rescope > -1 ) 
		) 
		vstBotStatus[ pinIdx ].vboAllowRescope = true;
	else
		vstBotStatus[ pinIdx ].vboAllowRescope = false;

	if ( vstBotStatus[ pinIdx ].vflDistance <= vflZoomRange_Min ) 
	{
		#ifdef defDebug_Zooming
		fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoUpdateBotScopeFire) At close range so forget scope!" );
		#endif
		// Close enough there's no need for a zoom;
		vstBotStatus[ pinIdx ].fvoDisableScoping( );
		vstBotStatus[ pinIdx ].vboZoomReady = true;
		return;
	}

	if ( 	vstBotStatus[ pinIdx ].fboHasZoom( ) )
	{
		#ifdef defDebug_Zooming
		fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoUpdateBotScopeFire) Has zoom (not scope)." );
		#endif
		vflFOV = FOV_ZOOMED;
	}
	else
	{
		if ( vstBotStatus[ pinIdx ].vflDistance < vflZoomRange_Short  ) 
			vflFOV = FOV_SCOPED_SHORT;
		else
			vflFOV = FOV_SCOPED_FAR; 
	}

	if ( pst_ptrEdict->v.fov > vflFOV )
	{
		if ( vstBotStatus[ pinIdx ].vclZoomedTimer.fboTimedOut( ) )
		{
			vstBotStatus[ pinIdx ].vboActionZoom = true;	
			vstBotStatus[ pinIdx ].vboZoomReady = false;
			#ifdef defDebug_Zooming
			fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoUpdateBotScopeFire) Scope action requested." );
			#endif
		}
		else
		{
			vstBotStatus[ pinIdx ].vboZoomReady = false;
			#ifdef defDebug_Zooming
			fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoUpdateBotScopeFire) Scope action in progress." );
			#endif
		}
	}
	else
	{
		if ( vstBotStatus[ pinIdx ].fboWeaponIsReadyToFire( ) )
		{
			// prevent bot from zooming in or out;
			vstBotStatus[ pinIdx ].fvoDisableScoping( );
			vstBotStatus[ pinIdx ].vboZoomReady = true;
			#ifdef defDebug_Zooming
			fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoUpdateBotScopeFire) Scope ready!" );
			#endif
		}
		else
		{
			#ifdef defDebug_Zooming
			fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoUpdateBotScopeFire) Scope is not yet ready!" );
			#endif
			vstBotStatus[ pinIdx ].vboZoomReady = false;
		}
	}

	return;

} // tclBotControl::fvoUpdateBotScopeFire

void tclBotControl::fvoUpdateBotBurstFire( edict_t *pst_ptrEdict, int pinIdx )
{
	if ( !fboBotBurstFireIsOn( ) )
		return;
	
	if ( pst_ptrEdict == NULL )
	// error condition;
		return;

	if (	vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_knife 
				|| 
			vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_c4 	
				||
			vstBotStatus[ pinIdx ].fboHasNade( )
				|| 
			vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_ump45 	
				||
			vstBotStatus[ pinIdx ].fboHasZoomable( )

		)
		// let bot fight on its own with these weapons;
	{
		vstBotStatus[ pinIdx ].vboIgnoreBotMovement = true;
		goto locNoControl;
	}

	if ( vstBotStatus[ pinIdx ].vboActionBurstFire )
	// already burst firing;
		return;

	float vflBurstFireOnMin;
	float vflBurstFireOnMax;
	float vflBurstFireOffMin;
	float vflBurstFireOffMax;

	if ( vstBotStatus[ pinIdx ].fboHasPistol( ) ) 
	{
		if ( vstBotStatus[ pinIdx ].vflDistance < 600 )
		{
			vflBurstFireOnMin   = 0.005;
			vflBurstFireOnMax   = 0.01;
			vflBurstFireOffMin  = 0.005;
			vflBurstFireOffMax  = 0.01;
			vstBotStatus[ pinIdx ].vboIgnoreBotMovement = true;
		}
		else
		if ( vstBotStatus[ pinIdx ].vflDistance < 1000 )
		{
			vflBurstFireOnMin   = 0.005;
			vflBurstFireOnMax   = 0.01;
			vflBurstFireOffMin  = 0.005;
			vflBurstFireOffMax  = 0.01;
			vstBotStatus[ pinIdx ].vboIgnoreBotMovement = true;
		}
		else
		if ( vstBotStatus[ pinIdx ].vflDistance < 2000 )
		{
			vflBurstFireOnMin   = 0.05;
			vflBurstFireOnMax   = 0.01;
			vflBurstFireOffMin  = 0.05;
			vflBurstFireOffMax  = 0.15;
		}
		else
		if ( vstBotStatus[ pinIdx ].vflDistance < 4000 )
		{
			vflBurstFireOnMin   = 0.15;
			vflBurstFireOnMax   = 0.25;
			vflBurstFireOffMin  = 0.15;
			vflBurstFireOffMax  = 0.25;
		}
		else
		{
			vflBurstFireOnMin   = 0.25;
			vflBurstFireOnMax   = 0.50;
			vflBurstFireOffMin  = 0.25;
			vflBurstFireOffMax  = 0.50;
		}
		goto locBurstFire;
	}

	// Not a pistol

	if ( vstBotStatus[ pinIdx ].vflDistance < 200 ) 
	{
		// always use rapid fire rate at this distance for all automatic weapons;
		vflBurstFireOnMin   = 0.005;
		vflBurstFireOnMax   = 0.01;
		vflBurstFireOffMin  = 0.005;
		vflBurstFireOffMax  = 0.01;
		vstBotStatus[ pinIdx ].vboIgnoreBotMovement = true;
		goto locBurstFire;
	}

	if (	vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_ak47	
				|| 
			vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_mac10	
				|| 
			vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_tmp 	
				|| 
			vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_xm1014 /* auto shotgun */
				|| 
			vstBotStatus[ pinIdx ].vtxWeaponModel_Compact == ctxModel_m249   /* para machinegun */
				
		)
	{
		if ( vstBotStatus[ pinIdx ].vflDistance < 300 ) 
		{
			// always use burst fire rate at this distance;
			vflBurstFireOnMin   = vflBotBurstFireOnMin;
			vflBurstFireOnMax   = vflBotBurstFireOnMax;
			vflBurstFireOffMin  = vflBotBurstFireOffMin;
			vflBurstFireOffMax  = vflBotBurstFireOffMax;
			vstBotStatus[ pinIdx ].vboIgnoreBotMovement = true;
			goto locBurstFire;
		}  
		
		if ( vstBotStatus[ pinIdx ].vflDistance < 800 ) 
		{
			// always use burst fire rate at this distance;
			vflBurstFireOnMin   = vflBotBurstFireOnMin;
			vflBurstFireOnMax   = vflBotBurstFireOnMax;
			vflBurstFireOffMin  = vflBotBurstFireOffMin;
			vflBurstFireOffMax  = vflBotBurstFireOffMax;
			goto locBurstFire;
		}  

		// always reduce burst fire rate at this distance;
		vflBurstFireOnMin   = vflBotBurstFireOnMin / 2;
		vflBurstFireOnMax   = vflBotBurstFireOnMax / 2;
		vflBurstFireOffMin  = vflBotBurstFireOffMin * 2;
		vflBurstFireOffMax  = vflBotBurstFireOffMax * 2;
		goto locBurstFire;

	} // Unstable weapons

	if ( vstBotStatus[ pinIdx ].vflDistance < 800 ) 
	{
		// always use burst fire rate at this distance;
		vflBurstFireOnMin   = vflBotBurstFireOnMin;
		vflBurstFireOnMax   = vflBotBurstFireOnMax;
		vflBurstFireOffMin  = vflBotBurstFireOffMin;
		vflBurstFireOffMax  = vflBotBurstFireOffMax;
		vstBotStatus[ pinIdx ].vboIgnoreBotMovement = true;
		goto locBurstFire;
	}

	if ( vstBotStatus[ pinIdx ].vflDistance < 1000 ) 
	{
		// always use burst fire rate at this distance;
		vflBurstFireOnMin   = vflBotBurstFireOnMin;
		vflBurstFireOnMax   = vflBotBurstFireOnMax;
		vflBurstFireOffMin  = vflBotBurstFireOffMin;
		vflBurstFireOffMax  = vflBotBurstFireOffMax;
		goto locBurstFire;
	}

	// always use burst fire rate at this distance;
	vflBurstFireOnMin   = vflBotBurstFireOnMin / 2;
	vflBurstFireOnMax   = vflBotBurstFireOnMax / 2;
	vflBurstFireOffMin  = vflBotBurstFireOffMin * 2;
	vflBurstFireOffMax  = vflBotBurstFireOffMax * 2;
	goto locBurstFire;

	locBurstFire:

	if ( !vstBotStatus[ pinIdx ].vboActionBurstFire )
	{
		vstBotStatus[ pinIdx ].
			fvoSwitchBurstFireOn( 
				vflBurstFireOnMin , vflBurstFireOnMax, 
				vflBurstFireOffMin, vflBurstFireOffMax );
	}
	
	return;

	locNoControl:
	{
		vstBotStatus[ pinIdx ].fvoSwitchBurstFireOff( );
		return;
	}

} // tclBotControl::fvoUpdateBotBurstFire

Vector UTIL_VecToAngles( const Vector &vec )
{
   float rgflVecOut[3];
   VEC_TO_ANGLES(vec, rgflVecOut);
   return Vector(rgflVecOut);

} // UTIL_VecToAngles

Vector vflGetGunPosition( edict_t* pst_ptrEdict )
{
	return ( pst_ptrEdict->v.origin + pst_ptrEdict->v.view_ofs );
} // vflGetGunPosition

void tclBotControl::fvoUpdateTargeting( edict_t *pentToSkip, int pinIdx ) // ORIGINAL
{
	if ( pentToSkip == NULL )
	{
		// this is an error condition
		vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::fvoUpdateTargeting): Invalid Edict Index (" + ftxIntToString( pinIdx ) + ")" );
		return;
	}
	// TraceResult vstTR;

	// build base vectors in bot's actual view direction
	// MAKE_VECTORS( pentToSkip->v.v_angle ); 
		
	// trace the line considering the ACTUAL view angles of the bot, not the ones 
	// it claims to have

   // GetGunPosition = pEdict->v.origin + pEdict->v.view_ofs

   // TRACE_LINE
	//		( pentToSkip->v.origin + pentToSkip->v.view_ofs,
	//		  pentToSkip->v.origin + pentToSkip->v.view_ofs + gpGlobals->v_forward * 9999,
   //      dont_ignore_monsters, pentToSkip, &vstTR );

	//vclWeapon.fvoWaypointDrawBeam
	//WaypointDrawBeam( pentToSkip, pentToSkip->v.origin + pentToSkip->v.view_ofs, pentToSkip->v.origin + pentToSkip->v.view_ofs + gpGlobals->v_forward * 9999, 30, 0, 255, 0, 0, 250, 5);
	//WaypointDrawBeam(pEnemy, pPlayer->v.origin, vecAim, 30, 0,255, 0, 0, 250, 5);

	vclBotControl.fvoUpdateBotControl( pentToSkip, pinIdx );

	if ( !fboBotAimIsOn( ) )
		return;

//!! CLEAN BELOW MESS UP

	if ( vstBotStatus[ pinIdx ].fboIsTargeting( ) )
	{
		// make bot point at target and fire no matter if target is visible or not;
		//	fvoPointGun_2( pentToSkip, pinIdx ); 

		edict_t* vst_ptrTarget = vclPlayer.fst_ptrGetPlayerByIndex( vstBotStatus[ pinIdx ].vinLastTargetIdx );

		if ( !vclPlayer.fboPlayerIsAliveByEdict( vst_ptrTarget ) )
		{
			vstBotStatus[ pinIdx ].fvoHasLostTarget( );
			//fvoExecFakeClientCommand( pentToSkip, "say", "I killed " + vclPlayer.ftxGetPlayerNameByEdict( vst_ptrTarget ) );
		}
		else
		{
			Vector v_enemy;

			if ( !vstBotStatus[ pinIdx ].vboHasTarget )
			{
				// BOT is not pointing at a visible enemy body part - try and locate one that
				// is visible;

				int vinBoneIdx;  
				Vector vclTarget;

					if ( fboPlayerIsVisible_Quick( pinIdx, pentToSkip, vst_ptrTarget, vinBoneIdx, vclTarget ) )
					{
						// aim at visible body part;
						vstBotStatus[ pinIdx ].fvoBoneIndex( vinBoneIdx ); 
						v_enemy = vclTarget - vflGetGunPosition( pentToSkip );
					}
					else
					{
					   // enemy is NOT visible;
					
						if ( !fboBotsShootThroughWallsIsOn( ) )
						{
							vstBotStatus[ pinIdx ].fvoHasLostTarget( );
						}
						else
						{
							v_enemy = 
								fclBotBodyTarget( vst_ptrTarget, PLAYERBONE_PELVIS ) - vflGetGunPosition( pentToSkip );
						}
					}
			}
			else
			{
				// BOT is pointing at a visible enemy body part;
				v_enemy = 
					fclBotBodyTarget( vst_ptrTarget, vstBotStatus[ pinIdx ].finBoneIndex( ) ) - vflGetGunPosition( pentToSkip );
			}

			if ( vstBotStatus[ pinIdx ].fboIsTargeting( ) )
			{

				pentToSkip->v.v_angle = fstWrapAngles( UTIL_VecToAngles( v_enemy ) );

				// change the bots ideal yaw and pitch to reflect where we want the
				// bot to point its gun;

				pentToSkip->v.ideal_yaw = pentToSkip->v.v_angle.y;
				pentToSkip->v.idealpitch = pentToSkip->v.v_angle.x;

				// How fast must we turn?
				// I think speed is in "degrees turned"

				pentToSkip->v.pitch_speed = 20; 
				pentToSkip->v.yaw_speed = 20;

				// set the body angles to point the gun correctly
				pentToSkip->v.angles.x = pentToSkip->v.v_angle.x / 3;

				pentToSkip->v.angles.y = pentToSkip->v.v_angle.y;
				pentToSkip->v.angles.z = 0;
				pentToSkip->v.v_angle.x = fflWrapAngle( -pentToSkip->v.v_angle.x );
				pentToSkip->v.angles = fstWrapAngles( pentToSkip->v.angles );

			}
		}
	}

} //  tclBotControl::fvoUpdateTargeting ORIGINAL

void tclBotControl::fvoUpdateTargeting_TEST( edict_t *pentToSkip, int pinIdx )
{
	if ( pentToSkip == NULL )
	{
		// this is an error condition
		vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::fvoUpdateTargeting): Invalid Edict Index (" + ftxIntToString( pinIdx ) + ")" );
		return;
	}
	// TraceResult vstTR;

	// build base vectors in bot's actual view direction
	// MAKE_VECTORS( pentToSkip->v.v_angle ); 
		
	// trace the line considering the ACTUAL view angles of the bot, not the ones 
	// it claims to have

   // GetGunPosition = pEdict->v.origin + pEdict->v.view_ofs

   // TRACE_LINE
	//		( pentToSkip->v.origin + pentToSkip->v.view_ofs,
	//		  pentToSkip->v.origin + pentToSkip->v.view_ofs + gpGlobals->v_forward * 9999,
   //      dont_ignore_monsters, pentToSkip, &vstTR );

	//vclWeapon.fvoWaypointDrawBeam
	//WaypointDrawBeam( pentToSkip, pentToSkip->v.origin + pentToSkip->v.view_ofs, pentToSkip->v.origin + pentToSkip->v.view_ofs + gpGlobals->v_forward * 9999, 30, 0, 255, 0, 0, 250, 5);
	//WaypointDrawBeam(pEnemy, pPlayer->v.origin, vecAim, 30, 0,255, 0, 0, 250, 5);

	vclBotControl.fvoUpdateBotControl( pentToSkip, pinIdx );

	if ( !fboBotAimIsOn( ) )
		return;

//!! CLEAN BELOW MESS UP

	if ( vstBotStatus[ pinIdx ].fboIsTargeting( ) )
	{
		// make bot point at target and fire no matter if target is visible or not;
		//	fvoPointGun_2( pentToSkip, pinIdx ); 

		edict_t* vst_ptrTarget = vclPlayer.fst_ptrGetPlayerByIndex( vstBotStatus[ pinIdx ].vinLastTargetIdx );

		if ( !vclPlayer.fboPlayerIsAliveByEdict( vst_ptrTarget ) )
		{
			vstBotStatus[ pinIdx ].fvoHasLostTarget( );
			//fvoExecFakeClientCommand( pentToSkip, "say", "I killed " + vclPlayer.ftxGetPlayerNameByEdict( vst_ptrTarget ) );
		}
		else
		{
			Vector v_enemy;

			if ( !vstBotStatus[ pinIdx ].vboHasTarget )
			{
				// BOT is not pointing at a visible enemy body part - try and locate one that
				// is visible;

				int vinBoneIdx;  
				Vector vclTarget;

					if ( fboPlayerIsVisible_Quick( pinIdx, pentToSkip, vst_ptrTarget, vinBoneIdx, vclTarget ) )
					{
						// aim at visible body part;
						vstBotStatus[ pinIdx ].fvoBoneIndex( vinBoneIdx ); 
						v_enemy = vclTarget - vflGetGunPosition( pentToSkip );
					}
					else
					{
					   // enemy is NOT visible;
					
						if ( !fboBotsShootThroughWallsIsOn( ) )
						{
							vstBotStatus[ pinIdx ].fvoHasLostTarget( );
						}
						else
						{
							v_enemy = 
								fclBotBodyTarget( vst_ptrTarget, PLAYERBONE_PELVIS ) - vflGetGunPosition( pentToSkip );
						}
					}
			}
			else
			{
				// BOT is pointing at a visible enemy body part;
				v_enemy = 
					fclBotBodyTarget( vst_ptrTarget, vstBotStatus[ pinIdx ].finBoneIndex( ) ) - vflGetGunPosition( pentToSkip );
			}

			if ( vclPlayer.finGetPlayerTeamByEdict( pentToSkip ) == cinTeam_TE  )
			{

				if ( vstBotStatus[ pinIdx ].fboIsTargeting( ) )
				{

					Vector v_idealangle = fstWrapAngles( UTIL_VecToAngles( v_enemy ) );
					// change the bots ideal yaw and pitch to reflect where we want the
					// bot to point its gun;

					pentToSkip->v.ideal_yaw = v_idealangle.y;
					pentToSkip->v.idealpitch = v_idealangle.x;

					// How fast must we turn?
					// I think speed is in "degrees turned"

					pentToSkip->v.pitch_speed = 20; 
					pentToSkip->v.yaw_speed = 20;

					Vector v_deviation = fstWrapAngles( Vector( v_idealangle.x, v_idealangle.y, 0 ) - vstBotStatus[ pinIdx ].vclBotAngle_Vector );
					pentToSkip->v.v_angle.x = vstBotStatus[ pinIdx ].vclBotAngle_Vector.x + ( v_deviation.x / 2 ); 
					pentToSkip->v.v_angle.y = vstBotStatus[ pinIdx ].vclBotAngle_Vector.y + ( v_deviation.y / 2 ); 

					// set the body angles to point the gun correctly
					pentToSkip->v.angles.x = pentToSkip->v.v_angle.x / 3;

					pentToSkip->v.angles.y = pentToSkip->v.v_angle.y;
					pentToSkip->v.angles.z = 0;
					pentToSkip->v.v_angle.x = fflWrapAngle( -pentToSkip->v.v_angle.x );
					pentToSkip->v.angles = fstWrapAngles( pentToSkip->v.angles );
					vstBotStatus[ pinIdx ].vclBotAngle_Vector = pentToSkip->v.angles;

				}
			}
			else
			/* original */
			if ( vstBotStatus[ pinIdx ].fboIsTargeting( ) )
			{

				pentToSkip->v.v_angle = fstWrapAngles( UTIL_VecToAngles( v_enemy ) );

				// change the bots ideal yaw and pitch to reflect where we want the
				// bot to point its gun;

				pentToSkip->v.ideal_yaw = pentToSkip->v.v_angle.y;
				pentToSkip->v.idealpitch = pentToSkip->v.v_angle.x;

				// How fast must we turn?
				// I think speed is in "degrees turned"

				pentToSkip->v.pitch_speed = 20; 
				pentToSkip->v.yaw_speed = 20;

				// set the body angles to point the gun correctly
				pentToSkip->v.angles.x = pentToSkip->v.v_angle.x / 3;

				pentToSkip->v.angles.y = pentToSkip->v.v_angle.y;
				pentToSkip->v.angles.z = 0;
				pentToSkip->v.v_angle.x = fflWrapAngle( -pentToSkip->v.v_angle.x );
				pentToSkip->v.angles = fstWrapAngles( pentToSkip->v.angles );

			}
		}
	}

} //  tclBotControl::fvoUpdateTargeting_TEST

void tclBotControl::fvoModifyPlayerMove( 
	edict_t* pst_ptrEdict, unsigned short &pinButtons, float &forwardmove, float &sidemove )
{
	if ( pst_ptrEdict == NULL ) 
	// bad edict pointer;
		return;

	int vinBotIdx = vclBotControl.finControlBot( pst_ptrEdict );

	if ( vinBotIdx < 0 || vinBotIdx >= cinMaxPlayers )
	{
		// This is an error condition;
		vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::fvoModifyButtons): Invalid Edict Index (" + ftxIntToString( vinBotIdx ) + ")" );
		return;
	}

	fvoUpdateTargeting( pst_ptrEdict, vinBotIdx );
	bool vboHoldStill = false;
	bool vboAttackShield = false;

	//
	// start Bot Aim enforcement;
	//

	if ( vboBotAimIsOn )
	{
		if ( ( vstBotStatus[ vinBotIdx ].fboIsTargeting( ) 
					|| 
			    vstBotStatus[ vinBotIdx ].vboHasTarget )
			)
		{
			vboHoldStill = true;
			fvoSetButtonOn(  pinButtons, cinBtnAttack1 );
			fvoSetButtonOff( pinButtons, cinBtnAttack2 );
		}
		else 
		{
			fvoSetButtonOff( pinButtons, cinBtnAttack1 );
			fvoSetButtonOff( pinButtons, cinBtnAttack2 );
		}

	} // vboBotAimIsOn

	//
	// End Bot Aim enforcement;
	//

	if ( vstBotStatus[ vinBotIdx ].fboIsBlind( ) 
				|| 
		  vstBotStatus[ vinBotIdx ].fboReactionSkillDelay( ) 
		)
	{
		fvoSetButtonOff( pinButtons, cinBtnAttack1 );
		fvoSetButtonOff( pinButtons, cinBtnAttack2 );
	}
	else
	//
	// Start knife attack enforcement;
	//
	if ( vstBotStatus[ vinBotIdx ].vboActionHasKnife )
	{
		vboAttackShield = true;

		if ( vstBotStatus[ vinBotIdx ].vinKnifeAttack == 1 ) 
		{	
			// vclDebugTrace.fvoWriteEventInfo( "Attack 1" );
			fvoSetButtonOn(  pinButtons, cinBtnAttack1 );
			fvoSetButtonOff( pinButtons, cinBtnAttack2 );
		}
		else
		if ( vstBotStatus[ vinBotIdx ].vinKnifeAttack == 2 )
		{
			// vclDebugTrace.fvoWriteEventInfo( "Attack 2" );
			fvoSetButtonOn(  pinButtons, cinBtnAttack2 );
			fvoSetButtonOff( pinButtons, cinBtnAttack1 );
		}
		else
		{
			// vclDebugTrace.fvoWriteEventInfo( "Attack 2" );
			fvoSetButtonOff( pinButtons, cinBtnAttack1 | cinBtnAttack2 );
		}
		vstBotStatus[ vinBotIdx ].vboActionHasKnife = false;
		vstBotStatus[ vinBotIdx ].vinKnifeAttack = 0; 
	}
	//
	// End knife attack enforcement;
	//
	else
	//
	// begin nade attack enforcement;
	//
	if ( vstBotStatus[ vinBotIdx ].vboActionHasNade )
	{
		vboAttackShield = true;

		#ifdef defDebug_Nade
		fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) I have a nade out!" );
		#endif

		// Three cases ...
		// 1: hold down attack button
		// 2: release the attack button
		// 3: do nothing (same as release)

		if ( vstBotStatus[ vinBotIdx ].vinNadeAttack == 1 )
		{
			#ifdef defDebug_Nade
			fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) NADE I am pressing the fire button." );
			#endif
			fvoSetButtonOn(  pinButtons, cinBtnAttack1 );
			fvoSetButtonOff( pinButtons, cinBtnAttack2 );
		}
		else
		if ( vstBotStatus[ vinBotIdx ].vinNadeAttack == 2 )
		{
			#ifdef defDebug_Nade
			fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) NADE I am releasing the fire button." );
			#endif
			fvoSetButtonOff( pinButtons, cinBtnAttack1 );
			fvoSetButtonOff( pinButtons, cinBtnAttack2 );
		}
		else
		{
			#ifdef defDebug_Nade
			fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) NADE - I have nothing to do." );
			#endif
		}

		#ifdef defDebug_Nade
		fvoDebugBot_Nade( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) NADE - I am setting Nade action back to false." );
		#endif
		vstBotStatus[ vinBotIdx ].vboActionHasNade = false;

	}
	//
	// End nade attack enforcement;
	//
	else
	//
	// start burst fire enforcement;
	//
	if ( vstBotStatus[ vinBotIdx ].vboActionBurstFire )
	{
		if ( vstBotStatus[ vinBotIdx ].vflDistance > 300 )
		{
			vboHoldStill = true;
		}
		
		if ( vstBotStatus[ vinBotIdx ].fboBurstFire_StateOn( ) )
		{
			fvoSetButtonOn( pinButtons, cinBtnAttack1 );
			fvoSetButtonOff( pinButtons, cinBtnAttack2 );
		}
		else
		{
			fvoSetButtonOff( pinButtons, cinBtnAttack1 );
			fvoSetButtonOff( pinButtons, cinBtnAttack2 );
		}
		// do not jump while burst firing!
		fvoSetButtonOff( pinButtons, cinBtnJump );
		vstBotStatus[ vinBotIdx ].fvoCycleBurstFire( );
	}
	//
	// end burst fire enforcement;
	//
	else
	//
	// begin zoom fire enforcement;
	// overrides other "aim" modes;
	//
	if ( fboBotScopeFireIsOn( ) )
	{	
		if ( vstBotStatus[ vinBotIdx ].fboHasZoomable( ) )
		{
			if ( vstBotStatus[ vinBotIdx ].vboActionZoom )
			{
				vboHoldStill = true;
				fvoSetButtonOff( pinButtons, cinBtnAttack1 );
				fvoSetButtonOn(  pinButtons, cinBtnAttack2 );
				// give zoom action enough time to complete;
				// note: this time is NOT the scoping time which is different.
				// as soon as the FOV is set correct, the ZoomReady flag will
				// be set, but scoping may still be in progress.

				vstBotStatus[ vinBotIdx ].fvoStartScopeDelay( );
				vstBotStatus[ vinBotIdx ].vboActionZoom = false;
				vstBotStatus[ vinBotIdx ].vboZoomReady = false;
				#ifdef defDebug_Zooming
				fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) Zoom or Scope action started!" );
				#endif
			} // action zoom
			else
			if ( vstBotStatus[ vinBotIdx ].vboZoomReady )
			{
				vboHoldStill = true;
				#ifdef defDebug_Zooming
				fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) Zoom or Scope is ready!" );
				#endif
				if ( vstBotStatus[ vinBotIdx ].fboWeaponIsReadyToFire( ) )
				{
					#ifdef defDebug_Zooming
					fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) Weapon is ready to fire!" );
					#endif
					// OK to fire weapon;
					fvoSetButtonOn(  pinButtons, cinBtnAttack1 );
					fvoSetButtonOff( pinButtons, cinBtnAttack2 );
					vstBotStatus[ vinBotIdx ].vboZoomReady = false;
					if ( vstBotStatus[ vinBotIdx ].fboWaitForRescope( ) )
						vstBotStatus[ vinBotIdx ].fvoStartRescopeDelay( );
				}
				else
				{
					fvoSetButtonOff( pinButtons, cinBtnAttack1 );
					fvoSetButtonOff( pinButtons, cinBtnAttack2 );
				}

				#ifdef defDebug_Zooming
				fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) Zoom or Scope is ready - fireing weapon!" );
				#endif
			}
			else
			if ( !vstBotStatus[ vinBotIdx ].vclZoomedTimer.fboTimedOut( ) )
			{
				vboHoldStill = true;
				// prevent bot from firing or zooming until zooming is allowed again;
				fvoSetButtonOff( pinButtons, cinBtnAttack1 );
				fvoSetButtonOff( pinButtons, cinBtnAttack2 );
				#ifdef defDebug_Zooming
				fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) Zooming and Scoping is disallowed!" );
				#endif
			}
			else
			{
				#ifdef defDebug_Zooming
				fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) Bot is prevented from firing or zooming." );
				#endif
				// prevent bot from firing weapon on its own;
				fvoSetButtonOff( pinButtons, cinBtnAttack1 );
				// unzoom if currently zoomed;
				if ( pst_ptrEdict->v.fov < FOV_NORMAL  )
				{
					fvoSetButtonOn( pinButtons, cinBtnAttack2 );
					// prevent repeat unzooming until action is completed;
					vstBotStatus[ vinBotIdx ].vclZoomedTimer.fvoStart( 0.1 );
					#ifdef defDebug_Zooming
					fvoDebugBot_Zooming( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) Unzooming action started!" );
					#endif
				}
				else
				// prevent bot from unzooming on its own;
					fvoSetButtonOff( pinButtons, cinBtnAttack2 );
			}
		} // has a zoomable weapon;
	}
	//
	// end zoom fire enforcement;
	//

	if ( !vboAttackShield && vstBotStatus[ vinBotIdx ].fboTargetHasShieldUp( ) )
	{

		// don't bother attacking when shield is up;
		//	fvoSetButtonOff( pinButtons, cinBtnAttack1 );
		//	fvoSetButtonOff( pinButtons, cinBtnAttack2 );
	

		if ( !vstBotStatus[ vinBotIdx ].fboTargetHasShieldUpCanShoot( ) )
		{
			
			if ( vstBotStatus[ vinBotIdx ].vclShieldAttackTimer.fboTimedOut( ) )
			{
				vstBotStatus[ vinBotIdx ].vboAttackShield = !vstBotStatus[ vinBotIdx ].vboAttackShield;
				
				if ( random( 2 ) == 0 )
				{
				// aimin at foot L
					
					vstBotStatus[ vinBotIdx ].fvoBoneIndex( PLAYERBONE_L_FOOT );
					// vclDebugTrace.fvoWriteEventInfo( "I am aiming at foot L." );
				}
				else
				{
					vstBotStatus[ vinBotIdx ].fvoBoneIndex( PLAYERBONE_R_FOOT );
					// vclDebugTrace.fvoWriteEventInfo( "I am aiming at foot R." );
				}

				if ( vstBotStatus[ vinBotIdx ].vboAttackShield )
				{
					vstBotStatus[ vinBotIdx ].vclShieldAttackTimer.fvoStart( fflRandomFloat( 0.125, 0.5 ) );
				}
				else
				{
					vstBotStatus[ vinBotIdx ].vclShieldAttackTimer.fvoStart( fflRandomFloat( 0.125, 10.0 ) );
				}
			}

			if ( !vstBotStatus[ vinBotIdx ].vboAttackShield )
			{
				fvoSetButtonOff( pinButtons, cinBtnAttack1 );
			}

			//vstBotStatus[ vinBotIdx ].fvoHasLostTarget( );

		}

	} // has shield up


/*
	if ( vstBotStatus[ vinBotIdx ].vboActionWalk ) 
		pst_ptrEdict->v.maxspeed = vflBotWalkSpeed;
	else
	if ( !vstBotStatus[ vinBotIdx ].vboActionWalk ) 
		pst_ptrEdict->v.maxspeed = vstBotStatus[ vinBotIdx ].fflGetMaxSpeed( );
*/

	if ( vstBotStatus[ vinBotIdx ].vboActionWalk && ( pst_ptrEdict->v.maxspeed != vflBotWalkSpeed ) )
	{
		// remember original speed;
		vstBotStatus[ vinBotIdx ].fvoSetMaxSpeed_ORIG( pst_ptrEdict->v.maxspeed );
		pst_ptrEdict->v.maxspeed = vflBotWalkSpeed;
	}
	else
	if ( !vstBotStatus[ vinBotIdx ].vboActionWalk // we are supposed to be running;
				&& 
		  ( pst_ptrEdict->v.maxspeed <= vflBotWalkSpeed 
				  ||	 
			 ( vflMaxSpeed != 0 && pst_ptrEdict->v.maxspeed != vflMaxSpeed ) 
		  )
		) 
	{	
		if ( vflMaxSpeed != 0 ) // we are using a custom run speed
		{
			vstBotStatus[ vinBotIdx ].fvoSetMaxSpeed_ORIG( pst_ptrEdict->v.maxspeed );
			pst_ptrEdict->v.maxspeed = vflMaxSpeed;
		}
		else
			pst_ptrEdict->v.maxspeed = vstBotStatus[ vinBotIdx ].fflGetMaxSpeed_ORIG( );
	}

	// check for jump suppression aim fix;

	if ( !vclSyncJumpTimer.fboTimedOut( ) )
	{
		fvoSetButtonOff( pinButtons, cinBtnJump );
		fvoSetButtonOff( pinButtons, cinBtnDuck );
		if ( vstBotStatus[ vinBotIdx ].vclNoMoveTimer.fboTimedOut( ) )
		{
			vstBotStatus[ vinBotIdx ].vboActionNoMove = true;
			vstBotStatus[ vinBotIdx ].vclNoMoveTimer.fvoStart( vclSyncJumpTimer.fflTimeLeft( ) );
		}
	}

	if ( vstBotStatus[ vinBotIdx ].vboPlantBomb )
	{
		#ifdef defDebug_Bombing
		fvoDebugBot_Bombing( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) I am planting the bomb." );
		#endif

		fvoSetButtonOn(  pinButtons, cinBtnAttack1 );
		fvoSetButtonOff( pinButtons, cinBtnAttack2 );
		fvoSetButtonOff( pinButtons, cinBtnJump );
	}
	else
	if ( vstBotStatus[ vinBotIdx ].fboIsBlind( ) )
	{
		// move backwards at full speed;
		forwardmove = vstBotStatus[ vinBotIdx ].fflGetMaxSpeed_ORIG( ) * -1;
		sidemove = 0.0;
	}
	else
	if ( fboBotCombatIsOn( ) && vstBotStatus[ vinBotIdx ].fboIsTargeting( ) )
	{
		if ( !vstBotStatus[ vinBotIdx ].vboIgnoreBotMovement )
		{
			if ( vstBotStatus[ vinBotIdx ].vclDuckTimer.fboTimedOut( ) 
						&&
					// never duck at same time when we are pressing the trigger;
					fboButtonIsOff( pinButtons, cinBtnAttack1  
						&&
					!vboHoldStill )
				)
			{
				if ( vstBotStatus[ vinBotIdx ].vflDistance > 800 )
				{
					// always duck at this range;
					vstBotStatus[ vinBotIdx ].vboActionDuck = true;
					vstBotStatus[ vinBotIdx ].vclDuckTimer.fvoStart( 
						vstBotStatus[ vinBotIdx ].vclLastTargetTimer.fflTimeLeft( ) + 0.5  );
				}
				else
				// select: duck or stand 
				if ( random( 4 ) != 0 )
				{ // duck
					vstBotStatus[ vinBotIdx ].vboActionDuck = true;
					vstBotStatus[ vinBotIdx ].vclDuckTimer.fvoStart( 
						vstBotStatus[ vinBotIdx ].vclLastTargetTimer.fflTimeLeft( ) + 0.5  );
				}
				else
				{ // stand
					vstBotStatus[ vinBotIdx ].vboActionDuck = false;
					vstBotStatus[ vinBotIdx ].vclDuckTimer.fvoStart( 
						vstBotStatus[ vinBotIdx ].vclLastTargetTimer.fflTimeLeft( ) + 0.5  );
				}
			}

			if ( vstBotStatus[ vinBotIdx ].vclNoJumpTimer.fboTimedOut( ) )
			{ 
				// prevent jumping
				vstBotStatus[ vinBotIdx ].vboActionNoJump = true;
				vstBotStatus[ vinBotIdx ].vclNoJumpTimer.fvoStart( 
					vstBotStatus[ vinBotIdx ].vclLastTargetTimer.fflTimeLeft( ) + 0.5 );
			}

			if ( vboHoldStill ) 
			{
				// cannot move with scoped weapon or aim goes way off;
				if ( fboButtonIsOn( pinButtons, cinBtnDuck ) )
					vstBotStatus[ vinBotIdx ].vboActionDuck = true; // true = duck;
				else
					vstBotStatus[ vinBotIdx ].vboActionDuck = false; // false = do NOT duck;
				vstBotStatus[ vinBotIdx ].vclDuckTimer.fvoStart( cflHoldStillDelay );

				vstBotStatus[ vinBotIdx ].vboActionNoJump = true; // true = do NOT jump;
				vstBotStatus[ vinBotIdx ].vclNoJumpTimer.fvoStart( cflHoldStillDelay + 1.0 );
				vstBotStatus[ vinBotIdx ].vboActionNoMove = true;
				vstBotStatus[ vinBotIdx ].vclNoMoveTimer.fvoStart( cflHoldStillDelay );
			}

		} // if ( !vboIgnoreBotMovement )

	} // if (  vstBotStatus[ vinBotIdx ].fboIsTargeting( ) )

	if ( vstBotStatus[ vinBotIdx ].vboActionDuck 
			&& 
		  !vstBotStatus[ vinBotIdx ].vclDuckTimer.fboTimedOut( ) 
		)
	{
		fvoSetButtonOn( pinButtons, cinBtnDuck );	
	}	
	else
	if ( !vstBotStatus[ vinBotIdx ].vboActionDuck 
				&& 
		  !vstBotStatus[ vinBotIdx ].vclDuckTimer.fboTimedOut( ) 
		)
	{
		fvoSetButtonOff( pinButtons, cinBtnDuck );	
	}	

	if ( vstBotStatus[ vinBotIdx ].vboActionNoJump 
			  && 
		  !vstBotStatus[ vinBotIdx ].vclNoJumpTimer.fboTimedOut( ) 
		)
	{
		// stop jumping
		fvoSetButtonOff( pinButtons, cinBtnJump );
	}

	if ( vstBotStatus[ vinBotIdx ].vboActionNoMove 
				&& 
		  !vstBotStatus[ vinBotIdx ].vclNoMoveTimer.fboTimedOut( ) 
		)
	{
		// cannot move with scoped weapon or aim goes way off;
		forwardmove = 0.0;
		sidemove = 0.0;
      // pst_ptrEdict->v.maxspeed = 0;
		fvoSetButtonOff( pinButtons, 
			cinBtnForward | cinBtnBack | cinBtnLeft | cinBtnRight | 
			cinBtnMoveLeft | cinBtnMoveRight | cinBtnRun | cinBtnAlt1 |
			cinBtnDuck | cinBtnJump );
	}

	if ( fboSilentWalkIsOn( ) && fboButtonIsOn( pinButtons, cinBtnDuck ) 
//!!.b - removed disengage of silent walk when bots jump
//				&& 
//		  ( fboButtonIsOn( pinButtons, cinBtnJump ) 
//				|| 
//			 fboButtonIsOn( pinButtons, cinBtnDuck ) 
//		   ) 
//!!.e
		)
	{
		fvoBotWalkStop_Force( 
			pst_ptrEdict, vinBotIdx, finRandom( vinBotFightTimeMin, vinBotFightTimeMax ) );
	}

	if ( !vstBotStatus[ vinBotIdx ].vboActionBurstFire )
	{
		vstBotStatus[ vinBotIdx ].vboIgnoreBotMovement = false;
	}
	vstBotStatus[ vinBotIdx ].vboHasTarget = false;

	#ifdef defDebug_Bombing
	if ( vstBotStatus[ vinBotIdx ].vboPlantBomb )
	{
		if ( fboButtonIsOn( pinButtons, cinBtnAttack1 ) )
		{
			fvoDebugBot_Bombing( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) I am pressing the fire button to plant the bomb." );
		}
		else		
		{
			fvoDebugBot_Bombing( pst_ptrEdict, "(tclBotControl::fvoModifyPlayerMove) I am NOT pressing the fire button to plant the bomb." );
		}
	}
	#endif

	return;

} // tclBotControl::fvoModifyPlayerMove

void tclBotControl::fvoPODFixHostage( edict_t *pst_ptrEdict )
{
	// execute only if POD bot is loaded and POD fixes are enabled;
	if ( !fboPODHostageFixIsOn( ) || pst_ptrEdict == NULL )
		return;

   if ( strcmp( STRING( pst_ptrEdict->v.classname ), "hostage_entity") == 0 )
   {
      pst_ptrEdict->v.health = 0x0FFFFFFF; // max out the hostage life points
      pst_ptrEdict->v.max_health = 0x0FFFFFFF;
   }

} // tclBotControl::fvoPODFixHostage

void tclBotControl::fvoPODFixHostage( TraceResult *pst_ptrTR )
{
	// execute only if POD bot is loaded and POD fixes are enabled;
	if ( !fboPODHostageFixIsOn( ) || pst_ptrTR == NULL )
		return;

	if ( pst_ptrTR->pHit == NULL )
		return;

	// check to see if a hostage was hit	
	if ( strcmp( STRING ( pst_ptrTR->pHit->v.classname ), "hostage_entity" ) == 0 )
   {
      pst_ptrTR->flFraction = 1.0; // pass through the hostage, disallowing damage for it
   }

} // tclBotControl::fvoPODFixHostage

//
// examples showing proper use of engine function hooks
//

/*

void pfnRunPlayerMove_ENG( 
	edict_t *fakeclient, const float *viewangles, float forwardmove, 
	float sidemove, float upmove, unsigned short buttons, byte impulse, 
	byte msec )
{

	vclBotControl.finControlBot( fakeclient );
	vclBotControl.fvoModifyPlayerMove( fakeclient, buttons, forwardmove, sidemove );
	
	(*vstENGFuncsOrig.pfnRunPlayerMove)( 
		fakeclient, viewangles, forwardmove, sidemove, upmove, buttons, impulse, msec );

} // pfnRunPlayerMove_ENG

*/

/*
float fflExpFunc( float p_Val )
{

	p_Val = p_Val - 27;

	if ( p_Val > 27 ) then
		return 0.999999999;
	else
	if ( p_Val < -27 ) then
		return 0.000000001;
	else
		return ( 1 / ( 1 + exp( -p_Val ) ) );

}

float fflSpeedFactor( float p_Deviation )
{
	
	float vflDev = abs( p_Deviation );

	if ( vflDev > 100 )
		vflDev = 100;

	return = 1/(1+exp( vflDev / 2 ) );
}

*/

int tclBotControl::finIfBotGetPlayerIdx( edict_t* pst_ptrEdict )
{
	if ( pst_ptrEdict == NULL )
		return -1; 

	if ( !vclPlayer.fboPlayerIsBotByEdict( pst_ptrEdict ) )
		return -1;

	int vinIdx = finGetIndexOfEdict( pst_ptrEdict );

	if ( vinIdx < cinMinPlayers || vinIdx > vclGlobalGameInfo.finGetMaxPlayers( ) )
	{
		// This is an error condition;
		vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::finControlBot): Invalid Edict Index (" + ftxIntToString( vinIdx ) + ")" );
		return -1;
	}

	// scale to zero based array index;
	vinIdx--;
	return vinIdx; 

} // tclBotControl::finIfBotGetPlayerIdx

float tclBotControl::fflBotChangePitch( edict_t *pEdict, float speed )
{
   float ideal;
   float current;
   float current_180;  // current +/- 180 degrees
   float diff;

   // turn from the current v_angle pitch to the idealpitch by selecting
   // the quickest way to turn to face that direction
   
   current = pEdict->v.v_angle.x;

   ideal = pEdict->v.idealpitch;

   // find the difference in the current and ideal angle
   diff = abs(current - ideal);

   // check if the bot is already facing the idealpitch direction...
   if (diff <= 1)
      return diff;  // return number of degrees turned

   // check if difference is less than the max degrees per turn
   if (diff < speed)
      speed = diff;  // just need to turn a little bit (less than max)

   // here we have four cases, both angle positive, one positive and
   // the other negative, one negative and the other positive, or
   // both negative.  handle each case separately...

   if ((current >= 0) && (ideal >= 0))  // both positive
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }
   else if ((current >= 0) && (ideal < 0))
   {
      current_180 = current - 180;

      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else if ((current < 0) && (ideal >= 0))
   {
      current_180 = current + 180;
      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else  // (current < 0) && (ideal < 0)  both negative
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }

   // check for wrap around of angle...
   if (current > 180)
      current -= 360;
   if (current < -180)
      current += 360;

   pEdict->v.v_angle.x = current;

   return speed;  // return number of degrees turned
} // tclBotControl::fflBotChangePitch

float tclBotControl::fflBotChangeYaw( edict_t *pEdict, float speed )
{
   float ideal;
   float current;
   float current_180;  // current +/- 180 degrees
   float diff;

   // turn from the current v_angle yaw to the ideal_yaw by selecting
   // the quickest way to turn to face that direction
   
   current = pEdict->v.v_angle.y;

   ideal = pEdict->v.ideal_yaw;

   // find the difference in the current and ideal angle
   diff = abs(current - ideal);

   // check if the bot is already facing the ideal_yaw direction...
   if (diff <= 1)
      return diff;  // return number of degrees turned

   // check if difference is less than the max degrees per turn
   if (diff < speed)
      speed = diff;  // just need to turn a little bit (less than max)

   // here we have four cases, both angle positive, one positive and
   // the other negative, one negative and the other positive, or
   // both negative.  handle each case separately...

   if ((current >= 0) && (ideal >= 0))  // both positive
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }
   else if ((current >= 0) && (ideal < 0))
   {
      current_180 = current - 180;

      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else if ((current < 0) && (ideal >= 0))
   {
      current_180 = current + 180;
      if (current_180 > ideal)
         current += speed;
      else
         current -= speed;
   }
   else  // (current < 0) && (ideal < 0)  both negative
   {
      if (current > ideal)
         current -= speed;
      else
         current += speed;
   }

   // check for wrap around of angle...
   if (current > 180)
      current -= 360;
   if (current < -180)
      current += 360;

   pEdict->v.v_angle.y = current;

   return speed;  // return number of degrees turned

} // tclBotControl::fflBotChangeYaw

bool tclBotControl::fboPlayerIsHit( TraceResult *pst_ptrTR )
{
	// execute only if POD bot is loaded and POD fixes are enabled;
	if ( pst_ptrTR == NULL )
		return false;

	if ( pst_ptrTR->pHit == NULL )
		return false;

	// check to see if a hostage was hit	
	if ( strcmp( STRING ( pst_ptrTR->pHit->v.classname ), "player" ) == 0 )
   {
      return true;
   }

	return false;

} // tclBotControl::fvoPlayerIsHit

Vector tclBotControl::fclBotBodyTarget( edict_t *pBotEnemy, int pinBoneIndex )
{
   Vector vclTarget;
	Vector vclTarget_Head;

 	// VERY GOOD, same as from CBasePlayer::BodyTarget (in player.h)

	pinBoneIndex = -1; //; PLAYERBONE_NECK;

	if ( pinBoneIndex < 0 )
	{
		#ifdef defDebug_BoneIndex
		fvoDebugBot_BoneIndex( pBotEnemy, "(tclBotControl::fclBotBodyTarget) <- Targeting without bone index." );
		#endif
		// aim randomly at a point somewhere around the torso to head position;
		// vclTarget = pBotEnemy->v.origin + pBotEnemy->v.view_ofs * RANDOM_FLOAT( 0.5, 1.1 );
		vclTarget = pBotEnemy->v.origin + pBotEnemy->v.view_ofs;
	}
	else
	{
		// aim exactly at the specified bone!
		Vector v_angles;
		fvoGetBonePosition( pBotEnemy, pinBoneIndex, vclTarget, v_angles );
		
		#ifdef defDebug_BoneIndex
		fvoGetBonePosition( pBotEnemy, PLAYERBONE_HEAD, vclTarget_Head, v_angles );
		fvoDebugBot_BoneIndex( pBotEnemy, "(tclBotControl::fclBotBodyTarget) <- Targeting with bone index: " + ftxIntToString( pinBoneIndex ) );
		fvoDebugBot_BoneIndex( pBotEnemy, "(tclBotControl::fclBotBodyTarget) <- Target Body Origin       : " + ftxVectorToString( pBotEnemy->v.origin ) );
		fvoDebugBot_BoneIndex( pBotEnemy, "(tclBotControl::fclBotBodyTarget) <- Target Default Aim       : " + ftxVectorToString( pBotEnemy->v.origin + pBotEnemy->v.view_ofs ) );
		fvoDebugBot_BoneIndex( pBotEnemy, "(tclBotControl::fclBotBodyTarget) <- Target Bone Head Origin  : " + ftxVectorToString( vclTarget_Head ) );
		fvoDebugBot_BoneIndex( pBotEnemy, "(tclBotControl::fclBotBodyTarget) <- Target Bone Origin       : " + ftxVectorToString( vclTarget ) );
		#endif
		// vclTarget = vclTarget + pBotEnemy->v.view_ofs;

	}

	return vclTarget;

} // tclBotControl::fclBotBodyTarget

void tclBotControl::TraceLine_Bot( 
	const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr )
{

	int vinBotIdx;
	int vinSkill;

	// Is this a bot? If so then return bot index;
	vinBotIdx = finIfBotGetPlayerIdx( pentToSkip );
	
	if ( vinBotIdx < 0 ) 
	// not a bot;
		goto locDefault;

	if ( !vstBotStatus[ vinBotIdx ].fboIsTargeting( ) )
		goto locDefault;

	// prevent targeting update since we are already targeting;

//	vinBotIdx = -1; 

	vinSkill = vclBot.finGetBotSkill_Fixed( );
	if ( vinSkill != cinSkillInsane )
		goto locDefault;

	locPreciseAim:	
	(*vstENGFuncsOrig.pfnTraceLine)
		( pentToSkip->v.origin + pentToSkip->v.view_ofs,
		  pentToSkip->v.origin + pentToSkip->v.view_ofs + gpGlobals->v_forward * 9999,
		  fNoMonsters, pentToSkip, ptr );

	goto locChecks;

	locDefault:
	(*vstENGFuncsOrig.pfnTraceLine)( v1, v2, fNoMonsters, pentToSkip, ptr );

//!!.begin	not needed?
//!!	if ( vinBotIdx >= 0 )
//!!		fvoUpdateBotTarget( pentToSkip, ptr, vinBotIdx );	
//!!.end

	locChecks:
	// POD Fix check;
	vclBotControl.fvoPODFixHostage( ptr );	
	vclPlayer.fvoCheckHeadShotMode( ptr );

} // tclBotControl::TraceLine_Bot

bool fboFInViewCone( int pinBotIdx, Vector *pOrigin, edict_t *pEdict )
{
   Vector2D vec2LOS;
   float    flDot;

   fvoMakeVectors( pEdict->v.angles );

   vec2LOS = ( *pOrigin - pEdict->v.origin ).Make2D( );
   vec2LOS = vec2LOS.Normalize( );

   flDot = DotProduct( vec2LOS , gpGlobals->v_forward.Make2D( ) );

//m_flFieldOfView
//0.9; // +-  25 degrees
//0.5; // +-  60 degrees
//0.0; // +- 180 degrees
//!!!!!!!!!!!

	if ( vclBot.finGetBotSkill_Fixed( ) == cinSkillInsane )
		return true;

	if ( vclBotControl.vstBotStatus[ pinBotIdx ].vinBotSkill >= 90  )
	{
      return true;
	}
	else
	if ( flDot >= vclBotControl.vflFieldOfView )  
      return true;

   return false;

} // fboFInViewCone

char vch_aryQuickScan[ 10 ] = 
	{	PLAYERBONE_HEAD, 
		PLAYERBONE_PELVIS, 
		PLAYERBONE_L_CLAVICLE, 
		PLAYERBONE_R_CLAVICLE, 
		PLAYERBONE_L_FOREARM, 
		PLAYERBONE_R_FOREARM,
		PLAYERBONE_L_FOOT, 
		PLAYERBONE_R_FOOT,
		PLAYERBONE_L_HAND,
		PLAYERBONE_R_HAND };

char vch_aryFullScan[ 29 ] = 
	{	PLAYERBONE_PELVIS,
		PLAYERBONE_SPINE,
		PLAYERBONE_SPINE1,
		PLAYERBONE_SPINE2,
		PLAYERBONE_SPINE3,
		PLAYERBONE_NECK,
		PLAYERBONE_HEAD,
		PLAYERBONE_L_CLAVICLE,
		PLAYERBONE_L_UPPERARM,
		PLAYERBONE_L_FOREARM,
		PLAYERBONE_L_HAND,
		PLAYERBONE_L_FINGER0,
		PLAYERBONE_L_FINGER01,
		PLAYERBONE_L_FINGER1,
		PLAYERBONE_L_FINGER11,
		PLAYERBONE_L_THIGH,
		PLAYERBONE_L_CALF,
		PLAYERBONE_L_FOOT,
		PLAYERBONE_R_CLAVICLE,
		PLAYERBONE_R_UPPERARM,
		PLAYERBONE_R_FOREARM,
		PLAYERBONE_R_HAND,
		PLAYERBONE_R_FINGER0,
		PLAYERBONE_R_FINGER01,
		PLAYERBONE_R_FINGER1,
		PLAYERBONE_R_FINGER11,
		PLAYERBONE_R_THIGH,
		PLAYERBONE_R_CALF,
		PLAYERBONE_R_FOOT };

bool tclBotControl::fboPlayerIsVisible_Quick
( int pinBotIdx, edict_t *pSource, edict_t *pPlayer, int &pinBoneIndex, Vector &pclOrigin )
{       
	Vector v_origin;
	Vector v_angles;       
	Vector v_src;       
	TraceResult tr;        
	int iBoneIndex;       
	int iNumBones;        
	bool bVisible;  
	
	v_src = vflGetGunPosition( pSource ); 

	// Get View Pos        
	iBoneIndex = 0;       
	iNumBones = sizeof( vch_aryQuickScan );
	// Get Amount of Bones        
	bVisible = false;  
	pinBoneIndex = -1;	

	while ( ( iBoneIndex < iNumBones ) && !bVisible ) 
	{             
		fvoGetBonePosition( pPlayer, vch_aryQuickScan[ iBoneIndex ], v_origin, v_angles );              
		if ( fboFInViewCone( pinBotIdx, &v_origin, pSource ) ) 
		{                   
			fvoTraceLine( v_src, v_origin, ignore_monsters, ignore_glass, NULL, &tr );  
			bVisible = tr.flFraction >= 1.0;   
			if ( bVisible )
			{
				pinBoneIndex = vch_aryQuickScan[ iBoneIndex ];
				pclOrigin = v_origin;
			}
		}          
		
		iBoneIndex++;       
	}        
	
	return bVisible;

} // tclBotControl::fboPlayerIsVisible_Quick

bool tclBotControl::fboPlayerIsVisible_Quick( int pinBotIdx, edict_t *pSource, edict_t *pPlayer, int &pinBoneIndex )
{
	Vector vclOrigin;
	return fboPlayerIsVisible_Quick( pinBotIdx, pSource, pPlayer, pinBoneIndex, vclOrigin );
} // tclBotControl::fboPlayerIsVisible_Quick

void tclBotControl::fvoSetBotSkill( int pinSkillMin, int pinSkillMax, int pinIdx )
{
	if ( pinIdx == 0 )
	{
		for ( int vinIdx = 0; vinIdx < cinMaxPlayers; vinIdx++ )
		{
			vstBotStatus[ vinIdx ].vinBotSkill = finRandom( pinSkillMin, pinSkillMax );
		}
	}
	else
	if ( ( pinIdx >= 0 ) && ( pinIdx <= cinMaxPlayerIndex ) )
	{
		vstBotStatus[ pinIdx ].vinBotSkill = finRandom( pinSkillMin, pinSkillMax );
	}

} // tclBotControl::fvoSetBotSkill

int tclBotControl::finGetBotSkillByUserIndex( int pinUserIdx )
{
	int vinBotIdx = pinUserIdx - 1;
	if ( ( vinBotIdx < 0 ) || ( vinBotIdx > cinMaxPlayerIndex - 1 ) )
	{
		return -1;
	}

	return vstBotStatus[ vinBotIdx ].vinBotSkill;

} // tclBotControl::finGetBotSkillByUserIndex

/*
void tclBotControl::fvoSetMaxSpeed( float pflMaxSpeed, int pinBotIdx )
{
	if ( ( pinBotIdx < 0 ) || ( pinBotIdx > cinMaxPlayerIndex - 1 ) )
	{
		// This is an error condition;
		vclDebugTrace.fvoWriteEventInfo( "ERROR (tclBotControl::fvoSetMaxSpeed): Invalid Bot Index (" + ftxIntToString( pinBotIdx ) + ")" );
		return;
	}

	vstBotStatus[ pinBotIdx ].fvoSetMaxSpeed( pflMaxSpeed );
} // tclBotControl::fvoSetMaxSpeed
*/

bool fboPlayerIsVisible_Full
( int pinBotIdx, edict_t *pSource, edict_t *pPlayer, int &pinBoneIndex, Vector &pclOrigin )
{       
	Vector v_origin;
	Vector v_angles;       
	Vector v_src;       
	TraceResult tr;        
	int iBoneIndex;       
	int iNumBones;        
	bool bVisible;  
	
	v_src = vflGetGunPosition( pSource ); 

	// Get View Pos        
	iBoneIndex = 0;       
	iNumBones = sizeof( vch_aryFullScan );
	// Get Amount of Bones        
	bVisible = false;  
	pinBoneIndex = -1;
	while ( ( iBoneIndex < iNumBones ) && !bVisible ) 
	{             
		fvoGetBonePosition( pPlayer, vch_aryFullScan[ iBoneIndex ], v_origin, v_angles );              
		if ( fboFInViewCone( pinBotIdx, &v_origin, pSource ) ) 
		{                   
			fvoTraceLine( v_src, v_origin, ignore_monsters, ignore_glass, NULL, &tr );  
			bVisible = tr.flFraction >= 1.0;   
			if ( bVisible )
			{
				pinBoneIndex = vch_aryFullScan[ iBoneIndex ];
				pclOrigin = v_origin;
			}
		}          
		
		iBoneIndex++;       
	}        
	
	return bVisible;

} // fboPlayerIsVisible_Full

void fvoBotMoneyMsg_End( void* pclMessage )
{

/*
Message_Begin
...MessageType: 102
...MessageDest: 1
...Entity Origin x : 3424.00
...Entity Origin y : 128.00
...Entity Origin z : -251.97
...Entity Name     : (mEAn)The Tick6
0...WriteLong       : 12440 <= amount of money 
1...WriteByte       : 1 <= unknown flag
Message_End
*/

	edict_t* vst_ptrEdict;
	vst_ptrEdict  = static_cast<tclMessage*>(pclMessage)->vst_ptrEdict;
	int vinBotIdx = vclBotControl.finIfBotGetPlayerIdx( vst_ptrEdict );

	if ( vinBotIdx < 0 )
	// not a bot;
		return;

	vclBotControl.vstBotStatus[ vinBotIdx ].vinMoney = 
		static_cast<tclMessage*>(pclMessage)->vst_aryValueList[ 0 ].vinInt;

} // fvoBotMoneyMsg_End

void fvoMsgScreenFade_End( void* pclMessage )
{

/*
Message_Begin
...MessageType: 98
...MessageDest: 1
...Entity Origin x : -166.18
...Entity Origin y : -1692.75
...Entity Origin z : 100.03
...Entity Name     : (mEAn)botmeister
0...WriteShort      : 40462 <= unknown
1...WriteShort      : 8991  <= unknown
2...WriteShort      : 0     <= unknown
3...WriteByte       : 255   <= red
4...WriteByte       : 255   <= green
5...WriteByte       : 255   <= blue
6...WriteByte       : 255   <= alpha
Message_End
*/

	edict_t* vst_ptrEdict;
	vst_ptrEdict  = static_cast<tclMessage*>(pclMessage)->vst_ptrEdict;
	int vinBotIdx = vclBotControl.finIfBotGetPlayerIdx( vst_ptrEdict );

	if ( vinBotIdx < 0 )
	// not a bot;
		return;

	int vflR = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[ 3 ].vinInt;
	int vflG = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[ 4 ].vinInt;
	int vflB = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[ 5 ].vinInt;
	int vflA = static_cast<tclMessage*>(pclMessage)->vst_aryValueList[ 6 ].vinInt;

//	if ( ( vflR == 255 ) && ( vflG == 255 ) && ( vflB == 255 ) && ( vflA > 200 ) )
	if ( ( vflR == 255 ) && ( vflG == 255 ) && ( vflB == 255 ) && ( vflA > 150 ) )
	{
//		float vflBlind = ( ( float ) vflA - 200.0 ) / 15;
		float vflBlind = ( ( float ) vflA - 150.0 ) / 20;
		// add to previous flash if any;
		vflBlind = vclBotControl.vstBotStatus[ vinBotIdx ].vclFlashedTimer.fflTimeLeft( ) + vflBlind;
		vclBotControl.vstBotStatus[ vinBotIdx ].vclFlashedTimer.fvoStart( vflBlind ); 
	}

} // fvoMsgScreenFade_End

