//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Configs.cpp
//	
//	[MEAN] Config File load class definitions.
//
//.e	

#include "MB_Includes.h"	
//#include "MA_GlobalVars.h"
//#include "MI_Util.h"
#include "MA_Configs.h"
#include "MA_EngDLLCmd.h"
#include "MG_Lib.h"
#include "MA_Player.h"
#include "MA_Bot.h"

//#include <iostream.h>
#include <fstream.h>

	tclCmdLine::tclCmdLine( )
	{
		vtxCmd = "";
		vinForTeam  = cinForTeam_Any;
		vinTeam	   = cinTeam_Any;
		vcl_ptrNext = NULL;
	} // tclCmdLine::tclCmdLine

	tclConfigFile::tclConfigFile( )
	{
		vinLineCount = 0;
		vcl_ptrCur   = NULL;
		vcl_ptrFirst = NULL;
		vcl_ptrLast  = NULL;
		vcl_ptrTemp  = NULL;

	} // tclConfigFile::tclConfigFile

	tclConfigFile::~tclConfigFile( )
	{
		fvoDestroyList( );
	} // tclConfigFile::tclConfigFile

	void tclConfigFile::fvoDestroyList( )
	{
		vcl_ptrCur = vcl_ptrFirst;
		while ( vcl_ptrCur != NULL )
		{
			vcl_ptrTemp = vcl_ptrCur;
			vcl_ptrCur = vcl_ptrCur->vcl_ptrNext;
			delete vcl_ptrTemp;
		}
		
		vcl_ptrFirst	= NULL;
		vcl_ptrLast		= NULL;
		vcl_ptrTemp		= NULL;
		vinLineCount	= 0;

	} // tclConfigFile::fvoDestroyList

	bool tclConfigFile::fboCmdLineIsValid( string ptxMsgLine, tclCmdLine* pcl_ptrTextLine )
	{
		if ( pcl_ptrTextLine == NULL )
			return false;

		// do nothing for now; later on check maximum line length and look for
		// illegal characters;

		pcl_ptrTextLine->vtxCmd = ptxMsgLine;
		return true;
	} // tclConfigFile::fboCmdLineIsValid

	bool tclConfigFile::fboLoadList( )
	{
		fvoDestroyList( );

		string vtxMsg;

		if ( !( fboFileExists( vtxFilePathName ) 
			        && 
			     fboFileCanBeRead( vtxFilePathName ) )  
			)
		{
			if ( vtxNotFoundMsg.empty( ) )
			{
				vtxNotFoundMsg = "The config file " + vtxFilePathName + " was not found.";
			}

			fvoServerPrint_nl( vtxNotFoundMsg );
			vclDebugTrace.fvoWriteEventInfo( vtxNotFoundMsg );
			return false;
		} 

		vtxMsg  = ctxMsgPrefix + "Loading configuration file:\n  " + vtxFilePathName;
		fvoServerPrint_nl( vtxMsg );
		vclDebugTrace.fvoWriteEventInfo( vtxMsg );

		FILE* vna_ptrFile;
		char vch_aryMsgLine[ 255 ];

		vna_ptrFile = fopen( vtxFilePathName.c_str( ), "r" );

		if ( vna_ptrFile == NULL )
		{
			vtxMsg  = "** ERROR: cannot open " + vtxFilePathName + " \n";;
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoServerPrint_nl( vtxMsg );
			vclDebugTrace.fvoWriteEventInfo( vtxMsg );
			return false;
		}

		vcl_ptrCur = NULL;
		tclCmdLine* vcl_ptrTextLine_New;
		vinLineCount = 0;
		string vtxMsgLine;

		while	( fgets( vch_aryMsgLine, 255, vna_ptrFile ) != NULL ) 
		{
			vtxMsgLine = vch_aryMsgLine;
			vtxMsgLine = ftxTrim( vtxMsgLine );

			if ( vtxMsgLine.empty( ) )
				continue;

			if ( vtxMsgLine[ 0 ] == ';' )
				continue;

			vcl_ptrTextLine_New = new tclCmdLine;

			if ( !fboCmdLineIsValid( vtxMsgLine, vcl_ptrTextLine_New ) )
			{
				delete vcl_ptrTextLine_New;
				vtxMsg  = "** WARNING: Configuration command line not valid! \n  " + vtxMsgLine;
				fvoServerPrint_nl( vtxMsg );
				vclDebugTrace.fvoWriteEventInfo( vtxMsg);
				continue;
			}

			if ( vcl_ptrFirst == NULL )
				vcl_ptrFirst = vcl_ptrTextLine_New;
			
			if ( vcl_ptrLast == NULL )
				vcl_ptrLast = vcl_ptrTextLine_New;	
			else
			{
				vcl_ptrLast->vcl_ptrNext = vcl_ptrTextLine_New;
				vcl_ptrLast = vcl_ptrTextLine_New;
			}	

			vinLineCount = ++vinLineCount;
//.begin for debugging only
//			vtxMsg  = "  Loaded: " + vtxMsgLine;
//			fvoServerPrint_nl( vtxMsg );
//			vclDebugTrace.fvoWriteEventInfo( vtxMsg );
//.end
		}

		fclose( vna_ptrFile );

		vtxMsg  = ctxMsgPrefix + "Configuration file load completed.";		
		fvoServerPrint_nl( vtxMsg );
		vclDebugTrace.fvoWriteEventInfo( vtxMsg );
		
		return true;

	} // tclConfigFile::fboLoadList

	void tclConfigFile::fvoExecuteCommands( )
	{
		#define cinCommon       0
		#define cinBotTeam_CT   1
		#define cinBotTeam_TE   2
		#define cinBotTeam_Any  3
		#define cinClanTeam_CT  4
		#define cinClanTeam_TE  5
		#define cinClanTeam_Any 6

		vcl_ptrCur = vcl_ptrFirst;

		if ( vcl_ptrCur == NULL )
			return;
		
		int vinBotTeam = vclBot.finGetBotTeam( );
		int vinClanTeam = vclPlayer.finGetClanTeam( );
		int vinCmdFor = cinCommon;
		string vtxMsg;
		fvoServerPrint_nl( "The following commands will be executed: " );

		vflLastDelay = vflDelayInSec;

		while ( vcl_ptrCur != NULL )
		{
//			if ( vcl_ptrCur->vtxCmd == "[random]" )		{ vinCmdFor = cinRandom; goto locNextCmd; }
			if ( vcl_ptrCur->vtxCmd == "[common]" )		{ vinCmdFor = cinCommon; goto locNextCmd; }
			if ( vcl_ptrCur->vtxCmd == "[botteam_ct]" )	{ vinCmdFor = cinBotTeam_CT; goto locNextCmd; }
			if ( vcl_ptrCur->vtxCmd == "[botteam_te]" )	{ vinCmdFor = cinBotTeam_TE; goto locNextCmd; }
			if ( vcl_ptrCur->vtxCmd == "[botteam_any]" )	{ vinCmdFor = cinBotTeam_Any; goto locNextCmd; }
			if ( vcl_ptrCur->vtxCmd == "[clanteam_ct]" )	{ vinCmdFor = cinClanTeam_CT; goto locNextCmd; }
			if ( vcl_ptrCur->vtxCmd == "[clanteam_te]" )	{ vinCmdFor = cinClanTeam_TE; goto locNextCmd; }
			if ( vcl_ptrCur->vtxCmd == "[clanteam_any]" ){ vinCmdFor = cinClanTeam_Any; goto locNextCmd; }

			if ( vinCmdFor != cinCommon )
			{
//				if ( vinCmdFor == cinMapId ) 
//				{ 
//					if ( vcl_ptrCur->vtxCmd == )
//					{
//					}
//				}
//				else
				if ( vinCmdFor == cinBotTeam_CT ) 
				{ 
					if ( vinBotTeam == cinTeam_CT ) 
						goto locRunCmd;
					else // skip
						goto locNextCmd;
				}
				else
				if ( vinCmdFor == cinBotTeam_TE ) 
				{ 
					if ( vinBotTeam == cinTeam_TE ) 
						goto locRunCmd;
					else // skip
						goto locNextCmd;
				}
				else
				if ( vinCmdFor == cinBotTeam_Any ) 
				{ 
					if ( vinBotTeam == cinTeam_Any ) 
						goto locRunCmd;
					else // skip
						goto locNextCmd;
				}
				else
				if ( vinCmdFor == cinClanTeam_CT ) 
				{ 
					if ( vinClanTeam == cinTeam_CT ) 
						goto locRunCmd;
					else // skip
						goto locNextCmd;
				}
				else
				if ( vinCmdFor == cinClanTeam_TE ) 
				{ 
					if ( vinClanTeam == cinTeam_TE ) 
						goto locRunCmd;
					else // skip
						goto locNextCmd;
				}
				else
				if ( vinCmdFor == cinClanTeam_Any ) 
				{ 
					if ( vinClanTeam == cinTeam_Any ) 
						goto locRunCmd;
					else // skip
						goto locNextCmd;
				}
				else
				{ // this is an error condition;
					vtxMsg = ctxMsgPrefix + "An unrecognized command section header was found: " + ftxIntToString( vinCmdFor );
					fvoServerPrint_nl( vtxMsg );
					vclDebugTrace.fvoWriteEventInfo( vtxMsg );
					goto locNextCmd;
				}
			}

			locRunCmd:
				fvoServerPrint_nl( "   " + vcl_ptrCur->vtxCmd );
				fvoServerCommand_nlDELAYED( vflLastDelay, vcl_ptrCur->vtxCmd );
				vflLastDelay = vflLastDelay + vflDelayInSec;

			locNextCmd:
				vcl_ptrCur = vcl_ptrCur->vcl_ptrNext;
		}
	} // tclConfigFile::fvoExecuteCommands

	void tclConfigFile::fvoRunConfigFile( 
		string ptxFilePathName, 
		string ptxNotFoundMessage,  
		float pflDelayInSec )
	{
		vflLastDelay	 = 0;
		vflDelayInSec	 = pflDelayInSec;
		vtxFilePathName = ptxFilePathName;

//		vtxFilePathName = ctxGameSubFolder + "\\" + ctxMEANFolder + "\\" + ctxGameModeFolder + "\\" + vtxFileName + ".cfg";

		vtxNotFoundMsg  = ptxNotFoundMessage;

		if ( !fboLoadList( ) )
			return;

		fvoExecuteCommands( );

	} // tclConfigFile::fvoRunConfigFile

	tclConfigFile vclConfigFile;
