//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_EngDLLCmd.h
//	
//	[MEAN] Interface Wrapper for commonly used Engine/DLL Commands.
//
//.e	

//.b skip over if header has already been included.
#ifndef defMA_EngDLLCmd_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
	#define defMA_EngDLLCmd_h

	// Include all general definition files.
	#include "MB_Includes.h"
	#include "MI_util.h"

	// all server messages will be prefixed by this common identifier;
	//!!.begin - these constants should go into a "common" module used by all modules;
	const string ctxMsgPrefix = "(mEAn) ";
	const string ctxVersion = "5.50.13";
	const string ctxBuild = "20040408.01";
	//!!.end

//   #define def_FAKE_CLIENT_BIT FL_FAKECLIENT
	#define def_FAKE_CLIENT_BIT FL_MONSTER


	// tydef for general server command function.
		typedef void (*tfn_ptrServerCmd) (void);

	void fvoServerPrint( string ptxMsg );
	void fvoServerPrint_nl( string ptxMsg );
	void fvoClientPrintNotify( edict_t* pst_ptrEdict, string ptxMsg );
	void fvoClientPrintConsole( edict_t* pst_ptrEdict, string ptxMsg );
	void fvoClientPrintConsole_nl( edict_t* pst_ptrEdict, string ptxMsg );
	void fvoClientPrintChat( edict_t* pst_ptrEdict, string ptxMsg );
	void fvoClientPrintCenter( edict_t* pst_ptrEdict, string ptxMsg );
	void fvoClientPrintNotifyAll( string msg_name );
	void fvoClientPrintConsoleAll( string msg_name );
	void fvoClientPrintChatAll( string msg_name );
	void fvoClientPrintCenterAll( string msg_name );
	void fvoConsolePrint( edict_t* pst_ptrEdict, string ptxMsg );
	void fvoConsolePrint_nl( edict_t* pst_ptrEdict, string ptxMsg );
	void fvoServerCommand( string ptxServerCmd );
	void fvoServerCommand_nl( string ptxServerCmd );
	void fvoServerCommandDELAYED( float pflDelayInSec, string ptxServerCmd );
	void fvoServerCommand_nlDELAYED( float pflDelayInSec, string ptxServerCmd );
	char* fch_ptrGetInfoKeyBuffer( edict_t* pst_ptrEdict );
	string ftxGetInfoKeyValue( char* pch_ptrInfoBuffer, string ptxKey );
	string ftxGetEdictKeyValue ( edict_t* pst_ptrEdict, string ptxKey );
	string ftxGetServerKeyValue ( string ptxKey );
	bool fboSetClientKeyValue ( edict_t* pst_ptrEdict, string ptxKey, string ptxKeyValue );
	void fvoEmitSoundFromPlayer ( edict_t* pst_ptrEdict, int pinChannel, string ptxSoundFile );
	void fvoKillPlayer( edict_t* pst_ptrEdict, string vtxReason );
	float fflRandomFloat( float pflLow, float pflHigh );
	string ftxCVarGetString( string ptxCVarName );
	void fvoCVarSetString( string ptxCVarName, string ptxValue );
	float fflCVarGetFloat( string ptxCVarName );
	float fflCVarGetFloat_Bounded( string ptxCVarName, float pflMin, float pflMax );
	void fvoCVarSetFloat( string ptxCVarName, float pflValue );
	long finCVarGetInt( string ptxCVarName );
	long finCVarGetInt_Bounded( string ptxCVarName, long pinMin, long pinMax );
	void fvoCVarSetInt( string ptxCVarName, long pinValue );
	bool fboCVarGetBool( string ptxCVarName );
	void fvoCVarSetBool( string ptxCVarName, bool pboValue );
	void fvoMessage_Begin( int pinMsgDest, int pinMsgType, const float* pfl_ptrOrigin, edict_t* pst_ptrEdict );
	void fvoMessage_End( void );
	void fvoMessage_WriteString( string ptxString );
	void fvoMessage_WriteByte( int pinByte );
	void fvoMessage_WriteChar( int pinChar );
	void fvoMessage_WriteShort( int pinShort );
	void fvoMessage_WriteLong( int pinLong );
	void fvoMessage_WriteAngle( float pflAngle );
	void fvoMessage_WriteCoord( float pflCoord );
	void fvoMessage_WriteEntity( int pinEntity );
	float fflGetEngineTime( void );
	void fvoExecClientCommand( edict_t *pEntity, string ptxCmd );
	void fvoExecClientCommandDELAYED( float pflDelayInSec, edict_t *pEntity, string ptxCmd );
	void fvoExecFakeClientCommand( edict_t *pEntity, string ptxArg1, string ptxArg2 = "", string ptxArg3 = "", string ptxArg4  = "" );
	void fvoExecFakeClientCommandDELAYED( float pflDelayInSec, edict_t *pEntity, string ptxArg1, string ptxArg2 = "", string ptxArg3 = "", string ptxArg4  = "" );
	bool fboIsMapValid( string ptxFileName );
	void fvoAddServerCommand( string ptxCmd, tfn_ptrServerCmd pfn_ptrServerCmd );
	int finGetCmdLineArgCount( void );
	string ftxGetCmdLineArgValue( int pinIdx );
	string ftxGetCmdLineString( void );
//	unsigned int finuGetPlayerWONId( edict_t* pst_ptrEdict );
//	string ftxGetPlayerWONId( edict_t* pst_ptrEdict );
	string ftxGetPlayerAuthId( edict_t* pst_ptrEdict );
	int finGetPlayerPing( edict_t* pst_ptrEdict );
	int finGetPlayerUserId( edict_t* pst_ptrEdict );
	string ftxGetPlayerUserId( edict_t* pst_ptrEdict );
	int finPrecacheSound( string ptxWavFile );
	int finPrecacheModel( string ptxModelFile );
	edict_t* fst_ptrGetEntityByIndex( int pinIndex );
	int finGetIndexOfEdict( const edict_t *pst_ptrEdict );
	void fvoMakeVectors( const float *pfl_ptrVector );
	float fflWrapAngle( float pAngle );
	Vector fstWrapAngles( Vector pAngles );
	int finGetNumBones( edict_t *pPlayer );
	void fvoGetBonePosition( const edict_t* pEdict, int iBone, float *rgflOrigin, float *rgflAngles );
	void fvoTraceLine( const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, IGNORE_GLASS ignoreGlass, edict_t *pentIgnore, TraceResult *ptr );

	bool fboButtonIsOn( unsigned short &pinButtons, unsigned short pinBit ){ return ( ( pinButtons & pinBit ) == pinBit ); };
	bool fboButtonIsOff( unsigned short &pinButtons, unsigned short pinBit ){ return !fboButtonIsOn( pinButtons, pinBit ); };
	void fvoSetButtonOn( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons |= pinBit; };
	void fvoSetButtonOff( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons &= ~pinBit; };
	bool fboSetButtonOn( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons |= pinBit; return true; };
	bool fboSetButtonOff( unsigned short &pinButtons, unsigned short pinBit ){ pinButtons &= ~pinBit;  return false; };

	void fvoRunPlayerMove( 
		edict_t *fakeclient, const float *viewangles, float forwardmove, 
		float sidemove, float upmove, unsigned short buttons, byte impulse, 
		byte msec );

	void fvoRunPlayerMove_DELAYED( 
		float pflDelayInSec, edict_t *fakeclient, const float *viewangles, float forwardmove, 
		float sidemove, float upmove, unsigned short buttons, byte impulse, 
		byte msec );

#endif //e. defMA_EngDLLCmd_h

