//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_GlobalVars.cpp
//	
//	[MEAN] Interface Wrapper for the Global Vars pointer.
//
//.e	

#include "MA_GlobalVars.h"

//	Create a pointer to the Engine's Global Variables.
// This pointer will be manipulated through the tclGlobalGameInfo class
// wrapper. Howevere, various utility functions from the HLSDK will 
// manipulate the pointer directly. This is why we are forced to use
// the name "gpGlobals".
	tst_prtENGGlobalVars gpGlobals;

// Since we are forced to use the name "gpGlobals" for the global
// vars structure, we define a more meaningfull name here for the
// wrapper class.
	#define vst_ptrENGGlobalVars gpGlobals
	
// This is the constructor.
	tclGlobalGameInfo::tclGlobalGameInfo 
		(void)
	{
		vst_ptrENGGlobalVars = NULL;
	}

//	Returns true if the global vars pointer is set.
	bool tclGlobalGameInfo::fboPtrIsSet
		(void)
	{
		return vst_ptrENGGlobalVars != NULL;
	}

//	Sets the global vars pointer value.
	void tclGlobalGameInfo::fvoSetPointer
		(tstENGGlobalVars *pst_ptrENGGlobalVars)
	{
		vst_ptrENGGlobalVars = pst_ptrENGGlobalVars;
	}

//	Gets the global vars pointer value.
	tstENGGlobalVars *tclGlobalGameInfo::fst_ptrGetPointer 
		(void)
	{
		return vst_ptrENGGlobalVars;
	}

//	Returns the maximum number of players that can connect to the game.
	int tclGlobalGameInfo::finGetMaxPlayers
		(void)
	{
		if (!fboPtrIsSet()){return 0;}

		return vst_ptrENGGlobalVars->maxClients;

	} // tclENGGlobalVars::finGetMaxPlayers

// Returns the number of players currently connected.
	int tclGlobalGameInfo::finGetCurPlayers
		(void)
	{
		if (!fboPtrIsSet()){return 0;}
		return 0;
	}

// Returns the current map name.
	string tclGlobalGameInfo::ftxGetMapName( void )
	{
		if ( !fboPtrIsSet( ) ) { return ""; }
		return ftxGetSring( vst_ptrENGGlobalVars->mapname );

	} // tclGlobalGameInfo::ftxGetMapName

// Returns the elapsed time on current map. 
	float tclGlobalGameInfo::fflGetElapsedTimeInSec
		(void)
	{
		if ( !fboPtrIsSet( ) ){ return 0; }
		float vflElapsedTime = vst_ptrENGGlobalVars->time;
		return vflElapsedTime;

	} // tclGlobalGameInfo::fflGetElapsedTimeInSec

// Sets the elapsed time on current map. 
	void tclGlobalGameInfo::fvoSetElapsedTimeInSec 
		( float pflTime )
	{
		if ( !fboPtrIsSet( ) ) { return; }

		if ( pflTime < cflMinElapsedTimeInSec )
			pflTime = cflMinElapsedTimeInSec;
		else
		if ( pflTime > cflMaxElapsedTimeInSec )
			pflTime = cflMaxElapsedTimeInSec;

		vst_ptrENGGlobalVars->time = pflTime;

	} // tclGlobalGameInfo::fvoSetElapsedTimeInSec

	string tclGlobalGameInfo::ftxGetSring( int pinOffset )
	{
		if ( !fboPtrIsSet( ) ) { return ""; }

		string vtxString = vst_ptrENGGlobalVars->pStringBase + pinOffset;
		return vtxString;

	} // tclGlobalGameInfo::ftxGetSring

// Create an instance of tclGlobalGameInfo. There should only be one
// instance.
	tclGlobalGameInfo vclGlobalGameInfo;