//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_GlobalVars.h
//	
//	[MEAN] Interface Wrapper for the Global Vars pointer.
//
//.e	

//.b skip over if header has already been included.
	#ifndef defMA_GlobalVars_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
		#define defMA_GlobalVars_h

	// Include all general definition files.
		#include "MB_Includes.h"

	// Give globalvars_t a more meaningfull and consistent name
	// for our interface.
		#define tstENGGlobalVars globalvars_t
		#define tst_prtENGGlobalVars globalvars_t*
		
	// Global Vars interface wrapper.

		const float cflMinElapsedTimeInSec = 0;
		const float cflMaxElapsedTimeInSec = 36000; // 10 hours in seconds

		class tclGlobalGameInfo
		{
			public:
				tclGlobalGameInfo( void );
				bool fboPtrIsSet( void );
				void fvoSetPointer( tst_prtENGGlobalVars pst_ptrENGGlobalVars );
				tst_prtENGGlobalVars fst_ptrGetPointer( void );
				int finGetMaxPlayers( void );
				int finGetCurPlayers( void );
				string ftxGetMapName( void );
				float fflGetElapsedTimeInSec( void );
				void fvoSetElapsedTimeInSec( float pflTime );
				string ftxGetSring( int pinOffset );
		};  // tclGlobalGameInfo

		extern tclGlobalGameInfo vclGlobalGameInfo;
		
	#endif // defMA_GlobalVars_h
//.e skip over if header has already been included.

//.b	The structure of "Global Vars" is displayed below as a reference only.
//		The actual structure is defined in:
//			HLSDK22\SDK\Source Code\engine\progdefs.h
/* 
		typedef struct
		{	
			float		time;
			float		frametime;
			float		force_retouch;
			string_t	mapname;
			string_t	startspot;
			float		deathmatch;
			float		coop;
			float		teamplay;
			float		serverflags;
			float		found_secrets;
			vec3_t		v_forward;
			vec3_t		v_up;
			vec3_t		v_right;
			float		trace_allsolid;
			float		trace_startsolid;
			float		trace_fraction;
			vec3_t		trace_endpos;
			vec3_t		trace_plane_normal;
			float		trace_plane_dist;
			edict_t		*trace_ent;
			float		trace_inopen;
			float		trace_inwater;
			int			trace_hitgroup;
			int			trace_flags;
			int			msg_entity;
			int			cdAudioTrack;
			int			maxClients;
			int			maxEntities;
			const char	*pStringBase;
			void		*pSaveData;
			vec3_t		vecLandmarkOffset;
		} globalvars_t;

*/
//.e	
