//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Player.cpp
//	
//	[MEAN] Interface UTIL function definitions.
//
//.e	

#include "MG_Lib.h"
#include "MA_GlobalVars.h"
#include "MI_Player.h"
#include "MA_Player.h"
#include "MA_EngDLLCmd.h"
#include "MA_Security.h"
#include "MI_Hud.h"
#include "MI_Sound.h"
#include "MA_BotControl.h"
#include "MA_Bot.h"

//.b MA_Player.cpp

// define global instance of tclPlayer object.
	tclPlayer vclPlayer;

	void fvoMA_Player_Event_EnforceHumanTeam( tclArgList& pclArgList )
	{
		float vflDelay = pclArgList.finGetArg_Int( 0 );
		vclPlayer.fvoEnforceHumanTeam( );
		vclPlayer.fboSendEvent_EnforceHumanTeam( vflDelay );

	} // fvoMA_Player_Event_EnforceHumanTeam

	void fvoMA_Player_Event_EnforceClanTeam( tclArgList& pclArgList )
	{
		float vflDelay = pclArgList.finGetArg_Int( 0 );
		vclPlayer.fvoEnforceClanTeam( );
		vclPlayer.fboSendEvent_EnforceClanTeam( vflDelay );

	} // fvoMA_Player_Event_EnforceClanTeam

	void fvoMA_Player_Event_KickPlayer( tclArgList& pclArgList )
	{
		int vinUserId     = pclArgList.finGetArg_Int( 0 );
		string vtxReason  = pclArgList.ftxGetArg_String( 1 );
		vclPlayer.fboKickPlayerByUserId( vinUserId, vtxReason );
	} // fvoMA_Player_Event_KickPlayer

	void fvoMA_Player_Event_SlapPlayer( tclArgList& pclArgList )
	{
		int vinPlayerIndex = pclArgList.finGetArg_Int( 0 ); 
		bool vboHard  = pclArgList.fboGetArg_Bool( 1 );  
		int vinEffect  = pclArgList.finGetArg_Int( 2 ); 
		int vinRepeat  = pclArgList.finGetArg_Int( 3 ); 
		string vtxReason  = pclArgList.ftxGetArg_String( 4 ); 

		vclPlayer.fboSlapPlayerByIndex( vinPlayerIndex, vboHard, vinEffect, vinRepeat, vtxReason);

	} // fvoMA_Player_Event_SlapPlayer

	void fvoMA_Player_Event_SlapSwicken( tclArgList& pclArgList )
	{
		int vinUserId			= pclArgList.finGetArg_Int(		0 ); 
		bool vboHard			= pclArgList.fboGetArg_Bool(		1 );  
		int vinEffect			= pclArgList.finGetArg_Int(		2 ); 
		int vinRepeat        = pclArgList.finGetArg_Int(		3 ); 
		string vtxReason     = pclArgList.ftxGetArg_String(	4 ); 
		float vflDelayInSecs = vclEventSched.fflGetArg_Float( 5 );

		if ( !vclPlayer.fboPlayerIsAliveByUserId( vinUserId ) )
		{
			// he's not alive so wait and try again;
			vclEventSched.fboCreateEvent( );
			vclEventSched.fboCreateArgList(	6 );
			vclEventSched.fvoSetArg_Int(		0, vinUserId );
			vclEventSched.fvoSetArg_Bool(		1, vboHard );
			vclEventSched.fvoSetArg_Int(		2, vinEffect );
			vclEventSched.fvoSetArg_Int(		3, vinRepeat ); 
			vclEventSched.fvoSetArg_String(	4, vtxReason );
			vclEventSched.fvoSetArg_Int(		5, vflDelayInSecs ); // delay
			vclEventSched.fvoSetEventFunc( fvoMA_Player_Event_SlapSwicken );
			vclEventSched.fvoSetDelayInSecs( vflDelayInSecs );
			vclEventSched.fboSendEvent( );
			return;
		}

		// tell everyone what is going on;
		vclEventSched.fboCreateEvent( ); 
		vclEventSched.fboCreateArgList( 2 );
		vclEventSched.fvoSetArg_String( 0, "red" ); // specify HUD display;
		vclEventSched.fvoSetArg_String( 1, vtxReason );
		vclEventSched.fvoSetEventFunc( fvoMI_HUD_Event_HUDDisplay );
		vclEventSched.fvoSetDelayInSecs( 2 );
		vclEventSched.fboSendEvent( );

		// give it to him!
		vclPlayer.fboSlapPlayerByUserId( vinUserId, vboHard, vinEffect, vinRepeat, "Change your name! Player is NOT allowed on this server\n" );

	} // fvoMA_Player_Event_SlapSwicken

	Vector fstMakeRandomBloodVector( void )
	{
		Vector vstVector_Direction;

		vstVector_Direction.x = RANDOM_FLOAT ( -1, 1 );
		vstVector_Direction.y = RANDOM_FLOAT ( -1, 1 );
		vstVector_Direction.z = RANDOM_FLOAT ( 0, 1 );

		return vstVector_Direction;
	} // fstMakeRandomBloodVector

	tclPlayer::tclPlayer( void )
	{
		vinHeadShotMode = cinHeadShot_Off;
		vinGameMode = cinGameMode_DEFAULT;
		vinCurrentClanTeam = cinTeam_Unknown;
		vboEnforceClanTeam = false;
		vinCurrentHumanTeam = cinTeam_Any;
		vboEnforceHumanTeam = false;
		vboEnforceHumanTeam_Fixed = false;
		vinMaxHumans = cinMaxPlayers;
		vinReservedSlots = 0;
		vinDamage_EqualProbCmdIdx = -1;
		vinDamage_HighProbCmdIdx  = -1;
		vinDamage_LowProbCmdIdx   = -1;
		vinDamage_HandSlapCmdIdx  = -1;
		vinDamage_BitchSlapCmdIdx = -1;

	} // tclPlayer::tclPlayer

// ****************************************************************************
//.b Miscellaneous Player Functions
// ****************************************************************************

	int tclPlayer::finGetMaxPlayers( void )
	{
		return vclGlobalGameInfo.finGetMaxPlayers( );
	} // tclPlayer::finGetMaxPlayers

	int tclPlayer::finGetCurPlayers( void )
	{
		int vinCount = 0;
		edict_t* vst_ptrEdict;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{

			vst_ptrEdict = INDEXENT( vinIdx );
			
			if ( GETPLAYERUSERID( vst_ptrEdict ) >= cinMinUserId )
				vinCount++;
		}

		return vinCount;

	} // tclPlayer::finGetCurPlayers

	int tclPlayer::finGenRandomTeam( void )
	{
		if ( random( 2 ) == 0 )
			return cinTeam_TE;

		return cinTeam_CT;

	} // tclPlayer::finGenRandomTeam

//.e Miscellaneous Player Functions

// ****************************************************************************
//.b Player by Edict_t Functions
// ****************************************************************************

	bool tclPlayer::fboAddHealthByEdict( edict_t* pst_ptrEdict, int intAddHealth, int pinMinHealth )
	{	  
		if ( !fboPlayerIsAliveByEdict( pst_ptrEdict ) )
			return false;

		long vlgNewHealth = pst_ptrEdict->v.health + intAddHealth;

		if ( vlgNewHealth > 100 )
			vlgNewHealth = 100;
		else
		if ( vlgNewHealth < 0 )
			vlgNewHealth = 0;

		if ( vlgNewHealth < pinMinHealth )
			vlgNewHealth = pinMinHealth;

		if ( pst_ptrEdict->v.health > pinMinHealth ) 
			pst_ptrEdict->v.health = vlgNewHealth;

		return true;

	} // tclPlayer::fboAddHealthByEdict

	bool tclPlayer::fboSlapPlayerByEdict( 
		edict_t*	pcl_ptrEdict, 
		bool		pboHard, 
		int		pinEffect, 
		string	ptxReason )
	{

		if ( !fboPlayerIsAliveByEdict( pcl_ptrEdict ) )
			return false;

		if ( !fboAddHealthByEdict( pcl_ptrEdict, -5, 15 ) )
			return false;

		// Play a random sound to simulate a slap
		string vtxSoundFile;

		// Counterstrike pain sounds
		if ( ( pinEffect == cinEffect_BitchSlap ) 
			        || 
			  ( pinEffect == cinEffect_FastBitchSlap ) )
			vtxSoundFile = vclSoundCmdList_System.ftxGetSoundFile( vinDamage_BitchSlapCmdIdx );
		else
		   vtxSoundFile = vclSoundCmdList_System.ftxGetSoundFile( vinDamage_HandSlapCmdIdx );

		// if sounds are off or not found, nothing will be played;
		fvoEmitSoundFromPlayer( pcl_ptrEdict, CHAN_VOICE, vtxSoundFile);
		//!! fvoClientPrintChat( pcl_ptrEdict, ptxReason );
		fvoClientPrintChat( NULL, ptxReason ); // tell everyone
		return fboThrowPlayerByEdict( pcl_ptrEdict, pboHard );

   } // tclPlayer::fboSlapPlayerByEdict

	bool tclPlayer::fboKillPlayerByEdict( edict_t* pst_ptrEdict, string ptxReason, bool pboSuicide )
	{
		if ( !fboPlayerIsAliveByEdict( pst_ptrEdict ) )
			return false;

		// send player flying to simulate him being blown up
		if ( !fboThrowPlayerByEdict( pst_ptrEdict, /* Hard = */ true) )
			return false;
		//!!.begin - example used "potentially auditable set" message and some
		//!! players did not see the explosion.
		// MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, pcl_ptrPlayer->pev->origin );
		//!!.end

		MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, pst_ptrEdict->v.origin );
		WRITE_BYTE( TE_TAREXPLOSION );
		WRITE_COORD( pst_ptrEdict->v.origin.x );
		WRITE_COORD( pst_ptrEdict->v.origin.y );
		WRITE_COORD( pst_ptrEdict->v.origin.z );
		MESSAGE_END( );
		 
		// MESSAGE_BEGIN( MSG_PAS, SVC_TEMPENTITY, pcl_ptrPlayer->pev->origin );
		MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pst_ptrEdict->v.origin );
		WRITE_BYTE(TE_LAVASPLASH);
		WRITE_COORD( pst_ptrEdict->v.origin.x );
		WRITE_COORD( pst_ptrEdict->v.origin.y );
		WRITE_COORD( pst_ptrEdict->v.origin.z );
		MESSAGE_END( );
	 
		if ( !pboSuicide )
			pst_ptrEdict->v.frags++;

		fvoKillPlayer( pst_ptrEdict, ptxReason );
	   return true;

	} // tclPlayer::fboKillPlayerByEdict

	bool tclPlayer::fboEmitSparksFromPlayerByEdict( edict_t* pst_ptrEdict, Vector pstOrigin )

	{
		if ( !fboPlayerIsAliveByEdict( pst_ptrEdict ) )
			return false;

		Vector vstOrigin = pst_ptrEdict->v.origin;

		vstOrigin.x += RANDOM_FLOAT(-3, 3);
		vstOrigin.y += RANDOM_FLOAT(-3, 3);
		vstOrigin.z += RANDOM_FLOAT(-8, 8);

		MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pst_ptrEdict->v.origin );
			WRITE_BYTE( TE_SPARKS );
			WRITE_COORD( vstOrigin.x );
			WRITE_COORD( vstOrigin.y );
			WRITE_COORD( vstOrigin.z );
		MESSAGE_END( );

		return true;

	} // tclPlayer::fboEmitSparksFromPlayerByEdict

	bool tclPlayer::fboEmitBloodFromPlayerByEdict( edict_t* pst_ptrEdict )
	{
		if ( !fboPlayerIsAliveByEdict( pst_ptrEdict ) )
			return false;

		Vector vstVector_Direction = fstMakeRandomBloodVector( );

		Vector vstOrigin = pst_ptrEdict->v.origin;

		vstOrigin.x += RANDOM_FLOAT(-2, 2);
		vstOrigin.y += RANDOM_FLOAT(-2, 2);
		vstOrigin.z += RANDOM_FLOAT(-5, 5);

		int vinAmount = ( 100 - pst_ptrEdict->v.health );
		vinAmount = min( vinAmount, 50 );

		MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, pst_ptrEdict->v.origin );
			WRITE_BYTE( TE_BLOOD );
			WRITE_COORD( vstOrigin.x );
			WRITE_COORD( vstOrigin.y );
			WRITE_COORD( vstOrigin.z );
			WRITE_COORD( vstVector_Direction.x );
			WRITE_COORD( vstVector_Direction.y );
			WRITE_COORD( vstVector_Direction.z );
			WRITE_BYTE( BLOOD_COLOR_RED );
			WRITE_BYTE( min( vinAmount, 255 ) );
		MESSAGE_END( );
/*
	MESSAGE_BEGIN( MSG_PVS, SVC_TEMPENTITY, origin );
		WRITE_BYTE( TE_BLOODSPRITE );
		WRITE_COORD( pcl_ptrPlayer->edict( )->v.origin.x );
		WRITE_COORD( pcl_ptrPlayer->edict( )->v.origin.y );
		WRITE_COORD( pcl_ptrPlayer->edict( )->v.origin.z );

		WRITE_SHORT( g_sModelIndexBloodSpray );			// see weapons.cpp for definition
		WRITE_SHORT( g_sModelIndexBloodDrop );				// see weapons.cpp for definition

		WRITE_BYTE( BLOOD_COLOR_RED );						
		WRITE_BYTE( min( max( 3, vinAmount / 10 ), 16 ) );		// size
	MESSAGE_END();
*/
	   return true;

	} // tclPlayer::fboEmitBloodFromPlayerByEdict

	bool tclPlayer::fboEmitSoundFromPlayerByEdict
		( edict_t* pst_ptrEdict, string ptxSoundFile, bool pboAliveOnly )
	{

		if ( !fboPlayerIsValidByEdict( pst_ptrEdict ) )
			return false; 

		if ( pboAliveOnly && !fboPlayerIsAliveByEdict( pst_ptrEdict ) )
			return false;
		
		fvoEmitSoundFromPlayer( pst_ptrEdict, CHAN_STREAM, ptxSoundFile);
		return true;

	} // fboEmitSoundFromPlayerByEdict

	bool tclPlayer::fboThrowPlayerByEdict( edict_t* pst_ptrEdict, bool pboHard )
	{	  
		if ( !fboPlayerIsAliveByEdict( pst_ptrEdict ) )
			return false;

		pst_ptrEdict->v.velocity.x += floor(RANDOM_FLOAT(-800,800));
		pst_ptrEdict->v.velocity.y += floor(RANDOM_FLOAT(-800,800));

		float vflMin;
		float vflMax;

		if ( pboHard )
		{	vflMin = 400;	vflMax = 800;	}
		else
		{	vflMin = 100;	vflMax = 300;	}

		pst_ptrEdict->v.velocity.z += floor(RANDOM_FLOAT(vflMin, vflMax));
		return true;

	} // tclPlayer::fboThrowPlayerByEdict

	bool tclPlayer::fboPlayerIsValidByEdict( edict_t* pst_ptrEdict )
	{
		string vtxMsg;

		if ( pst_ptrEdict == NULL )
			return false;

		if ( finGetPlayerUserId( pst_ptrEdict ) < cinMinUserId )
			return false;

		if ( ftxGetPlayerNameByEdict( pst_ptrEdict ) == ""  ) 
			return false;

		return true;

	} // tclPlayer::fboPlayerIsValidByEdict

	bool tclPlayer::fboPlayerIsAliveByEdict( edict_t* pst_ptrEdict )
	{
		if ( !fboPlayerIsValidByEdict( pst_ptrEdict ) )
			return false; 

		return ( pst_ptrEdict->v.deadflag == DEAD_NO ) 
						&& 
				   pst_ptrEdict->v.health > 0; 

	} // tclPlayer::fboPlayerIsAliveByEdict

	bool tclPlayer::fboPlayerIsSpectatorByEdict( edict_t* pst_ptrEdict )
	{
		if ( !fboPlayerIsValidByEdict( pst_ptrEdict ) )
			return false; 

		return ( pst_ptrEdict->v.flags & FL_SPECTATOR );
		
	} // tclPlayer::fboPlayerIsSpectatorByEdict

	string tclPlayer::ftxGetPlayerNameByEdict( edict_t* pst_ptrEdict )
	{
		if ( pst_ptrEdict == NULL )
		{
			return ctxAccess_SrvOp;
		}
		return ftxGetEdictKeyValue( pst_ptrEdict, "name" );
	} // tclPlayer::ftxGetPlayerNameByEdict

	int tclPlayer::finGetUserIdByEdict( edict_t* pst_ptrEdict )
	{
		return finGetPlayerUserId( pst_ptrEdict );
	} // tclPlayer::finGetUserIdByEdict

	int tclPlayer::finGetPlayerIndexByEdict( edict_t* pst_ptrEdict )
	{
		if ( pst_ptrEdict == NULL )
			return cinPlayer_PlayerIndexNotFound; 
	
		return finGetIndexOfEdict( pst_ptrEdict );

/*!! - redundant code
		int vinUserId = finGetPlayerUserId( pst_ptrEdict );

		if ( vinUserId < cinMinUserId )
			return cinPlayer_PlayerIndexNotFound;

		edict_t* vst_ptrEdict;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			vst_ptrEdict = fst_ptrGetPlayerByIndex( vinIdx );

			if ( vinUserId == finGetPlayerUserId( vst_ptrEdict ) )
				return vinIdx;
		} // for

		return cinPlayer_PlayerIndexNotFound;
  !! - redundant code */
	} // tclPlayer::finGetPlayerIndexByEdict

	string tclPlayer::ftxGetPlayerModelNameByEdict( edict_t* pst_ptrEdict )
	{
		if ( !fboPlayerIsValidByEdict( pst_ptrEdict ) )
			return ""; 

		if ( fboPlayerIsSpectatorByEdict( pst_ptrEdict ) )
		// Spectators do not belong to a team.
			return ""; 

		return ftxGetEdictKeyValue( pst_ptrEdict, "model" );

	} // tclPlayer::ftxGetPlayerModelNameByEdict

	int tclPlayer::finGetPlayerTeamByEdict( edict_t* pst_ptrEdict )
	{
		string vtxModelName = ftxGetPlayerModelNameByEdict( pst_ptrEdict );
	
		if ( vtxModelName.empty( ) || vtxModelName.length( ) < 3 )
			return cinTeam_Unknown;

		if ( ( vtxModelName[ 0 ] == 't' ) // TE "terror" Phoenix Connektion
					|| 
			  ( vtxModelName[ 0 ] == 'l' ) // TE "leet" L337 Krew
					|| 
			  ( vtxModelName[ 0 ] == 'a' ) // TE "arctic" Arctic Avenger
			)
		{
			return cinTeam_TE;
		}

		if ( ( vtxModelName[ 0 ] == 'u' ) // TE "urban" Seal Team 6
					|| 
			  ( vtxModelName[ 0 ] == 's' ) // CT "sas" UK SAS
					|| 
			  ( vtxModelName[ 0 ] == 'v' ) // CT "vip" VIP
			)
		{
			return cinTeam_CT;
		}

		if ( vtxModelName[ 0 ] == 'g' ) 
		{
			if ( vtxModelName[ 1 ] == 'u' ) // TE "guerilla" Gorilla Warfare
				return cinTeam_TE;

			if ( vtxModelName[ 1 ] == 's' ) // CT "gsg9" German GSG-9
				return cinTeam_CT;

			if ( vtxModelName[ 1 ] == 'i' ) // CT "gign" French GIGN
				return cinTeam_CT;
		}

/*
		if ( (vtxModelName == "terror"	) // Phoenix Connektion
					||  
			  ( vtxModelName == "leet"		) // L337 Krew
					|| 
			  ( vtxModelName == "arctic"	) // Arctic Avenger
					||
			  ( vtxModelName == "guerilla") // Gorilla Warfare
			)
			return cinTeam_TE;
					
		if ( ( vtxModelName == "urban"	) // Seal Team 6
					||
			  ( vtxModelName == "gsg9"		) // German GSG-9
					||
			  ( vtxModelName == "sas"		) // UK SAS
					||
			  ( vtxModelName == "gign"		) // French GIGN
					||
			  ( vtxModelName == "vip"		) // VIP
			)
			return cinTeam_CT;
*/
		return cinTeam_Unknown;  

	} // tclPlayer::finGetPlayerTeamByEdict

	int tclPlayer::finGetPlayerBioByEdict ( edict_t* pst_ptrEdict )
	{
		if ( !fboPlayerIsValidByEdict( pst_ptrEdict ) )
		// we don't yet know for certain what this player is
			return cinBio_Unknown;

		return finGetPlayerBioByEdict_RAW( pst_ptrEdict );

	} // tclPlayer::finGetPlayerBioByEdict

	int tclPlayer::finGetPlayerBioByEdict_RAW( edict_t* pst_ptrEdict )
	{
		if ( pst_ptrEdict == NULL )
			return cinBio_Unknown;

		string vtxAuthId = ftxGetPlayerAuthId( pst_ptrEdict );
//		int vinPing = finGetPlayerPing( pst_ptrEdict );

		bool vboIsFakeClient = ( pst_ptrEdict->v.flags & FL_FAKECLIENT ); 

		if ( ( vboIsFakeClient != true ) && ( vtxAuthId != "0" ) && ( vtxAuthId != "BOT" ) )
			return cinBio_Human;

//	|| 
// ( pst_ptrEdict->v.flags & def_FAKE_CLIENT_BIT );

		if ( ( vboIsFakeClient == true ) || ( vtxAuthId == "0" ) || ( vtxAuthId == "BOT" ) )
			return cinBio_Bot;

// BOTS always have a ping AND AuthId of zero;
//		if ( ( vinPing == 0 ) && ( vtxAuthId == "0" ) )
//			return cinBio_Bot;

// BOTS always have an ID of "BOT"
//		if ( vtxAuthId == "BOT" )
//			return cinBio_Bot;

		return cinBio_Unknown;

	} // tclPlayer::finGetPlayerBioByEdict_RAW

	int tclPlayer::finGetPlayerHealthByEdict( edict_t* pst_ptrEdict )
	{
		if ( !fboPlayerIsAliveByEdict( pst_ptrEdict ) )
			return 0;

		return pst_ptrEdict->v.health;
	} // tclPlayer::finGetPlayerHealthByEdict

	bool tclPlayer::fboGetPlayerOriginByEdict( edict_t* pst_ptrEdict, Vector& pstOrigin )
	{
		if ( !fboPlayerIsValidByEdict( pst_ptrEdict ) )
		{
			pstOrigin.x = 0;
			pstOrigin.y = 0;
			pstOrigin.z = 0;
			return false;
		}
		pstOrigin = pst_ptrEdict->v.origin;
		return true;

	} // tclPlayer::fboGetPlayerOriginByEdict

	bool tclPlayer::fboPlayerIsHumanByEdict( edict_t* pst_ptrEdict )
	{
		return ( finGetPlayerBioByEdict( pst_ptrEdict ) == cinBio_Human );
		
	} // tclPlayer::fboPlayerIsHumanByEdict

	bool tclPlayer::fboPlayerIsBotByEdict ( edict_t* pst_ptrEdict )
	{
		return ( finGetPlayerBioByEdict( pst_ptrEdict ) == cinBio_Bot );		

	} // tclPlayer::fboPlayerIsBotByEdict

	bool tclPlayer::fboKickPlayerByEdict( edict_t* pst_ptrEdict, string ptxReason )
	{
		int vinUserId = finGetUserIdByEdict( pst_ptrEdict );
		if ( vinUserId < cinMinUserId )
			return false;

		// exec: kick #userid
		string vtxServerCmd = "kick #" + ftxIntToString( vinUserId ) + "\n";

		if ( !fboPlayerIsBotByEdict( pst_ptrEdict ) )
		// message human players only
			fvoClientPrintConsole( pst_ptrEdict, "\n\n" + ptxReason + "\n\n"  );

		fvoServerPrint( vtxServerCmd );
		fvoServerCommand( vtxServerCmd );
		return true;

	} // tclPlayer::fboKickPlayerByEdict

	bool tclPlayer::fboSwitchTeamByEdict( edict_t* pst_ptrEdict, string ptxReason )
	{
		int vinTeam = finGetPlayerTeamByEdict( pst_ptrEdict );
		if ( vinTeam == cinTeam_Unknown )
			return false;

		string vtxMenuItem;

		if ( vinTeam == cinTeam_TE )
			vtxMenuItem == "1";
		else
		if ( vinTeam == cinTeam_CT )
			vtxMenuItem == "2";
		else
			return false;

		if ( fboPlayerIsHumanByEdict( pst_ptrEdict ) )
		{
			fvoClientPrintChat( pst_ptrEdict, ptxReason );
			//fvoExecFakeClientCommand( pst_ptrEdict, "chooseteam" );
			// Display of Team Selection Menu
			//fvoExecFakeClientCommandDELAYED( 0.5, pst_ptrEdict, "menuselect", vtxMenuItem );
			// Display of Skin Selection Menu
			// Specify a randomly selected skin
			//fvoExecFakeClientCommandDELAYED( 1.0, pst_ptrEdict, "menuselect", "5" ); 

			fvoExecClientCommand( pst_ptrEdict, "chooseteam" );
			//fvoExecClientCommandDELAYED( 1.5, pst_ptrEdict, "menuselect " + vtxMenuItem );
			//fvoExecClientCommandDELAYED( 2.5, pst_ptrEdict, "menuselect 5" );
			fvoExecClientCommand( pst_ptrEdict, "menuselect " + vtxMenuItem );
			fvoExecClientCommand( pst_ptrEdict, "menuselect 5" );
			fvoExecClientCommand( pst_ptrEdict, "menuselect 0" );
			
		}
		else
			return false;

		return true;

	} // tclPlayer::fboSwitchTeamByEdict

//.e Player by Edict_t Functions

// ****************************************************************************
//.b Player by Index Functions
// ****************************************************************************

	edict_t* tclPlayer::fst_ptrGetPlayerByIndex( int pinPlayerIndex )
	{
		edict_t*	vst_ptrEdict;

		// Player index is 1 based
		if ( pinPlayerIndex < cinMinPlayerIndex 
					|| 
			  pinPlayerIndex > finGetMaxPlayers( ) 
			)
			// index out of range
			return NULL;
		
		vst_ptrEdict = fst_ptrGetEntityByIndex( pinPlayerIndex );

		if ( vst_ptrEdict == NULL )
			return NULL;

		if ( vst_ptrEdict->free )
		//.!! I do not yet know what "free" means
			return NULL;

		if ( !fboPlayerIsValidByEdict( vst_ptrEdict ) )
			return NULL;

		return vst_ptrEdict;

	} // tclPlayer::fst_ptrGetPlayerByIndex

	bool tclPlayer::fboPlayerIsValidByIndex( int pinPlayerIndex )
	{
		return fst_ptrGetPlayerByIndex( pinPlayerIndex ) != NULL;
	} // tclPlayer::fboPlayerIsValidByIndex

	int tclPlayer::finGetUserIdByIndex( int pinPlayerIndex )
	{
		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );

		if ( !fboPlayerIsValidByEdict( vst_ptrEdict ) )
			return cinPlayer_UserIdNotFound;

		return finGetPlayerUserId( vst_ptrEdict );

	} // tclPlayer::finGetUserIdByIndex

	int tclPlayer::fboPlayerIsAliveByIndex( int pinPlayerIndex )
	{
		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		return fboPlayerIsAliveByEdict( vst_ptrEdict );

	} // tclPlayer::fboPlayerIsAliveByIndex

	bool tclPlayer::fboPlayerIsSpectatorByIndex( int pinPlayerIndex )
	{
		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		return fboPlayerIsSpectatorByEdict( vst_ptrEdict );

	} // tclPlayer::fboPlayerIsSpectatorByIndex

	string tclPlayer::ftxGetPlayerNameByIndex( int pinPlayerIndex ) 
	{
		return ftxGetPlayerNameByEdict( fst_ptrGetPlayerByIndex( pinPlayerIndex ) );
	} // tclPlayer::ftxGetPlayerNameByIndex

	int tclPlayer::finGetPlayerTeamByIndex( int pinPlayerIndex )
	{
		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		
		if ( !fboPlayerIsValidByEdict( vst_ptrEdict ) )
			return cinTeam_Unknown;

		return finGetPlayerTeamByEdict( vst_ptrEdict );

	} // tclPlayer::finGetPlayerTeamByIndex

	int tclPlayer::finGetPlayerBioByIndex( int pinPlayerIndex )
	{
		return finGetPlayerBioByEdict( fst_ptrGetPlayerByIndex( pinPlayerIndex ) );
	} // tclPlayer::finGetPlayerBioByIndex

	int tclPlayer::finGetPlayerPingByIndex( int pinPlayerIndex )
	{
		edict_t* vcl_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		if ( vcl_ptrEdict == NULL )
			return 0;
		return finGetPlayerPing( vcl_ptrEdict );

	} // tclPlayer::finGetPlayerPingByIndex

	bool tclPlayer::fboPlayerIsHumanByIndex( int pinPlayerIndex )
	{
		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		if ( !fboPlayerIsValidByEdict( vst_ptrEdict ) )
			return false;

		return fboPlayerIsHumanByEdict( vst_ptrEdict );

	} // tclPlayer::fboPlayerIsHumanByIndex

	bool tclPlayer::fboPlayerIsBotByIndex( int pinPlayerIndex )
	{
		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		if ( !fboPlayerIsValidByEdict( vst_ptrEdict ) )
			return false;
		return fboPlayerIsBotByEdict( vst_ptrEdict );

	} // tclPlayer::fboPlayerIsBotByIndex

	bool tclPlayer::fboKickPlayerByIndex( int pinPlayerIndex, string ptxReason )
	{
		int vinUserId = finGetUserIdByIndex( pinPlayerIndex );
		if ( vinUserId < cinMinUserId ) return false;
		
//		fboKickPlayerByUserId( vinUserId, ptxReason );

		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fboCreateArgList( 2 );
			vclEventSched.fvoSetArg_Int( 0, vinUserId );
			vclEventSched.fvoSetArg_String( 1, ptxReason );
			vclEventSched.fvoSetEventFunc( fvoMA_Player_Event_KickPlayer );
			vclEventSched.fvoSetDelayInSecs( 0.5 );
			vclEventSched.fboSendEvent( );
			return true;
		}
		return false;

	} // tclPlayer::fboKickPlayerByIndex

	bool tclPlayer::fboThrowPlayerByIndex( int pinPlayerIndex, bool pboHard )
	{	  
		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		return fboThrowPlayerByEdict( vst_ptrEdict, pboHard );

	} // tclPlayer::fboThrowPlayerByIndex

	bool tclPlayer::fboSlapPlayerByIndex( 
			int		pinPlayerIndex, 
			bool		pboHard, 
			int		pinEffect,
			int		pinRepeat,
			string	ptxReason)
	{

		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		bool vboResult = fboSlapPlayerByEdict( vst_ptrEdict, pboHard, pinEffect, ptxReason );

		if ( !vboResult )
			return false;

		if ( --pinRepeat <= 0 )
			return true;

		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fboCreateArgList( 5 );
			vclEventSched.fvoSetArg_Int( 0, pinPlayerIndex );
			vclEventSched.fvoSetArg_Bool( 1, pboHard );
			vclEventSched.fvoSetArg_Int( 2, pinEffect );
			vclEventSched.fvoSetArg_Int( 3, pinRepeat );
			vclEventSched.fvoSetArg_String( 4, ptxReason );
			vclEventSched.fvoSetEventFunc( fvoMA_Player_Event_SlapPlayer );

			if ( ( pinEffect == cinEffect_AdminSlap ) 
				       || 
				  ( pinEffect == cinEffect_BitchSlap ) )
				vclEventSched.fvoSetDelayInSecs( fflRandomFloat( 0.15, 2 ) );
			else
				vclEventSched.fvoSetDelayInSecs( fflRandomFloat( 0.15, 0.50 ) );
			vclEventSched.fboSendEvent( );
		}

		return true;
		
	} // tclPlayer::fboSlapPlayerByIndex

	bool tclPlayer::fboKillPlayerByIndex( int pinPlayerIndex, string ptxReason )
	{
		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		return fboKillPlayerByEdict( vst_ptrEdict, ptxReason );

	} // tclPlayer::fboKillPlayerByIndex

	bool tclPlayer::fboEmitSoundFromPlayerByIndex
		( int pinPlayerIndex, string ptxSoundFile, bool pboAliveOnly )
	{
		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		return fboEmitSoundFromPlayerByEdict( vst_ptrEdict, ptxSoundFile, pboAliveOnly );

	} // tclPlayer::fboEmitSoundFromPlayerByIndex

	bool tclPlayer::fboEmitSoundFromAlivePlayerByIndex
		( int pinPlayerIndex, string ptxSoundFile )
	{
		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		return fboEmitSoundFromPlayerByEdict
					( vst_ptrEdict, ptxSoundFile, /* pboAliveOnly = */ true );

	} // tclPlayer::fboEmitSoundFromAlivePlayerByIndex

	bool tclPlayer::fboSwitchTeamByIndex( int pinPlayerIndex, string ptxReason )
	{
		edict_t* vst_ptrEdict =  fst_ptrGetPlayerByIndex( pinPlayerIndex );
		return fboSwitchTeamByEdict( vst_ptrEdict, ptxReason );

	} // tclPlayer::fboSwitchTeamByIndex

//.e Player by Index Functions

// ****************************************************************************
//.b Player by User Id Functions
// ****************************************************************************

	edict_t* tclPlayer::fst_ptrGetPlayerByUserId( int pinPlayerId )
	{
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinPlayerId );
		return fst_ptrGetPlayerByIndex( vinPlayerIndex );

	} // tclPlayer::fst_ptrGetPlayerByUserId

	bool tclPlayer::fboPlayerExistsByUserId( int pinUserId )
	{
		return finGetPlayerIndexByUserId( pinUserId ) >= cinMinPlayerIndex;
	} // tclPlayer::fboPlayerExistsByUserId

	int tclPlayer::finGetPlayerIndexByUserId( int pinUserId )
	{
		edict_t* vst_ptrEdict;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			vst_ptrEdict = fst_ptrGetPlayerByIndex( vinIdx );

			if ( pinUserId == finGetUserIdByEdict( vst_ptrEdict ) )
				return vinIdx;
			
		} // for
			
		// if this point is reached then a match was not found.
		return cinPlayer_PlayerIndexNotFound;

	} // tclPlayer::finGetPlayerIndexByUserId

	bool tclPlayer::fboPlayerIsAliveByUserId( int pinUserId )
	{
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return fboPlayerIsAliveByIndex( vinPlayerIndex );

	} // tclPlayer::fboPlayerIsAliveByUserId

	string tclPlayer::ftxGetPlayerNameByUserId( int pinUserId )
	{
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return ftxGetPlayerNameByIndex( vinPlayerIndex );

	} // tclPlayer::ftxGetPlayerNameByUserId

	int tclPlayer::finGetPlayerBioByUserId( int pinUserId )
	{
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return finGetPlayerBioByIndex( vinPlayerIndex );

	} // tclPlayer::finGetPlayerBioByUserId

	bool tclPlayer::fboPlayerIsHumanByUserId( int pinUserId )
	{
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return fboPlayerIsHumanByIndex( vinPlayerIndex );

	} // tclPlayer::fboPlayerIsHumanByIndex

	bool tclPlayer::fboPlayerIsBotByUserId( int pinUserId )
	{
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return fboPlayerIsBotByIndex( vinPlayerIndex );

	} // tclPlayer::fboPlayerIsBotByUserId

	int tclPlayer::finGetPlayerTeamByUserId( int pinUserId )
	{
		return finGetPlayerTeamByIndex( finGetPlayerIndexByUserId( pinUserId ) );
	} // tclPlayer::finGetPlayerTeamByUserId

	bool tclPlayer::fboKickPlayerByUserId( int pinUserId, string ptxReason )
	{
//		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
//		if ( vinPlayerIndex < cinMinPlayerIndex )
//			return false;

		edict_t* vst_ptrEdict = fst_ptrGetPlayerByUserId( pinUserId );

		// exec: kick #userid
//		string vtxServerCmd = "kick #" + ftxIntToString( pinUserId ) + "\n";

		if ( vst_ptrEdict ==  NULL )
			return false;

		string vtxServerCmd = "kick \"" + ftxGetPlayerNameByEdict( vst_ptrEdict ) + "\"\n";

		if ( !fboPlayerIsBotByEdict( vst_ptrEdict ) )
		// message human players only
			fvoClientPrintConsole( vst_ptrEdict, "\n\n" + ptxReason + "\n\n"  );

		fvoServerPrint( vtxServerCmd );
		fvoServerCommand( vtxServerCmd );
		return true;

	} // tclPlayer::fboKickPlayerByUserId

	bool tclPlayer::fboBanPlayerByEdict( edict_t* pst_ptrEdict, int pinMins, string ptxReason, edict_t* pst_ptrEdictBannedBy )
	{
		if ( pst_ptrEdict == NULL )
			return false;

		bool vboPlayerIsBot = fboPlayerIsBotByEdict( pst_ptrEdict );
		if ( vboPlayerIsBot )
		// do not ban bots
			return false;

		// exec: banid mins #userid kick
		// exec: writeid

		int vinUserId = finGetUserIdByEdict( pst_ptrEdict );
		string vtxUserId = ftxIntToString( vinUserId );
		string vtxMins = ftxIntToString( pinMins );
		string vtxServerCmd = 
			"banid " + vtxMins + " #" + vtxUserId + " kick\n";

		string vtxMsg = ctxMsgPrefix + "You have been ";
		if ( pinMins == 0 )
			vtxMsg += "permanently banned from this server.";
		else
			vtxMsg += "banned for " + vtxMins + " minutes from this server.";

		fvoClientPrintConsole( pst_ptrEdict, "\n" + vtxMsg + "\n" );
		fvoClientPrintConsole( pst_ptrEdict, ptxReason + "\n" );

		fvoServerPrint( vtxServerCmd );
		fvoServerCommand( vtxServerCmd );
		vtxServerCmd = "writeid\n";
		fvoServerPrint( vtxServerCmd );
		fvoServerCommand( vtxServerCmd );

		string vtxName = ftxGetPlayerNameByEdict( pst_ptrEdict );
		string vtxAuthId = ftxGetPlayerAuthId( pst_ptrEdict );

		vtxMsg = "Banned by ";
		if ( pst_ptrEdictBannedBy == NULL )
			vtxMsg += "(mEAn) Server";
		else
			vtxMsg = "Admin \"" + ftxGetPlayerNameByEdict( pst_ptrEdictBannedBy );
		vtxMsg += "\", Ban Time (mins) = " + vtxMins;
		vtxMsg += ", SteamId = " + vtxAuthId + ", UserId = " + vtxUserId + ", UserName = \"" + vtxName + "\"" + ", Reason: \"" + ptxReason + "\"" ;
		vclClientBanLog.fvoWriteEventInfo( vtxMsg );

		return true;

	} // tclPlayer::fboBanPlayerByEdict

	bool tclPlayer::fboBanPlayerByIndex( int pinPlayerIndex, int pinMins, string ptxReason, edict_t* pst_ptrEdictBannedBy )
	{
		if ( pinPlayerIndex < cinMinPlayerIndex )
			return false;

		edict_t* vst_ptrEdict = fst_ptrGetPlayerByIndex( pinPlayerIndex );
		return fboBanPlayerByEdict( vst_ptrEdict, pinMins, ptxReason, pst_ptrEdictBannedBy );

	} // tclPlayer::fboBanPlayerByIndex

	bool tclPlayer::fboBanPlayerByUserId( int pinUserId, int pinMins, string ptxReason, edict_t* pst_ptrEdictBannedBy )
	{
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return fboBanPlayerByIndex( vinPlayerIndex, pinMins, ptxReason, pst_ptrEdictBannedBy );
	} // tclPlayer::fboBanPlayerByUserId

	bool tclPlayer::fboThrowPlayerByUserId( int pinUserId, bool pboHard )
	{	  
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return fboThrowPlayerByIndex( vinPlayerIndex, pboHard );
	
	} // tclPlayer::fboThrowPlayerByUserId

	bool tclPlayer::fboSlapPlayerByUserId( 
		int		pinUserId, 
		bool		pboHard, 
		int		pinEffect, 
		int		pinRepeat,
		string	ptxReason )
	{	  
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return fboSlapPlayerByIndex( vinPlayerIndex, pboHard, pinEffect, pinRepeat, ptxReason );
	
	} // tclPlayer::fboSlapPlayerByUserId

	void tclPlayer::fvoSlapAll( int pinBio, bool pboHard, int pinEffect, int pinRepeat, string ptxReason )
	{
		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( fboPlayerIsAliveByIndex( vinIdx ) )
			{
				if ( pinBio != cinBio_Any )
				{
					if ( finGetPlayerBioByIndex( vinIdx ) != pinBio )
						continue;
				}
				vclEventSched.fboCreateEvent( );
				vclEventSched.fboCreateArgList(	5 );
				vclEventSched.fvoSetArg_Int(		0, vinIdx );
				vclEventSched.fvoSetArg_Bool(		1, pboHard );
				vclEventSched.fvoSetArg_Int(		2, pinEffect );
				vclEventSched.fvoSetArg_Int(		3, pinRepeat ); 
				vclEventSched.fvoSetArg_String(	4, ptxReason );
				vclEventSched.fvoSetEventFunc( fvoMA_Player_Event_SlapPlayer );
				vclEventSched.fvoSetDelayInSecs( ( random( 100 ) + 1 ) / 100 );
				vclEventSched.fboSendEvent( );
				ptxReason = ""; // clear reason so it will show up only once for everyone;
			}

		} // for

	} // fvoSlapAll

	void tclPlayer::fvoSlapAllPlayers( bool pboHard, int pinEffect, int pinRepeat, string ptxReason )
	{
		fvoSlapAll( cinBio_Any, pboHard, pinEffect, pinRepeat, ptxReason );
	} // tclPlayer::fvoSlapAllPlayers

	void tclPlayer::fvoSlapAllBots( bool pboHard, int pinEffect, int pinRepeat, string ptxReason )
	{
		fvoSlapAll( cinBio_Bot, pboHard, pinEffect, pinRepeat, ptxReason );
	} // tclPlayer::fvoSlapAllBots

	void tclPlayer::fvoSlapAllHumans( bool pboHard, int pinEffect, int pinRepeat, string ptxReason )
	{
		fvoSlapAll( cinBio_Human, pboHard, pinEffect, pinRepeat, ptxReason );
	} // tclPlayer::fvoSlapAllHumans

	bool tclPlayer::fboKillPlayerByUserId( int pinUserId, string ptxReason )
	{	  
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return fboKillPlayerByIndex( vinPlayerIndex, ptxReason );

	} // tclPlayer::fboKillPlayerByUserId

	bool tclPlayer::fboEmitSoundFromPlayerByUserId
		( int pinUserId, string ptxSoundFile, bool pboAliveOnly )
	{
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return fboEmitSoundFromPlayerByIndex( vinPlayerIndex, ptxSoundFile, pboAliveOnly );

	} // tclPlayer::fboEmitSoundFromAlivePlayerByUserId

	bool tclPlayer::fboEmitSoundFromAlivePlayerByUserId
		( int pinUserId, string ptxSoundFile )
	{
		int vinPlayerIndex = finGetPlayerIndexByUserId( pinUserId );
		return fboEmitSoundFromAlivePlayerByIndex( vinPlayerIndex, ptxSoundFile );

	} // tclPlayer::fboEmitSoundFromAlivePlayerByUserId

//.e Player by User Id Functions

// ****************************************************************************
//.b Player Team Functions
// ****************************************************************************

	void tclPlayer::fvoCountEveryOne				
		( int &pinHumanSpectators, 
		  int &pinBotSpectators, 
		  int &pinHumansOnTE,
		  int &pinBotsOnTE,
		  int &pinHumansOnCT,
		  int &pinBotsOnCT )
  {
		pinHumanSpectators	= 0;
		pinBotSpectators		= 0;
		pinHumansOnTE			= 0;
		pinBotsOnTE				= 0;
		pinHumansOnCT			= 0;
		pinBotsOnCT				= 0;

		int vinPlayerBio;
		int vinTeam;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			vinPlayerBio = finGetPlayerBioByIndex( vinIdx );

			if ( vinPlayerBio == cinBio_Human )
			{
				vinTeam = finGetPlayerTeamByIndex( vinIdx );

				if ( vinTeam == cinTeam_Unknown)
					pinHumanSpectators++;
				else
				if ( vinTeam == cinTeam_TE )
					pinHumansOnTE++;
				else
				if ( vinTeam == cinTeam_CT )
					pinHumansOnCT++;
			}
			else
			if ( vinPlayerBio == cinBio_Bot )
			{
				vinTeam = finGetPlayerTeamByIndex( vinIdx );

				if ( vinTeam == cinTeam_Unknown)
					pinBotSpectators++;
				else
				if ( vinTeam == cinTeam_TE )
					pinBotsOnTE++;
				else
				if ( vinTeam == cinTeam_CT )
					pinBotsOnCT++;
			}

		} // for

  } // tclPlayer::fvoCountEveryOne

	void tclPlayer::fvoCountAliveDead(	
		int &pinAliveBots_TE, 
		int &pinAliveBots_CT,
		int &pinDeadHumansInGame,
		int &pinAliveHumansInGame )
	{
		pinAliveBots_TE = 0;
		pinAliveBots_CT = 0;
		pinDeadHumansInGame = 0;
		pinAliveHumansInGame = 0;
	
		int vinPlayerBio;
		int vinTeam;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			vinPlayerBio = finGetPlayerBioByIndex( vinIdx );

			if ( vinPlayerBio == cinBio_Human )
			{
				vinTeam = finGetPlayerTeamByIndex( vinIdx );

				if ( vinTeam != cinTeam_Unknown )
				{
					if ( fboPlayerIsAliveByIndex( vinIdx ) )
						pinAliveHumansInGame++;
					else
					if ( !fboPlayerIsSpectatorByIndex( vinIdx ) )
						pinDeadHumansInGame++;
				}
			}
			else
			if ( vinPlayerBio == cinBio_Bot )
			{
				vinTeam = finGetPlayerTeamByIndex( vinIdx );
				
				if ( vinTeam != cinTeam_Unknown )
				{
					if ( fboPlayerIsAliveByIndex( vinIdx ) )
					{
						if ( vinTeam == cinTeam_TE ) 
							pinAliveBots_TE++;
						else
						if ( vinTeam == cinTeam_CT ) 
							pinAliveBots_CT++;
					} 
				}
			}

		} // for

	} // tclPlayer::fvoCountAliveDead

	void tclPlayer::fvoCountClanMembers( int& pinClanOnTeam_TE, int& pinClanOnTeam_CT )
	{
		pinClanOnTeam_TE	= 0;
		pinClanOnTeam_CT	= 0;
		int vinTeam;
		edict_t* vstEdict_Player;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{

			if ( !fboPlayerIsHumanByIndex( vinIdx ) )
				continue;

			vstEdict_Player = fst_ptrGetPlayerByIndex( vinIdx );
			
			if ( !vclSecurity.fboUserIsClanByEdict( vstEdict_Player ) )
				continue;

			vinTeam = finGetPlayerTeamByIndex( vinIdx );

			if ( vinTeam == cinTeam_Unknown)
				continue;

			if ( vinTeam == cinTeam_TE )
				pinClanOnTeam_TE++;
			else
			if ( vinTeam == cinTeam_CT )
				pinClanOnTeam_CT++;

		} // for

  } // tclPlayer::fvoCountClanMembers

	int tclPlayer::finCountClanMembersOnTeam( int pinTeam )
	{ // counts humans players that are registered as clan members;
		
		int vinCount = 0;
		edict_t* vstEdict_Player;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !fboPlayerIsValidByIndex( vinIdx ) )
				continue;

			if ( !fboPlayerIsHumanByIndex( vinIdx ) )
				continue;

			vstEdict_Player = fst_ptrGetPlayerByIndex( vinIdx );
			
			if ( !vclSecurity.fboUserIsClanByEdict( vstEdict_Player ) )
				continue;

			if ( finGetPlayerTeamByIndex( vinIdx ) == pinTeam )
				vinCount++;
			else
			if ( pinTeam == cinTeam_Any )
				vinCount++;

		} // for

		return vinCount;

	} // tclPlayer::finCountClanMembersOnTeam

	int tclPlayer::finCountPlayersOnTeam( int pinTeam )
	{ // counts both bots and humans;
		int vinCount = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !fboPlayerIsValidByIndex( vinIdx ) )
				continue;

			if ( finGetPlayerTeamByIndex( vinIdx ) == pinTeam )
				vinCount++;
			else
			if ( pinTeam == cinTeam_Any )
				vinCount++;

		} // for

		return vinCount;

	} // tclPlayer::finCountPlayersOnTeam

	int tclPlayer::finCountHumansOnTeam( int pinTeam )
	{
		int vinCount = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !fboPlayerIsHumanByIndex (vinIdx) )
				continue;

			if ( finGetPlayerTeamByIndex ( vinIdx ) == pinTeam)
				vinCount++;
			else
			if ( pinTeam == cinTeam_Any )
				vinCount++;

		} // for

		return vinCount;

	} // tclPlayer::finCountHumansOnTeam

	void tclPlayer::finCountHumansOnTeam( int& pinHumansOnTeam_TE, int& pinHumansOnTeam_CT )
	{
		pinHumansOnTeam_TE	= 0;
		pinHumansOnTeam_CT	= 0;
		int vinTeam;
		edict_t* vstEdict_Player;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{

			if ( !fboPlayerIsHumanByIndex( vinIdx ) )
				continue;

			vstEdict_Player = fst_ptrGetPlayerByIndex( vinIdx );
			vinTeam = finGetPlayerTeamByEdict( vstEdict_Player );

			if ( vinTeam == cinTeam_Unknown)
				continue;

			if ( vinTeam == cinTeam_TE )
				pinHumansOnTeam_TE++;
			else
			if ( vinTeam == cinTeam_CT )
				pinHumansOnTeam_CT++;

		} // for

	} // tclPlayer::finCountHumansOnTeam

	int tclPlayer::finCountAliveHumansOnTeam( int pinTeam )
	{
		int vinCount = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !fboPlayerIsHumanByIndex( vinIdx ) )
				continue;

			if ( !fboPlayerIsAliveByIndex( vinIdx ) )
				continue;			

			if ( finGetPlayerTeamByIndex ( vinIdx ) == pinTeam)
				vinCount++;
			else
			if ( pinTeam == cinTeam_Any )
				vinCount++;

		} // for

		return vinCount;

	} // tclPlayer::finCountAliveHumansOnTeam

	int tclPlayer::finCountDeadHumansOnTeam( int pinTeam )
	{
		int vinCount = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !fboPlayerIsHumanByIndex( vinIdx ) )
				continue;

			if ( fboPlayerIsAliveByIndex( vinIdx ) )
				continue;			

			if ( fboPlayerIsSpectatorByIndex( vinIdx ) )
				continue;

			if ( finGetPlayerTeamByIndex ( vinIdx ) == pinTeam)
				vinCount++;
			else
			if ( pinTeam == cinTeam_Any )
				vinCount++;

		} // for

		return vinCount;

	} // tclPlayer::finCountDeadHumansOnTeam

	int tclPlayer::finCountBotsOnTeam( int pinTeam )
	{
		int vinCount = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			if ( pinTeam == cinTeam_Any )
			{
				vinCount++;
				continue;
			}

			if ( finGetPlayerTeamByIndex( vinIdx ) == pinTeam )
				vinCount++;

		} // for

		return vinCount;

	} // tclPlayer::finCountBotsOnTeam

	int tclPlayer::finCountAliveBotsOnTeam( int pinTeam )
	{
		int vinCount = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			if ( !fboPlayerIsAliveByIndex( vinIdx ) )
				continue;			

			if ( pinTeam == cinTeam_Any )
			{
				vinCount++;
				continue;
			}

			if ( finGetPlayerTeamByIndex( vinIdx ) == pinTeam )
				vinCount++;

		} // for

		return vinCount;

	} // tclPlayer::finCountAliveBotsOnTeam

	int tclPlayer::finCountDeadBotsOnTeam( int pinTeam )
	{
		int vinCount = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			if ( fboPlayerIsAliveByIndex( vinIdx ) )
				continue;			

			if ( fboPlayerIsSpectatorByIndex( vinIdx ) )
				continue;

			if ( pinTeam == cinTeam_Any )
			{
				vinCount++;
				continue;
			}

			if ( finGetPlayerTeamByIndex( vinIdx ) == pinTeam )
				vinCount++;

		} // for

		return vinCount;

	} // tclPlayer::finCountDeadBotsOnTeam

	int tclPlayer::finCountBotsInGame( )
	{ 
		return finCountBotsOnTeam( cinTeam_Any ); 
	}; // tclPlayer::finCountBotsInGame

	int tclPlayer::finCountAliveBotsInGame( )
	{ 
		return finCountAliveBotsOnTeam( cinTeam_Any ); 
	}; // tclPlayer::finCountAliveBotsInGame

	int tclPlayer::finCountDeadBotsInGame( )
	{ 
		return finCountDeadBotsOnTeam( cinTeam_Any ); 
	}; // tclPlayer::finCountDeadBotsInGame

	int tclPlayer::finCountHumansInGame( )
	{ 
		return finCountHumansOnTeam( cinTeam_Any ); 
	}; // tclPlayer::finCountHumansInGame

	int tclPlayer::finCountAliveHumansInGame( )
	{ 
		return finCountAliveHumansOnTeam( cinTeam_Any ); 
	}; // tclPlayer::finCountAliveHumansInGame

	int tclPlayer::finCountDeadHumansInGame( )
	{ 
		return finCountDeadHumansOnTeam( cinTeam_Any ); 
	}; // tclPlayer::finCountDeadHumansInGame

	bool tclPlayer::fboBotsInGame( )
	{
		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( !fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			return true;

		} // for

		return false;

	} // tclPlayer::fboBotsInGame

	void tclPlayer::fvoKillAllPlayers ( int pinTeam, bool pboExcludeBots, string ptxReason )
	{
		int vinKillTeam = pinTeam;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( pboExcludeBots && fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			if ( pinTeam != cinTeam_Any )
				vinKillTeam = finGetPlayerTeamByIndex( vinIdx );

			if ( vinKillTeam == pinTeam )
				fboKillPlayerByIndex( vinIdx, ptxReason );	
		}

	} // tclPlayer::fvoKillAllPlayers

	void tclPlayer::fvoKillAllHumansOnBotTeam ( int pinBotTeam, string ptxReason )
	{

		if ( pinBotTeam == cinTeam_Any || pinBotTeam == cinTeam_Unknown )
			return;
		
		int vinUserId;
		int vinTeam;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			if ( !fboPlayerIsAliveByIndex( vinIdx ) )
				continue;

   		vinUserId = vclPlayerSlot.finFindSlotById( finGetUserIdByIndex ( vinIdx ) );

			if ( vclPlayerSlot.fboIsAllowedOnBotTeam( vinUserId ) )
				continue;

			vinTeam = finGetPlayerTeamByIndex( vinIdx );

			if ( vinTeam == pinBotTeam )
				fboKillPlayerByIndex( vinIdx, ptxReason );	
		}

	} // tclPlayer::fvoKillAllHumansOnBotTeam

	void tclPlayer::fvoSwitchAllHumansOnBotTeam ( int pinBotTeam, string ptxReason )
	{
		if ( pinBotTeam == cinTeam_Any || pinBotTeam == cinTeam_Unknown )
			return;
		
		int vinUserId;
		int vinTeam;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( fboPlayerIsBotByIndex( vinIdx ) )
				continue;

//			if ( !fboPlayerIsAliveByIndex( vinIdx ) )
//				continue;

   		vinUserId = vclPlayerSlot.finFindSlotById( finGetUserIdByIndex ( vinIdx ) );

			if ( vclPlayerSlot.fboIsAllowedOnBotTeam( vinUserId ) )
				continue;

			vinTeam = finGetPlayerTeamByIndex( vinIdx );

			if ( vinTeam == pinBotTeam )
				fboSwitchTeamByIndex( vinIdx, ptxReason );	
		}

	} // tclPlayer::fvoSwitchAllHumansOnBotTeam

	void tclPlayer::fvoKillAllHumans( int pinTeam, string ptxReason )
	{
		fvoKillAllPlayers( pinTeam, /* pboExcludeBots = */ true, ptxReason ); 

	} // tclPlayer::fvoKillAllHumans

	void tclPlayer::fvoKickAllPlayers( 
		int		pinTeam, 
		bool		pboExcludeBots, 
		string	ptxReason )
	{
		int vinKickTeam = pinTeam;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			if ( pboExcludeBots && fboPlayerIsBotByIndex( vinIdx ) )
				continue;

			if ( pinTeam != cinTeam_Any )
				vinKickTeam = finGetPlayerTeamByIndex( vinIdx );

			if ( vinKickTeam == pinTeam )
				fboKickPlayerByIndex( vinIdx, ptxReason );	
		}

	} // tclPlayer::fvoKickAllPlayers

	void tclPlayer::fvoKickAllHumans( int pinTeam, string ptxReason )
	{
		fvoKickAllPlayers( pinTeam, /* pboExcludeBots = */ false, ptxReason ); 

	} // tclPlayer::fvoKickAllHumans

// ****************************************************************************
//.b Player Group Functions
// ****************************************************************************

	string tclPlayer::ftxIntToTeamStr( int pinTeam )
	{
		if ( ( pinTeam != cinTeam_TE ) 
					&& 
			  ( pinTeam != cinTeam_CT ) )
			return ctxTeam_Unknown;

		if ( pinTeam == cinTeam_TE )
			return ctxTeam_TE;
		
		return ctxTeam_CT;

	} // tclPlayer::ftxIntToTeamStr

	string tclPlayer::ftxIntToTeamStrLong( int pinTeam )
	{
		if ( ( pinTeam != cinTeam_TE ) 
					&& 
			  ( pinTeam != cinTeam_CT ) )
			return ctxTeam_UnknownLong;

		if ( pinTeam == cinTeam_TE )
			return ctxTeam_TELong;
		
		return ctxTeam_CTLong;

	} // tclPlayer::ftxIntToTeamStrLong

	string tclPlayer::ftxIntToBioStr( int pinBio )
	{
		if ( pinBio == cinBio_Human ) 
			return ctxBio_Human;

		if ( pinBio == cinBio_Bot )
			return ctxBio_Bot;

		return ctxBio_Unknown;

	} // tclPlayer::ftxIntToBioStr

	string tclPlayer::ftxIntToBioStrLong( int pinBio )
	{
		if ( pinBio == cinBio_Human ) 
			return ctxBio_Human;

		if ( pinBio == cinBio_Bot )
			return ctxBio_Bot;

		return ctxBio_UnknownLong;

	} // tclPlayer::ftxIntToBioStrLong

	int tclPlayer::finTeamStrToInt( string ptxTeam )
	{
		fvoToLower( ptxTeam );

		if ( ptxTeam == ftxToLower( ctxTeam_TE ) )
			return cinTeam_TE;

		if ( ptxTeam == ftxToLower( ctxTeam_CT ) )
			return cinTeam_CT;

		if ( ptxTeam == ftxToLower( ctxTeam_Any ) )
			return cinTeam_Any;

		if ( ptxTeam == ftxIntToString( cinTeam_TE ) )
			return cinTeam_TE;

		if ( ptxTeam == ftxIntToString( cinTeam_CT ) )
			return cinTeam_CT;

		if ( ptxTeam == ftxIntToString( cinTeam_Any ) )
			return cinTeam_Any;

		return cinTeam_Unknown;

	} // tclPlayer::finTeamStrToInt

	int tclPlayer::finBioStrToBioInt( string ptxBio )
	{
		fvoToLower( ptxBio );

		if ( ptxBio == ftxToLower( ctxBio_Bot ) )
			return cinBio_Bot;

		if ( ptxBio == ftxToLower( ctxBio_Human ) )
			return cinBio_Human;

		if ( ptxBio == ftxToLower( ctxBio_Any ) )
			return cinBio_Any;

		return cinBio_Unknown;

	} // tclPlayer::finBioStrToBioInt

	void tclPlayer::fvoListPlayers( edict_t* pst_ptrEdict, int pinTeam, int pinBio )
	{
		string vtxTeam;
		string vtxBio;

		if ( ( pinTeam != cinTeam_TE ) && ( pinTeam != cinTeam_CT ) )
		{
			pinTeam = cinTeam_Any;
			vtxTeam = "all";
		}
		else
			vtxTeam = ftxIntToTeamStr( pinTeam );

		if ( ( pinBio != cinBio_Bot ) && ( pinBio != cinBio_Human ) )
		{
			pinBio = cinBio_Any;
			vtxBio = "all";
		}
		else
			vtxBio = ftxIntToBioStr( pinBio );
		
		string vtxList 
			      = "\n" + ctxMsgPrefix + "Player Listing where Team = " + vtxTeam + " and Bio = " + vtxBio;
		fvoConsolePrint( pst_ptrEdict, vtxList + "\n" );
//		vtxList  = "\n  Slot  team    bio  Alive  userid  skill  name\n";
//		vtxList +=   "  ====  ====  =====  =====  ======  =====  =====================================\n";
//								  1    TE  human    yes	 2341  33333  JoeBlow
		vtxList  = "\n  Slot  team    bio  Alive  userid  skill  name\n";
		vtxList +=   "  ====  ====  =====  =====  ======  =====  =====================================\n";
//									       human    yes	  2341    100	JoeBlow
		fvoConsolePrint( pst_ptrEdict, vtxList );

		int vinTeam;
		int vinBio; 	
		
		int vinUserId; 
		int vinPlayerIndex; 
		bool vboAlive;
		string vtxName;
		int vinSkill;
		string vtxSkill;
//		int vinPing;

		int vinCount_Humans = 0;
		int vinCount_Bots   = 0;
		int vinCount_TE = 0;
		int vinCount_CT = 0;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{

			if ( !fboPlayerIsValidByIndex( vinIdx ) )
				continue;	

			vinTeam = finGetPlayerTeamByIndex( vinIdx );

			if ( ( pinTeam != cinTeam_Any ) && ( pinTeam != vinTeam ) )
				continue;

			vinBio = finGetPlayerBioByIndex( vinIdx );
		
			if ( ( pinBio != cinBio_Any ) && ( pinBio != vinBio ) )
				continue;

			if ( vinTeam == cinTeam_TE )
				vinCount_TE++;
			else
			if ( vinTeam == cinTeam_CT )
				vinCount_CT++;

			if ( vinBio == cinBio_Human )
				vinCount_Humans++;
			else
			if ( vinBio == cinBio_Bot )
				vinCount_Bots++;

			vinUserId = finGetUserIdByIndex( vinIdx );
			vboAlive	 = fboPlayerIsAliveByIndex( vinIdx );
			vtxName   = ftxGetPlayerNameByIndex( vinIdx ); 

			if ( vinBio == cinBio_Bot )
			{
				if ( vclBotControl.fboBotAimIsOn( ) )
				{
					vinSkill = vclBotControl.finGetBotSkillByUserIndex( vinIdx );
					if ( vinSkill == -1 )
						vtxSkill = "Err";
					else
						vtxSkill = ftxIntToStringF( vinSkill , 5, '<', ' '  );
				}
				else
					vtxSkill = "   na";
			}
			else
			{
				vtxSkill = "     ";
			}

//			vinPing   = finGetPlayerPingByIndex( vinIdx ); 
			vtxList  = "  " + fxtFillLead( ftxIntToString( vinIdx ), 4, ' ' );
			vtxList += "  " + fxtFillLead( ftxIntToTeamStr( vinTeam ), 4, ' ' );
			vtxList += "  " + fxtFillLead( ftxIntToBioStr( vinBio  ), 5, ' '  );
			vtxList += "  " + fxtFillLead( ftxBoolToString( vboAlive, "yes", "no" ), 5, ' '  );
			vtxList += "  " + ftxIntToStringF( vinUserId , 6, '<', ' '  );
//			vtxList += "  " + ftxIntToStringF( vinPing , 4, '<', ' '  );
			vtxList += "  " + vtxSkill;
			vtxList += "  " + vtxName;
			fvoConsolePrint( pst_ptrEdict, vtxList + "\n" );
  		   
		}
		vtxList  = "\nList Totals: Humans " + ftxIntToString( vinCount_Humans );
		vtxList += "   Bots " + ftxIntToString( vinCount_Bots ) + "\n";
		vtxList += "Note: The skill is present for Bots only when BotAim is set ON\n";
		fvoConsolePrint( pst_ptrEdict, vtxList );

	} // tclPlayer::fvoListPlayers

	void tclPlayer::fvoInitSoundDamage( void )
	{
		// initialize command indexes only if needed
		if	( vinDamage_EqualProbCmdIdx == -1 ) 
			vinDamage_EqualProbCmdIdx = vclSoundCmdList_Damage.finFindSoundCmd( ctxDamage_EqualProbCmd );
		if	( vinDamage_HighProbCmdIdx == -1 ) 
			vinDamage_HighProbCmdIdx = vclSoundCmdList_Damage.finFindSoundCmd( ctxDamage_HighProbCmd );
		if	( vinDamage_LowProbCmdIdx == -1 ) 
			vinDamage_LowProbCmdIdx = vclSoundCmdList_Damage.finFindSoundCmd( ctxDamage_LowProbCmd );

		if	( vinDamage_HandSlapCmdIdx == -1 ) 
			vinDamage_HandSlapCmdIdx = vclSoundCmdList_System.finFindSoundCmd( ctxHandSlapCmd );
		if	( vinDamage_BitchSlapCmdIdx == -1 ) 
			vinDamage_BitchSlapCmdIdx = vclSoundCmdList_System.finFindSoundCmd( ctxBitchSlapCmd );
		
	} // tclPlayer::fvoInitSoundDamage

	bool tclPlayer::fboPlayDamageSound(  edict_t* pst_ptrEdict  )
	{
		if ( !fboPlayerIsAliveByEdict( pst_ptrEdict ) )
			return false;

		int vinSlot = vclPlayerSlot.finFindSlotByEdict( pst_ptrEdict );
		
		if ( vinSlot < 0 )
			return false;		
		
		if ( vclPlayerSlot.vcl_aryPlayer[ vinSlot ].vclTimer_Damage.fboTimedOut( ) == false )
			return false;

		string vtxSound;
		int vinRnd;
		if ( fboPlayerIsBotByEdict( pst_ptrEdict ) )
		{
			vinRnd = random( 100 );

			if ( vinRnd > 30 )
				vtxSound = vclSoundCmdList_Damage.ftxGetSoundFile( vinDamage_HighProbCmdIdx );
			else
				vtxSound = vclSoundCmdList_Damage.ftxGetSoundFile( vinDamage_LowProbCmdIdx );
		}

		if ( vtxSound.empty( ) )
			return false;

		vclPlayerSlot.vcl_aryPlayer[ vinSlot ].vclTimer_Damage.fvoStart( 1.25 );
		fvoEmitSoundFromPlayer( pst_ptrEdict, CHAN_AUTO, vtxSound );
		return true;

	} // tclPlayer::fboPlayDamageSound

	bool tclPlayer::fboListUserInfoByUserId( edict_t* pst_ptrEdict, int pinUserId )
	{
		const string ctxNo  = "no";
		const string ctxYes = "yes";

		string vtxMsg;

		edict_t* vst_ptrEdictUser = fst_ptrGetPlayerByUserId( pinUserId );
		string vtxUserId = ftxIntToString( pinUserId );
		
		if ( vst_ptrEdictUser == NULL )
		{
			vtxMsg = ctxMsgPrefix + "No user found with the specified user id of " + vtxUserId;
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return false;
		}

		string vtxUserName = ftxGetPlayerNameByEdict( vst_ptrEdictUser );
		string vtxAuthId    = ftxGetPlayerAuthId( vst_ptrEdictUser );
//!!.begin slot system needs to be redone
// string vtxNetAddr  = vclPlayerSlot.ftxGetPlayerAddressById( pinUserId );
//!!.end
      int vinPing        = finGetPlayerPing( vst_ptrEdictUser );
		string vtxPing		 = ftxIntToString( vinPing );

		tclUser* vclUser = vclSecurity.finAuthenticate( vst_ptrEdictUser );
		
		string vtxIsSrvOp  = ctxNo;
		string vtxIsAdmin1 = ctxNo;
		string vtxIsAdmin2 = ctxNo;
		string vtxIsClan   = ctxNo;
		string vtxIsGuest  = ctxNo;
		string vtxIsPublic = ctxNo;

		if ( vclUser != NULL )
		{
			if ( vclUser->vboAccessLevel_SrvOp  ) vtxIsSrvOp   = ctxYes;
			if ( vclUser->vboAccessLevel_Admin1 ) vtxIsAdmin1  = ctxYes;
			if ( vclUser->vboAccessLevel_Admin2 ) vtxIsAdmin2  = ctxYes;
			if ( vclUser->vboAccessLevel_Clan   ) vtxIsClan    = ctxYes;
			if ( vclUser->vboAccessLevel_Guest  ) vtxIsGuest   = ctxYes;
			if ( vclUser->vboAccessLevel_Public ) vtxIsPublic  = ctxYes;
		}

		vtxMsg  = ctxMsgPrefix + "User Information\n\n";
		fvoConsolePrint( pst_ptrEdict, vtxMsg );
		vtxMsg = "  User Name .. \"" + vtxUserName + "\"\n";
		fvoConsolePrint( pst_ptrEdict, vtxMsg );
		if ( ( vclSecurity.fboUserIsSrvOpByEdict( pst_ptrEdict ) )
					|| 
			  ( pst_ptrEdict == NULL ) 
					||
			  ( pst_ptrEdict == vst_ptrEdictUser ) )
		{
			string vtxPassword = vclSecurity.ftxGetPassword( vst_ptrEdictUser );
			vtxMsg = "  Password ... \"" + vtxPassword + "\"\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
		}
		
		vtxMsg  = "  Steam Id ... " + vtxAuthId + "\n";
		vtxMsg += "  User Id .... " + vtxUserId + "\n";
//		vtxMsg += "  ip:port .... " + vtxNetAddr + "\n";
		vtxMsg += "  ping ....... " + vtxPing + "\n";
		vtxMsg += "  Is SrvOp ... " + vtxIsSrvOp + "\n";
		vtxMsg += "  Is Admin1 .. " + vtxIsAdmin1 + "\n";
		vtxMsg += "  Is Admin2 .. " + vtxIsAdmin2 + "\n";
		vtxMsg += "  Is Clan .... " + vtxIsClan + "\n";
		vtxMsg += "  Is Guest ... " + vtxIsGuest + "\n";
		vtxMsg += "  Is Public .. " + vtxIsPublic + "\n";
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		
		return true;

	} // tclPlayer::fvoListUserInfoByUserId


	int tclPlayer::finGetGameMode( void )
	{
		return vinGameMode;
	} // tclPlayer::fvoGetGameMode

	void tclPlayer::fvoSetGameMode( void )
	{
		fvoSetGameMode( vinGameMode );
	} // tclPlayer::fvoSetGameMode

	void tclPlayer::fvoSetHeadShotMode( int pinHeadShotMode )
	{
		if ( pinHeadShotMode < cinHeadShot_Off )
			pinHeadShotMode = cinHeadShot_Off;
		else
		if ( pinHeadShotMode > cinHeadShot_All )
			pinHeadShotMode = cinHeadShot_All;

		vinHeadShotMode = pinHeadShotMode;

	} // tclPlayer::fvoSetHeadShotMode
	
	void tclPlayer::fvoCheckHeadShotMode( TraceResult* ptrTR )
	{
		if ( finGetHeadShotMode( ) == cinHeadShot_Off )
		// nothing to do;
			return;

		if ( ptrTR == NULL )
		// must be a valid pointer;
			return;

		if ( ptrTR->pHit == NULL )
			return;

		if ( ptrTR->flFraction == 1.0 )
		{
			// damage already prevented;
			return;
		}

//		if ( strcmp( STRING ( ptrTR->pHit->v.classname ), "player" ) != 0 )  

		if ( vclGlobalGameInfo.ftxGetSring( ptrTR->pHit->v.classname ) != "player" )
		// must be a player;
			return;

		if ( finGetHeadShotMode( ) == cinHeadShot_Bot )
		{
			if ( !fboPlayerIsBotByEdict( ptrTR->pHit ) )
			// must be a bot;
				return;
		}
		else
		if ( finGetHeadShotMode( ) == cinHeadShot_Human )
		{
			if ( !fboPlayerIsHumanByEdict( ptrTR->pHit ) )
			// must be a human;
				return;
		}
		else
		if ( finGetHeadShotMode( ) == cinHeadShot_Clan )
		{
			if ( finGetPlayerTeamByEdict( ptrTR->pHit ) != finGetClanTeam( ) )
			// must be on the clan team;
				return;
		}
		else
		if ( finGetHeadShotMode( ) == cinHeadShot_World )
		{
			if ( finGetPlayerTeamByEdict( ptrTR->pHit ) == finGetClanTeam( ) )
			// must be on the world team;
				return;
		}

		if ( ptrTR->iHitgroup != HITGROUP_HEAD ) 
		// pass through the bodypart, disallowing damage for it;
			ptrTR->flFraction = 1.0; 

	} // tclPlayer::fvoCheckHeadShotMode

	void tclPlayer::fvoSetGameMode( int pinGameMode )
	{
		if ( pinGameMode == cinGameMode_Fun )
		{
			fvoCVarSetString( "mp_startmoney", "16000" );
			fvoCVarSetString( "mp_friendlyfire", "0" );
			fvoCVarSetString( "mp_freezetime", "10" );
			fvoCVarSetString( "mp_buytime", "4" );
//!!.removed for beta test
//!!			fvoCVarSetString( "mp_timelimit", "20" );
//!!.end
			fvoCVarSetString( "mp_roundtime", "5" );
		}
		else
		if ( pinGameMode == cinGameMode_Serious )
		{
			fvoCVarSetString( "mp_startmoney", "800" );
			fvoCVarSetString( "mp_friendlyfire", "1" );
			fvoCVarSetString( "mp_freezetime", "6" );
			fvoCVarSetString( "mp_buytime", "0.5" );
//!!.removed for beta test
//!!			fvoCVarSetString( "mp_timelimit", "0" );
//!!.end
			fvoCVarSetString( "mp_roundtime", "5" );
		}
		else
		// this is an error condition caused by an invalid mode
		// assignment attempt; do not assign the value;
			return;

		vinGameMode = pinGameMode;

	} // tclPlayer::fvoSetGameMode

	int tclPlayer::finGetClanTeam( void )
	{
		if ( vinCurrentClanTeam == cinTeam_Unknown ) 
		{
			int vinClanOnTeam_TE;
			int vinClanOnTeam_CT;

			fvoCountClanMembers( vinClanOnTeam_TE, vinClanOnTeam_CT );

			if ( ( vinClanOnTeam_TE > 0 ) 
				      && 
				  ( vinClanOnTeam_CT == 0 ) 
				)
				vinCurrentClanTeam = cinTeam_CT;
			else
			if ( ( vinClanOnTeam_CT > 0 ) 
				      && 
				  ( vinClanOnTeam_TE == 0 ) 
				)
				vinCurrentClanTeam = cinTeam_TE;
			else
				vinCurrentClanTeam = cinTeam_Any;
		} // ( vinCurrentClanTeam == cinTeam_Unknown )

		if ( vinCurrentClanTeam == cinTeam_Any )
			return cinTeam_Any;

		if ( vinCurrentClanTeam == cinTeam_TE )
			return cinTeam_TE;

		if ( vinCurrentClanTeam == cinTeam_CT )
			return cinTeam_CT;
	
		return cinTeam_Unknown;

	} // tclPlayer::finGetClanTeam

	bool tclPlayer::fboIsAllowedOnClanTeamByUserId( int pinUserId )
	{
		edict_t* vstEdict_Player = fst_ptrGetPlayerByUserId( pinUserId );

		if ( vstEdict_Player == NULL )
		// this is an error condition; 
			return true;

		if ( fboPlayerIsBotByEdict( vstEdict_Player ) )
		// bots are always allowed on the clan team;
			return true;

		if ( vclSecurity.fboUserIsClanByEdict( vstEdict_Player ) )
		// clan members are always allowed on the clan team;
			return true;

		int vinSlotIdx = vclPlayerSlot.finFindSlotById( pinUserId );
		int vinIsAllowedOnClanTeam = vclPlayerSlot.finIsAllowedOnClanTeam( vinSlotIdx );

		return ( vinIsAllowedOnClanTeam == cinYes );

	} // tclPlayer::fboIsAllowedOnClanTeamByUserId

	bool tclPlayer::fboIsAllowedOffClanTeamByUserId( int pinUserId )
	{
		edict_t* vstEdict_Player = fst_ptrGetPlayerByUserId( pinUserId );

		if ( vstEdict_Player == NULL )
		// this is an error condition; 
			return true;

		if ( fboPlayerIsBotByEdict( vstEdict_Player ) )
		// bots are always allowed off the clan team;
			return true;

		if ( vclSecurity.fboUserIsClanByEdict( vstEdict_Player ) )
		{
			int vinSlotIdx = vclPlayerSlot.finFindSlotById( pinUserId );
			int vinIsAllowedOffClanTeam = vclPlayerSlot.finIsAllowedOffClanTeam( vinSlotIdx );
			return ( vinIsAllowedOffClanTeam == cinYes );
		}

		// non clan members are always allowed off the clan team;
		return true;

	} // tclPlayer::fboIsAllowedOffClanTeamByUserId

	void tclPlayer::fvoEnforceClanTeam( void )
	{
		if ( vboEnforceClanTeam != true )
			return;

		int vinClanTeam = finGetClanTeam( );
	
		if ( ( vinClanTeam != cinTeam_TE )
					&& 
			  ( vinClanTeam != cinTeam_CT )
			)
		{
			// this is an error condition;
			vboEnforceClanTeam = false;
			return;
		}

		string vtxReason = "You are on the wrong team - press 'M' to switch teams.";
		
		//string vtxReason = "You were on the wrong team - auto switched by server.";

		int vinUserId;
		int vinSlotIdx;
		int vinTeam;
		bool vboClanMember;
		int vinClanMemberCount = 0;
		edict_t* vstEdict_Player;
		

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			vstEdict_Player = fst_ptrGetPlayerByIndex( vinIdx );

			if ( !fboPlayerIsHumanByEdict( vstEdict_Player ) )
				continue;

			vboClanMember = 
				vclSecurity.fboUserIsClanByEdict( vstEdict_Player ) 
					||
				vclSecurity.fboUserHasClanTagByEdict( vstEdict_Player );
			

			if ( vboClanMember )
				vinClanMemberCount++;

			if ( !fboPlayerIsAliveByEdict( vstEdict_Player ) )
				continue;

			vinTeam = finGetPlayerTeamByEdict( vstEdict_Player );

/*!! -- removed
			if ( ( vinTeam != vinClanTeam ) 
				       && 
				  ( vboClanMember          ) 
			   )
			{
				vinSlotIdx = vclPlayerSlot.finFindSlotByEdict( vstEdict_Player );
				if ( vclPlayerSlot.finIsAllowedOffClanTeam( vinSlotIdx ) == cinYes )
					continue;

				fboKillPlayerByIndex( vinIdx, vtxReason + "\n" );	
				//fboSwitchTeamByEdict( vstEdict_Player, vtxReason );
				continue;
			}
*/	
			if ( ( vinTeam == vinClanTeam ) 
				       && 
				  ( !vboClanMember         ) 
			   )
			{
				vinSlotIdx = vclPlayerSlot.finFindSlotByEdict( vstEdict_Player );
				if ( vclPlayerSlot.finIsAllowedOnClanTeam( vinSlotIdx ) == cinYes )
					continue;

				fboKillPlayerByEdict( vstEdict_Player, vtxReason + "\n" );	
				//fboSwitchTeamByEdict( vstEdict_Player, vtxReason );
			}
		}
		
		if ( vinClanMemberCount <= 0 )
		{
		   // no more clan members, so turn enforcement off
			vclPlayer.vboEnforceClanTeam = false;
			vclPlayer.vinCurrentClanTeam = cinTeam_Unknown;
			vtxReason = ctxMsgPrefix + "There are no clan members. Clan team enforcement will be turned off.";
			vclHUD.fvoStatusSay ( vtxReason );
		}

	} // tclPlayer::fvoEnforceClanTeam

	bool tclPlayer::fboSendEvent_EnforceClanTeam( float pflDelay )
	{
		bool vboResult = vclEventSched.fboCreateEvent( );

		if ( vboResult )
		{
			float vflDelay = pflDelay + fflRandomFloat( 0.0, 2.0 );
			vclEventSched.fvoSetEventFunc( fvoMA_Player_Event_EnforceClanTeam );
			vboResult = vboResult & vclEventSched.fboCreateArgList( 1 );
			vclEventSched.fvoSetArg_Short( 0, pflDelay );
			vclEventSched.fvoSetDelayInSecs( vflDelay ); 
			vboResult = vboResult & vclEventSched.fboSendEvent( );
		}

		return vboResult;

	} // tclPlayer::fboSendEvent_EnforceClanTeam

	int tclPlayer::finGetHumanTeam( void )
	{

		if ( !vboEnforceHumanTeam )
			return cinTeam_Any;

		if ( vboEnforceHumanTeam_Fixed )
			return vinCurrentHumanTeam;

		int vinHumansOnTeam_TE;
		int vinHumansOnTeam_CT;

		finCountHumansOnTeam( vinHumansOnTeam_TE, vinHumansOnTeam_CT );

		if ( ( vinHumansOnTeam_TE + vinHumansOnTeam_CT ) == 0 )
		{
			// allow human on any team until there are humans in the game;
			vinCurrentHumanTeam = cinTeam_Any;
		}
		else
		if ( ( vinHumansOnTeam_TE == 0 ) && ( vinHumansOnTeam_CT > 0 ) )
			return cinTeam_CT;
		else
		if ( ( vinHumansOnTeam_CT == 0 ) && ( vinHumansOnTeam_TE > 0 ) )
			return cinTeam_TE;
		else
		if ( vinCurrentHumanTeam == cinTeam_CT )
			return cinTeam_CT;
		else
		if ( vinCurrentHumanTeam == cinTeam_TE )
			return cinTeam_TE;
		else
		if ( vinHumansOnTeam_CT > vinHumansOnTeam_TE )
			vinCurrentHumanTeam = cinTeam_CT;
		else
		if ( vinHumansOnTeam_TE > vinHumansOnTeam_CT )
			vinCurrentHumanTeam = cinTeam_TE;
		else
			vinCurrentHumanTeam = finGenRandomTeam( );	

		return vinCurrentHumanTeam;

	} // tclPlayer::finGetHumanTeam

	void tclPlayer::fvoEnforceHumanTeam( void )
	{
		if ( !vboEnforceHumanTeam || !vclBot.fboBotsInGame( ) )
			return;

		int vinHumanTeam = finGetHumanTeam( );
	
		if ( ( vinHumanTeam != cinTeam_TE )
					&& 
			  ( vinHumanTeam != cinTeam_CT )
			)
		{
			// this is NOT an error condition;
			// humans are allowed on any team, there is nothing to do;
			return;
		}

		string vtxReason = "You are on the wrong team - press 'M' to switch teams.";
		
		int vinTeam;
		edict_t* vstEdict_Player;

		for ( int vinIdx = cinMinPlayerIndex; 
				vinIdx <= finGetMaxPlayers( ); 
				vinIdx++ )
		{
			vstEdict_Player = fst_ptrGetPlayerByIndex( vinIdx );

			if ( !fboPlayerIsHumanByEdict( vstEdict_Player ) )
				continue;

			if ( !fboPlayerIsAliveByEdict( vstEdict_Player ) )
				continue;

			vinTeam = finGetPlayerTeamByEdict( vstEdict_Player );

			if ( vinTeam != vinHumanTeam ) 
			{
				fboKillPlayerByEdict( vstEdict_Player, vtxReason + "\n" );	
			}
		}
		
	} // tclPlayer::fvoEnforceHumanTeam

	bool tclPlayer::fboSendEvent_EnforceHumanTeam( float pflDelay )
	{
		bool vboResult = vclEventSched.fboCreateEvent( );

		if ( vboResult )
		{
			float vflDelay = pflDelay + fflRandomFloat( 0.0, 2.0 );
			vclEventSched.fvoSetEventFunc( fvoMA_Player_Event_EnforceHumanTeam );
			vboResult = vboResult && vclEventSched.fboCreateArgList( 1 );
			vclEventSched.fvoSetArg_Short( 0, pflDelay );
			vclEventSched.fvoSetDelayInSecs( vflDelay ); 
			vboResult = vboResult && vclEventSched.fboSendEvent( );
		}

		return vboResult;

	} // tclPlayer::fboSendEvent_EnforceHumanTeam

	int tclPlayer::finGetMaxHumans( )
	{ 
		if ( vinMaxHumans > vclGlobalGameInfo.finGetMaxPlayers( ) )
			vinMaxHumans = vclGlobalGameInfo.finGetMaxPlayers( );
		return vinMaxHumans; 
	} // tclPlayer::finGetMaxHumans

	bool tclPlayer::fboSetMaxHumans( int pinMaxHumans )
	{
		if ( ( pinMaxHumans < cinMinPlayers ) || ( pinMaxHumans > vclGlobalGameInfo.finGetMaxPlayers( ) ) )
		{
			return false;
		}
		vinMaxHumans = pinMaxHumans; 
		return true;

	} // tclPlayer::fboSetMaxHumans

	bool tclPlayer::fboHumanCountExceeded( )
	{
		return finCountHumansInGame( ) > vclPlayer.finGetMaxHumans( );
	} // tclPlayer::fboHumanCountExceeded

//.e MA_Player.cpp


void tclPlayer::fvoAddBot( string ptxBotName, const int pinTeam )
{

	string vtxMsg;
	int vinTean = pinTeam;

	if ( ( pinTeam != cinTeam_TE ) && ( pinTeam != cinTeam_CT ) )
	{
		vinTean = finGenRandomTeam( );
	}

	string vtxTeam = ftxIntToString( pinTeam );
	string vtxSkin;

	if ( vinTean == cinTeam_TE )
		vtxSkin = "2";
	else
		vtxSkin = "4";

/*
  edict_t *BotEnt;  // this is a pointer to the engine's edict structure
   char ptr[128];  // allocate space for message from ClientConnect
   char *infobuffer;  // pointer to buffer for key/value data
   int clientIndex;  // engine's player index (1-32)

   BotEnt = g_engfuncs.pfnCreateFakeClient)( "Bot" );
   player( VARS(BotEnt) );
   infobuffer = g_engfuncs.pfnGetInfoKeyBuffer)( BotEnt )
   clientIndex = ENTINDEX( BotEnt );
   g_engfuncs.pfnSetClientKeyValue)( clientIndex, infobuffer, "model", "gina" );
   ClientConnect( BotEnt, "BotName", "127.0.0.1", ptr );
   ClientPutInServer( BotEnt );
   BotEnt->v.flags |= FL_FAKECLIENT;
*/

	edict_t *vst_ptrEdict;  // this is a pointer to the engine's edict structure
	
	vst_ptrEdict = 
		vstENGFuncsBot.pfnCreateFakeClient( ptxBotName.c_str( ) );

	if ( vst_ptrEdict == NULL )
	{
		vtxMsg = ctxMsgPrefix + "Cannot add bot - server may be full.";
		fvoServerPrint_nl( vtxMsg );
		return;
	}

	//	player( VARS(BotEnt) ); Line below replaces this one.
	vclInterfaceL1.fvoCreateEntityPlayer( vst_ptrEdict );

//	int vinPlayerIdx = finGetIndexOfEdict( pst_ptrEdict );

   //	infobuffer = g_engfuncs.pfnGetInfoKeyBuffer)( vst_ptrEntity )
	// infobuffer = fch_ptrGetInfoKeyBuffer( vst_ptrEdict );
   // int clientIndex = ENTINDEX( vst_ptrEdict );
	// g_engfuncs.pfnSetClientKeyValue( clientIndex, infobuffer, "model", "gina" );
	
	fboSetClientKeyValue( vst_ptrEdict, "model", "gina" );
	fboSetClientKeyValue( vst_ptrEdict, "rate", "3500.000000" );
	fboSetClientKeyValue( vst_ptrEdict, "cl_updaterate", "20" );
	fboSetClientKeyValue( vst_ptrEdict, "cl_lw", "1" );
	fboSetClientKeyValue( vst_ptrEdict, "cl_lc", "1" );
	fboSetClientKeyValue( vst_ptrEdict, "tracker", "0" );
	fboSetClientKeyValue( vst_ptrEdict, "cl_dlmax", "128" );
	fboSetClientKeyValue( vst_ptrEdict, "lefthand", "1" );
	fboSetClientKeyValue( vst_ptrEdict, "friends", "0" );
	fboSetClientKeyValue( vst_ptrEdict, "dm", "0" );
	fboSetClientKeyValue( vst_ptrEdict, "ah", "1" );
	
	vst_ptrEdict->v.flags |= FL_FAKECLIENT;
	vst_ptrEdict->v.spawnflags |= FL_FAKECLIENT;
  
	char szRejectReason[ 128] = "";

	vstDLLFuncsBot.pfnClientConnect
		( vst_ptrEdict, 
		  ptxBotName.c_str( ), 
		  "127.0.0.1", szRejectReason );

   vstDLLFuncsOrig.pfnClientPutInServer( vst_ptrEdict );

	vst_ptrEdict->v.flags &= ~FL_FAKECLIENT;
	vst_ptrEdict->v.flags |= def_FAKE_CLIENT_BIT;
	vst_ptrEdict->v.spawnflags &= ~FL_FAKECLIENT;
	vst_ptrEdict->v.spawnflags |= def_FAKE_CLIENT_BIT;

	vst_ptrEdict->v.button |= IN_ATTACK;
	
	vst_ptrEdict->v.maxspeed = fflCVarGetFloat( "sv_maxspeed" );

	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );

// select TEAM
	fvoExecFakeClientCommandDELAYED( 
		/* float pflDelayInSec */ 3, 
		/* edict_t *pEntity    */ vst_ptrEdict,
		/* string ptxArg1      */ "menuselect", 
		/* string ptxArg2 = "" */ vtxTeam, 
	   /* string ptxArg3 = "" */ "", 
		/* string ptxArg4 = "" */ "" );

	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	4, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );

// select SKIN
	fvoExecFakeClientCommandDELAYED( 
		/* float pflDelayInSec */ 5, 
		/* edict_t *pEntity    */ vst_ptrEdict,
		/* string ptxArg1      */ "menuselect", 
		/* string ptxArg2 = "" */ vtxSkin, 
	   /* string ptxArg3 = "" */ "", 
		/* string ptxArg4 = "" */ "" );

	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	6, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );

	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	6.1, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );

} // tclPlayer::fvoAddBot 

void junk()
{
	edict_t *vst_ptrEdict;

	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );
	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );
	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );
	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );
	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );
	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );
	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );

	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2.01, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );

	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2.10, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );

	fvoRunPlayerMove_DELAYED( 
		/* float pflDelayInSec		*/	2.11, 
		/* edict_t *fakeclient		*/	vst_ptrEdict, 
		/* const float *viewangles */ vst_ptrEdict->v.v_angle, 
		/* float forwardmove			*/	0, 
		/* float sidemove				*/	0, 
		/* float upmove				*/ 0, 
		/* unsigned short buttons	*/ vst_ptrEdict->v.button, 
		/* byte impulse				*/ 0, 
		/* byte msec					*/ 10 );

}
