//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Sched.cpp
//	
//	[MEAN] Event Scheduling Module.
//
//.e	

#include "MG_Lib.h"
#include "MA_Sched.h"
#include <new.h>

	const int cinIgnoreRollOverCount = -1; 
	const int cinTickCountNotSet		= -1; 
	const string ctxNull = "";

	long vinEventMsgId = 0;

	string vtxMsg;

	long finGetNextEventId( )
	{
		return ( vinEventMsgId == cinMaxRollOverCount ) ? 0 : ++vinEventMsgId;
	} // finGetNextEventId

	// ===========================================================
	// START: tclCPUClock_2
	// ===========================================================

	tclCPUClock_2 vclCPUClock_2;

	tclCPUClock_2::tclCPUClock_2( )
	{
		vinRollOverCount = 0;
		vinPrevTickCount = cinTickCountNotSet; 	
	} // tclCPUClock_2::tclCPUClock_2

	clock_t tclCPUClock_2::finGetTickCount( )
	{
		// On error clock returns -1;
		clock_t vinCurTickCount = clock( );

		if ( vinRollOverCount < 0 ) 
			vinRollOverCount = 0;

		if ( vinPrevTickCount < 0 )
			goto locExitPoint;
		
		if ( vinPrevTickCount > vinCurTickCount )
		// the clock has rolled over;
		{
			if ( vinRollOverCount == cinMaxRollOverCount )
				vinRollOverCount = 0;
			else
				++vinRollOverCount;
		}

		locExitPoint:
		{
			vinPrevTickCount = vinCurTickCount;
			return vinCurTickCount;
		}

	} // tclCPUClock_2::finGetTickCount

	clock_t tclCPUClock_2::finGetTickCount( long& pinRollOverCount )
	{
		finGetTickCount( );
		pinRollOverCount = vinRollOverCount;
		return vinPrevTickCount;

	} // tclCPUClock_2::finGetTickCount

	long tclCPUClock_2::finGetRollOverCount( )
	{
		return vinRollOverCount;
	} // tclCPUClock_2::finGetRollOverCount

	// ===========================================================
	// START: tclType
	// ===========================================================

	tclType::tclType( )
	{
		fvoSetNull( );
	} // tclType::tclType

	bool tclType::fboIsNull( )
	{
		return vinType == cinType_Null;
	} // tclType::fboIsNull

	bool tclType::fboIsType( const short pinType )
	{
		return vinType == pinType;
	} // tclType::fboIsType

	void tclType::fvoSetNull( )
	{
		vinType = cinType_Null;
		vtxString = "";
	} // tclType::fvoSetNull

	// ===========================================================
	// START: tclArgList
	// ===========================================================

	tclArgList::tclArgList( )
	{
		vcl_ptrType = NULL;
		vinNumArgs = 0;
	} // tclArgList::tclArgList

	tclArgList::~tclArgList( )
	{
		fvoDeleteArgList( );
	} // tclArgList::~tclArgList

	void tclArgList::fvoDeleteArgList( )
	{
		if ( vcl_ptrType == NULL )
		{
			return;
		}

		delete[] vcl_ptrType; 
		vcl_ptrType = NULL;
		vinNumArgs = 0;

	} // tclArgList::fvoDeleteArgList

	bool tclArgList::fboCreateArgList( int pinNumArgs )
	{

		fvoDeleteArgList( );

		if ( pinNumArgs <= 0 )
			return true;

		if ( pinNumArgs > cinMaxArgList ) pinNumArgs = cinMaxArgList;
		// change default handler to return NULL on fail;
		set_new_handler( 0 );
		vcl_ptrType = new tclType[ pinNumArgs ];

		if ( vcl_ptrType == NULL )
			goto locFailed;
		
		// if we get here the argument list was successfully created with
		// element size = pinNumArgs;
		vinNumArgs = pinNumArgs;
		return true;

		locFailed:
		{
			vinNumArgs = 0;
			vcl_ptrType = NULL;
			return false;
		}

	} // tclArgList::fboCreateArgList

	int tclArgList::finGetNumArgs( )
	{
		if ( ( vcl_ptrType == NULL ) && ( vinNumArgs != 0 ) )
			vinNumArgs = 0;

		return vinNumArgs;
	} // tclArgList::finGetNumArgs

	bool tclArgList::fboArgIdxOk( int pinIdx )
	{
		if ( vcl_ptrType == NULL )
			return false;
		
		if ( ( pinIdx < 0 ) || ( pinIdx >= vinNumArgs ) )
			return false;
		
		return true;

	} // tclArgList::fboArgIdxOk

	bool tclArgList::fboArgIdxOk( int pinIdx, const short pinType )
	{
		if ( !fboArgIdxOk( pinIdx ) )
			return false;

		return vcl_ptrType[ pinIdx ].fboIsType( pinType ); 

	} // tclArgList::fboArgIdxOk

	bool tclArgList::fboIsNull( int pinIdx )
	{
		return fboArgIdxOk( pinIdx ) ? vcl_ptrType[ pinIdx ].fboIsNull( ) : true;
	} // tclArgList::fboIsNull

	bool tclArgList::fboIsType( int pinIdx, const short pinType )
	{
		if ( !fboArgIdxOk( pinIdx ) )
		{
			if ( pinType == cinType_Null ) return true;
			return false;
		}

		return vcl_ptrType[ pinIdx ].fboIsType( pinType ); 

	} // tclArgList::fboIsType

	int tclArgList::finFindUnusedArgIdx( )
	{
		int vinMaxIdx = finGetNumArgs( ) - 1; 

		for ( int vinIdx = 0; vinIdx <= vinMaxIdx; vinIdx++ )
		{
			if ( fboIsNull( vinIdx ) )
				return vinIdx;
		}

		return -1;

	} // tclArgList::finFindUnusedArgIdx

	int tclArgList::finFindArgIdx( string ptxName )
	{
		int vinMaxIdx = finGetNumArgs( ) - 1; 

		for ( int vinIdx = 0; vinIdx <= vinMaxIdx; vinIdx++ )
		{
			if ( fboIsNull( vinIdx ) )
				continue;

			if ( vcl_ptrType[ vinIdx ].vtxName == ptxName )
				return vinIdx;
		}

		return -1;

	} // tclArgList::finFindArgIdx

	void tclArgList::fvoSetArg_Char( int pinIdx, signed char pchType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vchSChar = pchType;
		vcl_ptrType[ pinIdx ].vinType = cinType_SChar;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_Char

	int tclArgList::finSetArg_Char( string ptxName, signed char pchType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_Char( vinIdx, pchType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_Char

	void tclArgList::fvoSetArg_UChar( int pinIdx, unsigned char pchType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vchUChar = pchType;
		vcl_ptrType[ pinIdx ].vinType = cinType_UChar;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_UChar

	int tclArgList::finSetArg_UChar( string ptxName, unsigned char pchType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_UChar( vinIdx, pchType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_UChar

	void tclArgList::fvoSetArg_Bool( int pinIdx, bool pboType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vboBool = pboType;
		vcl_ptrType[ pinIdx ].vinType = cinType_Bool;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_Bool

	int tclArgList::finSetArg_Bool( string ptxName, bool pboType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_Bool( vinIdx, pboType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_Bool

	void tclArgList::fvoSetArg_Short( int pinIdx, signed short pinType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vinSShort = pinType;
		vcl_ptrType[ pinIdx ].vinType = cinType_SShort;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_Short

	int tclArgList::finSetArg_Short( string ptxName, signed short pinType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_Short( vinIdx, pinType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_Short

	void tclArgList::fvoSetArg_UShort( int pinIdx, unsigned short pinType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vinUShort = pinType;
		vcl_ptrType[ pinIdx ].vinType = cinType_UShort;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_UShort

	int tclArgList::finSetArg_UShort( string ptxName, unsigned short pinType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_UShort( vinIdx, pinType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_UShort

	void tclArgList::fvoSetArg_Int( int pinIdx, signed int pinType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vinSInt = pinType;
		vcl_ptrType[ pinIdx ].vinType = cinType_SInt;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_Int

	int tclArgList::finSetArg_Int( string ptxName, signed int pinType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_Int( vinIdx, pinType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_Int

	void tclArgList::fvoSetArg_UInt( int pinIdx, unsigned int pinType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vinUInt = pinType;
		vcl_ptrType[ pinIdx ].vinType = cinType_UInt;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_UInt

	int tclArgList::finSetArg_UInt( string ptxName, unsigned int pinType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_UInt( vinIdx, pinType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_Int

	void tclArgList::fvoSetArg_Long( int pinIdx, signed long pinType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vinSLong = pinType;
		vcl_ptrType[ pinIdx ].vinType = cinType_SLong;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_Long

	int tclArgList::finSetArg_Long( string ptxName, signed long pinType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_Long( vinIdx, pinType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_Long

	void tclArgList::fvoSetArg_ULong( int pinIdx, unsigned long pinType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vinULong = pinType;
		vcl_ptrType[ pinIdx ].vinType = cinType_ULong;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_ULong

	int tclArgList::finSetArg_ULong( string ptxName, unsigned long pinType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_ULong( vinIdx, pinType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_ULong

	void tclArgList::fvoSetArg_Float( int pinIdx, float pflType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vflFloat = pflType;
		vcl_ptrType[ pinIdx ].vinType = cinType_Float;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_Float

	int tclArgList::finSetArg_Float( string ptxName, float pflType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_Float( vinIdx, pflType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_Float

	void tclArgList::fvoSetArg_String( int pinIdx, string ptxType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		
		vcl_ptrType[ pinIdx ].vtxString = ptxType;
		vcl_ptrType[ pinIdx ].vinType = cinType_String;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;

	} // tclArgList::fvoSetArg_String

	int tclArgList::finSetArg_String( string ptxName, string ptxType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_String( vinIdx, ptxType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_String

	void tclArgList::fvoSetArg_PtrVoid( int pinIdx, void* pvo_ptrType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		vcl_ptrType[ pinIdx ].vvo_ptrVoid = pvo_ptrType;
		vcl_ptrType[ pinIdx ].vinType = cinType_PtrVoid;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;
	} // tclArgList::fvoSetArg_PtrVoid

	int tclArgList::finSetArg_PtrVoid( string ptxName, void* pvo_ptrType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_PtrVoid( vinIdx, pvo_ptrType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_PtrVoid

	void tclArgList::fvoSetArg_PtrFloat( int pinIdx, float* pfl_ptrType, string ptxName )
	{
		if ( !fboArgIdxOk( pinIdx ) )	return;
		vcl_ptrType[ pinIdx ].vfl_ptrFloat = pfl_ptrType;
		vcl_ptrType[ pinIdx ].vinType = cinType_PtrFloat;
		vcl_ptrType[ pinIdx ].vtxName = ptxName;
	} // tclArgList::fvoSetArg_PtrFloat

	int tclArgList::finSetArg_PtrFloat( string ptxName, float* pfl_ptrType )
	{
		int vinIdx = finFindUnusedArgIdx( );
		if ( !fboArgIdxOk( vinIdx ) )	return -1;
		fvoSetArg_PtrFloat( vinIdx, pfl_ptrType, ptxName );
		return vinIdx;
	} // tclArgList::finSetArg_PtrFloat

	signed char tclArgList::fchGetArg_Char( int pinIdx )
	{
		return fboArgIdxOk( pinIdx, cinType_SChar ) ? vcl_ptrType[ pinIdx ].vchSChar : 0;
	} // tclArgList::fchGetArg_Char

	signed char tclArgList::fchGetArg_Char( string ptxName )
	{
		return fchGetArg_Char( finFindArgIdx( ptxName ) );
	} // tclArgList::fchGetArg_Char

	unsigned char tclArgList::fchGetArg_UChar( int pinIdx )
	{
		return fboArgIdxOk( pinIdx, cinType_UChar ) ? vcl_ptrType[ pinIdx ].vchUChar : 0;
	} // tclArgList::fchGetArg_UChar

	unsigned char tclArgList::fchGetArg_UChar( string ptxName )
	{
		return fchGetArg_UChar( finFindArgIdx( ptxName ) );
	} // tclArgList::fchGetArg_UChar

	bool tclArgList::fboGetArg_Bool( int pinIdx )
	{
		return fboArgIdxOk( pinIdx, cinType_Bool ) ? vcl_ptrType[ pinIdx ].vboBool : 0;
	} // tclArgList::fboGetArg_Bool

	bool tclArgList::fboGetArg_Bool( string ptxName )
	{
		return fboGetArg_Bool( finFindArgIdx( ptxName ) );
	} // tclArgList::fboGetArg_Bool

	signed short tclArgList::finGetArg_Short( int pinIdx )
	{
		return fboArgIdxOk( pinIdx, cinType_SShort ) ? vcl_ptrType[ pinIdx ].vinSShort : 0;
	} // tclArgList::finGetArg_Short

	signed short tclArgList::finGetArg_Short( string ptxName )
	{
		return finGetArg_Short( finFindArgIdx( ptxName ) );
	} // tclArgList::finGetArg_Short

	unsigned short tclArgList::finGetArg_UShort( int pinIdx )
	{
		return fboArgIdxOk( pinIdx, cinType_UShort ) ? vcl_ptrType[ pinIdx ].vinUShort : 0;
	} // tclArgList::finGetArg_UShort

	unsigned short tclArgList::finGetArg_UShort( string ptxName )
	{
		return finGetArg_UShort( finFindArgIdx( ptxName ) );
	} // tclArgList::finGetArg_UShort

	signed int tclArgList::finGetArg_Int( int pinIdx )
	{
		return fboArgIdxOk( pinIdx, cinType_SInt ) ? vcl_ptrType[ pinIdx ].vinSInt : 0;
	} // tclArgList::finGetArg_Int

	signed int tclArgList::finGetArg_Int( string ptxName )
	{
		return finGetArg_Int( finFindArgIdx( ptxName ) );
	} // tclArgList::finGetArg_Int

	unsigned int tclArgList::finGetArg_UInt( int pinIdx )
	{
		return fboArgIdxOk( pinIdx, cinType_UInt ) ? vcl_ptrType[ pinIdx ].vinUInt : 0;
	} // tclArgList::finGetArg_UInt

	unsigned int tclArgList::finGetArg_UInt( string ptxName )
	{
		return finGetArg_UInt( finFindArgIdx( ptxName ) );
	} // tclArgList::finGetArg_UInt

	signed long tclArgList::finGetArg_Long( int pinIdx )
	{
		return fboArgIdxOk( pinIdx, cinType_SLong ) ? vcl_ptrType[ pinIdx ].vinSLong : 0;
	} // tclArgList::finGetArg_Long

	signed long tclArgList::finGetArg_Long( string ptxName )
	{
		return finGetArg_Long( finFindArgIdx( ptxName ) );
	} // tclArgList::finGetArg_Long

	unsigned long tclArgList::finGetArg_ULong( int pinIdx )
	{
		return fboArgIdxOk( pinIdx, cinType_ULong ) ? vcl_ptrType[ pinIdx ].vinULong : 0;
	} // tclArgList::finGetArg_ULong

	unsigned long tclArgList::finGetArg_ULong( string ptxName )
	{
		return finGetArg_ULong( finFindArgIdx( ptxName ) );
	} // tclArgList::finGetArg_ULong

	float tclArgList::fflGetArg_Float( int pinIdx )
	{
		return fboArgIdxOk( pinIdx, cinType_Float ) ? vcl_ptrType[ pinIdx ].vflFloat : 0.0;
	} // tclArgList::ffGetArg_Float

	float tclArgList::fflGetArg_Float( string ptxName )
	{
		return fflGetArg_Float( finFindArgIdx( ptxName ) );
	} // tclArgList::ffGetArg_Float

	string tclArgList::ftxGetArg_String( int pinIdx )
	{
		 return fboArgIdxOk( pinIdx, cinType_String ) ? vcl_ptrType[ pinIdx ].vtxString : ctxNull;
	} // tclArgList::ftxGetArg_String

	string tclArgList::ftxGetArg_String( string ptxName )
	{
		 return ftxGetArg_String( finFindArgIdx( ptxName ) );
	} // tclArgList::ftxGetArg_String

	void* tclArgList::fvo_ptrGetArg_PtrVoid( int pinIdx )
	{
		 return fboArgIdxOk( pinIdx, cinType_PtrVoid ) ? vcl_ptrType[ pinIdx ].vvo_ptrVoid : NULL;
	} // tclArgList::fvo_ptrGetArg_PtrVoid

	void* tclArgList::fvo_ptrGetArg_PtrVoid( string ptxName )
	{
		 return fvo_ptrGetArg_PtrVoid( finFindArgIdx( ptxName ) );
 	} // tclArgList::fvo_ptrGetArg_PtrVoid

	float* tclArgList::ffl_ptrGetArg_PtrFloat( int pinIdx )
	{
		 return fboArgIdxOk( pinIdx, cinType_PtrFloat ) ? vcl_ptrType[ pinIdx ].vfl_ptrFloat : NULL;
	} // tclArgList::ffl_ptrGetArg_PtrFloat

	float* tclArgList::ffl_ptrGetArg_PtrFloat( string ptxName )
	{
		 return ffl_ptrGetArg_PtrFloat( finFindArgIdx( ptxName ) );
 	} // tclArgList::ffl_ptrGetArg_PtrFloat

	// ===========================================================
	// START: tclEventMsg
	// ===========================================================

	tclEventMsg::tclEventMsg( )
	{

//!! vtxMsg = "Initializing Event";
//!! vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		
		// by default events will time out instantly;
		vinEventMsgId				= finGetNextEventId( );

//!! vtxMsg = "Initializing Event ID: " + ftxIntToString( finGetEventMsgId( ) );
//!! vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );

		vflDelayPeriodInSecs    = 0.0;
		vinInitialRollOverCount = cinIgnoreRollOverCount; 
		vinTimeOutRollOverCount = cinIgnoreRollOverCount; 
		vfn_ptrEventFunc			= NULL;
		vcl_ptrPred = NULL;
		vcl_ptrSucc = NULL;
		fvoSetDelayInTicks( vinTimeOutRollOverCount );

	} // tclEventMsg::tclEventMsg

	void tclEventMsg::fvoSetEventFunc( tfn_ptrEventFunc pfn_ptrEventFunc )
	{
		vfn_ptrEventFunc = pfn_ptrEventFunc;
	} // tclEventMsg::fvoSetEventFunc

	void tclEventMsg::fvoExecEventFunc( )
	{
		if ( vfn_ptrEventFunc == NULL ) return;
		vfn_ptrEventFunc( vclArgList );
	} // tclEventMsg::fvoExecEventFunc

	void tclEventMsg::fvoSetDelayInTicks( clock_t pinDelayInTicks )
	{
		if ( pinDelayInTicks < 0 ) pinDelayInTicks = 0;

		vflDelayPeriodInSecs = pinDelayInTicks / cinTicksInSec;
		clock_t vinCurTickCount = vclCPUClock_2.finGetTickCount( vinInitialRollOverCount );

		clock_t vinMaxDelayWithoutRollOver = cinMaxTickCount - vinCurTickCount;
		
		if ( vinMaxDelayWithoutRollOver < pinDelayInTicks )
		{
			if ( vinInitialRollOverCount == cinMaxRollOverCount )
				vinTimeOutRollOverCount = 0;
			else
				vinTimeOutRollOverCount = vinInitialRollOverCount + 1;

			vinTimeOutTickCount = pinDelayInTicks - vinMaxDelayWithoutRollOver - 1;
		}
		else
		{
			vinTimeOutRollOverCount = vinInitialRollOverCount;
			vinTimeOutTickCount = pinDelayInTicks + vinCurTickCount;
		}

	} // tclEventMsg::fvoSetDelayInTicks

	void tclEventMsg::fvoSetDelayInSecs( float pflDelayInSecs )
	{
		if ( pflDelayInSecs < 0.0 ) 
			pflDelayInSecs = 0.0;
		else
		if ( pflDelayInSecs > cflMaxDelayInSec ) 
			pflDelayInSecs = cflMaxDelayInSec;

		clock_t vinDelayInTicks = pflDelayInSecs * CLK_TCK;
		fvoSetDelayInTicks( vinDelayInTicks );

	} // tclEventMsg::fvoSetDelayInSecs

	void tclEventMsg::fvoSetDelayInHrs( float pflDelayInHrs )
	{
		if ( pflDelayInHrs < 0.0 ) 
			pflDelayInHrs = 0.0;
		else
		if ( pflDelayInHrs > cflMaxDelayInHrs ) 
			pflDelayInHrs = cflMaxDelayInHrs;

		clock_t vinDelayInTicks = pflDelayInHrs * cinTicksInHr;
		fvoSetDelayInTicks( vinDelayInTicks );

	} // tclEventMsg::fvoSetDelayInHrs

	bool tclEventMsg::fboEventHasTimedOut( )
	{

//!!	vtxMsg = "Inside tclEventMsg::fboEventHasTimedOut( )";
//!!	vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );

		clock_t vinCurRollOverCount; 
		clock_t vinCurTickCount = vclCPUClock_2.finGetTickCount( vinCurRollOverCount );

		if ( vinTimeOutRollOverCount == vinCurRollOverCount )
		{
			if ( vinTimeOutTickCount <= vinCurTickCount ) 
				return true;
			else
				return false;
		}

		if ( vinCurRollOverCount > vinTimeOutRollOverCount )
		{
			return true;
		}

		if ( ( vinCurRollOverCount == cinMinRollOverCount )
			      &&
			  ( vinTimeOutRollOverCount == cinMaxRollOverCount ) )
		{
			return true;
		}

		// if we get here the event delay has not yet fully elapsed;
		return false; 

	} // tclEventMsg::fboEventHasTimedOut

	bool tclEventMsg::fboIsGreaterThan( tclEventMsg* pcl_ptrEventMsg )
	{
		if ( pcl_ptrEventMsg == NULL )
			return false;

		if ( vinTimeOutRollOverCount == pcl_ptrEventMsg->vinTimeOutRollOverCount )
		{
			if ( vinTimeOutTickCount > pcl_ptrEventMsg->vinTimeOutTickCount ) 
				return true;
			
			return false;
		}

		if ( vinTimeOutRollOverCount == cinMinRollOverCount )
		{
			if ( pcl_ptrEventMsg->vinTimeOutRollOverCount == cinMaxRollOverCount )
				return true;

			return false;
		}

		if ( vinTimeOutRollOverCount == cinMaxRollOverCount )
		{
			if ( pcl_ptrEventMsg->vinTimeOutRollOverCount == cinMinRollOverCount )
				return false;

			return true;

		}

		if ( vinTimeOutRollOverCount > pcl_ptrEventMsg->vinTimeOutRollOverCount )
		{
			return true;
		}
		
		return false;

	} // tclEventMsg::fboIsGreaterThan

	bool tclEventMsg::fboIsLesserThan( tclEventMsg* pcl_ptrEventMsg )
	{
		if ( pcl_ptrEventMsg == NULL )
			return false;

		if ( vinTimeOutRollOverCount == pcl_ptrEventMsg->vinTimeOutRollOverCount )
		{
			if ( vinTimeOutTickCount < pcl_ptrEventMsg->vinTimeOutTickCount ) 
				return true;
			
			return false;
		}

		if ( vinTimeOutRollOverCount == cinMaxRollOverCount )
		{
			if ( pcl_ptrEventMsg->vinTimeOutRollOverCount == cinMinRollOverCount )
				return true;

			return false;
		}

		if ( vinTimeOutRollOverCount == cinMinRollOverCount )
		{
			if ( pcl_ptrEventMsg->vinTimeOutRollOverCount == cinMaxRollOverCount )
				return false;
	
			return true;
		}

		if ( vinTimeOutRollOverCount < pcl_ptrEventMsg->vinTimeOutRollOverCount )
		{
			return true;
		}
		
		return false;

	} // tclEventMsg::fboIsLesserThan

	bool tclEventMsg::fboIsEqualTo( tclEventMsg* pcl_ptrEventMsg )
	{
		if ( pcl_ptrEventMsg == NULL )
			return false;

		if ( ( vinTimeOutRollOverCount == pcl_ptrEventMsg->vinTimeOutRollOverCount )
					&&
			  ( vinTimeOutTickCount == pcl_ptrEventMsg->vinTimeOutTickCount ) )
		{
			return true;
		}

		return false;

	} // tclEventMsg::fboIsEqualTo

	void tclEventMsg::fvoInsertEvent( tclEventMsg*& pcl_ptrStartOfList )
	{
//!!	vtxMsg = "Inserting Event ID: " + ftxIntToString( finGetEventMsgId( ) );
//!!	vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );

		if ( pcl_ptrStartOfList == NULL )
		{
			pcl_ptrStartOfList = this;
			goto locExitInsert;
		}

		tclEventMsg* vcl_ptrEventMsg;
		vcl_ptrEventMsg = pcl_ptrStartOfList;

		// find location to insert;

		locInsertLoop: 
		{			
			if ( vcl_ptrEventMsg->fboIsGreaterThan( this ) )
			{

				if ( vcl_ptrEventMsg->vcl_ptrPred == NULL )
				{
					pcl_ptrStartOfList = this;
					vcl_ptrSucc = vcl_ptrEventMsg;
					vcl_ptrEventMsg->vcl_ptrPred = this;
				}
				else
				{
					vcl_ptrEventMsg->vcl_ptrPred->vcl_ptrSucc = this;
					vcl_ptrPred = vcl_ptrEventMsg->vcl_ptrPred;
					vcl_ptrSucc = vcl_ptrEventMsg;
					vcl_ptrEventMsg->vcl_ptrPred = this;
				}

				goto locExitInsert;

			}

			if ( vcl_ptrEventMsg->vcl_ptrSucc == NULL )
			{
				// we are at the end of the list, so insert at end of list;
				vcl_ptrPred = vcl_ptrEventMsg;
				vcl_ptrEventMsg->vcl_ptrSucc = this;
				goto locExitInsert;
			}

			vcl_ptrEventMsg = vcl_ptrEventMsg->vcl_ptrSucc;
			goto locInsertLoop;

		} // locInsertLoop

		locExitInsert:
		// nothing more to do;

	} // tclEventMsg::fvoInsertEvent

	tclEventMsg* tclEventMsg::fcl_ptrRemoveEvent( tclEventMsg*& pcl_ptrStartOfList )
	{

//!!	vtxMsg = "Removing Event ID: " + ftxIntToString( finGetEventMsgId( ) );
//!!	vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );

		// no check is made to ensure the event is actually in the event list;

		if ( vcl_ptrPred == NULL )
			pcl_ptrStartOfList = vcl_ptrSucc;
		else
			vcl_ptrPred->vcl_ptrSucc = vcl_ptrSucc;

		if ( vcl_ptrSucc != NULL )
			vcl_ptrSucc->vcl_ptrPred = vcl_ptrPred;

		vcl_ptrSucc = NULL;
		vcl_ptrPred = NULL;

		return this;

	} // tclEventMsg::fcl_ptrRemoveEvent
	
	void tclEventMsg::fvoRemoveEvent( tclEventMsg*& pcl_ptrStartOfList )
	{
		fcl_ptrRemoveEvent( pcl_ptrStartOfList );
	} // tclEventMsg::fvoRemoveEvent

	// ===========================================================
	// START: tclEventSched
	// ===========================================================

	tclEventSched vclEventSched;

	tclEventSched::tclEventSched( )
	{
		vcl_ptrActiveEventMsg = NULL;
		vcl_ptrNewEventMsg = NULL;
		vcl_ptrEventList = NULL;
	
	} // tclEventSched::tclEventSched

	tclEventSched::~tclEventSched( )
	{
		if ( vcl_ptrNewEventMsg != NULL )
		// a message exists and was not scheduled;
			delete vcl_ptrNewEventMsg;

		// free memory from event list;
		while ( vcl_ptrEventList != NULL )
		{
			vcl_ptrActiveEventMsg = vcl_ptrEventList;
			vcl_ptrActiveEventMsg = vcl_ptrActiveEventMsg->fcl_ptrRemoveEvent( vcl_ptrEventList );
			if ( vcl_ptrActiveEventMsg != NULL )
				delete vcl_ptrActiveEventMsg;
		} 
	
	} // tclEventSched::~tclEventSched

	bool tclEventSched::fboCreateEvent( )
	{
//!!	vclDebugTrace.fvoWriteEventInfo( true, "inside fboCreateEvent" );

		if ( vcl_ptrNewEventMsg != NULL )
		{	// remove message that was not scheduled;
//!! vclDebugTrace.fvoWriteEventInfo( true, "vcl_ptrNewEventMsg != NULL" );
			delete vcl_ptrNewEventMsg;
			vcl_ptrNewEventMsg = NULL;
		}
//!!	vclDebugTrace.fvoWriteEventInfo( true, "set_new_handler( 0 )" );
		set_new_handler( 0 );
//!! vclDebugTrace.fvoWriteEventInfo( true, "vcl_ptrNewEventMsg = new tclEventMsg;" );
		vcl_ptrNewEventMsg = new tclEventMsg;
		if ( vcl_ptrNewEventMsg == NULL )
		{
//!! vclDebugTrace.fvoWriteEventInfo( true, "about to return false" );
			return false;
		}
//!!vclDebugTrace.fvoWriteEventInfo( true, "vcl_ptrNewEventMsg->finGetEventMsgId( );" );
		vinLastMsgId = vcl_ptrNewEventMsg->finGetEventMsgId( );
//!!vclDebugTrace.fvoWriteEventInfo( true, "about to return true" );
		return true;

	} // tclEventSched::fboCreateEvent

	bool tclEventSched::fboSendEvent( )
	{
		if ( vcl_ptrNewEventMsg == NULL )
		// there is no message to be sent;
			return false;

		vcl_ptrNewEventMsg->fvoInsertEvent( vcl_ptrEventList );
		vcl_ptrNewEventMsg = NULL;
		return true;

	} // tclEventSched::fboSendEvent

	bool tclEventSched::fboCancelEvent( long pinEventId )
	{
		return false;
	} // tclEventSched::fboCancelEvent

	void tclEventSched::fvoExecEvent( )
	{
		if ( vcl_ptrEventList != NULL )
		{
			vcl_ptrActiveEventMsg = vcl_ptrEventList;

			if ( vcl_ptrActiveEventMsg->fboEventHasTimedOut( ) )
			{
				vcl_ptrActiveEventMsg->fcl_ptrRemoveEvent( vcl_ptrEventList );
				vcl_ptrActiveEventMsg->fvoExecEventFunc( );
				delete vcl_ptrActiveEventMsg;
			}
		}
		
	} //	tclEventSched::fvoExecEvent

	//
	// interface to tclArgList vclArgList;
	//
	void tclEventSched::fvoDeleteArgList( )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoDeleteArgList( );
	} // tclEventSched::fvoDeleteArgList

	bool tclEventSched::fboCreateArgList( int pinNumArgs )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return false;
		return vcl_ptrNewEventMsg->vclArgList.fboCreateArgList( pinNumArgs );
	} // tclEventSched::fboCreateArgList

	int tclEventSched::finGetNumArgs( )
	{
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetNumArgs( );
	} // tclEventSched::finGetNumArgs

	bool tclEventSched::fboIsNull( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return true;
		return vcl_ptrNewEventMsg->vclArgList.fboIsNull( pinIdx );
	} // tclEventSched::fboIsNull

	bool tclEventSched::fboIsType( int pinIdx, const short pinType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL )
		{
			if ( pinType == cinType_Null )
				return true;
			return false;
		}
		return vcl_ptrNewEventMsg->vclArgList.fboIsType( pinIdx, pinType );
	} // tclEventSched::fboIsType

	void tclEventSched::fvoSetArg_Char( int pinIdx, signed char pchType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_Char( pinIdx, pchType, ptxName );
	} // tclEventSched::fvoSetArg_Char

	int tclEventSched::finSetArg_Char( string ptxName, signed char pchType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_Char( ptxName, pchType );
	} // tclEventSched::finSetArg_Char

	void tclEventSched::fvoSetArg_UChar( int pinIdx, unsigned char pchType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_UChar( pinIdx, pchType, ptxName );
	} // tclEventSched::fvoSetArg_UChar

	int tclEventSched::finSetArg_UChar( string ptxName, unsigned char pchType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_UChar( ptxName, pchType );
	} // tclEventSched::finSetArg_UChar

	void tclEventSched::fvoSetArg_Bool( int pinIdx, bool pboType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_Bool( pinIdx, pboType, ptxName );
	} // tclEventSched::fvoSetArg_Bool

	int tclEventSched::finSetArg_Bool( string ptxName, bool pboType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_Bool( ptxName, pboType );
	} // tclEventSched::finSetArg_Bool

	void tclEventSched::fvoSetArg_Short( int pinIdx, signed short pinType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_Short( pinIdx, pinType, ptxName );
	} // tclEventSched::fvoSetArg_Short

	int tclEventSched::finSetArg_Short( string ptxName, signed short pinType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_Short( ptxName, pinType );
	} // tclEventSched::finSetArg_Short

	void tclEventSched::fvoSetArg_UShort( int pinIdx, unsigned short pinType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_UShort( pinIdx, pinType, ptxName );
	} // tclEventSched::fvoSetArg_UShort

	int tclEventSched::finSetArg_UShort( string ptxName, unsigned short pinType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_UShort( ptxName, pinType );
	} // tclEventSched::finSetArg_UShort

	void tclEventSched::fvoSetArg_Int( int pinIdx, signed int pinType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_Int( pinIdx, pinType, ptxName );
	} // tclEventSched::fvoSetArg_Int

	int tclEventSched::finSetArg_Int( string ptxName, signed int pinType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_Int( ptxName, pinType );
	} // tclEventSched::finSetArg_Int

	void tclEventSched::fvoSetArg_UInt( int pinIdx, unsigned int pinType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_UInt( pinIdx, pinType, ptxName );
	} // tclEventSched::fvoSetArg_UInt

	int tclEventSched::finSetArg_UInt( string ptxName, unsigned int pinType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_UInt( ptxName, pinType );
	} // tclEventSched::finSetArg_UInt

	void tclEventSched::fvoSetArg_Long( int pinIdx, signed long pinType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_Long( pinIdx, pinType, ptxName );
	} // tclEventSched::fvoSetArg_Long

	int tclEventSched::finSetArg_Long( string ptxName, signed long pinType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_Long( ptxName, pinType );
	} // tclEventSched::fvoSetArg_Long

	void tclEventSched::fvoSetArg_ULong( int pinIdx, unsigned long pinType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_ULong( pinIdx, pinType, ptxName );
	} // tclEventSched::fvoSetArg_ULong

	int tclEventSched::finSetArg_ULong( string ptxName, unsigned long pinType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_ULong( ptxName, pinType );
	} // tclEventSched::fvoSetArg_ULong

	void tclEventSched::fvoSetArg_Float( int pinIdx, float pflType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_Float( pinIdx, pflType, ptxName );
	} // tclEventSched::fvoSetArg_Float

	int tclEventSched::finSetArg_Float( string ptxName, float pflType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_Float( ptxName, pflType );
	} // tclEventSched::fvoSetArg_Float

	void tclEventSched::fvoSetArg_String( int pinIdx, string ptxType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_String( pinIdx, ptxType, ptxName );
	} // tclEventSched::fvoSetArg_String

	int tclEventSched::finSetArg_String( string ptxName, string ptxType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_String( ptxName, ptxType );
	} // tclEventSched::fvoSetArg_String

	void tclEventSched::fvoSetArg_PtrVoid( int pinIdx, void* pvo_ptrType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_PtrVoid( pinIdx, pvo_ptrType, ptxName );
	} // tclEventSched::fvoSetArg_PtrVoid

	int tclEventSched::finSetArg_PtrVoid( string ptxName, void* pvo_ptrType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_PtrVoid( ptxName, pvo_ptrType );
	} // tclEventSched::finSetArg_PtrVoid

	void tclEventSched::fvoSetArg_PtrFloat( int pinIdx, float* pfl_ptrType, string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->vclArgList.fvoSetArg_PtrFloat( pinIdx, pfl_ptrType, ptxName );
	} // tclEventSched::fvoSetArg_PtrFloat

	int tclEventSched::finSetArg_PtrFloat( string ptxName, float* pfl_ptrType )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->vclArgList.finSetArg_PtrFloat( ptxName, pfl_ptrType );
	} // tclEventSched::finSetArg_PtrFloat

	signed char tclEventSched::fchGetArg_Char( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.fchGetArg_Char( pinIdx );
	} // tclEventSched::fchGetArg_Char

	signed char tclEventSched::fchGetArg_Char( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.fchGetArg_Char( ptxName );
	} // tclEventSched::fchGetArg_Char

	unsigned char tclEventSched::fchGetArg_UChar( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.fchGetArg_UChar( pinIdx );
	} // tclEventSched::fchGetArg_UChar

	unsigned char tclEventSched::fchGetArg_UChar( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.fchGetArg_UChar( ptxName );
	} // tclEventSched::fchGetArg_UChar

	bool tclEventSched::fboGetArg_Bool( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return false;
		return vcl_ptrNewEventMsg->vclArgList.fboGetArg_Bool( pinIdx );
	} // tclEventSched::fboGetArg_Bool

	bool tclEventSched::fboGetArg_Bool( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return false;
		return vcl_ptrNewEventMsg->vclArgList.fboGetArg_Bool( ptxName );
	} // tclEventSched::fboGetArg_Bool

	signed short tclEventSched::finGetArg_Short( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_Short( pinIdx );
	} // tclEventSched::finGetArg_Short

	signed short tclEventSched::finGetArg_Short( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_Short( ptxName );
	} // tclEventSched::finGetArg_Short

	unsigned short tclEventSched::finGetArg_UShort( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_UShort( pinIdx );
	} // tclEventSched::finGetArg_UShort

	unsigned short tclEventSched::finGetArg_UShort( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_UShort( ptxName );
	} // tclEventSched::finGetArg_UShort

	signed int tclEventSched::finGetArg_Int( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_Int( pinIdx );
	} // tclEventSched::finGetArg_Int

	signed int tclEventSched::finGetArg_Int( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_Int( ptxName );
	} // tclEventSched::finGetArg_Int

	unsigned int tclEventSched::finGetArg_UInt( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_UInt( pinIdx );
	} // tclEventSched::finGetArg_UInt

	unsigned int tclEventSched::finGetArg_UInt( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_UInt( ptxName );
	} // tclEventSched::finGetArg_UInt

	signed long tclEventSched::finGetArg_Long( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_Long( pinIdx );
	} // tclEventSched::finGetArg_Long

	unsigned long tclEventSched::finGetArg_ULong( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_ULong( pinIdx );
	} // tclEventSched::finGetArg_ULong

	unsigned long tclEventSched::finGetArg_ULong( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0;
		return vcl_ptrNewEventMsg->vclArgList.finGetArg_ULong( ptxName );
	} // tclEventSched::finGetArg_ULong

	float tclEventSched::fflGetArg_Float( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0.0;
		return vcl_ptrNewEventMsg->vclArgList.fflGetArg_Float( pinIdx );
	} // tclEventSched::fflGetArg_Float

	float tclEventSched::fflGetArg_Float( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return 0.0;
		return vcl_ptrNewEventMsg->vclArgList.fflGetArg_Float( ptxName );
	} // tclEventSched::fflGetArg_Float

	string tclEventSched::ftxGetArg_String( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return "";
		return vcl_ptrNewEventMsg->vclArgList.ftxGetArg_String( pinIdx );
	} // tclEventSched::ftxGetArg_String

	string tclEventSched::ftxGetArg_String( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return "";
		return vcl_ptrNewEventMsg->vclArgList.ftxGetArg_String( ptxName );
	} // tclEventSched::ftxGetArg_String

	void* tclEventSched::fvo_ptrGetArg_PtrVoid( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return NULL;
		return vcl_ptrNewEventMsg->vclArgList.fvo_ptrGetArg_PtrVoid( pinIdx );
	} // tclEventSched::fvo_ptrGetArg_PtrVoid

	void* tclEventSched::fvo_ptrGetArg_PtrVoid( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return NULL;
		return vcl_ptrNewEventMsg->vclArgList.fvo_ptrGetArg_PtrVoid( ptxName );
	} // tclEventSched::fvo_ptrGetArg_PtrVoid

	float* tclEventSched::ffl_ptrGetArg_PtrFloat( int pinIdx )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return NULL;
		return vcl_ptrNewEventMsg->vclArgList.ffl_ptrGetArg_PtrFloat( pinIdx );
	} // tclEventSched::ffl_ptrGetArg_PtrFloat

	float* tclEventSched::ffl_ptrGetArg_PtrFloat( string ptxName )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return NULL;
		return vcl_ptrNewEventMsg->vclArgList.ffl_ptrGetArg_PtrFloat( ptxName );
	} // tclEventSched::ffl_ptrGetArg_PtrFloat

	//
	// interface to new vcl_ptrNewEventMsg;
	//
	int tclEventSched::finGetEventMsgId( )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return -1;
		return vcl_ptrNewEventMsg->finGetEventMsgId( );
	} // tclEventSched::finGetEventMsgId

	void tclEventSched::fvoSetEventFunc( tfn_ptrEventFunc pfn_ptrEventFunc )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->fvoSetEventFunc( pfn_ptrEventFunc );
	} // tclEventSched::fvoSetEventFunc

	void tclEventSched::fvoSetDelayInHrs( float pflDelayInHrs )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->fvoSetDelayInHrs( pflDelayInHrs );
	} // tclEventSched::fvoSetDelayInHrs

	void tclEventSched::fvoSetDelayInSecs( float pflDelayInSecs )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->fvoSetDelayInSecs( pflDelayInSecs );
	} // tclEventSched::fvoSetDelayInSecs

	void tclEventSched::fvoSetDelayInTicks( clock_t pinDelayInTicks )
	{ 
		if ( vcl_ptrNewEventMsg == NULL ) return;
		vcl_ptrNewEventMsg->fvoSetDelayInTicks( pinDelayInTicks );
	} // tclEventSched::fvoSetDelayInTicks

