//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Sched.h
//	
//	[MEAN] Event Scheduling Module. 
//
//.e	

//.b skip over if header has already been included.
	#ifndef defMA_Sched_h

// Prevent the reprocessing of this definition file by defining 
// the alias used in the above "ifndef" check.
	#define defMA_Sched_h

// Include all general definition files.
	#include "MB_Includes.h"
	#include "MA_time.h"
	#include <values.h>

	// ===========================================================
	// START: tclCPUClock
	// ===========================================================

	const clock_t cinMaxTickCount = MAXLONG;
	const clock_t cinMinTickCount = 0;
	const long cinMaxRollOverCount = MAXLONG;
	const long cinMinRollOverCount = 0;

//	const short cinSecsInMin		= 60;
//	const short cinSecsInHr			= cinSecsInMin * 60;

//	const clock_t cinTicksInSec	= CLK_TCK;
//	const clock_t cinTicksInMin	= cinSecsInMin * cinTicksInSec;
//	const clock_t cinTicksInHr		= cinSecsInHr * cinTicksInSec;

	const float cflMaxDelayInSec = cinMaxTickCount / cinTicksInSec;
	const float cflMinDelayInSec = 0.0;
	const float cflMaxDelayInHrs = cinMaxTickCount / cinTicksInHr;
	const float cflMinDelayInHrs = 0.0;

	class tclCPUClock_2
	{
		public:
			clock_t vinPrevTickCount;     
			long vinRollOverCount;

			tclCPUClock_2( );
			clock_t finGetTickCount( );
			clock_t finGetTickCount( long& pinRollOverCount );
			long finGetRollOverCount( ); 

	}; // tclCPUClock_2

	// ===========================================================
	// START: tclType
	// ===========================================================

	const short cinType_Null		 =  0; // no value defined - end of list marker;
	const short cinType_SChar		 =  1; 
	const short cinType_UChar		 =  2; 
	const short cinType_Bool		 =  3;
	const short cinType_SShort		 =  4; 
	const short cinType_UShort		 =  5; 
	const short cinType_SInt		 =  6; 
	const short cinType_UInt		 =  7; 
	const short cinType_SLong	    =  8; 
	const short cinType_ULong		 =  9; 
	const short cinType_Float		 = 10; 
	const short cinType_Double		 = 11;
	const short cinType_LDouble	 = 12;
	const short cinType_PtrVoid	 = 13; 
	const short cinType_PtrSChar	 = 14; 
	const short cinType_PtrUChar	 = 15; 
	const short cinType_PtrSShort	 = 16; 
	const short cinType_PtrUShort	 = 17; 
	const short cinType_PtrSInt	 = 18; 
	const short cinType_PtrUInt	 = 19; 
	const short cinType_PtrSLong   = 20; 
	const short cinType_PtrULong   = 21; 
	const short cinType_PtrFloat   = 22; 
	const short cinType_PtrDouble	 = 23;
	const short cinType_PtrLDouble = 24;
	const short cinType_String		 = 25; 

	//!! idea on how to deal with array pointers to ensure they
	//!! always will be deallocated from the tclType class;
/*
	class tclLDouble_ary
	{
		long double* vdb_ptrLDouble; 
		int vinSize;
		public:
		tclLDouble_ary( );
		tclLDouble_ary( int pinSize );
		~tclLDouble_ary( );
	};

	tclLDouble_ary vclLDouble_ary( 10 );
*/
	class tclType
	{
		public:
			int vinType;
			union 
			{ 	signed char				vchSChar; 
				unsigned char			vchUChar; 
				bool						vboBool;
				signed short			vinSShort; 
				unsigned short			vinUShort; 
				signed int				vinSInt; 
				unsigned int			vinUInt; 
				signed long int		vinSLong; 
				unsigned long int		vinULong; 
				float						vflFloat; 
				double					vdbDouble; 
				long double				vdbLDouble; 
				//!! pointers leave the possibility of memory leaks
				//!! even if the calling routine clears them because leaks will
				//!! happen when the software shuts down. Something has to be
				//!! put in place to ensure that everything is cleared up;
				//!! see idea above;
				void*						vvo_ptrVoid; 
				signed char*			vch_ptrSChar; 
				unsigned char*			vch_ptrUChar; 
				signed short*			vin_ptrSShort; 
				unsigned short*		vin_ptrUShort; 
				signed int*				vin_ptrSInt; 
				unsigned int*			vin_ptrUInt; 
				signed long int*		vin_ptrSLongInt; 
				unsigned long int*	vin_ptrULongInt; 
				float*					vfl_ptrFloat; 
				double*					vdb_ptrDouble; 
				long double*			vdb_ptrLDouble; 
			};

			// classes cannot exist within a union structure;
			string vtxString;
			string vtxName; // descriptive name of argument;
			tclType( );
			bool fboIsNull( );
			bool fboIsType( const short pinType );
			void fvoSetNull( );

	}; // tclType

	// ===========================================================
	// START: tclArgList
	// ===========================================================

	const int cinMaxArgList = 255;

	class tclArgList
	{
		tclType* vcl_ptrType;
		int vinNumArgs;
		public:
			tclArgList( );
			~tclArgList( );
			void fvoDeleteArgList( );
			bool fboCreateArgList( int pinNumArgs );
			int finGetNumArgs( );
			bool fboArgIdxOk( int pinIdx );
			bool fboArgIdxOk( int pinIdx, const short pinType );
			bool fboIsNull( int pinIdx );
			bool fboIsType( int pinIdx, const short pinType );
			int finFindUnusedArgIdx( );
			int finFindArgIdx( string ptxName );
			void fvoSetArg_Char( int pinIdx, signed char pchType, string ptxName = "" );
			int finSetArg_Char( string ptxName, signed char pchType );
			void fvoSetArg_UChar( int pinIdx, unsigned char pchType, string ptxName = "" );
			int finSetArg_UChar( string ptxName, unsigned char pchType );
			void fvoSetArg_Bool( int pinIdx, bool pboType, string ptxName = "" );
			int finSetArg_Bool( string ptxName, bool pboType );
			void fvoSetArg_Short( int pinIdx, signed short pinType, string ptxName = "" );
			int finSetArg_Short( string ptxName , signed short pinType );
			void fvoSetArg_UShort( int pinIdx, unsigned short pinType, string ptxName = "" );
			int finSetArg_UShort( string ptxName, unsigned short pinType );
			void fvoSetArg_Int( int pinIdx, signed int pinType, string ptxName = ""  );
			int finSetArg_Int( string ptxName, signed int pinType );
			void fvoSetArg_UInt( int pinIdx, unsigned int pinType, string ptxName = "" );
			int finSetArg_UInt( string ptxName, unsigned int pinType );
			void fvoSetArg_Long( int pinIdx, signed long pinType, string ptxName = "" );
			int finSetArg_Long( string ptxName, signed long pinType );
			void fvoSetArg_ULong( int pinIdx, unsigned long pinType, string ptxName = "" );
			int finSetArg_ULong( string ptxName, unsigned long pinType );
			void fvoSetArg_Float( int pinIdx, float pflType, string ptxName = "" );
			int finSetArg_Float( string ptxName, float pflType );
			void fvoSetArg_String( int pinIdx, string ptxType, string ptxName = "" );
			int finSetArg_String( string ptxName, string ptxType );
			void fvoSetArg_PtrVoid( int pinIdx, void* pvo_ptrType, string ptxName = "" );
			int finSetArg_PtrVoid( string ptxName, void* pvo_ptrType );
			void fvoSetArg_PtrFloat( int pinIdx, float* pfl_ptrType, string ptxName = "" );
			int finSetArg_PtrFloat( string ptxName, float* pfl_ptrType );

			signed char fchGetArg_Char( int pinIdx );
			signed char fchGetArg_Char( string ptxName );
			unsigned char fchGetArg_UChar( int pinIdx );
			unsigned char fchGetArg_UChar( string ptxName );
			bool fboGetArg_Bool( int pinIdx );
			bool fboGetArg_Bool( string ptxName );
			signed short finGetArg_Short( int pinIdx );
			signed short finGetArg_Short( string ptxName );
			unsigned short finGetArg_UShort( int pinIdx );
			unsigned short finGetArg_UShort( string ptxName );
			signed int finGetArg_Int( int pinIdx );
			signed int finGetArg_Int( string ptxName );
			unsigned int finGetArg_UInt( int pinIdx );
			unsigned int finGetArg_UInt( string ptxName );
			signed long finGetArg_Long( int pinIdx );
			signed long finGetArg_Long( string ptxName );
			unsigned long finGetArg_ULong( int pinIdx );
			unsigned long finGetArg_ULong( string ptxName );
			float fflGetArg_Float( int pinIdx );
			float fflGetArg_Float( string ptxName );
			string ftxGetArg_String( int pinIdx );
			string ftxGetArg_String( string ptxName );
			void* fvo_ptrGetArg_PtrVoid( int pinIdx );
			void* fvo_ptrGetArg_PtrVoid( string ptxName );
			float* ffl_ptrGetArg_PtrFloat( int pinIdx );
			float* ffl_ptrGetArg_PtrFloat( string ptxName );

	}; // tclArgList

	// ===========================================================
	// START: tclEventMsg
	// ===========================================================

	typedef void ( *tfn_ptrEventFunc )( tclArgList& pclArgList );

	class tclEventMsg
	{
		private: 
			tfn_ptrEventFunc vfn_ptrEventFunc;

			float vflDelayPeriodInSecs;    // Initial delay in seconds before event;
			long vinInitialRollOverCount; 
			long vinTimeOutRollOverCount; 
			clock_t vinTimeOutTickCount; 
			tclEventMsg* vcl_ptrPred; // previous message in d-linked list;
			tclEventMsg* vcl_ptrSucc; // next message in d-linked list;

		public:
			tclArgList vclArgList;    // message data storage class;
			long vinEventMsgId;
			tclEventMsg( );
			int finGetEventMsgId( ){ return vinEventMsgId; }
			void fvoSetEventFunc( tfn_ptrEventFunc pfn_ptrEventFunc );
			void fvoExecEventFunc( );
			void fvoSetDelayInHrs( float pflDelayInHrs );
			void fvoSetDelayInSecs( float pflDelayInSecs );
			void fvoSetDelayInTicks( clock_t pinDelayInTicks );
			bool fboEventHasTimedOut( );
			bool fboIsGreaterThan( tclEventMsg* pcl_ptrEventMsg );
			bool fboIsLesserThan( tclEventMsg* pcl_ptrEventMsg );
			bool fboIsEqualTo( tclEventMsg* pcl_ptrEventMsg );
			void fvoInsertEvent( tclEventMsg*& pcl_ptrStart );
			void fvoRemoveEvent( tclEventMsg*& pcl_ptrStart );
			tclEventMsg* fcl_ptrRemoveEvent( tclEventMsg*& pcl_ptrStart );

	}; // tclEventMsg

	// ===========================================================
	// START: tclEventSched
	// ===========================================================

	class tclEventSched
	{
		tclEventMsg* vcl_ptrEventList;
		tclEventMsg* vcl_ptrActiveEventMsg;
		tclEventMsg* vcl_ptrNewEventMsg;
		public:
			long vinLastMsgId;
			tclEventSched( );
			~tclEventSched( );

			bool fboCreateEvent( );
			bool fboSendEvent( );
			bool fboCancelEvent( long pinEventId );
			void fvoExecEvent( );
			
			//
			// interface to tclArgList vclArgList;
			//
			void fvoDeleteArgList( );
			bool fboCreateArgList( int pinNumArgs );
			int finGetNumArgs( );
			bool fboIsNull( int pinIdx );
			bool fboIsType( int pinIdx, const short pinType );

			void fvoSetArg_Char( int pinIdx, signed char pchType, string ptxName = "" );
			void fvoSetArg_UChar( int pinIdx, unsigned char pchType, string ptxName = "" );
			void fvoSetArg_Bool( int pinIdx, bool pboType, string ptxName = "" );
			void fvoSetArg_Short( int pinIdx, signed short pinType, string ptxName = "" );
			void fvoSetArg_UShort( int pinIdx, unsigned short pinType, string ptxName = "" );
			void fvoSetArg_Int( int pinIdx, signed int pinType, string ptxName = "" );
			void fvoSetArg_UInt( int pinIdx, unsigned int pinType, string ptxName = "" );
			void fvoSetArg_Long( int pinIdx, signed long pinType, string ptxName = "" );
			void fvoSetArg_ULong( int pinIdx, unsigned long pinType, string ptxName = "" );
			void fvoSetArg_Float( int pinIdx, float pflType, string ptxName = "" );
			void fvoSetArg_String( int pinIdx, string ptxType, string ptxName = "" );
			void fvoSetArg_PtrVoid( int pinIdx, void* pvo_ptrType, string ptxName = "" );
			void fvoSetArg_PtrFloat( int pinIdx, float* pfl_ptrType, string ptxName = "" );

			int finSetArg_Char( string ptxName, signed char pchType );
			int finSetArg_UChar( string ptxName, unsigned char pchType );
			int finSetArg_Bool( string ptxName, bool pboType );
			int finSetArg_Short( string ptxName, signed short pinType );
			int finSetArg_UShort( string ptxName, unsigned short pinType );
			int finSetArg_Int( string ptxName, signed int pinType );
			int finSetArg_UInt( string ptxName, unsigned int pinType );
			int finSetArg_Long( string ptxName, signed long pinType );
			int finSetArg_ULong( string ptxName, unsigned long pinType );
			int finSetArg_Float( string ptxName, float pflType );
			int finSetArg_String( string ptxName, string ptxType );
			int finSetArg_PtrVoid( string ptxName, void* pvo_ptrType );
			int finSetArg_PtrFloat( string ptxName, float* pfl_ptrType );

			signed char fchGetArg_Char( int pinIdx );
			unsigned char fchGetArg_UChar( int pinIdx );
			bool fboGetArg_Bool( int pinIdx );
			signed short finGetArg_Short( int pinIdx );
			unsigned short finGetArg_UShort( int pinIdx );
			signed int finGetArg_Int( int pinIdx );
			unsigned int finGetArg_UInt( int pinIdx );
			signed long finGetArg_Long( int pinIdx );
			unsigned long finGetArg_ULong( int pinIdx );
			float fflGetArg_Float( int pinIdx );
			string ftxGetArg_String( int pinIdx );
			void* fvo_ptrGetArg_PtrVoid( int pinIdx );
			float* ffl_ptrGetArg_PtrFloat( int pinIdx );

			signed char fchGetArg_Char( string ptxName );
			unsigned char fchGetArg_UChar( string ptxName );
			bool fboGetArg_Bool( string ptxName );
			signed short finGetArg_Short( string ptxName );
			unsigned short finGetArg_UShort( string ptxName );
			signed int finGetArg_Int( string ptxName );
			unsigned int finGetArg_UInt( string ptxName );
			signed long finGetArg_Long( string ptxName );
			unsigned long finGetArg_ULong( string ptxName );
			float fflGetArg_Float( string ptxName );
			string ftxGetArg_String( string ptxName );
			void* fvo_ptrGetArg_PtrVoid( string ptxName );
			float* ffl_ptrGetArg_PtrFloat( string ptxName );

			//
			// interface to new vcl_ptrNewEventMsg;
			//
			int finGetEventMsgId( );
			void fvoSetEventFunc( tfn_ptrEventFunc pfn_ptrEventFunc );
			void fvoSetDelayInHrs( float pflDelayInHrs );
			void fvoSetDelayInSecs( float pflDelayInSecs );
			void fvoSetDelayInTicks( clock_t pinDelayInTicks );

	}; // tclEventSched

	extern tclEventSched vclEventSched;

	#endif // defMA_Security_h
//.e skip over if header has already been included.

