//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Security.cpp
//	
//	[MEAN] Server Security Module. 
//
//.e	

#include "MG_Lib.h"
#include "MA_EngDLLCmd.h"
#include "MA_Player.h"
#include "MI_Player.h"
#include "MB_InterfaceL1.h"
#include "MA_Security.h"

	cvar_t vstCVar_ClanTag = { const_cast< char* >( ctxCVar_ClanTag.c_str( ) )	, "", FCVAR_EXTDLL };


	tclIPBan::tclIPBan( )
	{
		string vtxIP_Sub = "*";
		vtxIP_Full = "";
		for ( int vinIdx = 0; vinIdx < 4; vinIdx++ )
		{
			vstIP_Sub[ vinIdx ].vtxIP_Sub = vtxIP_Sub;
		}
		vcl_ptrNext = NULL;
	} // tclIPBan::tclIPBan

	tclIPBanList::tclIPBanList( )
	{
		vcl_ptrFirst = NULL;
	} // tclIPBanList::tclIPBanList

	tclIPBanList::~tclIPBanList( )
	{
		fvoDestroyList( );
	} // tclIPBanList::~tclIPBanList

	void tclIPBanList::fvoDestroyList( )
	{
		tclIPBan* vcl_ptrTemp;
		tclIPBan* vcl_ptrCur = vcl_ptrFirst;
		while ( vcl_ptrCur != NULL )
		{
			vcl_ptrTemp = vcl_ptrCur;
			vcl_ptrCur = vcl_ptrCur->vcl_ptrNext;
			delete vcl_ptrTemp;
		}
		
		vcl_ptrFirst = NULL;
	
	} // tclIPBanList::fvoDestroyList

	bool tclIPBanList::fboIPIsValid( string vtxLine, tclIPBan* vcl_ptrNew )
	{

string vtxMsg;
//vtxMsg = "we are here: tclIPBanList::fboIPIsValid (1)";
//vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);

		if ( vcl_ptrNew == NULL )
		{
			return false;
		}

		if ( vtxLine.empty( ) )
		{
			return false;
		}

		vcl_ptrNew->vtxIP_Full = vtxLine;

		string vtxIPSub = "";
		int vinSubCount = 0;
		int vinTestSub;

		for ( unsigned int vinIdx = 0; vinIdx < vtxLine.length( ); vinIdx++ )
		{
			if ( vtxLine[ vinIdx ] == '.' )
			{
				if ( vinSubCount <= 3 )
				{
					if ( !vtxIPSub.empty( ) )
					{
						if ( vtxIPSub != "*" )
						{
							vinTestSub = finStringToInt( vtxIPSub );

							if ( ( vinTestSub == 0 ) && ( vtxIPSub != "0" ) )
							{
								goto locError;
							}
						
							if ( ( vinTestSub < 0 ) || ( vinTestSub > 254 ) )
							{
								goto locError;
							}
						}

						vcl_ptrNew->vstIP_Sub[ vinSubCount ].vtxIP_Sub = vtxIPSub;
					}
				}

				vtxIPSub = "";	
				vinSubCount++;

				if ( vinSubCount > 3 )
				{
					goto locError;
				}
				continue;
			}
			else
			{
				vtxIPSub += vtxLine[ vinIdx ];
			}
		}

//vtxMsg = "we are here: tclIPBanList::fboIPIsValid (2)";
//vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);

		return true;

		locError:
			return false;

	} // tclIPBanList::fboIPIsValid

	void tclIPBanList::fvoLoadList( void )
	{
		fvoLoadList( NULL );
	} // tclIPBanList::fvoLoadList

	void tclIPBanList::fvoLoadList( edict_t* pst_ptrEdict )
	{
		string vtxMsg;
		string vtxFileName = ctxGameSubFolder + "\\" + ctxMEANFolder + "\\ipbanlist.cfg";

		vtxMsg  = ctxMsgPrefix + "Loading ip ban list from file:\n" + vtxFileName;		
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );

		if ( !( fboFileExists( vtxFileName ) 
			        && 
			     fboFileCanBeRead( vtxFileName ) )  
			)
		{
			vtxMsg  = "** WARNING: cannot read from ip ban list file\n";
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return;
		} 

		FILE* vna_ptrFile;
		char vch_aryLine[ 255 ];

//vclDebugTrace.fvoWriteEventInfo( true, "before destroy");

		if ( vcl_ptrFirst != NULL )
			fvoDestroyList( );
		
//vclDebugTrace.fvoWriteEventInfo( true, "after destroy");

		vna_ptrFile = fopen( vtxFileName.c_str( ), "r" );

		if ( vna_ptrFile == NULL )
		{
			vtxMsg  = "** ERROR: cannot open ip ban list file";
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return;
		}

		vcl_ptrFirst = NULL;
		tclIPBan* vcl_ptrCur;
		tclIPBan* vcl_ptrNew;
		tclIPBan* vcl_ptrLast = NULL;
		vinCount = 0;
		string vtxLine;
		
		while	( fgets( vch_aryLine, 255, vna_ptrFile ) != NULL ) 
		{
			vtxLine = vch_aryLine;
			vtxLine = ftxTrim( vch_aryLine );

			if ( vtxLine.empty( ) )
				continue;

			if ( vtxLine[ 0 ] == ';' )
				continue;

//vclDebugTrace.fvoWriteEventInfo( true, "before new");
			vcl_ptrNew = new tclIPBan;
//vclDebugTrace.fvoWriteEventInfo( true, "after new");

			if ( !fboIPIsValid( vtxLine, vcl_ptrNew ) )
			{
				delete vcl_ptrNew;
				vtxMsg  = "** WARNING: IP ban line not valid: " + vtxLine;
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
				continue;
			}

			if ( vcl_ptrFirst == NULL )
				vcl_ptrFirst = vcl_ptrNew;
			
			if ( vcl_ptrLast == NULL )
				vcl_ptrLast = vcl_ptrNew;	
			else
			{
				vcl_ptrLast->vcl_ptrNext = vcl_ptrNew;
				vcl_ptrLast = vcl_ptrNew;
			}	

			vinCount = ++vinCount;
//.begin for debugging only
//			vtxMsg  = "  Loaded: " + vtxLine;
//			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
//			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
//.end
		}

		fclose( vna_ptrFile );

		vtxMsg  = ctxMsgPrefix + "IP ban load completed.";		
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);

	} // tclIPBanList::fvoLoadList

	bool tclIPBanList::fboIPBanned( string ptxName, string ptxAuthId, string ptxUserId, string ptxAddress )
	{
		if ( ptxUserId.empty( ) )
		{
			return false;
		}

		string vtxIP_Full;
		tstIP_Sub vstIP_Sub[ 4 ];
		int vinSubCount = 0;
		// strip out ::port and assign subnets;
		
		for ( unsigned int vinIdx = 0; vinIdx < ptxAddress.length( ); vinIdx++ )
		{
			if ( ptxAddress[ vinIdx ] == ':' )
			{
				vinIdx = ptxAddress.length( );
			}
			else
			{
				vtxIP_Full += ptxAddress[ vinIdx ];

				if ( ptxAddress[ vinIdx ] == '.' )
				{
					vinSubCount++;
				}
				else
				if ( vinSubCount <= 3 )
				{
					vstIP_Sub[ vinSubCount ].vtxIP_Sub += ptxAddress[ vinIdx ];
				}
			}
		}

		// search for matching IP
		
		string vtxMsg;
		bool vboMatch;

		tclIPBan* vcl_ptrCur = vcl_ptrFirst;
		while ( vcl_ptrCur != NULL )
		{
			if ( vcl_ptrCur->vtxIP_Full == vtxIP_Full )
			{
				vtxMsg  = "Match Found: " + vtxIP_Full;
				fvoConsolePrint( NULL, vtxMsg + "\n" );
				vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
				return true;
			}
			else
			{
				vboMatch = true;
				for ( int vinIdx = 0; vinIdx <= 3; vinIdx++ )
				{

//if ( vcl_ptrCur->vstIP_Sub[ vinIdx ].vtxIP_Sub == "*" )
//{
//	vtxMsg = vstIP_Sub[ vinIdx ].vtxIP_Sub + " == " + vcl_ptrCur->vstIP_Sub[ vinIdx ].vtxIP_Sub;
//}
//else
//if ( vcl_ptrCur->vstIP_Sub[ vinIdx ].vtxIP_Sub != vstIP_Sub[ vinIdx ].vtxIP_Sub )
//{
//	vtxMsg = vstIP_Sub[ vinIdx ].vtxIP_Sub + " <> " + vcl_ptrCur->vstIP_Sub[ vinIdx ].vtxIP_Sub;
//}
//else
//{
//	vtxMsg = vstIP_Sub[ vinIdx ].vtxIP_Sub + " == " + vcl_ptrCur->vstIP_Sub[ vinIdx ].vtxIP_Sub;
//}
//fvoConsolePrint( NULL, vtxMsg + "\n" );
//vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);

					if ( vcl_ptrCur->vstIP_Sub[ vinIdx ].vtxIP_Sub != "*" )
					{
						vboMatch = vboMatch & 
							( vcl_ptrCur->vstIP_Sub[ vinIdx ].vtxIP_Sub == vstIP_Sub[ vinIdx ].vtxIP_Sub );
					}
				}
				
				if ( !vboMatch )
				{
					vcl_ptrCur = vcl_ptrCur->vcl_ptrNext;
				}
				else
				{
					vtxMsg  = "Banned IP filer " + vcl_ptrCur->vtxIP_Full + " matches with connecting IP " + vtxIP_Full;
					fvoConsolePrint( NULL, vtxMsg + "\n" );
					vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
					return true;
				}
			}
		}

		return false;

	} // tclIPBanList::fboIPBanned

	tclIPBanList vclIPBanList;

	tclUser::tclUser( )
	{
		vtxUserName = "";
		vtxAuthID = "";
		vtxPassword = ctxPW_Guest_DEFAULT;
		vboAccessLevel_SrvOp   = false;
		vboAccessLevel_Admin1  = false;
		vboAccessLevel_Admin2  = false;
		vboAccessLevel_Clan    = false;
		vboAccessLevel_Guest   = false;
		vboAccessLevel_Public  = true;
		vinRank = cinRank_DEFAULT; 
		vcl_ptrNext = NULL;
	} // tclUser::tclUser

	bool tclUser::fboSetAuthID( string ptxAuthID )
	{
		vtxAuthID = ptxAuthID;
		return true;
	} // tclUser::fboSetAuthID

	bool tclUser::fboSetUserName( string ptxUserName )
	{
		vtxUserName = ptxUserName;
		return true;
	} // tclUser::fboSetUserName

	bool tclUser::fboSetPassword( string ptxPassword )
	{
		vtxPassword = ptxPassword;
		return true;
	} // tclUser::fboSetPassword

	bool tclUser::fboSetAccess( string ptxAccess )
	{
		if ( ptxAccess.empty( ) )
			return false;
		
		for ( unsigned int vinIdx = 0; vinIdx < ptxAccess.length( ); vinIdx++ )
		{
			if ( ptxAccess[ vinIdx ] == cchAccess_SrvOp )
				vboAccessLevel_SrvOp = true;
			else
			if ( ptxAccess[ vinIdx ] == cchAccess_Admin1 )
				vboAccessLevel_Admin1 = true;		
			else
			if ( ptxAccess[ vinIdx ] == cchAccess_Admin2 )
				vboAccessLevel_Admin2 = true;		
			else
			if ( ptxAccess[ vinIdx ] == cchAccess_Clan )
				vboAccessLevel_Clan = true;		
			else
			if ( ptxAccess[ vinIdx ] == cchAccess_Guest )
				vboAccessLevel_Guest = true;		
			else
			if ( ( ptxAccess[ vinIdx ] == ' ' ) 
				       || 
				  ( ptxAccess[ vinIdx ] == '\t' ) )
				continue;
			else
				return false;
		}
		
		return true;

	} // tclUser::fboSetAccess

	bool tclUser::fboItemsAreSpecified( )
	{
		return !( vtxUserName.empty( ) 
			         && 
			       vtxPassword.empty( )
						&&
					 vtxAuthID.empty( ) );
	} // tclUser::fboItemsAreSpecified

 	int tclUser::finHighestAccessLevel( void )
	{
		if ( vboAccessLevel_SrvOp )
			return cinAccess_SrvOp;

		if ( vboAccessLevel_Admin1 )
			return cinAccess_Admin1;

		if ( vboAccessLevel_Admin2 )
			return cinAccess_Admin2;

		if ( vboAccessLevel_Clan )
			return cinAccess_Clan;

		if ( vboAccessLevel_Guest )
			return cinAccess_Guest;

		return cinAccess_Public;

	} // tclUser::finHighestAccessLevel

 	string tclUser::ftxHighestAccessLevel( void )
	{
		if ( vboAccessLevel_SrvOp )
			return ctxAccess_SrvOp;

		if ( vboAccessLevel_Admin1 )
			return ctxAccess_Admin1;

		if ( vboAccessLevel_Admin2 )
			return ctxAccess_Admin2;

		if ( vboAccessLevel_Clan )
			return ctxAccess_Clan;

		if ( vboAccessLevel_Guest )
			return ctxAccess_Guest;

		return ctxAccess_Public;

	} // tclUser::ftxHighestAccessLevel


	tclSecurity::tclSecurity( )
	{
		vcl_ptrUser_Cur	= NULL;
		vcl_ptrUser_First = NULL;
		vcl_ptrUser_Last	= NULL;
		vcl_ptrUser_Temp	= NULL;

		vtxPassword_Guest = ctxPW_Guest_DEFAULT;
		vinServerLock		= cinServerLock_DEFAULT;
		vboAllowGuests		= cboAllowGuests_DEFAULT;

		vclUser_SrvOp.vtxUserName				= ctxUserSrvOp;
		vclUser_SrvOp.vtxAuthID					= "";
		vclUser_SrvOp.vtxPassword				= ctxPW_SrvOp_DEFAULT;
		vclUser_SrvOp.vboAccessLevel_SrvOp	= true;
		vclUser_SrvOp.vboAccessLevel_Admin1	= true;
		vclUser_SrvOp.vboAccessLevel_Admin2	= true;
		vclUser_SrvOp.vboAccessLevel_Clan	= true;
		vclUser_SrvOp.vboAccessLevel_Guest	= true;
		vclUser_SrvOp.vinRank					= cinRank_SRVOP;

		vclUser_Guest.vtxUserName				= ctxUserGuest;
		vclUser_Guest.vtxAuthID					= "";
		vclUser_Guest.vtxPassword				= ctxPW_Guest_DEFAULT;
		vclUser_Guest.vboAccessLevel_Guest	= true;
		vclUser_Guest.vinRank					= cinRank_GUEST;

		vclUser_Public.vtxUserName				 = ctxUserGuest;
		vclUser_Public.vtxAuthID				 = "";
		vclUser_Public.vtxPassword				 = ctxPW_Public_DEFAULT;
		vclUser_Public.vboAccessLevel_Public = true;
		vclUser_Public.vinRank					 = cinRank_PUBLIC;
	} // tclSecurity::tclSecurity

	tclSecurity::~tclSecurity( )
	{
		
	} // tclSecurity::~tclSecurity

	bool tclSecurity::fboSecurityInfoIsValid( string ptxSecurityInfo, tclUser* pcl_ptrUser )
	{
		if ( pcl_ptrUser == NULL )
			return false;

		const int cinBegin = 0;
		const int cinEnd   = 1;
		
		const int cinAuthId	 = 1;
		const int cinUserName = 2;
		const int cinPassword = 3;
		const int cinAccess   = 4;
		const int cinFinished = 5;

		if ( ptxSecurityInfo.empty( ) )
			return false;

		string vtxInfo = "";
		int vinQuote = cinBegin;
		int vinInfo = cinAuthId;
		bool vboCapture = false;

//		vclDebugTrace.fvoWriteEventInfo( true, ptxSecurityInfo );

		for ( unsigned int vinIdx = 0; vinIdx < ptxSecurityInfo.length( ); vinIdx++ )
		{
			if ( ptxSecurityInfo[ vinIdx ] == '"' )
			{
				if ( vinQuote == cinBegin )
				{
					vboCapture = true;
					vinQuote = cinEnd;
					vtxInfo = "";
					continue;
				}

				if ( vinQuote == cinEnd )
				{
					if ( vinInfo == cinAuthId )
					{
						if ( !pcl_ptrUser->fboSetAuthID( vtxInfo ) )
							return false;
						vinInfo = cinUserName;
					}
					else
					if ( vinInfo == cinUserName )
					{
						if ( !pcl_ptrUser->fboSetUserName( vtxInfo ) )
							return false;
						vinInfo = cinPassword;
					}
					else
					if ( vinInfo == cinPassword )
					{
						if ( !pcl_ptrUser->fboSetPassword( vtxInfo ) )
							return false;
						vinInfo = cinAccess;
					}
					else
					if ( vinInfo == cinAccess )
					{
						if ( !pcl_ptrUser->fboSetAccess( vtxInfo ) )
							return false;
						vinInfo = cinFinished;
					}
					else
						return false;
					
					vboCapture	= false;
					vinQuote		= cinBegin;
					vtxInfo		= "";

					if ( vinInfo == cinFinished )
					{
						// check if at least one security item was assigned;
						return pcl_ptrUser->fboItemsAreSpecified( );
					}

					continue;

				} // if quote = end

				return false;

			} // if = quote

			if ( vboCapture )
				vtxInfo += ptxSecurityInfo[ vinIdx ];
			else
			if ( ( ptxSecurityInfo[ vinIdx ] != ' ' ) && ( ptxSecurityInfo[ vinIdx ] != '\t' ) )
			{
				return false;
			}

		} // for

		return false;

	} // tclSecurity::fboSecurityInfoIsValid

	void tclSecurity::fvoDestroyList( )
	{
		vcl_ptrUser_Cur = vcl_ptrUser_First;
		while ( vcl_ptrUser_Cur != NULL )
		{
			vcl_ptrUser_Temp = vcl_ptrUser_Cur;
			vcl_ptrUser_Cur = vcl_ptrUser_Cur->vcl_ptrNext;
			delete vcl_ptrUser_Temp;
		}
		
		vcl_ptrUser_First = NULL;
		vcl_ptrUser_Last	= NULL;
		vcl_ptrUser_Temp	= NULL;

	} // tclSecurity::fvoDestroyList

	void tclSecurity::fvoLoadSecurity( void )
	{
		fvoLoadSecurity( NULL );
	} // tclSecurity::fvoLoadSecurity

	void tclSecurity::fvoLoadSecurity( edict_t* pst_ptrEdict )
	{
		string vtxMsg;
		string vtxFileName = ctxGameSubFolder + "\\" + ctxMEANFolder + "\\users.cfg";

		vtxMsg  = ctxMsgPrefix + "Loading security information from file:\n  " + vtxFileName;		
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );

		if ( !( fboFileExists( vtxFileName ) 
			        && 
			     fboFileCanBeRead( vtxFileName ) )  
			)
		{
			vtxMsg  = "** ERROR: cannot read from security file\n";
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return;
		} 

		FILE* vna_ptrFile;
		char vch_arySecurity[ 255 ];

		if ( vcl_ptrUser_First != NULL )
			fvoDestroyList( );
		
		vna_ptrFile = fopen( vtxFileName.c_str( ), "r" );

		if ( vna_ptrFile == NULL )
		{
			vtxMsg  = "** ERROR: cannot open security file";
			vtxMsg += ctxMsgPrefix + "Load was aborted due to an error."; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
			return;
		}

		vcl_ptrUser_Cur = NULL;
		tclUser* vcl_ptrUser_New;
		vinUserCount = 0;
		string vtxSecurityInfo;

		while	( fgets( vch_arySecurity, 255, vna_ptrFile ) != NULL ) 
		{
			vtxSecurityInfo = vch_arySecurity;
			vtxSecurityInfo = ftxTrim( vtxSecurityInfo );

			if ( vtxSecurityInfo.empty( ) )
				continue;

			if ( vtxSecurityInfo[ 0 ] == ';' )
				continue;

			vcl_ptrUser_New = new tclUser;

			if ( !fboSecurityInfoIsValid( vtxSecurityInfo, vcl_ptrUser_New ) )
			{
				delete vcl_ptrUser_New;
				vtxMsg  = "** WARNING: security line not valid! \n  " + vtxSecurityInfo;
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
				continue;
			}

			if ( vcl_ptrUser_First == NULL )
				vcl_ptrUser_First = vcl_ptrUser_New;
			
			if ( vcl_ptrUser_Last == NULL )
				vcl_ptrUser_Last = vcl_ptrUser_New;	
			else
			{
				vcl_ptrUser_Last->vcl_ptrNext = vcl_ptrUser_New;
				vcl_ptrUser_Last = vcl_ptrUser_New;
			}	

			vinUserCount = ++vinUserCount;
//.begin for debugging only
//			vtxMsg  = "  Loaded: " + vtxSecurityInfo;
//			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
//			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);
//.end
		}

		fclose( vna_ptrFile );

		vtxMsg  = ctxMsgPrefix + "Security file load completed.";		
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg);

	} // tclSecurity::fvoLoadSecurity

	string tclSecurity::ftxGetPassword( edict_t* pst_ptrEdict )
	{
		return ftxGetEdictKeyValue( pst_ptrEdict, ctxKey_PW );
	} // tclSecurity::ftxGetPassword

	tclUser* tclSecurity::fst_ptrFindUser( string ptxAuthID, string ptxUserName, string ptxPassword )
	{
		vcl_ptrUser_Cur = vcl_ptrUser_First;

		bool vboMatch;

		while ( vcl_ptrUser_Cur != NULL )
		{
			if ( !vcl_ptrUser_Cur->vtxAuthID.empty( ) )
			{ 
			   vboMatch = ( vcl_ptrUser_Cur->vtxAuthID == ptxAuthID );
				if ( !vboMatch )
					goto locNext;
			}

			if ( !vcl_ptrUser_Cur->vtxUserName.empty( ) )
			{ 
			   vboMatch = ( vcl_ptrUser_Cur->vtxUserName == ptxUserName );
				if ( !vboMatch )
					goto locNext;
			}

			if ( !vcl_ptrUser_Cur->vtxPassword.empty( ) )
			{ 
			   vboMatch = ( vcl_ptrUser_Cur->vtxPassword == ptxPassword );
				if ( !vboMatch )
					goto locNext;
			}

			return vcl_ptrUser_Cur;

			locNext:
				vcl_ptrUser_Cur = vcl_ptrUser_Cur->vcl_ptrNext;
		}
		
		return NULL;

	} // tclSecurity::fst_ptrFindUser

	tclUser* tclSecurity::finAuthenticate( edict_t* pst_ptrEdict )
	{
		if ( pst_ptrEdict == NULL )
		// A NULL edict can only come from a dedicated console command entry;
			return &vclUser_SrvOp;

		string vtxUserName = vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );
		string vtxPassword = ftxGetPassword( pst_ptrEdict );
		string vtxAuthID	 = ftxGetPlayerAuthId( pst_ptrEdict );

		tclUser* vcl_ptrUser = fst_ptrFindUser( vtxAuthID, vtxUserName, vtxPassword );

		if ( vcl_ptrUser == NULL )
		{
			if ( vtxPassword == vtxPassword_Guest )
				return &vclUser_Guest;

			return &vclUser_Public;
		}

      // if we get here, the user was authenticated;
		return vcl_ptrUser;

	} // tclSecurity::finAuthenticate

	bool tclSecurity::fboAccessGranted( tclUser* pcl_ptrUser )
	{
		if ( pcl_ptrUser == NULL )
			return false;

		if ( vinServerLock == cinAccess_SrvOp )
			return pcl_ptrUser->vboAccessLevel_SrvOp;

		if ( vinServerLock == cinAccess_Admin1 )
			return pcl_ptrUser->vboAccessLevel_SrvOp 
						|| 
					 pcl_ptrUser->vboAccessLevel_Admin1;

		if ( vinServerLock == cinAccess_Admin2 )
			return pcl_ptrUser->vboAccessLevel_SrvOp 
						|| 
					 pcl_ptrUser->vboAccessLevel_Admin1
						|| 
					 pcl_ptrUser->vboAccessLevel_Admin2;

		if ( vinServerLock == cinAccess_Clan )
			return pcl_ptrUser->vboAccessLevel_SrvOp 
						|| 
					 pcl_ptrUser->vboAccessLevel_Admin1
						|| 
					 pcl_ptrUser->vboAccessLevel_Admin2
						||
					 pcl_ptrUser->vboAccessLevel_Clan
						||
					 ( pcl_ptrUser->vboAccessLevel_Guest && vboAllowGuests );

		if ( vinServerLock == cinAccess_Public )
		// by default everyone has public access granted;
			return pcl_ptrUser->vboAccessLevel_Public;

		// if we get here then something has gone wrong; allow everyone in;
		return true;

	} // tclSecurity::fboAccessGranted

	bool tclSecurity::fboAccessGranted( edict_t* pst_ptrEdict )
	{
		tclUser* vcl_ptrUser;
		return fboAccessGranted( pst_ptrEdict, vcl_ptrUser );

	} // tclSecurity::fboAccessGranted

	bool tclSecurity::fboAccessGranted( edict_t* pst_ptrEdict, tclUser*& pcl_ptrUser )
	{
		pcl_ptrUser = finAuthenticate( pst_ptrEdict );
		return fboAccessGranted( pcl_ptrUser );
	} // tclSecurity::fboAccessGranted

	void tclSecurity::fvoLockServer( string ptxPassword )
	{
		if ( ptxPassword.empty( ) )
		{
			vtxPassword_Guest = ctxPW_Guest_DEFAULT;
			vinServerLock = cinAccess_Clan;
			vboAllowGuests = false;
		}
		else
		{
			vtxPassword_Guest = ptxPassword;
			vinServerLock		= cinAccess_Clan;
			vboAllowGuests		= true;
		}
	
		fvoCVarSetString( "sv_password", vtxPassword_Guest );

	} // tclSecurity::fvoLockServer

	void tclSecurity::fvoUnlockServer( )
	{
		vtxPassword_Guest = ctxPW_Guest_DEFAULT;
		vinServerLock		= cinAccess_Public;
		vboAllowGuests		= true;
		fvoCVarSetString( "sv_password", "" );

	} // tclSecurity::fvoUnlockServer

	bool tclSecurity::fboServerIsLocked( )
	{
		return vinServerLock != cinAccess_Public;
	} // tclSecurity::fboServerIsLocked

	void tclSecurity::fvoCheckServerLock( )
	{
		if ( !fboServerIsLocked( ) )
			return;

		fvoCVarSetString( "sv_password", vtxPassword_Guest );
		
	} // tclSecurity::fvoCheckServerLock

	void tclSecurity::fvoKickDeniedPlayers( edict_t* pst_ptrEdict )
	{

	} // tclSecurity::fvoKickDeniedPlayers

	void tclSecurity::fvoKickDeniedPlayer( edict_t* pst_ptrEdict )
	{
		string vtxRejectReason = ctxMsgPrefix + "The server is Locked - access denied. Try again later.\n";
		vclDebugTrace.fvoWriteEventInfo( true, vtxRejectReason );
		string vtxMsg  = ctxMsgPrefix + "Kicking player " + vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );
		vtxMsg += "\n" + vtxRejectReason;
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoServerPrint( vtxMsg + "\n" );
		vclPlayer.fboKickPlayerByEdict( pst_ptrEdict, vtxRejectReason );
	} // tclSecurity::fvoKickDeniedPlayer

	bool tclSecurity::fboUserIsSrvOpByEdict( edict_t* pst_ptrEdict )
	{
		tclUser* pcl_ptrUser = finAuthenticate( pst_ptrEdict );
		if ( pcl_ptrUser == NULL )
			return false;

		return pcl_ptrUser->vboAccessLevel_SrvOp;
	} // tclSecurity::fboUserIsSrvOpByEdict

	bool tclSecurity::fboUserIsAdminByEdict( edict_t* pst_ptrEdict )
	{
		tclUser* pcl_ptrUser = finAuthenticate( pst_ptrEdict );
		if ( pcl_ptrUser == NULL )
			return false;

		return ( pcl_ptrUser->vboAccessLevel_Admin1 || pcl_ptrUser->vboAccessLevel_Admin2 );
	} // tclSecurity::fboUserIsAdminByEdict

	bool tclSecurity::fboUserIsAdmin1ByEdict( edict_t* pst_ptrEdict )
	{
		tclUser* pcl_ptrUser = finAuthenticate( pst_ptrEdict );
		if ( pcl_ptrUser == NULL )
			return false;

		return pcl_ptrUser->vboAccessLevel_Admin1;
	} // tclSecurity::fboUserIsAdmin1ByEdict

	bool tclSecurity::fboUserIsAdmin2ByEdict( edict_t* pst_ptrEdict )
	{
		tclUser* pcl_ptrUser = finAuthenticate( pst_ptrEdict );
		if ( pcl_ptrUser == NULL )
			return false;

		return pcl_ptrUser->vboAccessLevel_Admin2;
	} // tclSecurity::fboUserIsAdminByEdict

	bool tclSecurity::fboUserIsClanByEdict( edict_t* pst_ptrEdict )
	{
		tclUser* pcl_ptrUser = finAuthenticate( pst_ptrEdict );
		if ( pcl_ptrUser == NULL )
			return false;

		return pcl_ptrUser->vboAccessLevel_Clan;
	} // tclSecurity::fboUserIsClanByEdict
	
	bool tclSecurity::fboUserHasClanTagByEdict( edict_t* pst_ptrEdict )
	{
		string vtxClanTag = ftxToLower( ftxCVarGetString( ctxCVar_ClanTag ) );

		if ( vtxClanTag == "" )
			return false;

		string vtxPlayerName = ftxToLower( vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict ) );

		unsigned int vinPos = vtxPlayerName.find( vtxClanTag, 0 );

		if ( vinPos == string::npos )
			return false;

		return true;

	} // tclSecurity::fboUserHasClanTagByEdict

	bool tclSecurity::fboUserIsGuestByEdict( edict_t* pst_ptrEdict )
	{
		tclUser* pcl_ptrUser = finAuthenticate( pst_ptrEdict );
		if ( pcl_ptrUser == NULL )
			return false;

		return pcl_ptrUser->vboAccessLevel_Guest;
	} // tclSecurity::fboUserIsGuestByEdict

	bool tclSecurity::fboUserIsPublicByEdict( edict_t* pst_ptrEdict )
	{
		tclUser* pcl_ptrUser = finAuthenticate( pst_ptrEdict );
		if ( pcl_ptrUser == NULL )
			return false;

		return pcl_ptrUser->vboAccessLevel_Public;
	} // tclSecurity::fboUserIsPublicByEdict

	int tclSecurity::finHighestAccessLevel( edict_t* pst_ptrEdict )
	{
		tclUser* pcl_ptrUser = finAuthenticate( pst_ptrEdict );
		if ( pcl_ptrUser == NULL )
			return cinAccess_Public;

		return pcl_ptrUser->finHighestAccessLevel( );

	} // tclSecurity::finHighestAccessLevel

	int tclSecurity::finStrToIntAccess( string ptxAccess )
	{
		string vtxAccess = ftxToLower( ptxAccess );

		if ( vtxAccess == ftxToLower( ctxAccess_SrvOp ) )
			return cinAccess_SrvOp;

		if ( vtxAccess == ftxToLower( ctxAccess_Admin1 ) )
			return cinAccess_Admin1;

		if ( vtxAccess == ftxToLower( ctxAccess_Admin2 ) )
			return cinAccess_Admin2;

		if ( vtxAccess == ftxToLower( ctxAccess_Clan ) )
			return cinAccess_Clan;

		if ( vtxAccess == ftxToLower( ctxAccess_Guest ) )
			return cinAccess_Guest;

		if ( vtxAccess == ftxToLower( ctxAccess_Public ) )
			return cinAccess_Public;

		return cinAccess_Min - 1;

	} // tclSecurity::finStrToIntAccess

	string tclSecurity::finIntToStrAccess( int pinAccess )
	{
		if ( pinAccess == cinAccess_SrvOp ) 
			return ctxAccess_SrvOp;

		if ( pinAccess == cinAccess_Admin1 )
			return ctxAccess_Admin1;

		if ( pinAccess == cinAccess_Admin2 )
			return ctxAccess_Admin2;

		if ( pinAccess == cinAccess_Clan )
			return ctxAccess_Clan;

		if ( pinAccess == cinAccess_Guest )
			return ctxAccess_Guest;

		if ( pinAccess == cinAccess_Public )
			return ctxAccess_Public;

		return ctxAccess_Unknown;

	} // tclSecurity::finIntToStrAccess

	string tclSecurity::ftxHighestAccessLevel( edict_t* pst_ptrEdict )
	{
		tclUser* pcl_ptrUser = finAuthenticate( pst_ptrEdict );
		if ( pcl_ptrUser == NULL )
			return ctxAccess_Public;

		return pcl_ptrUser->ftxHighestAccessLevel( );

	} // tclSecurity::ftxHighestAccessLevel

	int tclSecurity::finListAdmins( edict_t* pst_ptrEdict )
	{
		int vinAdminCount = 0;
		string vtxMsg = ctxMsgPrefix + "List of available admins:\n";
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		int vinUserId;
		edict_t* vst_ptrEdictUser;

		for ( int vinIdx = cinMinPlayerIndex; 
					 vinIdx < cinMaxPlayerIndex; 
					 vinIdx++ )
		{
			vst_ptrEdictUser = vclPlayer.fst_ptrGetPlayerByIndex( vinIdx );
			if ( vst_ptrEdictUser == NULL )
				continue;
			if ( !fboUserIsAdminByEdict( vst_ptrEdictUser ) )
				continue;
			
			vinAdminCount++;
			vtxMsg = vclPlayer.ftxGetPlayerNameByEdict( vst_ptrEdictUser );
			fvoConsolePrint( pst_ptrEdict, "  Name: " + vtxMsg + "\n" );
		}
		vtxMsg = "\n" + ctxMsgPrefix + "There are " + ftxIntToString( vinAdminCount ) + " admins in game.";
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		return vinAdminCount;

	} // tclSecurity::finListAdmins

	void tclSecurity::fvoDumpAccessInfo( edict_t* pst_ptrEdict )
	{

		const string ctxNo  = "no";
		const string ctxYes = "yes";
		string vtxIsSrvOp;  
		string vtxIsAdmin1 = ctxNo;
		string vtxIsAdmin2 = ctxNo;
		string vtxIsClan   = ctxNo;
		string vtxIsGuest  = ctxNo;
		string vtxIsPublic = ctxNo;

		vcl_ptrUser_Cur = vcl_ptrUser_First;

		fvoConsolePrint_nl( pst_ptrEdict, ctxMsgPrefix + "Sending Access Info to " + vclDebugTrace.ftxGetFileName( ) + " ... " );
		vclDebugTrace.fvoWriteEventInfo( "" );
		vclDebugTrace.fvoWriteEventInfo( "BEGIN Access Info Dump" );

		while ( vcl_ptrUser_Cur != NULL )
		{
			if ( vcl_ptrUser_Cur->vboAccessLevel_SrvOp  ) vtxIsSrvOp   = ctxYes; else vtxIsSrvOp  = ctxNo;
			if ( vcl_ptrUser_Cur->vboAccessLevel_Admin2 ) vtxIsAdmin1  = ctxYes; else vtxIsAdmin1 = ctxNo;
			if ( vcl_ptrUser_Cur->vboAccessLevel_Admin2 ) vtxIsAdmin2  = ctxYes; else vtxIsAdmin2 = ctxNo;
			if ( vcl_ptrUser_Cur->vboAccessLevel_Clan   ) vtxIsClan    = ctxYes; else vtxIsClan   = ctxNo;
			if ( vcl_ptrUser_Cur->vboAccessLevel_Guest  ) vtxIsGuest   = ctxYes; else vtxIsGuest  = ctxNo;
			if ( vcl_ptrUser_Cur->vboAccessLevel_Public ) vtxIsPublic  = ctxYes; else vtxIsPublic = ctxNo;

			vclDebugTrace.fvoWriteEventInfo( "" );
			vclDebugTrace.fvoWriteEventInfo( "  Steam Id  : " + vcl_ptrUser_Cur->vtxAuthID );
			vclDebugTrace.fvoWriteEventInfo( "  UserName  : " + vcl_ptrUser_Cur->vtxUserName );
			vclDebugTrace.fvoWriteEventInfo( "  Password  : " + vcl_ptrUser_Cur->vtxPassword );
			vclDebugTrace.fvoWriteEventInfo( "  Is SrvOp  : " + vtxIsSrvOp );
			vclDebugTrace.fvoWriteEventInfo( "  Is Admin1 : " + vtxIsAdmin1 );
			vclDebugTrace.fvoWriteEventInfo( "  Is Admin2 : " + vtxIsAdmin2 );
			vclDebugTrace.fvoWriteEventInfo( "  Is Clan   : " + vtxIsClan );
			vclDebugTrace.fvoWriteEventInfo( "  Is Guest  : " + vtxIsGuest );
			vclDebugTrace.fvoWriteEventInfo( "  Is Public : " + vtxIsPublic );

			vcl_ptrUser_Cur = vcl_ptrUser_Cur->vcl_ptrNext;
		}

		vclDebugTrace.fvoWriteEventInfo( "" );
		vclDebugTrace.fvoWriteEventInfo( "END Access Info Dump. " );
		fvoConsolePrint_nl( pst_ptrEdict, ctxMsgPrefix + "Completed." );

	} // tclSecurity::fvoDumpAccessInfo

	void tclSecurity::fvoSetCVars( )
	{

		CVAR_REGISTER( &vstCVar_ClanTag );

	} // tclSecurity::fvoSetCVars

// Define global instance of Security Class;
	tclSecurity vclSecurity;

