//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Security.h
//	
//	[MEAN] Server Security Module. 
//
//.e	

//.b skip over if header has already been included.
	#ifndef defMA_Security_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
		#define defMA_Security_h

	// Include all general definition files.
		#include "MB_Includes.h"

   // the lower the number the higher the rank;

	const string ctxCVar_ClanTag = "m_clantag";
	
	const int cinRank_Max   = 9;
	const int cinRank_Min   = 0;
	const int cinRank_SRVOP   = cinRank_Max;
	const int cinRank_PUBLIC  = cinRank_Min;
	const int cinRank_GUEST   = cinRank_Min+1;
	const int cinRank_DEFAULT = cinRank_PUBLIC;

	const string ctxKey_PW			    = "mean_pw";
	const string ctxPW_SrvOp_DEFAULT  = "srvop232914"; // hard to guess password
	const string ctxPW_Guest_DEFAULT  = "guest909344"; // hard to guess password
	const string ctxPW_Public_DEFAULT = "";
	const bool cboAllowGuests_DEFAULT = false; 

//	const string ctxPW_Admin = "guard249";

	const string ctxUserSrvOp  = "srvop";
	const string ctxUserGuest  = "guest";
	const string ctxUserPublic = "public";

	const int cinAccess_Min		       =  0;
	const int cinAccess_Max		       =  5;
	const int cinAccess_SrvOp         =  0;
	const int cinAccess_Admin1        =  1;
	const int cinAccess_Admin2        =  2;
	const int cinAccess_Clan          =  3;
	const int cinAccess_Guest		    =  4;
	const int cinAccess_Public		    =  5;
	const int cinAccess_DEFAULT		 = cinAccess_SrvOp;
	const int cinServerLock_DEFAULT   = cinAccess_Public;

	const string ctxAccess_SrvOp     =  "SrvOp";
	const string ctxAccess_Admin1    =  "Admin1";
	const string ctxAccess_Admin2    =  "Admin2";
	const string ctxAccess_Clan      =  "Clan";
	const string ctxAccess_Guest     =  "Guest";
	const string ctxAccess_Public	   =  "Public";
	const string ctxAccess_Unknown   =  "Unknown";

	const char cchAccess_SrvOp  = 'o';
	const char cchAccess_Admin1 = '1';
	const char cchAccess_Admin2 = '2';
	const char cchAccess_Clan   = 'c';
	const char cchAccess_Guest  = 'g';

	class tclUser
	{
		public:
			string vtxUserName;
			string vtxPassword;
			string vtxAuthID; 
			bool vboAccessLevel_SrvOp;
			bool vboAccessLevel_Admin1;
			bool vboAccessLevel_Admin2;
			bool vboAccessLevel_Clan;
			bool vboAccessLevel_Guest;
			bool vboAccessLevel_Public;
			int vinRank;

			tclUser* vcl_ptrNext;
			tclUser( );
			bool fboSetAuthID( string ptxAuthID );
			bool fboSetUserName( string ptxUserName );
			bool fboSetPassword( string ptxPassword );
			bool fboSetAccess( string ptxAccess );
			bool fboItemsAreSpecified( );
			int finHighestAccessLevel( void );
			string ftxHighestAccessLevel( void );

	}; // tclUser

	struct tstIP_Sub
	{
		string vtxIP_Sub;
	}; 

	class tclIPBan
	{
		public:
		string vtxIP_Full;
		tstIP_Sub vstIP_Sub[ 4 ];
		tclIPBan* vcl_ptrNext;
		tclIPBan( );
	}; // tclIPBan

	class tclIPBanList
	{
		public:
		int vinCount;
		tclIPBan* vcl_ptrFirst;
		tclIPBanList( );
		~tclIPBanList( );
		void fvoDestroyList( );
		void fvoLoadList( );
		void fvoLoadList( edict_t* pst_ptrEdict );
		bool fboIPIsValid( string vtxLine, tclIPBan* vcl_ptrNew );
		bool fboIPBanned( string ptxName, string ptxAuthId, string ptxUserId, string ptxAddress );

	}; // tclIPBanList

	class tclSecurity
	{
		public:
			tclUser* vcl_ptrUser_Cur;
			tclUser* vcl_ptrUser_First;
			tclUser* vcl_ptrUser_Last;
			tclUser* vcl_ptrUser_Temp;
				
			tclUser vclUser_SrvOp;
			tclUser vclUser_Guest;
			tclUser vclUser_Public;

			tclSecurity( );
			~tclSecurity( );

			// the common password used by all guests;
			string vtxPassword_Guest;
			int vinServerLock;
			int vinSlots_Reserved;
			int vinUserCount;
			bool vboAllowGuests;
			void fvoDestroyList( );
			void fvoLoadSecurity( edict_t* pst_ptrEdict );
			void fvoLoadSecurity( void );
			bool fboSecurityInfoIsValid( string ptxSecurityInfo, tclUser* pcl_ptrUser );
			string ftxGetPassword( edict_t* pst_ptrEdict );
			tclUser* fst_ptrFindUser( string ptxAuthID, string ptxUserName, string ptxPassword );
			tclUser* finAuthenticate( edict_t* pst_ptrEdict );
			bool fboAccessGranted( tclUser* pcl_ptrUser );
			bool fboAccessGranted( edict_t* pst_ptrEdict );
			bool fboAccessGranted( edict_t* pst_ptrEdict, tclUser*& pcl_ptrUser );
			void fvoKickDeniedPlayer( edict_t* pst_ptrEdict );
			void fvoKickDeniedPlayers( edict_t* pst_ptrEdict );
			bool fboUserIsSrvOpByEdict( edict_t* pst_ptrEdict );
			bool fboUserIsAdminByEdict( edict_t* pst_ptrEdict );
			bool fboUserIsAdmin1ByEdict( edict_t* pst_ptrEdict );
			bool fboUserIsAdmin2ByEdict( edict_t* pst_ptrEdict );
			bool fboUserIsClanByEdict( edict_t* pst_ptrEdict );
			bool fboUserHasClanTagByEdict( edict_t* pst_ptrEdict );
			bool fboUserIsGuestByEdict( edict_t* pst_ptrEdict );
			bool fboUserIsPublicByEdict( edict_t* pst_ptrEdict );
			int finHighestAccessLevel( edict_t* pst_ptrEdict );
			int finStrToIntAccess( string ptxAccess );
			string finIntToStrAccess( int pinAccess );
			string ftxHighestAccessLevel( edict_t* pst_ptrEdict );
			int finListAdmins( edict_t* pst_ptrEdict );
			void fvoDumpAccessInfo( edict_t* pst_ptrEdict );
			void fvoSetCVars( );
			void fvoLockServer( string ptxPassword );
			void fvoUnlockServer( );
			bool fboServerIsLocked( );
			void fvoCheckServerLock( );

	}; // tclSecurity

	extern tclIPBanList vclIPBanList;
	extern tclSecurity vclSecurity;

	#endif // defMA_Security_h
//.e skip over if header has already been included.

