//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Weapon.h
//	
//	[MEAN] Interface Wrapper for weapon selections.
//
//.e	

//.b skip over if header has already been included.
#ifndef defMA_Weapon_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
	#define defMA_Weapon_h

	// Include all general definition files.
	#include "MB_Includes.h"
	#include "MA_Player.h"
	#include "MA_Message.h"
	#include "MA_time.h"

	const int cinWeaponBanPenalty_off				= 0;
	const int cinWeaponBanPenalty_health_reduced = 1;
	const int cinWeaponBanPenalty_health_dropped = 2;
	const int cinWeaponBanPenalty_timebomb			= 3;
	const int cinWeaponBanPenalty_slap_soft		= 4;
	const int cinWeaponBanPenalty_slap_hard		= 5;
	const int cinWeaponBanPenalty_slap_bitch		= 6;
	const int cinWeaponBanPenalty_explode 			= 7;
	const int cinWeaponBanPenalty_random			= 8;
	const int cinWeaponBanPenalty_min				= cinWeaponBanPenalty_health_reduced;
	const int cinWeaponBanPenalty_max				= cinWeaponBanPenalty_explode;

	const string ctxModel_prefix			= "models/";			// path prefix
	const string ctxModel_suffix			= ".mdl";				// path suffix
	const string ctxModel_knife			= "p_knife";			// Knife" 
	const string ctxModel_c4				= "p_c4";				// Bomb - C4 Explosive
	const string ctxModel_usp				= "p_usp";				// Pistol - USP .45
	const string ctxModel_glock			= "p_glock18";			// Pistol - Glock 18
	const string ctxModel_deagle			= "p_deagle";			// Pistol - Desert eagle
	const string ctxModel_p228				= "p_p228";				// Pistol - SIG P228
	const string ctxModel_elite			= "p_elite";			// Pistol - Dual Berettas
	const string ctxModel_fiveseven		= "p_fiveseven";		// Pistol - FiveSeven
	const string ctxModel_m3				= "p_m3";				// Shotgun pump - M3 super shotgun
	const string ctxModel_xm1014			= "p_xm1014";			// Shotgun auto - Benneli xm1014
	const string ctxModel_mp5				= "p_mp5";				// Sub - MP5 Navy
	const string ctxModel_tmp				= "p_tmp";				// Sub - Tactical Machine Pistol
	const string ctxModel_p90				= "p_p90";				// Sub - P90
	const string ctxModel_mac10			= "p_mac10";			// Sub - MAC-10
	const string ctxModel_ump45			= "p_ump45";			// Sub - Universal Machine Pistol
	const string ctxModel_ak47				= "p_ak47"; 			// Rifle - AK 47
	const string ctxModel_m4a1				= "p_m4a1"; 			// Rifle - Colt M4A1 Carbine
	const string ctxModel_sg552			= "p_sg552"; 			// Rifle - Commando
	const string ctxModel_aug				= "p_aug"; 				// Rifle - Steyr Aug
	const string ctxModel_famas			= "p_famas";		   // Rifle  - Famas
	const string ctxModel_galil			= "p_galil";	      // Rifle  - Galil
	const string ctxModel_scout			= "p_scout"; 			// Snipe - Scout
	const string ctxModel_awp				= "p_awp"; 				// Snipe - Artic
	const string ctxModel_g3sg1			= "p_g3sg1"; 			// Snipe - H&K Sniper Rifle
	const string ctxModel_sg550			= "p_sg550"; 			// Snipe - Sig 550
	const string ctxModel_m249				= "p_m249"; 		  // Machinegun - Para
	const string ctxModel_flashbang		= "p_flashbang";    // Grenade - Flash
	const string ctxModel_hegrenade		= "p_hegrenade";    // Grenade - Explosive
	const string ctxModel_smokegrenade	= "p_smokegrenade"; // Grenade - Smoke

	const string ctxModel_shield	 			= "p_shield";				// Shield with weapon suffix removed;
	const string ctxModel_shield_knife	 	= "p_shield_knife";		// Shield 
	const string ctxModel_shield_usp			= "p_shield_usp";		   // Shield 
	const string ctxModel_shield_glock18	= "p_shield_glock18";	// Shield 
	const string ctxModel_shield_deagle		= "p_shield_deagle";		// Shield 
	const string ctxModel_shield_p228		= "p_shield_p228";		// Shield 
	const string ctxModel_shield_elite		= "p_shield_elite";		// Shield 
	const string ctxModel_shield_fiveseven	= "p_shield_fiveseven";	// Shield 
	const string ctxModel_shield_flashbang = "p_shield_flashbang";
	const string ctxModel_shield_hegrenade	= "p_shield_hegrenade.mdl";
	const string ctxModel_shield_smokegrenade	= "p_shield_smokegrenade.mdl";

	const string ctxWeapon_knife			= "weapon_knife";			// Knife: TE+CT
	const string ctxWeapon_elite			= "weapon_elite";			// Dual Pistol: TE
	const string ctxWeapon_glock18		= "weapon_glock18";		// Glock Pistol: TE+CT
	const string ctxWeapon_fiveseven		= "weapon_fiveseven";	// FiveSeven Pistol: CT
	const string ctxWeapon_usp				= "weapon_usp";			// USP Pistol: TE+CT
	const string ctxWeapon_p228			= "weapon_p228";			// P228 Pistol: TE+CT
	const string ctxWeapon_deagle			= "weapon_deagle";		// Deagle Pistol: TE+CT
	const string ctxWeapon_m3				= "weapon_m3";				// Shotgun: TE+CT
	const string ctxWeapon_xm1014			= "weapon_xm1014";		// AutoShotgun:  TE+CT
	const string ctxWeapon_mac10			= "weapon_mac10";			
	const string ctxWeapon_tmp				= "weapon_tmp";
	const string ctxWeapon_ump45			= "weapon_ump45";
	const string ctxWeapon_mp5navy		= "weapon_mp5navy";
	const string ctxWeapon_p90				= "weapon_p90";
	const string ctxWeapon_ak47			= "weapon_ak47";
	const string ctxWeapon_m4a1			= "weapon_m4a1";			// Colt Rifle: CT
	const string ctxWeapon_sg552			= "weapon_sg552";			// Commando Rifle: TE
	const string ctxWeapon_aug				= "weapon_aug";
	const string ctxWeapon_scout			= "weapon_scout";
	const string ctxWeapon_g3sg1			= "weapon_g3sg1";			// H&K Sniper Sniper: TE
	const string ctxWeapon_sg550			= "weapon_sg550";			// Sig 550 Sniper: CT
	const string ctxWeapon_awp				= "weapon_awp";
	const string ctxWeapon_m249			= "weapon_m249";			// PARA Machinegun: TE+CT
	const string ctxWeapon_hegrenade		= "weapon_hegrenade";
	const string ctxWeapon_flashbang		= "weapon_flashbang";
	const string ctxWeapon_smokegrenade = "weapon_smokegrenade";
	const string ctxWeapon_c4				= "weapon_c4";
	const string ctxWeapon_famas			= "weapon_famas";
	const string ctxWeapon_galil			= "weapon_galil";
	const string ctxWeapon_shield			= "weapon_shield";

	const int cinWeaponMode_RegularWar		=  0;
	const int cinWeaponMode_KnifeWar			=  1;

	const int cinWeaponMode_PistolWar		=  2;
	const int cinWeaponMode_DeagleWar		=  3;
	const int cinWeaponMode_GlockUSPWar		=  4;
	const int cinWeaponMode_GlockWar			=  5;
	const int cinWeaponMode_USPWar			=  6;
	const int cinWeaponMode_Dual57War		=  7;
	const int cinWeaponMode_P228War			=  8;

	const int cinWeaponMode_LightPistolWar	=  9;
	const int cinWeaponMode_LightSubWar		= 10;
	const int cinWeaponMode_UziWar			= 11;
	const int cinWeaponMode_UMPWar			= 12;
	const int cinWeaponMode_P90War			= 13;
	const int cinWeaponMode_MP5War			= 14;
	const int cinWeaponMode_SubWar			= 15;

	const int cinWeaponMode_PumpWar			= 16;
	const int cinWeaponMode_ShotgunWar		= 17;
	const int cinWeaponMode_AutoShotgunWar = 18;
	const int cinWeaponMode_LightArmsWar	= 19;
	const int cinWeaponMode_SmallArmsWar	= 20;
	const int cinWeaponMode_HeavyArmsWar	= 21;

	const int cinWeaponMode_ScoutWar			= 22;
	const int cinWeaponMode_SnipeWar			= 23;
	const int cinWeaponMode_LightSnipeWar	= 24;
	const int cinWeaponMode_AWPWar			= 25;

	const int cinWeaponMode_PARAWar			= 26;
	const int cinWeaponMode_SG552AugWar		= 27;
	const int cinWeaponMode_AK47ColtWar		= 28;
	const int cinWeaponMode_HK550SnipeWar	= 29;
	const int cinWeaponMode_NadeWar			= 30;
	const int cinWeaponMode_FamasGalilWar	= 31;

	const cinMaxWeapons = 50;

	#define RANK_N -1 // null rank;
	#define RANK_L 0 // low
	#define RANK_M 1 // med
	#define RANK_H 2 // high

	#define USERANK_Y true 
	#define USERANK_N false 

	#define BUY_Y true
	#define BUY_N false
//	#define SIDEARM_Y true
//	#define SIDEARM_N false
//	#define MAINARM_Y true
//	#define MAINARM_N false
	
	#define ARM_OTHER 0
	#define ARM_SIDE 1
	#define ARM_MAIN 2
	#define ARM_NADE 4
	#define ARM_BOMB 5
	#define ARM_KNIFE 6
	#define ARM_ALL 7

	#define DEFAULT_Y true
	#define DEFAULT_N false

	#define WALL_Y true
	#define WALL_N false

	#define ZOOM_N 0 // none
	#define ZOOM_Z 1 // zoom
	#define ZOOM_S 2 // scope

	string ftxWeaponRemovePath( string ptxWeapon );
	string ftxConvertShieldModel( string ptxWeapon );
	bool fboModelIsShield( string ptxWeapon );

	const unsigned int cinBan_Off			= 0;
	const unsigned int cinBan_Bots		= (1 << 0);
	const unsigned int cinBan_Humans		= (1 << 1); // takes precedence over below;
	const unsigned int cinBan_Clan		= (1 << 2);
	const unsigned int cinBan_World		= (1 << 3);
	const unsigned int cinBan_ClanTeam	= (1 << 4);
	const unsigned int cinBan_WorldTeam	= (1 << 5);
	const unsigned int cinBan_All			= cinBan_Bots|cinBan_Humans|cinBan_Clan|cinBan_World|cinBan_ClanTeam|cinBan_WorldTeam;

	class tstWeapon
	{
		public:
		string	vtxEntityName;
		string	vtxWeaponDesc;
		string	vtxModel;     // this is the model name without the path information;
		string	vtxModelFull; // this is the fullpath name of the model: "models/model.mdl";
		bool		vboDefault;
		int		vinArmType; 
		int		vinRank; // 0 = Low; 1 = Med; 2 = High;
		bool		vboInitialized;
		int		vinTeam;
		bool		vboCanBuy;
		float		vflMinTrackTime;
		float		vflMaxTrackTime; // Amount of time to keep shooting at hidden enemy;
		bool		vboCanShootThroughWalls;

//		float		vflReloadTime;

		float		vflRescopeDelay;
		int		vinZoomType;
		
//		float		vflZoomDelay;

		int		finBuyOption( int pinTeam )
		{ 
			if ( pinTeam == cinTeam_TE )
				return vinBuyOption_TE;
			else
			if ( pinTeam == cinTeam_CT )
				return vinBuyOption_CT;
			else
				return 0;
		};

		int		finBuySlot( int pinTeam )
		{ 
			if ( pinTeam == cinTeam_TE )
				return vinBuySlot_TE;
			else
			if ( pinTeam == cinTeam_CT )
				return vinBuySlot_CT;
			else
				return 0;
		};

		int		vinBuyOption_CT;
		int		vinBuySlot_CT;
		int		vinBuyOption_TE;
		int		vinBuySlot_TE;

		string   vtxBuyCommand;

		unsigned short vinBanBitFlag;
		bool vboWeaponIsBanned;

		bool		fboWeaponIsBanned_Switch( );
		void		fvoSetWeaponIsBanned_Switch( bool pboWeaponIsBanned );
		bool		fboWeaponIsBanned_ByFlag( unsigned short pinBanBit );
		bool		fboEntityBanned( );

		bool		vboAvailable;
		int		vinPrice; // how much does it cost to buy weapon;
		tclTimer vclTimer_EntityBan;

		int		vinPrimaryAmmoType;
		int		vinPrimaryAmmoClip;
		int		vinSecondaryAmmoType;
		int		vinSecondaryAmmoClip;
		int		vinHUDSlot;
		int		vinSlotPos;
		int		vinWeaponId;
		int		vinFlags;
		
		bool fboIsZoomable( ) { return ( vinZoomType > ZOOM_N ); };
		bool fboHasZoom( ) { return ( vinZoomType == ZOOM_Z ); };
		bool fboHasScope( ) { return ( vinZoomType == ZOOM_S ); };
		bool fboIsSideArm( ){ return ( vinArmType == ARM_SIDE ); };
		bool fboIsMainArm( ){ return ( vinArmType == ARM_MAIN ); };
		bool fboIsNade( ){ return ( vinArmType == ARM_NADE ); };
		bool fboCanShootThroughWalls( ) { return vboCanShootThroughWalls; };
		float fflRescopeDelay( ) { return vflRescopeDelay; };
		float fflMinTrackTime( ) { return vflMinTrackTime; };
		float fflMaxTrackTime( ) { return vflMaxTrackTime; };

	}; // tstWeapon

	const int cinOptions_Min =  1;
	const int cinOptions_Max = 10;

	const int cinBuySlots_Min =  1;
	const int cinBuySlots_Max = 10;

	const int cinNotBuying = -1; // no weapon purchase in progress;
	const int cinBuyOption =  0; // selected a weapon option;
	const int cinBuySlot	  =  1; // selected a weapon slot;

	struct tstBuyMenu
	{
		int vinState;
		int vinBuyOption;
		int vinBuySlot;
	}; // tstBuyMenu

	class tclWeapon
	{
		public:
			int		   vinNumWeapons;
			tstWeapon	vstWeaponList [ cinMaxWeapons ];
			int		   vinWeaponMode;
			string	   vtxWeaponModeDisplay;
			tstBuyMenu  vin_aryBuyMenu[ cinMaxPlayers ];
			
			unsigned short vinGlobalBanBitFlag;

			float		   vflDamageReduction; 
			bool			vboUseRank;

		tclWeapon(void);
		void fvoPrecacheSprites( );
		int  finFindWeapon( string ptxEntityName );
		int  finFindWeaponByModel( string ptxModel );
		int  finFindWeaponById( int pinWeaponId );
		int  finFindWeaponBySlot( int pinTeam, int pinBuyOption, int pinBuySlot );
		int  finFindWeaponByBuyCmd( string ptxBuyCommand );
		bool fboAddWeapon(
			string	ptxEntityName, 
			int		pinTeam,
			int		pinRank,
			bool		pboCanBuy,
			bool		pboDefault,
			int		pinArmType,
			bool		pboCanShootThroughWalls,
			float 	pflRescopeDelay,
			int		pinZoomType,
			float		pflMinTrackTime,
			float		pflMaxTrackTime,
			int		pinBuyOption_TE,	
			int		pinBuySlot_TE,
			int		pinBuyOption_CT,	
			int		pinBuySlot_CT,
			string   ptxBuyCommand,
			int		pinPrice,
			string   ptxModel,
			string	ptxWeaponDesc );

		string ftxGetWeaponNameById( int pinWeaponId );
		string ftxGetWeaponDescById( int pinWeaponId );
		string ftxGetWeaponDescByIndex( int pinWeaponIndex );
		bool fboInitWeapon
		(  string	ptxEntityName, 
			int		pinPrimaryAmmoType, 
			int		pinPrimaryAmmoClip,
			int		pinSecondaryAmmoType, 
			int		pinSecondaryAmmoClip, 
			int		pinHUDSlot,
			int		pinSlotPos,
			int		pinWeaponId,
			int		pinFlags);
		
		void fvoSetGlobalWeaponBanFlag( unsigned short pinBanFlag );
		void fvoSetGlobalWeaponBanFlagBit_On( unsigned short pinBanBit );
		void fvoSetGlobalWeaponBanFlagBit_Off( unsigned short pinBanBit );
		bool fboWeaponBanFlagIsOn( unsigned short pinBanBit );
		void fvoSetWeaponBan_UsingGlobalFlag( );

      bool fboWeaponBanFlagIsOn( );

		void fvoSetAllWeaponBan( bool pboState );
		void fvoSetWeaponBanSwitch( string ptxEntityName, bool pboBanState );
		void fvoSetWeaponBanFlag( string ptxEntityName, unsigned short pinBanFlag );
		void fvoSetWeaponBanFlagBit_On( string ptxEntityName, unsigned short pinBanBit );
		void fvoSetWeaponBanFlagBit_Off( string ptxEntityName, unsigned short pinBanBit );

//		void fvoSetWeaponBan( string ptxEntityName, bool pboMenuBan, bool pboEntityban );
//		void fvoSetWeaponBan_Menu( string ptxEntityName, bool pboMenuBan );
//		void fvoSetWeaponBan_Entity( string ptxEntityName, bool pboEntityBan  );
		void fvoBanWeaponByName( string ptxEntityName );
//		void fvoBanWeapon( string ptxEntityName, bool pboEntityBan );
		void fvoUnbanWeaponByName( string ptxEntityName );
//		void fvoUnbanWeapon_Entity( string ptxEntityName );
		void fvoBanAllWeapons( void );
		void fvoUnbanAllWeapons( void );

		bool fboWeaponIndexIsValid( int pinWeaponIdx );
		tstWeapon* fst_ptrGetWeaponPtr( int pinWeaponIdx );

		bool fboWeaponIsBanned_SwitchByName( string ptxEntityName );
		bool fboWeaponIsBanned_EntityByName( string ptxEntityName );
		bool fboWeaponIsBanned_SwitchById( int pinWeaponId );
		bool fboWeaponIsBanned_EntityById( int pinWeaponId );
		bool fboWeaponIsBanned_SwitchByIndex( int pinWeaponIdx );
		bool fboWeaponIsBanned_EntityByIndex( int pinWeaponIdx );

		bool fboWeaponIsBanned_SwitchByNameReturnIndex( string ptxEntityName, int& pinIdx );
		bool fboWeaponIsBanned_SwitchBySlotReturnIndex( int pinTeam, int pinBuyOption, int pinBuySlot, int& pinIdx );
		
		bool fboDefaultWeaponIsBanned_SwitchByTeam( int pinTeam );
		bool fboDefaultWeaponIsBanned_EntityByTeam( int pinTeam );

		bool fboWeaponIsBanned_HumanCheckByIndex( edict_t* pst_ptrEdict, int pinIdx );
		bool fboWeaponIsBanned_HumanCheckBySlot( edict_t* pst_ptrEdict, int pinBuyOption, int pinBuySlot, int& pinIdx );
		bool fboWeaponIsBanned_HumanCheckByName( edict_t* pst_ptrEdict, string ptxEntityName, int& pinIdx );
		bool fboWeaponIsBanned_HumanCheckByBuyCmd( edict_t* pst_ptrEdict, string ptxBuyCmd, int& pinIdx );
		bool fboWeaponIsBanned_HumanCheckById( edict_t* pst_ptrEdict, int pinWeaponId, int& pinIdx );

		bool fboWeaponIsDefaultByIndex( int pinWeaponIdx );
		bool fboWeaponIsDefaultByIndex( int pinWeaponIdx, int pinTeam );
		bool fboWeaponIsSideArm_ByIndex( int pinWeaponIndex );
		bool fboWeaponIsSideArm_ById( int pinWeaponId );
		bool fboWeaponIsMainArm_ByIndex( int pinWeaponIndex );
		bool fboWeaponIsMainArm_ById( int pinWeaponId );
		void fvoBanAllGuns( void );
		void fvoUnbanAllGuns( void );
		void fvoBanAllPistols( void );
		void fvoUnbanAllPistols( void );
		void fvoBanAllSubs( void );
		void fvoUnbanAllSubs( void );
		void fvoBanAllShotguns( void );
		void fvoUnbanAllShotguns( void );
		void fvoBanAllRifles( void );
		void fvoUnbanAllRifles( void );
		void fvoBanAllSnipe( void );
		void fvoUnbanAllSnipe( void );
		void fvoBanAllNades( void );
		void fvoUnbanAllNades( void );
		void fvoBanPARA( void );
		void fvoUnbanPARA( void );

		void fvoSetWeaponMode_RegularWar( void );
		void fvoSetWeaponMode_LightArmsWar( void );
		void fvoSetWeaponMode_SmallArmsWar( void );
		void fvoSetWeaponMode_HeavyArmsWar( void );
		void fvoSetWeaponMode_KnifeWar( void );
		void fvoSetWeaponMode_NadeWar( void );
		void fvoSetWeaponMode_LightPistolWar( void );
		void fvoSetWeaponMode_PistolWar( void );
		void fvoSetWeaponMode_DeagleWar( void );
		void fvoSetWeaponMode_GlockUSPWar( void );
		void fvoSetWeaponMode_GlockWar( void );
		void fvoSetWeaponMode_USPWar( void );
		void fvoSetWeaponMode_Dual57War( void );
		void fvoSetWeaponMode_P228War( void );
		void fvoSetWeaponMode_LightSubWar( void );
		void fvoSetWeaponMode_UziWar( void );
		void fvoSetWeaponMode_UMPWar( void );
		void fvoSetWeaponMode_P90War( void );
		void fvoSetWeaponMode_MP5War( void );
		void fvoSetWeaponMode_SubWar( void );
		void fvoSetWeaponMode_PumpWar( void );
		void fvoSetWeaponMode_AutoShotgunWar( void );
		void fvoSetWeaponMode_ShotgunWar( void );
		void fvoSetWeaponMode_ScoutWar( void );
		void fvoSetWeaponMode_SnipeWar( void );
		void fvoSetWeaponMode_LightSnipeWar( void );
		void fvoSetWeaponMode_AWPWar( void );
		void fvoSetWeaponMode_PARAWar( void );
		void fvoSetWeaponMode_AK47ColtWar( void );
		void fvoSetWeaponMode_SG552AugWar( void );
		void fvoSetWeaponMode_HK550SnipeWar( void );
		void fvoSetWeaponMode_FamasGalilWar( void );

		bool fboStopWeaponSelect( edict_t* pst_ptrEdict, string ptxCmd, string ptxMenuItem );
		
		float fflGetDamageReduction( ) { return vflDamageReduction; };
		void fvoSetDamageReduction( float pflDamageReduction );
		void fvoApplyDamageReduction( edict_t* pst_ptrEdict_Source, TraceResult* pst_ptrTR );

		void fvoSetUseRank( bool pboUseRank ){ vboUseRank = pboUseRank; };
		bool fboUseRank( ){ return vboUseRank; };
//		int finGetRandomArm( int vinTeam, int pinArmType, int pinWeaponInHand = -1 );
		int finGetRandomArm_orig( int pinTeam, int pinArmType, int pinWeaponInHand, int& pinMoney, bool pboUseRank = USERANK_Y );
		int finGetRandomArm( int pinTeam, int pinArmType, int pinWeaponInHand, int& pinMoney );

		void fvoForceDropWeapon( edict_t* pst_ptrEdict, float pflDropTime );
		void fvoCheckWeapons( edict_t* pst_ptrEdict, int pinUserIndex );
		float fflForceWeaponBuy( edict_t* pst_ptrEdict, int pinArmType, int pinUserTeam, int pinWeaponInHand, int pinMoney );
/*		void fvoWaypointDrawBeam( 
			edict_t* pst_ptrEdict, 
			Vector pstStart, Vector pstEnd, 
			int pinWidth,
			int pinNoise, 
			int pinRed, int pinGreen, int pinBlue, int pinBrightness, 
			int pinSpeed );
*/
		// void fvoWeaponBuy( edict_t* pst_ptrEdict, float pflBuyTime, int pinArmType );

		int finGetWeaponBanPenalty( );
		int finGetWeaponBanPenalty_Amount( );
		void fvoGetWeaponBanPenaltyAndAmount( int& pinPenalty, int& pinAmount );
		void fvoGetRandomWeaponBanPenaltyAndAmount( int& pinPenalty, int& pinAmount );
		void fvoExecWeaponBanPenalty( edict_t* pst_ptrEdict );

	}; // tclWeapon

	extern tclWeapon vclWeapon;

/* =====================================
   Weapon List Message Format Example
   =====================================
	Message BEGIN 
	...Message Type: 77
	...Message Dest: 1
	...Player Name : [MEAN] the.bot.meister
	0...WriteString : weapon_flashbang
	1...WriteByte   : 11 Primary Ammo
	2...WriteByte   : 2  Max Primary Ammo
	3...WriteByte   : -1 Secondary Ammo
	4...WriteByte   : -1 Max Secondary Ammo
	5...WriteByte   : 3  HUD Slot
	6...WriteByte   : 2  Slot Position
	7...WriteByte   : 25 Weapon Id
	8...WriteByte   : 24 Flags
	Message END */

	class tclWeaponListMsg: public tclBaseMsg
	{
		public:
		// Message contents
			string		 vtxWeaponName;
			int			 vinPrimaryAmmoType;
			int			 vinPrimaryAmmoClip;
			int			 vinSecondaryAmmoType;
			int			 vinSecondaryAmmoClip;
			int			 vinHUDSlot;
			int			 vinSlotPos;
			int			 vinWeaponId;
			int			 vinFlags;
			tclWeaponListMsg( void );
	}; // tclWeaponListMsg

	extern tclWeaponListMsg vclWeaponListMsg; 

/* =====================================
   Weapon Pickup Message Format Example
   =====================================
	Message BEGIN // weapon pickup
	...Message Type: 92
	...Message Dest: 1
	...Player Name : [POD]Fender*Bender

	...WriteByte   : 29
	Message END */

	class tclWeaponPickupMsg: public tclBaseMsg
	{
		public:
			int			 vinWeaponId;
			tclWeaponPickupMsg( void );
	}; // tclWeaponPickupMsg

	extern tclWeaponPickupMsg vclWeaponPickupMsg;

/* =============================
   Damage Message Format Example
   =============================
	Message BEGIN
	...Message Type   : 71
	...Message Dest   : 1
	...Entity Origin x: 1450.918701
	...Entity Origin y: 1221.412842
	...Entity Origin z: 18.031250
	...Entity Name    : [PLB]Alfred Nobel
	...WriteByte      : 0
	...WriteByte      : 27
	...WriteLong      : 0
	...WriteCoord     : 1179.267212
	...WriteCoord     : 1022.546631
	...WriteCoord     : 36.031250
	Message END */

	class tclDamageMsg: public tclBaseMsg
	{
		public:
		// Message contents
			int			 vinMsgType;
			int			 vinMsgDest;
		   const float* vfl_ptrOrigin;
		   edict_t*     vst_ptrEdict;
			int   vinByte;    // use unknown;
			int   vinDamage;  // amount of damage;
			int   vinLong;    // use unknown;
			Vector vstOrigin; // < x, y, x > vector origin of player who is inflicting the damage;
			tclDamageMsg( void );
	}; // tclDamageMsg

	extern tclDamageMsg vclDamageMsg;

	void fvoWeaponListMsg_End( void* pclMessage );
	void fvoWeaponPickupMsg_End( void* pclMessage );
	void fvoDamageMsg_End( void* pclMessage );
	void fvoDamageMsg_Begin( void* pclMessage );
	void fvoDamageMsg_Sent( void* pclMessage );
	void fvoMsgDeath_End( void* pclMessage );

#endif // defMA_Weapon_h


