#include "MB_Directive.h"
#include "MB_Debug.h"
#include <time.h>

//.e	member functions of tclDebugTrace
//

	tclDebugTrace::tclDebugTrace( string ptxFileName )
	{
		vtxFileName = ptxFileName;
	}

	void tclDebugTrace::fvoWriteEventHeader 
		(	bool pboDebugOn,
		   string ptxModule,
			string ptxRoutine)
	{

		if (!pboDebugOn)
		{
			return;
		}

		string vtxHeader = "Module: " + ptxModule + ", Routine: " + ptxRoutine + ":";

		vna_ptrRecFile = fopen (vtxFileName.c_str(), "a"); 
		fprintf (vna_ptrRecFile, vtxHeader.c_str()); 
		fprintf (vna_ptrRecFile, "\r\n"); 
		fclose (vna_ptrRecFile); 

	} // tclDebugTrace::fvoWriteEventHeader

	void tclDebugTrace::fvoWriteEventInfo( string ptxInfo )
	{
		fvoWriteEventInfo( true, ptxInfo);
	} // tclDebugTrace::fvoWriteEventInfo

	void tclDebugTrace::fvoWriteEventInfo 
		(	bool pboDebugOn,
		   string ptxInfo)
	{

		if (!pboDebugOn)
		{
			return;
		}

		time_t vlgTime;
		string vtxTimeStr;		
		time( &vlgTime );
	   vtxTimeStr = ctime( &vlgTime );

		int vinLength = vtxTimeStr.length( );

		if ( vinLength > 0 )
		{
			if ( vtxTimeStr[ vinLength-1 ] == '\n' )
				vtxTimeStr.resize( vinLength-1 );
		}

		ptxInfo = vtxTimeStr + " :: " + ptxInfo;
		vna_ptrRecFile = fopen( vtxFileName.c_str( ), "a" ); 
		fprintf ( vna_ptrRecFile, ptxInfo.c_str( ) ); 
//		fprintf ( vna_ptrRecFile, "\r\n" );  // orig
//		fprintf ( vna_ptrRecFile, "\n\r" ); 
		fprintf ( vna_ptrRecFile, "\n" ); 
		fclose ( vna_ptrRecFile ); 

	} // tclDebugTrace::fvoWriteEvent


//
//.e	member functions of tclDebugTrace

tclDebugTrace vclDebugTrace( "cstrike\\mean\\logs\\general.log" );
tclDebugTrace vclMapLoadTrace( "cstrike\\mean\\logs\\mapload.log" );
tclDebugTrace vclClientConnTrace( "cstrike\\mean\\logs\\player.log" );
tclDebugTrace vclClientBanLog( "cstrike\\mean\\logs\\ban.log" );