//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MB_InterfaceL1.cpp
//	
//	BOT Interface Layer 1. 
//
// Each interface function will first execute the inserted BOT 
// code (if any), then it will call the real half-life engine 
// function or the real MOD function depending on the case. The
//	inserted BOT code acts as the interface between the BOT,
//	Engine and the MOD.
//
//.e	
#include "MB_Includes.h"
#include "MB_InterfaceL1.h"
#include "MB_InterfaceL2.h"
#include "MG_Lib.h"
#include "MI_Hud.h"
#include "MI_Sound.h"
#include "MI_Player.h"
#include "MA_Player.h"
#include "MA_Bot.h"
#include "MA_EngDLLCmd.h"
#include "MI_Map.h"
#include "MA_Weapon.h"
#include "MA_Cmd.h"
#include "MA_Security.h"
#include "MA_Text.h"
#include "MA_Message.h"
#include "MA_Sched.h"
#include "MA_BotControl.h"

int m_spriteTexture = 0;

int vinMsg_WeaponList	= 0;
int vinMsg_ShowMenu		= 0;
int vinMsg_WeaponPickup	= 0;
int vinMsg_Damage			= 0;
int vinMsg_VGUIMenu		= 0;
int vinMsg_Money			= 0;
int vinMgs_ScreenFade	= 0;
int vinCurrentMessage	= 0;
int vinMsg_Death			= 0;
int vinMsg_RoundTime		= 0;
int vinMsg_HLTV			= 0;


// TheFatal - START
   long vin_msecnum = 0;
   float vfl_msecdel = 0.0;
   float vfl_msecval = 10.0;
// TheFatal - END

//.b	debugging variables and definitions.
	const bool cboDebugAll = false;
	
//.e

//.b	Engine Function Tables.
	tstENGFuncs			g_engfuncs;				// Engine Funcs: Original (see "#define" below).
	tstENGFuncs			vstENGFuncsBot;		// Engine Funcs: BOT version.

//.e	Engine Function Tables.

//.b	MOD DLL Function Tables.
	tstDLLFuncs			vstDLLFuncsOrig;		// Original.
	tstDLLFuncs			vstDLLFuncsBot;		// BOT version.
//.e	MOD DLL Function Tables.

const char *cch_ptrGiveFnptrsToDll		= "GiveFnptrsToDll";
const char *cch_ptrGetEntityAPI			= "GetEntityAPI";
const char *cch_ptrGetNewDLLFunctions	= "GetNewDLLFunctions";
const char *cch_ptrEntityPlayer			= "player";
const char *cch_ptrBlendingAPI			= "Server_GetBlendingInterface";

//.b	Definitions of the interface function pointers.
	typedef int (FAR *tfn_ptrGetEntityAPI)(tstDLLFuncs *, int);
	typedef int (FAR *tfn_ptrGetNewDLLFunctions)(tstDLLFuncsNew *, int *);
	typedef void (DLLEXPORT *tfn_ptrGiveFnptrsToDLL) 
		(tstENGFuncs *, tstENGGlobalVars *);
//.e	

//.b	Instances of the interface function pointers.
	tfn_ptrGetEntityAPI vfn_ptrGetEntityAPI = NULL;
	tfn_ptrGiveFnptrsToDLL vfn_ptrGiveFnptrsToDLL = NULL;
	tfn_ptrGetNewDLLFunctions vfn_ptrGetNewDLLFunctions = NULL;
//.e

tclInterfaceL1 vclInterfaceL1;

tclInterfaceL1::tclInterfaceL1 (void)
// Constructor: autoinitializes object class on instance creation.
{
	vboGameIsFullyLoaded			= false;
	vboENGFuncsOrigIsInit		= false;
	vboENGFuncsBotIsInit			= false;
	vboDLLFuncsOrigIsInit		= false;
	vboDLLFuncsBotIsInit			= false;	
	vfn_ptrEntityPlayerOrig		= NULL;
	vfn_ptrBlendingAPI			= NULL;
	vboCanceled						= false;
	vboBroken						= false;
	vna_ptrGameDLL					= NULL;
	vna_ptrCSTRIKEDLL				= NULL;
	vboRoundStarted				= false;

	vboFirstFrameOf_ServerStart	= true;
	vboFirstFrameOf_MapStart		= true;
	vflTimeOf_ServerStart			= 0.0;
	vflTimeOf_MapStart				= 0.0;
	vlgFrameCounter		= 0;
	vboGameDLLIsLoaded	= false;
	vinEngineType			= cinEngineIsUnknown;

	vboIsFakeClient = false;
	vinNumFakeArgs  = 0;
	fvoClearArgS( );

} // tclInterfaceL1::tclInterfaceL1

void tclInterfaceL1::fvoClearArgS( )
{
	for ( int vinIdx = 0; vinIdx < cinMaxArg; vinIdx++ )
		vtx_aryArgS[ vinIdx ] = "";		
	vtxArgS = "";
	vinNumFakeArgs = 0;

} // tclInterfaceL1::fvoClearArgS

void tclInterfaceL1::fvoAddArgS( string ptxArg )
{
	if ( ( vinNumFakeArgs < 0 ) || ( vinNumFakeArgs > cinMaxArg ) )
	// this is an error condition, reset buffer;
		fvoClearArgS( );

	if ( vinNumFakeArgs == cinMaxArg )
	// buffer is full;
		return;

	vtx_aryArgS[ vinNumFakeArgs ] = ptxArg;

	if ( vinNumFakeArgs > 0 )
	{
		if ( !vtxArgS.empty( ) ) ptxArg = " " + ptxArg;
		vtxArgS += ptxArg;
		
	}

	vinNumFakeArgs++;

} // tclInterfaceL1::fvoAddArgS

int tclInterfaceL1::finStartUp( void )
{
	if ( !vclInterfaceL2.finStartUp( ) )
	{
		vboBroken = true;
	}
	
	return !vboBroken;

} // tclInterfaceL1::finStartUp

int tclInterfaceL1::finShutDown( void )
{
	if ( fboGameDLLIsLoaded( ) != true )
	{
   	FreeLibrary( fna_ptrGetGameDLLPtr ( ) );
	}
	
	if ( fboCSTRIKEDLLIsLoaded( ) != true )
	{
   	FreeLibrary( fna_ptrGetCSTRIKEDLLPtr ( ) );
	}

	vclInterfaceL2.finShutDown( );
	vfn_ptrEntityPlayerOrig	= NULL;
	vna_ptrGameDLL				= NULL;
	vna_ptrCSTRIKEDLL			= NULL;
	vboFirstFrameOf_ServerStart = false;
	vboFirstFrameOf_MapStart	 = false;
	vflTimeOf_ServerStart       = 0;
	vflTimeOf_MapStart          = 0;
	vlgFrameCounter			= 0;
	vboGameDLLIsLoaded		= false;
	vinEngineType				= cinEngineIsUnknown;
	vboBroken					= false;
	vboCanceled					= false;

	return !vboBroken;

} // tclInterfaceL1::finShutDown

void tclInterfaceL1::fvoDisplayAbout( void )
{
	if ( !vboENGFuncsOrigIsInit )
	{
		return;
	}
		
	fvoServerPrint( "\n###\n" );
	fvoServerPrint( "### (mEAn) Bot.Admin Manager version " + ctxVersion + ", Build: " + ctxBuild + "\n" );

	#ifdef def_CS16
		fvoServerPrint_nl( "### For Counter-Strike 1.6" );
	#else
		fvoServerPrint_nl( "### For Counter-Strike 1.5" );
	#endif
//	fvoServerPrint( "### (mEAn) Test using \"Fake Client\" bit only - do not distribute!\n" );
	fvoServerPrint( "### Copyright (c) 2002-2004 BotMeister (tm)\n" );
	fvoServerPrint( "###\n");
	fvoServerPrint( "### (mEAn) Bot.Admin Manager comes WITHOUT ANY WARRANTY\n" );
	fvoServerPrint( "### without even the implied warranty of merchantability or\n" );
	fvoServerPrint( "### fitness for a particular purpose.\n" ); 
	fvoServerPrint( "###\n");

} // tclInterfaceL1::fvoDisplayAbout

bool tclInterfaceL1::fboCanceled (void)
{
	if ( vboCanceled == true )
	{
		vboCanceled = false;
		return true;
	}
	return false;
} // tclInterfaceL1::fboCanceled

bool tclInterfaceL1::fboEngineIsServer (void)
{
	return vinEngineType == cinEngineIsServer;
}
bool tclInterfaceL1::fboEngineIsClient (void)
{
	return vinEngineType == cinEngineIsClient;
}
bool tclInterfaceL1::fboEngineIsUnknown (void)
{
	return vinEngineType == cinEngineIsUnknown;
}

void tclInterfaceL1::fvoCreateEntityPlayer 
	( edict_t *pst_ptrEdict )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			( cboDebugAll, "tclInterfaceL1::fvoCreateEntityPlayer: Entry point." );
	#endif

	if ( pst_ptrEdict == NULL )
		return;

	(*vfn_ptrEntityPlayerOrig) ( &pst_ptrEdict->v );

} // tclInterfaceL1::fvoCreateEntityPlayer

bool tclInterfaceL1::fboGameDLLIsLoaded 
	(void)
{
	return vboGameDLLIsLoaded;
} // tclInterfaceL1::fboGameDLLIsLoaded

void tclInterfaceL1::fvoSetGameDLLPtr 
	(HINSTANCE pna_ptrGameDLL)
{
	vna_ptrGameDLL = pna_ptrGameDLL;
	vboGameDLLIsLoaded = vna_ptrGameDLL != NULL;
} // tclInterfaceL1::fvoSetGameDLLPtr

void tclInterfaceL1::fvoSetCSTRIKEDLLPtr 
	( HINSTANCE pna_ptrDLL )
{
	vna_ptrCSTRIKEDLL = pna_ptrDLL;
	vboCSTRIKEDLLIsLoaded = vna_ptrCSTRIKEDLL != NULL;
} // tclInterfaceL1::fvoSetGameDLLPtr

void tclInterfaceL1::vboExecuteAfter_InitENGFuncsOrig (void)
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			( cboDebugAll, "vboExecuteAfter_InitENGFuncsOrig: Entry point." );
	#endif

	vclInterfaceL1.vboENGFuncsOrigIsInit = true;
	vclInterfaceL1.fvoDisplayAbout ();
	if ( vclCommand.fboAddAllCmds( ) == false )
		fvoServerPrint( ctxMsgPrefix + "WARNING: One or more server commands where not added.\n" );

} // tclInterfaceL1::vboExecuteAfter_InitENGFuncsOrig

void tclInterfaceL1::fvoExecuteOn_ServerCommand_ENG
	(char *pch_ptrCommand)
{

	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			( cboDebugAll, "fvoExecuteOn_ServerCommand_ENG: Entry point." );
	#endif

	vboCanceled = false;

} // tclInterfaceL1::fvoExecuteOn_ServerCommand_ENG

void fvoMsg_RoundStart_End( void* pclMessage )
{
	if ( static_cast<tclMessage*>(pclMessage)->vst_aryValueList[0].vinInt == 0 
			 && 
		  static_cast<tclMessage*>(pclMessage)->vst_aryValueList[1].vinInt == 0 
		)
	{
		vclInterfaceL1.vboRoundStarted = true;
		// vclInterfaceL1.vclRoundStartTimer.fvoStart( );
		// vclDebugTrace.fvoWriteEventInfo( "ROUND ENDED" );
	}

} // fvoMsg_RoundStart_End

void tclInterfaceL1::fvoExecuteBefore_MsgBegin_ENG
	( int msg_dest, int msg_type, const float *pOrigin, edict_t* pst_ptrEdict )
{

	vboCanceled = false;
	vinCurrentMessage = msg_type;
	string vtxMsg;

	vclMessage.fvoMsg_Begin( msg_dest, msg_type, pOrigin, pst_ptrEdict );
	vclMessage.vboTraceMsg = false;

//!!.b
//	vclMessage.fvoSetCaptureMsgOn( );
//	vclMessage.fvoSetSendMsgFlagOn( );
//	vclMessage.vboTraceMsg = true;
//	vclMessage.vfn_ptrMsgEnd = NULL;
//	vclMessage.vfn_ptrMsgSent = NULL;
//!!.e


	if ( vinCurrentMessage == vinMsg_Damage )
	{
		vclMessage.fvoSetCaptureMsgOn( );
		vclMessage.fvoSetSendMsgFlagOn( );
		//vclMessage.vboTraceMsg = true;
		vclMessage.vfn_ptrMsgEnd = fvoDamageMsg_End;
		vclMessage.vfn_ptrMsgSent = fvoDamageMsg_Sent;
		return;
	}

	if ( vinCurrentMessage == vinMsg_WeaponList )
	{
		vclMessage.fvoSetCaptureMsgOn( );
		vclMessage.fvoSetSendMsgFlagOn( );
		// vclMessage.vboTraceMsg = true;
		vclMessage.vfn_ptrMsgEnd = fvoWeaponListMsg_End;
		return;
	}

	if ( vinCurrentMessage == vinMsg_WeaponPickup )
	{
		vclMessage.fvoSetCaptureMsgOn( );
		vclMessage.fvoSetSendMsgFlagOn( );
		//vclMessage.vboTraceMsg = true;
		vclMessage.vfn_ptrMsgEnd = fvoWeaponPickupMsg_End;
		return;
	}

	if ( vinCurrentMessage == vinMsg_Money )
	{
		vclMessage.fvoSetCaptureMsgOn( );
		vclMessage.fvoSetSendMsgFlagOn( );
		// vclMessage.vboTraceMsg = true;
		vclMessage.vfn_ptrMsgEnd = fvoBotMoneyMsg_End;
		return;
	}

	if ( vinCurrentMessage == vinMgs_ScreenFade )
	{
		vclMessage.fvoSetCaptureMsgOn( );
		vclMessage.fvoSetSendMsgFlagOn( );
		// vclMessage.vboTraceMsg = true;
		vclMessage.vfn_ptrMsgEnd = fvoMsgScreenFade_End;
		return;
	}

	if ( vinCurrentMessage == vinMsg_Death )
	{
		vclMessage.fvoSetCaptureMsgOn( );
		vclMessage.fvoSetSendMsgFlagOn( );
		// vclMessage.vboTraceMsg = true;
		vclMessage.vfn_ptrMsgEnd = fvoMsgDeath_End;
		return;
	}

//	if ( vinCurrentMessage == vinMsg_RoundTime )
//	{
//		// let message pass through normally;
//		vboRoundEnded = true;
//		return;
//	}

	if ( vinCurrentMessage == vinMsg_HLTV )
	{
		vclMessage.fvoSetCaptureMsgOn( );
		vclMessage.fvoSetSendMsgFlagOn( );
		vclMessage.vboTraceMsg = false;
		vclMessage.vfn_ptrMsgEnd = fvoMsg_RoundStart_End;
		return;
	}

} // tclInterfaceL1::fvoExecuteBefore_MsgBegin_ENG

void tclInterfaceL1::fvoExecuteOn_GameInit_DLL
	(void)
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "fvoExecuteOn_GameInit_DLL: Entry point.");
	#endif
	
	vboCanceled = false;

	if (vstENGFuncsBot.pfnIsDedicatedServer () == true)
	{
		vinEngineType = cinEngineIsServer;
	}
	else
	{
		vinEngineType = cinEngineIsClient;
	}

} // tclInterfaceL1::fvoExecuteOn_GameInit_DLL

void tclInterfaceL1::fvoExecuteOn_Spawn_DLL
	( edict_t *pst_ptrEdict )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, "fvoExecuteOn_Spawn_DLL: Entry point.");
	#endif
	
	vboCanceled = false;

	char *vch_ptrClassname = (char *)STRING(pst_ptrEdict->v.classname);
	string vtxClassName;
	vtxClassName= vch_ptrClassname;

//	vclDebugTrace.fvoWriteEventInfo 
//		("fvoExecuteAfter_Spawn_DLL: " + vtxClassName );


	if ( vtxClassName == "worldspawn" ) 
	{
		vboFirstFrameOf_MapStart = true;
		vclWeapon.fvoUnbanAllWeapons( );
	   //vclWeapon.fvoPrecacheSprites( );

		m_spriteTexture = PRECACHE_MODEL( "sprites/lgtning.spr");

		// precache of all sounds must be done during each worldspawn event.
		// !!.begin - should be moved to a class function in mi_sounds.cpp
		vclSoundCmdList_System.fvoPrecacheSndFiles( );
		vclSoundCmdList_Damage.fvoPrecacheSndFiles( );
		vclSoundCmdList_Admin.fvoPrecacheSndFiles( );
		vclSoundCmdList_BotRandom.fvoPrecacheSndFiles( );
		vclSoundCmdList_Public.fvoPrecacheSndFiles( );
		vclTimeBomb.fvoInitSounds( );
		vclPlayer.fvoInitSoundDamage( );
		// !!.end - should be moved to a class function in mi_sounds.cpp
		vclPlayerSlot.vclTimer_AFK.fvoStart( vclPlayerSlot.vinAutoAFKKickTimeout );
		
	} // worldspawn
//!!	else 
//!!	if (vtxClassName == "player") 
//!!	{
//!!		// tests indicate that this section never gets executed because
//!!		// players are not entities that get spawned during a map load.
//!!
//!!	}

}	// tclInterfaceL1::fvoExecuteOn_Spawn_DLL

void tclInterfaceL1::fvoExecuteAfter_Spawn_DLL
	(	edict_t *pst_ptrEdict, int pinResult)
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, "fvoExecuteAfter_Spawn_DLL: Entry point.");
	#endif

	string vtxMsg;

	if ( pinResult != 0 )
	{
		vtxMsg = ctxMsgPrefix + "Warning - spawn was unsuccessfull! Result code: " + ftxIntToString( pinResult );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		return;
	}

	if ( pst_ptrEdict == NULL )
	{
		vtxMsg = ctxMsgPrefix + "Warning - spawn entity is NULL! Result code: " + ftxIntToString( pinResult );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		return;
	}

	char *vch_ptrClassname = (char *)STRING(pst_ptrEdict->v.classname);
	string vtxClassName;
	vtxClassName= vch_ptrClassname;

	vclBotControl.fvoPODFixHostage( pst_ptrEdict );	

	if ( vtxClassName == "worldspawn" ) 
	{
		// vclBot.fvoFillServerWithBots();
	} // worldspawn
	else 
	if ( vtxClassName == "player" ) 
	{
		// tests indicate that this section never gets executed because
		// players are not entities that get spawned during a map load.
	}

}	// tclInterfaceL1::fvoExecuteAfter_Spawn_DLL

void tclInterfaceL1::fvoExecuteOn_Think_DLL 
	( edict_t *pst_ptrEdict )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "fvoExecuteOn_Think_DLL: Entry point.");
	#endif
   vboCanceled = false;
 //  vboCanceled = true;

} // tclInterfaceL1::fvoExecuteOn_Think_DLL
	
void tclInterfaceL1::fvoExecuteBefore_ClientConnect_DLL 
	(	edict_t *pst_ptrEdict, 
		const char *pch_ptrName, 
		const char *pch_ptrAddress,
		char szRejectReason[ 128 ] )
//		char* szRejectReason[ 128 ] )
//		aryRejectReason &szRejectReason )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "fvoExecuteBefore_ClientConnect_DLL: Entry point.");
	#endif

	vboCanceled = false;

	string vtxMsg;

	if ( pst_ptrEdict == NULL )
	{
		vtxMsg = "ERROR: pst_ptrEdict == NULL during connection attempt.";
		fvoServerPrint_nl( vtxMsg );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		vboCanceled = true;
		return;
	}

	string vtxName;
	string vtxAddress;
	string vtxAuthId;
	string vtxUserId;
	
	vtxName = ftxGetEdictKeyValue ( pst_ptrEdict, "name" );
	vtxAddress = pch_ptrAddress;
	vtxUserId = ftxGetPlayerUserId( pst_ptrEdict );
	vtxAuthId = ftxGetPlayerAuthId( pst_ptrEdict );

	if ( ( vtxAuthId == "0" ) || ( vtxAuthId == "BOT" ) )
	{
		vtxMsg = ctxMsgPrefix + "Bot \"" + vtxName + "\" connecting ...";
		fvoServerPrint_nl( vtxMsg );
		return;
	}

	// prevent buffer overflow's with messages that are too long;
	string vtxDebugTrace;
	vtxMsg = 
		"\n" + ctxMsgPrefix + "Client Connect: \n"
		"  User Id : " + vtxUserId + "\n";
	vtxDebugTrace = vtxMsg;
	fvoServerPrint( vtxMsg );
	vtxMsg = "  Name    : " + vtxName + "\n";
	vtxDebugTrace += vtxMsg;
	fvoServerPrint( vtxMsg );
	vtxMsg = 
		"  Steam Id: " + vtxAuthId + "\n" + 
		"  IP:Port : " + vtxAddress + "\n\n";
	vtxDebugTrace += vtxMsg;
	fvoServerPrint( vtxMsg );
	vclDebugTrace.fvoWriteEventInfo( true, vtxDebugTrace );
	vtxDebugTrace = "Connected \"" + vtxName + "\", SteamId = " + vtxAuthId + ", UserId = " + vtxUserId  + ", IP:Port  = " + vtxAddress;
	vclClientConnTrace.fvoWriteEventInfo( true, vtxDebugTrace );

//
// For testing only
//	vclPlayer.vinMaxHumans = 0;
//
//

	if ( vclIPBanList.fboIPBanned( vtxName, vtxAuthId, vtxUserId, vtxAddress ) )
	{
		vtxMsg = "Disconnected \"" + vtxName + "\", IP address has been refused.";
		strcpy( szRejectReason, vtxMsg.c_str( ) );
		vboCanceled = true;
		return;
	}

	if ( vclPlayer.fboHumanCountExceeded( ) )
	{
		vtxMsg = "Disconnected \"" + vtxName + "\", Human player count exceeded. Try again later.";
		strcpy( szRejectReason, vtxMsg.c_str( ) );
		vboCanceled = true;
		return;
	}

	string vtxHostName = ftxCVarGetString( "hostname");
	tclUser* vcl_ptrUser;
	
	bool vboAccessGranted = vclSecurity.fboAccessGranted( pst_ptrEdict, vcl_ptrUser );
	string vtxAccessLevel;

	if ( vcl_ptrUser == NULL )
	{
		vtxMsg = "ERROR: vcl_ptrUser == NULL, please report this error to the server operator.";
		fvoClientPrintConsole( pst_ptrEdict, vtxMsg + "\n" );
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		vtxAccessLevel = "PUBLIC";
	}
	else
		vtxAccessLevel = vcl_ptrUser->ftxHighestAccessLevel( );

	vtxMsg = "\n===================================================================\n" ; 
	fvoClientPrintConsole( pst_ptrEdict, vtxMsg );

	vtxMsg = "Welcome " + vtxName + " to " + vtxHostName + "\n" ;
	fvoClientPrintConsole( pst_ptrEdict, vtxMsg );
   
	if ( vboAccessGranted )
		vtxMsg = "You have been authenticated with " + vtxAccessLevel + " privileges.\n";
	//!!.begin - is this obsolete?
	else
		vtxMsg = "The server is locked. Access will be denied after the game loads.\n";
	//!!.end - is this obsolete?

	vtxMsg += "\n";
	
	fvoClientPrintConsole( pst_ptrEdict, vtxMsg );
	vclMA_Text.vclConnMsg.fvoDisplayMsg( pst_ptrEdict );
	fvoClientConsoleWarModeDisplay( pst_ptrEdict );

	vtxMsg  = "This server is powered by the (mEAn) Bot.Admin Mod v " + ctxVersion + "\n";
	fvoClientPrintConsole( pst_ptrEdict, vtxMsg );
	vtxMsg = "Get the mod at http://www3.telus.net/mean/\n";
	fvoClientPrintConsole( pst_ptrEdict, vtxMsg );
	vtxMsg  = "===================================================================\n\n";
	fvoClientPrintConsole( pst_ptrEdict, vtxMsg );

/*
	if ( ftxToLower( vtxName ) == "[MEAN][MF]Rameses]*=" )
	{
		vtxMsg = "Death extends his mighty hand and inflicts pain on ";
		vtxMsg += vtxName;
		vclEventSched.fboCreateEvent( );
		vclEventSched.fboCreateArgList(	6 );
		vclEventSched.fvoSetArg_Int(		0, finGetPlayerUserId( pst_ptrEdict ) );
		vclEventSched.fvoSetArg_Bool(		1, true ); // vboHard
		vclEventSched.fvoSetArg_Int(		2, cinEffect_FastAdminSlap );
		vclEventSched.fvoSetArg_Int(		3, 1000, "repeat" ); // repeat
		vclEventSched.fvoSetArg_String(	4, vtxMsg );
		vclEventSched.fvoSetArg_Float(	5, 50.0 ); // delay
		vclEventSched.fvoSetEventFunc( fvoMA_Player_Event_SlapSwicken );
		vclEventSched.fvoSetDelayInSecs( vclEventSched.fflGetArg_Float( 5 ) );
		vclEventSched.fboSendEvent( );
	}

	if ( ftxToLower( vtxName ) == "player" )
	{
		vtxMsg = "Death extends his mighty hand and inflicts pain on ";
		vtxMsg += vtxName;
		vclEventSched.fboCreateEvent( );
		vclEventSched.fboCreateArgList(	6 );
		vclEventSched.fvoSetArg_Int(		0, finGetPlayerUserId( pst_ptrEdict ) );
		vclEventSched.fvoSetArg_Bool(		1, true ); // vboHard
		vclEventSched.fvoSetArg_Int(		2, cinEffect_FastAdminSlap );
		vclEventSched.fvoSetArg_Int(		3, 1000, "repeat" ); // repeat
		vclEventSched.fvoSetArg_String(	4, vtxMsg );
		vclEventSched.fvoSetArg_Float(	5, 50.0 ); // delay
		vclEventSched.fvoSetEventFunc( fvoMA_Player_Event_SlapSwicken );
		vclEventSched.fvoSetDelayInSecs( vclEventSched.fflGetArg_Float( 5 ) );
		vclEventSched.fboSendEvent( );
	}

 */

} // tclInterfaceL1::fvoExecuteBefore_ClientConnect_DLL

void tclInterfaceL1::fvoExecuteAfter_ClientConnect_DLL 
	(	edict_t*		pst_ptrEdict, 
		const char*	pch_ptrName, 
		const char*	pch_ptrAddress, 
		bool			pboConnected )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, "fvoExecuteAfter_ClientConnect_DLL: Entry point.");
	#endif

} // tclInterfaceL1::fvoExecuteAfter_ClientConnect_DLL

void tclInterfaceL1::fvoExecuteBefore_ClientDisconnect_DLL
	( edict_t *pst_ptrEdict )
{
	vboCanceled = false;
	string vtxMsg;

	int vinUserId = vclPlayer.finGetUserIdByEdict( pst_ptrEdict );
	int vinPlayerSlotIdx = vclPlayerSlot.finFindSlotByEdict( pst_ptrEdict );
	string vtxUserId = ftxIntToString( vinUserId );

//	if ( vclPlayer.fboPlayerIsBotByUserId( vinUserId ) )
//	{ // Player is a BOT
//		return;
//	}

//	if ( vinPlayerSlotIdx < 0 )
//	{
//		vtxMsg = 
//			"\nERROR:\n"
//			"  Function: fvoExecuteBefore_ClientDisconnect_DLL:\n"
//			"  Message : User id " + vtxUserId + 
//			" is disconnecting and a player slot was not found.\n\n";
//
		// fvoServerPrint( vtxMsg );
//		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
//	}

	
	string vtxPlayerName = vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );
	string vtxPlayerAuthId = ftxGetPlayerAuthId( pst_ptrEdict );
//	string vtxPlayerAddress = vclPlayerSlot.ftxGetPlayerAddress( vinPlayerSlotIdx );

	vclPlayerSlot.finRemovePlayer( vinPlayerSlotIdx );

	if ( !vclPlayer.fboPlayerIsHumanByEdict( pst_ptrEdict ) )
	{ // Player is a BOT or is invalid;
		return;
	}

	string vtxDebugTrace;

	vtxMsg = 
		"\n" + ctxMsgPrefix + "Client Disconnect: \n"
		"  User Id : " + vtxUserId + "\n";
	vtxDebugTrace = vtxMsg;
	fvoServerPrint( vtxMsg );
	vtxMsg = 
		"  Name    : " + vtxPlayerName + "\n";
	vtxDebugTrace += vtxMsg;
	fvoServerPrint( vtxMsg );
	vtxMsg = 
		"  Steam Id: " + vtxPlayerAuthId + "\n\n"; 
//		"  IP:Port : " + vtxPlayerAddress + "\n\n";
	vtxDebugTrace += vtxMsg;
	fvoServerPrint( vtxMsg );
	vclDebugTrace.fvoWriteEventInfo( true, vtxDebugTrace );

	vtxDebugTrace = "Disconnected \"" + vtxPlayerName + "\", SteamId = " + vtxPlayerAuthId + " UserId, = " + vtxUserId;
	vclClientConnTrace.fvoWriteEventInfo( true, vtxDebugTrace );
//!!	vclInterfaceL2.fvoDisplayPlayerSlotStatus( );

} // tclInterfaceL1::fvoExecuteBefore_ClientDisconnect_DLL

void tclInterfaceL1::fvoExecuteOn_ClientDisconnect_DLL 
	( edict_t *pst_ptrEdict )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "fvoExecuteOn_ClientDisconnect_DLL: Entry point.");
	#endif
	
} // tclInterfaceL1::fvoExecuteOn_ClientDisconnect_DLL

void tclInterfaceL1::fvoExecuteBefore_ClientKill_DLL 
	(edict_t *pst_ptrEdict)
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, "fvoExecuteBefore_ClientKill_DLL: Entry point.");
	#endif
	vboCanceled = false;

} // tclInterfaceL1::fvoExecuteBefore_ClientKill_DLL

void tclInterfaceL1::fvoExecuteBefore_ClientCommand_DLL 
	( edict_t *pst_ptrEdict )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "fvoExecuteBefore_ClientCommand_DLL: Entry point.");
	#endif

	vboCanceled = false;

	if ( pst_ptrEdict == NULL )
		return;
	
	if ( !pst_ptrEdict->pvPrivateData )
		return;

	vclCommand.fboCmdDispatch( pst_ptrEdict, enClient );
	vboCanceled = vclCommand.vboCancel;

} // tclInterfaceL1::fvoExecuteBefore_ClientCommand_DLL

void tclInterfaceL1::fvoExecuteOnFirstFrameOfServer_DLL( void )
{

	vclMapLoadTrace.fvoWriteEventInfo( "** SERVER START - " + ctxVersion + " **");	

	vboCanceled = false;
	int vinDelay;

	// Indicate next frames are no longer the first frame.
		vboFirstFrameOf_ServerStart = false;
		vflTimeOf_ServerStart = fflGetEngineTime( );

		vlgFrameCounter_Start = vlgFrameCounter;
		vclFrameTimer.fvoStart( 0.25 );

   //
	// schedule recurring event messages;
	//

	fvoMA_Bot_Event_AutoKillBots_Start(  );

	if ( vclEventSched.fboCreateEvent( ) )
	{
		vinDelay = 60;
		vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoRandomBotSpeak );
		vclEventSched.fboCreateArgList( 1 );
		vclEventSched.fvoSetArg_Short( 0, vinDelay );  // maximum delay in seconds between BotSpeak;
		vclEventSched.fvoSetDelayInSecs( random( vinDelay ) + 1 ); 
		vclEventSched.fboSendEvent( );
	}

	if ( vclEventSched.fboCreateEvent( ) )
	{
		vinDelay = 3.0;
		vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoCheckStatsProtection );
		vclEventSched.fboCreateArgList( 1 );
		vclEventSched.fvoSetArg_Short( 0, vinDelay );
		vclEventSched.fvoSetDelayInSecs( vinDelay ); 
		vclEventSched.fboSendEvent( );
	}

	if ( vclEventSched.fboCreateEvent( ) )
	{
		vinDelay = 5.0;
		vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoCheckPODBotFixProtection );
		vclEventSched.fboCreateArgList( 1 );
		vclEventSched.fvoSetArg_Short( 0, vinDelay );
		vclEventSched.fvoSetDelayInSecs( vinDelay ); 
		vclEventSched.fboSendEvent( );
	}

	if ( vclEventSched.fboCreateEvent( ) )
	{
		vinDelay = 5.5;
		vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoKickDupBots );
		vclEventSched.fboCreateArgList( 1 );
		vclEventSched.fvoSetArg_Short( 0, vinDelay );
		vclEventSched.fvoSetDelayInSecs( vinDelay ); 
		vclEventSched.fboSendEvent( );
	}

	vclPlayer.fboSendEvent_EnforceClanTeam( 3.0 );
	vclPlayer.fboSendEvent_EnforceHumanTeam( 3.0 );

	vclBotControl.fvoSetCVars( );
	vclBotControl.fvoSetBotSkill( vclBot.vinBotSkill_Variable_Min, vclBot.vinBotSkill_Variable_Max );
	vclSecurity.fvoSetCVars( );
	
} // tclInterfaceL1::fvoExecuteOnFirstFrameOfServer_DLL

void tclInterfaceL1::fvoExecuteOnFirstFrameOfMap_DLL( void )
{
	vboCanceled = false;

//!!.removed for beta test
//!!	vclPlayer.fvoSetGameMode( );
//!!.end

	vboGameIsFullyLoaded = true;
	
	vclSecurity.fvoCheckServerLock( );

	// Indicate next frames are no longer the first frame.
		vboFirstFrameOf_MapStart = false;
		vflTimeOf_MapStart = fflGetEngineTime( );

	string vtxMap = vclMap.ftxGetMapName( );
	vclMapLoadTrace.fvoWriteEventInfo( vtxMap + " (loaded - first frame check)" );	

	
	vclScenario.fvoRunScenario( );
	
//!!  vclDebugTrace.fvoWriteEventInfo( true, "About to create an event" );

		if ( vclEventSched.fboCreateEvent( ) )
		{
			vclEventSched.fboCreateArgList( 2 );
			vclEventSched.fvoSetArg_String( 0, "status" ); // specify HUD display;
			vclEventSched.fvoSetArg_String( 1, ctxMsgPrefix + "You are playing on map " + vtxMap );
			vclEventSched.fvoSetEventFunc( fvoMI_HUD_Event_HUDDisplay );
			vclEventSched.fvoSetDelayInSecs( 60 );
			vclEventSched.fboSendEvent( );
		}
		
//		if ( vclEventSched.fboCreateEvent( ) )
//		{
//			vclEventSched.fvoSetEventFunc( fvoMA_BOT_Event_fvoDisplayBotTeam );
//			vclEventSched.fboCreateArgList( 2 );
//			vclEventSched.fvoSetArg_Short( 0, 6 ); // repeat count
//			vclEventSched.fvoSetArg_Short( 1, 5 ); // delay
//			vclEventSched.fvoSetDelayInSecs( 5 );
//			vclEventSched.fboSendEvent( );
//		}

} // tclInterfaceL1::fvoExecuteOnFirstFrameOfMap_DLL

void tclInterfaceL1::fvoExecuteOn_Frame_DLL( void )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "fvoExecuteOn_Frame_DLL: Entry point.");
//	char *itoa(int value, char *string, int radix);
		
//		vclDebugTrace.fvoWriteEventInfo 
//			(cboDebugAll, ftxIntToString( vlgFrameCounter ));
	
	#endif
	
	vboCanceled = false;

	vclEventSched.fvoExecEvent( );

	if ( vlgFrameCounter < LONG_MAX )
   	vlgFrameCounter++;
	else
		vlgFrameCounter = 0;

	vclTimeBomb.fvoCountDown( );
	vclMA_Text.vclPopupMsg.fvoDisplayMsg( );

	if ( vlgFrameCounter % 100 == 0 )
	{

		int vinTimeLeftInSec = (int) vclMap.fflGetMapTimeLeftInSec( );
		string vtxMsg;

		if ( vinTimeLeftInSec == 300 )
		{
			vtxMsg = ctxMsgPrefix + "The map will change to " + vclMap.ftxGetNextMapName( ) + " in 5 minutes.";
			vclHUD.fvoStatusSay( vtxMsg  );
		}
		else
		if ( vinTimeLeftInSec == 60 )
		{
			vtxMsg = ctxMsgPrefix + "The next map will be " + vclMap.ftxGetNextMapName( );
			vclHUD.fvoStatusSay( vtxMsg  );
		}
		else
		if ( vinTimeLeftInSec == 13 )
		{
			vtxMsg = "The map will change to " + vclMap.ftxGetNextMapName( );
			vclHUD.fvoCenterMessageAll( vtxMsg );
		}
		// vclHUD.fvoChatMessageAll( vtxMsg );
	
	}

	if ( vlgFrameCounter % 2000 == 0 )
	{
		vclBot.fvoEnforceBotTeam( );
	}

	if (vlgFrameCounter % 3000 == 0)
	{
		vclBot.fvoBalanceBots( );
	}

	if (vlgFrameCounter % 100 == 0) // 6000 = 3 mins
	{
		vclPlayerSlot.fvoAutoKickAFKPlayers( );		
	}

	vboCanceled = false;

} // tclInterfaceL1::fvoExecuteOn_Frame_DLL

void tclInterfaceL1::fvoExecuteAfter_Frame_DLL( )
{
	//!! vclBotControl.fvoFixUseKnife( );
} // tclInterfaceL1::fvoExecuteAfter_Frame_DLL

void tclInterfaceL1::fvoExecuteOn_CreateEntity_DLL
	( const char *pch_ptrEntityName )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "fvoExecuteOn_CreateEntity_DLL: Entry point.");
		string ptxInfo = pch_ptrEntityName;
		vclDebugTrace.fvoWriteEventInfo(	cboDebugAll, ptxInfo);
	#endif
	vboCanceled = false;

	string vtxClassName = pch_ptrEntityName;
	
//	vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclWeapon::fboStopWeaponSelect) vtxClassName: " + vtxClassName );

	int vinWeaponIdx = vclWeapon.finFindWeapon( vtxClassName );
	
//	vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclWeapon::fboStopWeaponSelect) vinWeaponIdx: " + ftxIntToString( vinWeaponIdx ) );
	
	if ( vclWeapon.fboWeaponIsBanned_EntityByIndex( vinWeaponIdx ) )
	{

//		vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclWeapon::fboStopWeaponSelect) weapon is banned." );

		#ifdef defDebug_On
			vclDebugTrace.fvoWriteEventInfo 
				(cboDebugAll || false, 
				 "fvoExecuteOn_CreateEntity_DLL: killing weapon:");
			vclDebugTrace.fvoWriteEventInfo( cboDebugAll || false, vtxClassName );
		#endif
		
//		if ( vclWeapon.vstWeaponList[ vinWeaponIdx ].vclTimer_EntityBan.fboTimedOut( ) )
//			vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclWeapon::fboStopWeaponSelect) weapon won't be spawned." );
//		else
//			vclDebugTrace.fvoWriteEventInfo( "DEBUG (tclWeapon::fboStopWeaponSelect) weapon will be spawned." );

		vboCanceled = vclWeapon.vstWeaponList[ vinWeaponIdx ].vclTimer_EntityBan.fboTimedOut( );
//		vboCanceled = true;

	} 

	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "fvoExecuteOn_CreateEntity_DLL: Exit point.");
	#endif

}	// tclInterfaceL1::fvoExecuteOn_CreateEntity_DLL

void tclInterfaceL1::fvoExecuteOn_ServerActivate_DLL 
	(void)
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "fvoExecuteOn_ServerActivate_DLL: Entry point.");
	#endif
	
	vboCanceled = false;
	vboRoundStarted = true;
	vclRoundStartTimer.fvoStart( 0.12 );
} // fvoExecuteOn_ServerActivate_DLL 

//.b	BOT Engine Interface Functions.
//

void pfnChangeLevel_ENG( char *pch_ptrS1, char *pch_ptrS2 )
{
	string vtxMap;
	string vtxMsg = "\n" + ctxMsgPrefix + "Map time limit reached. Loading map: ";
	// check map name string for a null terminator. We expect
	// a map name to never exceed 50 chars.

   vtxMap = pch_ptrS1;
	vtxMsg += vtxMap;
	vclDebugTrace.fvoWriteEventInfo( vtxMsg );
	vtxMsg += "\n";
	fvoServerPrint( vtxMsg );

	if ( vclBot.fboSwitchBotTeamRandomly( ) )
	{
		vtxMsg = ctxMsgPrefix +  + "BOT Team will be switched.";
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoServerPrint( vtxMsg + "\n" );
	}
	
	if ( vclBot.fboSwitchBotSkillRandomly( ) )
	{
		vtxMsg = ctxMsgPrefix +  + "BOT Skill will be changed.";
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoServerPrint( vtxMsg + "\n" );
	}
	
	vclMapLoadTrace.fvoWriteEventInfo( vtxMap + " (auto load from map timeout)");
	vclMap.fvoMoveToNextMap( vtxMap );

	//!!.begin - Map cycle must be reloaded in case changes were made to it;
	//vclMap.fvoLoadMapCycle( );
	//vclMap.fboPositionMapPointer( vtxMap );
	//!!.end

	// set to indicate sound file list is no longer precached;
	// the list will get precached during the next map load if
	// sounds are enabled; If sounds are disabled, then the
	// setting will indicate the sound list is not precached
	// and if the user enables sounds he will not be able to
	// turn them on until after they have been precached during 
	// the next map load;

	// !!.begin - should be moved to a class function in mi_sounds.cpp
	vclSoundCmdList_System.vboAllPrecached = false;
	vclSoundCmdList_Admin.vboAllPrecached = false;
	vclSoundCmdList_BotRandom.vboAllPrecached = false;
	vclSoundCmdList_Damage.vboAllPrecached = false;
	vclSoundCmdList_Public.vboAllPrecached = false;
	// !!.end 

	// reset frame counter and flags
	// vclInterfaceL1.vboFirstFrameOf_MapStart = true; //!! this is done elsewhere in worldspawn;
	vclInterfaceL1.vflTimeOf_MapStart = 0.0;
	vclInterfaceL1.vlgFrameCounter = 0;

	(*vstENGFuncsOrig.pfnChangeLevel) ( pch_ptrS1, pch_ptrS2 );

} // pfnChangeLevel_ENG

void pfnRemoveEntity_ENG 
	(edict_t *pst_ptrEdict)
{

	#ifdef defDebug_On
		string vtxMsg;
		int vinUserID = vclPlayer.finGetUserIdByEdict( pst_ptrEdict );
		if (vinUserID > 0)
		{
			vtxMsg = "User ID is " + ftxIntToString(vinUserID) + ".";
			vclDebugTrace.fvoWriteEventInfo (true, "pfnRemoveEntity_ENG: " + vtxMsg);
		}
	#endif

	(*vstENGFuncsOrig.pfnRemoveEntity) (pst_ptrEdict);

} // pfnRemoveEntity_ENG

void	pfnServerCommand_ENG
	(char *pch_ptrCommand)
{
	#ifdef defDebug_On
		const bool cboDebugDisp = cboDebugAll || false;
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugDisp, "pfnServerCommand_ENG: Entry point.");
//		vclDebugTrace.fvoWriteEventInfo (cboDebugDisp, pch_ptrCommand);
	#endif
	
	vclInterfaceL1.fvoExecuteOn_ServerCommand_ENG (pch_ptrCommand);
	if ( vclInterfaceL1.fboCanceled( ) )
		return;

	(*vstENGFuncsOrig.pfnServerCommand) (pch_ptrCommand);
}

void pfnMessageBegin_ENG( int msg_dest, int msg_type, const float *pOrigin, edict_t* pst_ptrEdict )
{
	vclInterfaceL1.fvoExecuteBefore_MsgBegin_ENG( msg_dest, msg_type, pOrigin, pst_ptrEdict );
	if ( vclMessage.fboCaptureMsgIsOn( ) )
		return;

	vstENGFuncsOrig.pfnMessageBegin( msg_dest, msg_type, pOrigin, pst_ptrEdict );
			
} // pfnMessageBegin_ENG

void pfnMessageEnd_ENG( void )
{

	if ( vclMessage.fboCaptureMsgIsOn( ) )
	{
		vclMessage.fvoMsg_End( );
		vinCurrentMessage = 0;
		return;
	}
	
	vinCurrentMessage = 0;
	vstENGFuncsOrig.pfnMessageEnd( );

} // pfnMessageEnd_ENG

void pfnWriteByte_ENG( int iValue)
{
	if ( vclMessage.fboCaptureMsgIsOn( ) )
	{
		vclMessage.fvoCapture_Byte( iValue );
		return;
	}

	vstENGFuncsOrig.pfnWriteByte( iValue);

} // pfnWriteByte_ENG

void pfnWriteChar_ENG( int iValue )
{
	if ( vclMessage.fboCaptureMsgIsOn( ) )
	{
		vclMessage.fvoCapture_Char( iValue );
		return;
	}

	vstENGFuncsOrig.pfnWriteChar( iValue);

} // pfnWriteChar_ENG

void pfnWriteShort_ENG( int iValue )
{
	if ( vclMessage.fboCaptureMsgIsOn( ) )
	{
		vclMessage.fvoCapture_Short( iValue );
		return;
	}

	vstENGFuncsOrig.pfnWriteShort( iValue);

} // pfnWriteShort_ENG

void pfnWriteLong_ENG( int iValue )
{
	if ( vclMessage.fboCaptureMsgIsOn( ) )
	{
		vclMessage.fvoCapture_Long( iValue );
		return;
	}

	vstENGFuncsOrig.pfnWriteLong( iValue);

} // pfnWriteLong_ENG

void pfnWriteAngle_ENG( float flValue )
{
	if ( vclMessage.fboCaptureMsgIsOn( ) )
	{
		vclMessage.fvoCapture_Angle( flValue );
		return;
	}

	vstENGFuncsOrig.pfnWriteAngle( flValue);

} // pfnWriteAngle_ENG

void pfnWriteCoord_ENG( float flValue )
{
	if ( vclMessage.fboCaptureMsgIsOn( ) )
	{
		vclMessage.fvoCapture_Coord( flValue );
		return;
	}

	vstENGFuncsOrig.pfnWriteCoord( flValue);

} // pfnWriteCoord_ENG

void pfnWriteString_ENG( const char *sz )
{

//.b
//	string vtxMsg;
//	vtxMsg = sz;
//	vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
//	vtxMsg += "\n";
//	fvoServerPrint( vtxMsg );
//.e

// Sun Dec 21 00:01:56 2003 :: %!MRAD_BOMBPL
// Sun Dec 21 00:01:56 2003 :: #Bomb_Planted

	if( vclBotControl.fboSilentWalkIsOn( ) )
	{
		// Check if it's the "Bomb Planted" Message
		if ( FStrEq( sz, "%!MRAD_BOMBPL" ) )
		{
			if ( vclBotControl.vboSyncActionWalk )
			{
				// force CT bots to stop walking;
				vclBotControl.fvoBotWalkStop_Force_CT( fflCVarGetFloat( "mp_c4timer" ) + 5.0 );
				vclBot.fvoBombWasPlanted( true ); // do not kill bots;
//				vclBotControl.vboSyncActionWalk = false;
//				vclBotControl.vclSyncWalkTimer.fvoStart( fflCVarGetFloat( "mp_c4timer" ) + 5.0 );
			}
		}
	}
	if ( vclMessage.fboCaptureMsgIsOn( ) )
	{
		vclMessage.fvoCapture_String( sz );
		return;
	}

	vstENGFuncsOrig.pfnWriteString( sz );

} // pfnWriteString_ENG

void pfnWriteEntity_ENG( int iValue )
{
	vstENGFuncsOrig.pfnWriteEntity( iValue );

} // pfnWriteEntity_ENG

void pfnAlertMessage_ENG( ALERT_TYPE atype, char *szFmt, ...)
{

	static char buf[1024];

	va_list ap;
	va_start(ap, szFmt);
	vsnprintf( buf, sizeof(buf), szFmt, ap );
	va_end(ap);

	string vtxMsg = buf;

//	if ( vtxMsg == "World triggered \"Round_End\"\n" )
//	{
//		vclInterfaceL1.vboRoundStarted = true;
//		vclInterfaceL1.vclRoundStartTimer.fvoStart( 5 ); 
//		vclDebugTrace.fvoWriteEventInfo( "ROUND END" );
//	}

	if ( vtxMsg == "World triggered \"Round_Start\"\n" )
	{
		// this event happens after the round start delay is over;
		// make sure bots know they can start running;
		vclInterfaceL1.vclRoundStartTimer.fvoStop( ); 
		vclBotControl.vclSyncJumpTimer.fvoStop( );
		//vclDebugTrace.fvoWriteEventInfo( "ROUND START: DELAY ENDED" );
	}
//	vclDebugTrace.fvoWriteEventInfo 
//		("pfnAlertMessage_ENG: " + vtxMsg );

	vstENGFuncsOrig.pfnAlertMessage( atype, "%s", buf );

} // pfnAlertMessage_ENG

int pfnRegUserMsg_ENG( const char *pszName, int iSize )
{
	int vinMsgId = vstENGFuncsOrig.pfnRegUserMsg( pszName, iSize );

	string vtxMsgName;

	vtxMsgName = pszName;
//.b - log registration
//	string vtxMsg;
//	vtxMsg = ftxIntToString( vinMsgId ) + ": " + vtxMsgName;
//	vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
//	vtxMsg += "\n";
//	fvoServerPrint( vtxMsg );
//.e

	if ( vtxMsgName == "ScreenFade" )
	{
		vinMgs_ScreenFade = vinMsgId;
	}
	else
	if ( vtxMsgName == "Money" )
	{
		vinMsg_Money = vinMsgId;
	}
	else
	if ( vtxMsgName == "VGUIMenu" )
	{
		vinMsg_VGUIMenu = vinMsgId;
	}
	else
	if ( vtxMsgName == "WeaponList" )
	{
		vinMsg_WeaponList = vinMsgId;
	}
	else
	if ( vtxMsgName == "ShowMenu" )
	{
		vinMsg_ShowMenu = vinMsgId;
	}
	else
	if ( vtxMsgName == "WeapPickup" )
	{
		vinMsg_WeaponPickup = vinMsgId;
	}
	else
	if ( vtxMsgName == "Damage" )
	{
		vinMsg_Damage = vinMsgId;
	}
	else 
	if ( vtxMsgName == "DeathMsg") 
	{
		vinMsg_Death = vinMsgId;
	}
	else 
	if ( vtxMsgName == "RoundTime") 
	{
		vinMsg_RoundTime = vinMsgId;
	}
	else 
	if ( vtxMsgName == "HLTV") 
	{
		vinMsg_HLTV = vinMsgId;
	}

   return vinMsgId;

} // pfnRegUserMsg_ENG

const char* pfnCmd_Args_ENG( void )		// these 3 added 
{
	if ( vclInterfaceL1.vboIsFakeClient )
		return vclInterfaceL1.vtxArgS.c_str( );

	return vstENGFuncsOrig.pfnCmd_Args( );

} // pfnCmd_Args_ENG

const char* pfnCmd_Argv_ENG( int argc )	// so game DLL can easily 
{
	if ( !vclInterfaceL1.vboIsFakeClient )
		return vstENGFuncsOrig.pfnCmd_Argv( argc );

	if ( ( argc < 0 ) || ( argc >= cinMaxArg ) )
		return NULL;

	return vclInterfaceL1.vtx_aryArgS[ argc ].c_str( );

} // pfnCmd_Argv_ENG

int pfnCmd_Argc_ENG( void )		// access client 'cmd' strings
{
	if ( vclInterfaceL1.vboIsFakeClient )
		return vclInterfaceL1.vinNumFakeArgs;

	return vstENGFuncsOrig.pfnCmd_Argc( );

} // pfnCmd_Argc_ENG

void pfnGetGameDir_ENG
	(	char *szGetGameDir )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnGetGameDir_ENG: Entry point.");
	#endif

	(*vstENGFuncsOrig.pfnGetGameDir) (szGetGameDir);
} // pfnGetGameDir_ENG

edict_t* pfnCreateFakeClient_ENG
	(	const char* netname )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnCreateFakeClient_ENG: Entry point.");
	#endif

	vclDebugTrace.fvoWriteEventInfo( cboDebugAll, netname );

	return (*vstENGFuncsOrig.pfnCreateFakeClient) (netname);
} // pfnCreateFakeClient_ENG

void pfnRunPlayerMove_ENG( 
	edict_t *fakeclient, const float *viewangles, float forwardmove, 
	float sidemove, float upmove, unsigned short buttons, byte impulse, 
	byte msec )
{
	// vclDebugTrace.fvoWriteEventInfo( "pfnRunPlayerMove_ENG: Entry point." );
	// vclDebugTrace.fvoWriteEventInfo( "  forwardmove = " + ftxFloatToString( forwardmove ) ); 
	// vclDebugTrace.fvoWriteEventInfo( "  sidemove    = " + ftxFloatToString( sidemove ) ); 
	// vclDebugTrace.fvoWriteEventInfo( "  upmove      = " + ftxFloatToString( upmove ) ); 
	// vclDebugTrace.fvoWriteEventInfo( "  buttons     = " + ftxFloatToString( buttons ) ); 
	// vclDebugTrace.fvoWriteEventInfo( "  impulse     = " + ftxFloatToString( impulse ) ); 
	// vclDebugTrace.fvoWriteEventInfo( "  msec        = " + ftxFloatToString( msec ) ); 

// #################
// TESTING 

	if ( vclPlayer.fboPlayerIsAliveByEdict( fakeclient ) 
//				&& 
//		  vclPlayer.finGetPlayerTeamByEdict( fakeclient ) == cinTeam_TE 
		)
	{
		vclBotControl.fvoModifyPlayerMove( fakeclient, buttons, forwardmove, sidemove );
	}

// #################

	// vclDebugTrace.fvoWriteEventInfo( "  MOD buttons = " + ftxIntToString( buttons ) );
	// vclBotAim.fvoAdjustAim_2( fakeclient, buttons );
	
	(*vstENGFuncsOrig.pfnRunPlayerMove)( 
		fakeclient, viewangles, forwardmove, sidemove, upmove, buttons, impulse, msec );

} // pfnRunPlayerMove_ENG

edict_t*	pfnFindEntityByString_ENG( 
	edict_t *pEdictStartSearchAfter, const char *pszField, const char *pszValue )
{

	#ifdef def_CS15
	
	// string vtxField = pszField;
	
	string vtxValue = pszValue;

	//	vclDebugTrace.fvoWriteEventInfo( "  pszField        = " + vtxField ); 
	//	vclDebugTrace.fvoWriteEventInfo( "  pszValue        = " + vtxValue ); 

	edict_t *vst_ptrEdict = 
		(*vstENGFuncsOrig.pfnFindEntityByString)( pEdictStartSearchAfter, pszField, pszValue );
	
	if ( vtxValue == "info_map_parameters" )
	{
		// round start event;
		// vclBotControl.fvoRoundStart( );
		vclInterfaceL1.vboRoundStarted = true;
	}

	return vst_ptrEdict;

	#else

	return (*vstENGFuncsOrig.pfnFindEntityByString)( pEdictStartSearchAfter, pszField, pszValue );

	#endif
} // pfnFindEntityByString_ENG

void pfnSetClientMaxspeed_ENG( const edict_t *pEdict, float fNewMaxspeed )
{
	int vinBotIdx = vclBotControl.finIfBotGetPlayerIdx( const_cast<edict_t*>( pEdict ) );
	if ( vinBotIdx >= 0 )
	{
		vclBotControl.vstBotStatus[ vinBotIdx ].fvoSetMaxSpeed_ORIG( fNewMaxspeed );
	}
	if ( pEdict != NULL )
	{
		((edict_t *) pEdict)->v.maxspeed = fNewMaxspeed;
	}
	
	vstENGFuncsOrig.pfnSetClientMaxspeed( pEdict, fNewMaxspeed );

} // pfnSetClientMaxspeed_ENG

void pfnTraceLine_ENG( 
	const float *v1, const float *v2, int fNoMonsters, edict_t *pentToSkip, TraceResult *ptr )
{

//############################
//if (  vclPlayer.finGetPlayerTeamByEdict( pentToSkip ) == cinTeam_TE )
//{
	vclBotControl.TraceLine_Bot( v1, v2, fNoMonsters, pentToSkip, ptr );
//}
// NOTE: the below else statement is to be REMOVED along with the TEST code
//else
//	vstENGFuncsOrig.pfnTraceLine( v1, v2, fNoMonsters, pentToSkip, ptr );
//############################

	// POD Fix check;
	vclBotControl.fvoPODFixHostage( ptr );	
	vclPlayer.fvoCheckHeadShotMode( ptr );
	vclWeapon.fvoApplyDamageReduction( pentToSkip, ptr );
} // pfnTraceLine_ENG

const char* pfnGetPlayerAuthId_ENG( edict_t *e )
{
//	if ( vclBotControl.fboBotLogFixIsOn( ) )
//	{  
//		if ( ( e->v.flags & FL_FAKECLIENT ) 
//					|| 
//			  ( e->v.flags & def_FAKE_CLIENT_BIT ) 
//			)
//			return "0";
//	}
//
//	locNormalExit:

	if ( vclBotControl.fboBotLogFixIsOn( ) )
	{
		string vtxAuthId = vstENGFuncsOrig.pfnGetPlayerAuthId( e );

		if ( vtxAuthId == "BOT" )
			return "0";
	}

	// return vtxAuthId.c_str( );
	return vstENGFuncsOrig.pfnGetPlayerAuthId( e );

} // pfnGetPlayerAuthId_ENG

//
//.e	BOT Engine Interface Functions.
//

//
//.b	BOT Dll Interface Functions.
//

void pfnGameInit_DLL
	( void )			
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, "pfnGameInit_DLL: Entry point.");
	#endif
	vclInterfaceL1.fvoExecuteOn_GameInit_DLL ();
	if (vclInterfaceL1.fboCanceled())
	{
		return;
	}
	(*vstDLLFuncsOrig.pfnGameInit) ();
}

int pfnSpawn_DLL
	( edict_t *pent )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, "pfnSpawn_DLL: Entry point.");
	#endif

   vclInterfaceL1.fvoExecuteOn_Spawn_DLL( pent );
	if (vclInterfaceL1.fboCanceled( ) == true)
	{
		#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || true, "pfnSpawn_DLL: canceled.");
		#endif
		return -1;
	}
	int vinResult = (*vstDLLFuncsOrig.pfnSpawn) (pent);
	vclInterfaceL1.fvoExecuteAfter_Spawn_DLL( pent, vinResult );
	return vinResult;
}

void pfnThink_DLL
	( edict_t *pent )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnThink_DLL: Entry point.");
	#endif
	vclInterfaceL1.fvoExecuteOn_Think_DLL (pent);
	if ( vclInterfaceL1.fboCanceled( ) )
	{
		return;
	}

	(*vstDLLFuncsOrig.pfnThink) (pent);

} // pfnThink_DLL

qboolean xpfnClientConnect_DLL( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason [ 128 ] )
{

	vclPlayer.vinMaxHumans = 0;
	if ( vclPlayer.fboHumanCountExceeded( ) )
	{
		strcpy( szRejectReason, "Human player count exceeded. Try again later." );
		return FALSE;
	}

	return (*vstDLLFuncsOrig.pfnClientConnect)( pEntity, pszName, pszAddress, szRejectReason );
}

qboolean	pfnClientConnect_DLL
	(	edict_t *pEntity, 
		const char *pszName, 
		const char *pszAddress, 
		char szRejectReason [ 128 ] )
//		char* szRejectReason [128] )
//		char* szRejectReason )
//		aryRejectReason &szRejectReason )

{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnClientConnect_DLL: Entry point.");
	#endif
	
	vclInterfaceL1.fvoExecuteBefore_ClientConnect_DLL 
		( pEntity, pszName, pszAddress, szRejectReason );

	if ( vclInterfaceL1.fboCanceled( ) )
	{
		vclClientConnTrace.fvoWriteEventInfo( szRejectReason );
		return FALSE;
	}
//	qboolean	vboConnected;

//	vboConnected = 
	return (*vstDLLFuncsOrig.pfnClientConnect)
			( pEntity, pszName, pszAddress, szRejectReason );

//	vclInterfaceL1.fvoExecuteAfter_ClientConnect_DLL 
//		( pEntity, pszName, pszAddress, vboConnected );

//	return vboConnected;

}	// pfnClientConnect_DLL

void	pfnClientDisconnect_DLL( edict_t *pEntity )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnClientDisconnect_DLL: Entry point.");
	#endif
	
	vclInterfaceL1.fvoExecuteBefore_ClientDisconnect_DLL( pEntity );
						
	if ( vclInterfaceL1.fboCanceled( ) )
		return;

	vclInterfaceL1.fvoExecuteOn_ClientDisconnect_DLL( pEntity );
	(*vstDLLFuncsOrig.pfnClientDisconnect)( pEntity );

}	// pfnClientConnect_DLL

void pfnClientKill_DLL 
	(edict_t *pEntity )
{
	
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnClientKill_DLL: Entry point.");
	#endif
	
	vclInterfaceL1.fvoExecuteBefore_ClientKill_DLL (pEntity);

	if ( vclInterfaceL1.fboCanceled( ) )
	{
		return;
	}
	
	(*vstDLLFuncsOrig.pfnClientKill)	(pEntity);

} // pfnClientKill_DLL

void pfnClientPutInServer_DLL( edict_t* pst_ptrEdict )
{
	if ( pst_ptrEdict != NULL ) 
	{
		int vinResult = vclPlayerSlot.finAddPlayer( pst_ptrEdict );
		// return slot number or -1 if player has no slot.
		if ( vinResult < 0 )
		{
			string vtxMsg = ctxMsgPrefix + "Warning - add player was unsuccessfull. Error code is: " + ftxIntToString( vinResult );
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		}
	}

	if ( !vclPlayer.fboPlayerIsBotByEdict( pst_ptrEdict ) )
	{
		string vtxDebugTrace;
		string vtxName = vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );
		string vtxAuthId = ftxGetPlayerAuthId( pst_ptrEdict ); 
		string vtxUserId = ftxGetPlayerUserId( pst_ptrEdict );
		vtxDebugTrace = "In Server \"" + vtxName + "\", SteamId = " + vtxAuthId + ", UserId = " + vtxUserId;
		vclClientConnTrace.fvoWriteEventInfo( true, vtxDebugTrace );
	}

	(*vstDLLFuncsOrig.pfnClientPutInServer)( pst_ptrEdict );

} // pfnClientPutInServer_DLL

void pfnClientCommand_DLL( edict_t *pEntity )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnClientCommand_DLL: Entry point.");
	#endif
	
	vclInterfaceL1.fvoExecuteBefore_ClientCommand_DLL( pEntity );

	if ( vclInterfaceL1.fboCanceled( ) )
		return;

	(*vstDLLFuncsOrig.pfnClientCommand)(pEntity);

} // pfnClientCommand_DLL

void pfnServerActivate_DLL
	(	edict_t *pEdictList, 
		int edictCount, 
		int clientMax )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, "pfnServerActivate_DLL: Entry point.");
	#endif

	vclInterfaceL1.fvoExecuteOn_ServerActivate_DLL ();
	if (vclInterfaceL1.fboCanceled())
	{
		return;
	}
	(*vstDLLFuncsOrig.pfnServerActivate) ( pEdictList, edictCount, clientMax );

} // pfnServerActivate_DLL

void pfnStartFrame_DLL
	( void )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnStartFrame_DLL: Entry point.");
	#endif

	if ( vclInterfaceL1.vboRoundStarted && vclInterfaceL1.vclRoundStartTimer.fboTimedOut( ) )
	{
		vclBotControl.fvoRoundStart( );
		vclInterfaceL1.vboRoundStarted = false;
		//	vclDebugTrace.fvoWriteEventInfo( "ROUND STARTED" );
	}

	if ( vclInterfaceL1.vboFirstFrameOf_ServerStart == true )
	{
		vclInterfaceL1.fvoExecuteOnFirstFrameOfServer_DLL( );
	}
	else
	if ( vclInterfaceL1.vboFirstFrameOf_MapStart == true )
	{
		vclInterfaceL1.fvoExecuteOnFirstFrameOfMap_DLL( );
	}
	else
	{
		vclInterfaceL1.fvoExecuteOn_Frame_DLL( );

		if ( vclInterfaceL1.vclFrameTimer.fboTimedOut( ) )
		{
			vclInterfaceL1.vlgFrameCounter_Diff = vclInterfaceL1.vlgFrameCounter - vclInterfaceL1.vlgFrameCounter_Start;
		
			if ( vclInterfaceL1.vlgFrameCounter_Diff > 0 )
			{
				vfl_msecval = 200 / vclInterfaceL1.vlgFrameCounter_Diff;

				if ( vfl_msecval < 1 )    // don't allow msec to be less than 1...
					vfl_msecval = 1;

				if ( vfl_msecval > 100 )  // ...or greater than 100
					vfl_msecval = 100;
			}

			vclInterfaceL1.vlgFrameCounter_Start = vclInterfaceL1.vlgFrameCounter;
			vclInterfaceL1.vclFrameTimer.fvoStart( 0.25 );
		}
	}

	if ( vclInterfaceL1.fboCanceled( ) ) 
	{
		return;	
	}

	if ( vclBot.fboBotsInGame( ) )
	{
		if ( vclBot.finGetBotSystem( ) == cinBot_MEAN )
		{
			edict_t* vstEdict_Bot;

			// TheFatal - START from Advanced Bot Framework (Thanks Rich!)
	/*
				// adjust the millisecond delay based on the frame rate interval...
				if ( vfl_msecdel <= gpGlobals->time )
				{
					vfl_msecdel = gpGlobals->time + 0.5;
					if ( vin_msecnum > 0 )
						vfl_msecval = 450.0 / vin_msecnum;
					vin_msecnum = 0;
				}
				else
					vin_msecnum++;

				if ( vfl_msecval < 1 )    // don't allow msec to be less than 1...
					vfl_msecval = 1;

				if ( vfl_msecval > 100 )  // ...or greater than 100
					vfl_msecval = 100;
	*/
			// TheFatal - END

			for ( int vinIdx = cinMinPlayerIndex; 
					vinIdx <= vclPlayer.finGetMaxPlayers( ); 
					vinIdx++ )
			{

				vstEdict_Bot = vclPlayer.fst_ptrGetPlayerByIndex( vinIdx );

				if ( vstEdict_Bot == NULL )
					continue;

				if ( !vclPlayer.fboPlayerIsBotByEdict( vstEdict_Bot ) )
					continue;

				vstEdict_Bot->v.flags |= def_FAKE_CLIENT_BIT;

				vstENGFuncsBot.pfnRunPlayerMove( 
					vstEdict_Bot, 
					vstEdict_Bot->v.v_angle, 
					0,
					0, 
					0, 
					vstEdict_Bot->v.button, 
					0, 
					vfl_msecval );

				vstEdict_Bot->v.flags |= def_FAKE_CLIENT_BIT;
			}
		}
		
	}

	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnStartFrame_DLL: Before call to original.");
	#endif

	(*vstDLLFuncsOrig.pfnStartFrame)( );

	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnStartFrame_DLL: After call to original.");
	#endif

	vclInterfaceL1.fvoExecuteAfter_Frame_DLL( );

} // pfnStartFrame_DLL

void pfnParmsNewLevel_DLL ( void )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "pfnParmsNewLevel_DLL: Entry point.");
	#endif

	(*vstDLLFuncsOrig.pfnParmsNewLevel)	();
}

void pfnParmsChangeLevel_DLL ( void )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, "pfnParmsChangeLevel_DLL: Entry point.");
	#endif

	(*vstDLLFuncsOrig.pfnParmsChangeLevel) ();
}

//
//.e	BOT Dll Interface Functions.
//

bool fboInitENGFuncsOrig 
	(	tstENGFuncs*	   pst_ptrENGFuncsOrig, 
		tstENGGlobalVars* pst_ptrENGGlobalVars)
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, 
			 "fboInitENGFuncsOrig: Entry point.");
	#endif

	if ( pst_ptrENGFuncsOrig == NULL )
	{
		#ifdef defDebug_On
			vclDebugTrace.fvoWriteEventInfo 
				(cboDebugAll || true, 
				 "fboInitENGFuncsOrig Error: pst_ptrENGFuncsOrig == NULL.");
		#endif
		return false;
	}

	if ( pst_ptrENGGlobalVars == NULL )
	{
		#ifdef defDebug_On
			vclDebugTrace.fvoWriteEventInfo 
				(cboDebugAll || true, 
				 "fboInitENGFuncsOrig Error: pst_ptrENGGlobalVars == NULL.");
		#endif
		return false;
	}
	
	vclGlobalGameInfo.fvoSetPointer( pst_ptrENGGlobalVars );
	vstENGFuncsOrig = *pst_ptrENGFuncsOrig;
	vclInterfaceL1.vboExecuteAfter_InitENGFuncsOrig( );
	return true;

} // fboInitENGFuncsOrig

void fvoInitENGFuncsBot( tstENGFuncs* pst_ptrENGFuncsOrig )
{	

	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, "fvoInitENGFuncsBot: Entry point.");
	#endif

	vstENGFuncsBot = *pst_ptrENGFuncsOrig; // vstENGFuncsOrig;
	
	vstENGFuncsBot.pfnChangeLevel = pfnChangeLevel_ENG;
	pst_ptrENGFuncsOrig->pfnChangeLevel = pfnChangeLevel_ENG;

	vstENGFuncsBot.pfnServerCommand = pfnServerCommand_ENG;
	pst_ptrENGFuncsOrig->pfnServerCommand = pfnServerCommand_ENG;
//	
	vstENGFuncsBot.pfnMessageBegin = pfnMessageBegin_ENG;
	pst_ptrENGFuncsOrig->pfnMessageBegin = pfnMessageBegin_ENG;

	vstENGFuncsBot.pfnMessageEnd = pfnMessageEnd_ENG;
	pst_ptrENGFuncsOrig->pfnMessageEnd = pfnMessageEnd_ENG;

	vstENGFuncsBot.pfnWriteByte = pfnWriteByte_ENG;
	pst_ptrENGFuncsOrig->pfnWriteByte = pfnWriteByte_ENG;

	vstENGFuncsBot.pfnWriteChar = pfnWriteChar_ENG;
	pst_ptrENGFuncsOrig->pfnWriteChar = pfnWriteChar_ENG;

	vstENGFuncsBot.pfnWriteShort = pfnWriteShort_ENG;
	pst_ptrENGFuncsOrig->pfnWriteShort = pfnWriteShort_ENG;

	vstENGFuncsBot.pfnWriteLong = pfnWriteLong_ENG;
	pst_ptrENGFuncsOrig->pfnWriteLong = pfnWriteLong_ENG;

	vstENGFuncsBot.pfnWriteAngle = pfnWriteAngle_ENG;
	pst_ptrENGFuncsOrig->pfnWriteAngle = pfnWriteAngle_ENG;

	vstENGFuncsBot.pfnWriteCoord = pfnWriteCoord_ENG;
	pst_ptrENGFuncsOrig->pfnWriteCoord = pfnWriteCoord_ENG;

	vstENGFuncsBot.pfnWriteString = pfnWriteString_ENG;
	pst_ptrENGFuncsOrig->pfnWriteString = pfnWriteString_ENG;

	vstENGFuncsBot.pfnWriteEntity = pfnWriteEntity_ENG;
	pst_ptrENGFuncsOrig->pfnWriteEntity = pfnWriteEntity_ENG;
//

	vstENGFuncsBot.pfnAlertMessage = pfnAlertMessage_ENG;
	pst_ptrENGFuncsOrig->pfnAlertMessage = pfnAlertMessage_ENG;

	vstENGFuncsBot.pfnRegUserMsg = pfnRegUserMsg_ENG;
	pst_ptrENGFuncsOrig->pfnRegUserMsg = pfnRegUserMsg_ENG;

	vstENGFuncsBot.pfnRemoveEntity = pfnRemoveEntity_ENG;
	pst_ptrENGFuncsOrig->pfnRemoveEntity = pfnRemoveEntity_ENG;
	
	vstENGFuncsBot.pfnCmd_Args = pfnCmd_Args_ENG;
	pst_ptrENGFuncsOrig->pfnCmd_Args = pfnCmd_Args_ENG;

	vstENGFuncsBot.pfnCmd_Argv = pfnCmd_Argv_ENG;
	pst_ptrENGFuncsOrig->pfnCmd_Argv = pfnCmd_Argv_ENG;

	vstENGFuncsBot.pfnCmd_Argc = pfnCmd_Argc_ENG;
	pst_ptrENGFuncsOrig->pfnCmd_Argc = pfnCmd_Argc_ENG;

	vstENGFuncsBot.pfnGetGameDir = pfnGetGameDir_ENG;
	pst_ptrENGFuncsOrig->pfnGetGameDir = pfnGetGameDir_ENG;
	
	vstENGFuncsBot.pfnCreateFakeClient = pfnCreateFakeClient_ENG;
	pst_ptrENGFuncsOrig->pfnCreateFakeClient = pfnCreateFakeClient_ENG;
	
	vstENGFuncsBot.pfnRunPlayerMove = pfnRunPlayerMove_ENG;
	pst_ptrENGFuncsOrig->pfnRunPlayerMove = pfnRunPlayerMove_ENG;

	vstENGFuncsBot.pfnFindEntityByString = pfnFindEntityByString_ENG;
	pst_ptrENGFuncsOrig->pfnFindEntityByString = pfnFindEntityByString_ENG;;

	vstENGFuncsBot.pfnSetClientMaxspeed = pfnSetClientMaxspeed_ENG;
	pst_ptrENGFuncsOrig->pfnSetClientMaxspeed = pfnSetClientMaxspeed_ENG;

	vstENGFuncsBot.pfnTraceLine = pfnTraceLine_ENG;
	pst_ptrENGFuncsOrig->pfnTraceLine = pfnTraceLine_ENG;

	vstENGFuncsBot.pfnGetPlayerAuthId = pfnGetPlayerAuthId_ENG;
	pst_ptrENGFuncsOrig->pfnGetPlayerAuthId = pfnGetPlayerAuthId_ENG;

	vclInterfaceL1.vboENGFuncsBotIsInit = true;

}	// fvoInitENGFuncsBot

string ftxGetGameDllPath( )
{
	string vtxGameDllPath;
	string vtxDLLKeyValue;
	string vtxBotNameKeyValue;

	vtxDLLKeyValue		 = ftxGetServerKeyValue( ctxPlugInKey );
	vtxBotNameKeyValue = ftxGetServerKeyValue( ctxBotKey );
	
	vtxDLLKeyValue     = ftxTrim( vtxDLLKeyValue );
	vtxBotNameKeyValue = ftxTrim( vtxBotNameKeyValue );
	fvoToLower( vtxDLLKeyValue );
	fvoToLower( vtxBotNameKeyValue );

	vclBot.fboAssignBotSystem( vtxBotNameKeyValue );

	if ( vtxDLLKeyValue == "" )
	{
		return ctxGameDLLPath;
	}

	vclBot.fboAssignBotSystem( vtxBotNameKeyValue );

	if ( vtxDLLKeyValue == ctxTEAMBotFolder )
	{
		vtxGameDllPath = "";
	}
	else
	if ( vtxDLLKeyValue == ctxRealBotFolder )
	{
		vtxGameDllPath = "";
	}
	else
	if ( vtxDLLKeyValue == ctxRaccBotFolder )
	{
		vtxGameDllPath = "";
	}
	else
		vtxGameDllPath = ctxGameSubFolder + "\\";
	
	for (unsigned int vinIdx = 0; vinIdx < vtxDLLKeyValue.length( ); vinIdx++)
	{
		if (vtxDLLKeyValue[ vinIdx ] == '/')
		{
			vtxDLLKeyValue[ vinIdx ] = '\\';
		}
		vtxGameDllPath += vtxDLLKeyValue[ vinIdx ];
	}
	
	return vtxGameDllPath;

} // ftxGetGameDllPath

bool fboLoadGameDLL( string ptxGameDLLpath )
{
	int vinPos;
   char vch_aryModSubFolder [32] = "";
	char vch_aryGameFolder [256] = "";
	string vtxMsg;

	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || false, "fboLoadGameDLL: About to run pfnGetGameDir.");
	#endif

	vtxMsg = "\n\n" + ctxMsgPrefix + "will load MOD DLL: " + ptxGameDLLpath + "\n\n";
	vstENGFuncsOrig.pfnServerPrint (vtxMsg.c_str());
	vstENGFuncsOrig.pfnGetGameDir (vch_aryGameFolder);
	
//	=====================
// This will work with 4.1.1.1 as well as older versions;
	vinPos = 0;     
	if ( strstr( vch_aryGameFolder, "/" ) != NULL)    
	{       
		vinPos = strlen( vch_aryGameFolder ) - 1;        
		// scan backwards till first directory separator...       
		while ( ( vinPos ) && ( vch_aryGameFolder[ vinPos ] != '/'))          
			vinPos--;        
		
		vinPos++;    
	}     
	
	strcpy( vch_aryModSubFolder, &vch_aryGameFolder[ vinPos ] );

/*	============
   // old version prior to 4.1.1.1
	vinPos = strlen (vch_aryGameFolder) - 1;
	while ((vinPos > 0) && (vch_aryGameFolder[vinPos] != '/'))
		vinPos--;

	vinPos++;
	
	strcpy (vch_aryModSubFolder, &vch_aryGameFolder [vinPos]);
*/

	if ( vch_aryModSubFolder != ctxGameSubFolder )
	{
		#ifdef defDebug_On
			vclDebugTrace.fvoWriteEventInfo 
				(cboDebugAll, 
				 "fboLoadGameDLL: MOD DLL sub path does not match 'cstrike'.");
		#endif

		vstENGFuncsOrig.pfnAlertMessage 
			( at_error, 
			 "MEAN Bot Error: Game directory is not associated with "
		    "Counter-Strike! The game will not load.");
		return false;
	}
	
	vclInterfaceL1.fvoSetGameDLLPtr( LoadLibrary ( ptxGameDLLpath.c_str( ) ) );
	vclInterfaceL1.fvoSetCSTRIKEDLLPtr( LoadLibrary ( ctxGameDLLPath.c_str( ) ) );

	if ( vclInterfaceL1.fboGameDLLIsLoaded( ) != true )
   {
		#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "fboLoadGameDLL: vna_ptrGameDLL == NULL.");
		#endif
		vstENGFuncsOrig.pfnAlertMessage 
			(at_error, "MEAN Bot Error: Game directory does not point to "
		    "Counter-Strike! Game will not load.");
		return false;
   }

	return true;

}	// fboLoadGameDLL

BOOL WINAPI DllMain
	(	HINSTANCE hinstDLL, 
		DWORD fdwReason, 
		LPVOID lpvReserved)
// DLL entry point.
{
	#ifdef defDebug_On
	vclDebugTrace.fvoWriteEventInfo (cboDebugAll, "DllMain: Entry point.");
	#endif
   
   if (fdwReason == DLL_PROCESS_ATTACH)
   {
		#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "DllMain: DLL_PROCESS_ATTACH.");
		#endif

		// good place to ensure the random generator works properly.
		randomize( );

		if ( vclInterfaceL1.finStartUp( ) != true )
		{
			#ifdef defDebug_On
			vclDebugTrace.fvoWriteEventInfo 
				(cboDebugAll || true, 
				 "DllMain Error: Initialization of vclInterfaceL1 failed!");
			#endif
		}
   }
   else if (fdwReason == DLL_PROCESS_DETACH)
   {
		#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "DllMain: DLL_PROCESS_DETACH.");
		#endif
		
		vclMap.fvoDestroyMapList( );
		vclSecurity.fvoDestroyList( );

		if (vclInterfaceL1.finShutDown() != true)
		{
			#ifdef defDebug_On
			vclDebugTrace.fvoWriteEventInfo 
				(cboDebugAll, 
				 "DllMain Error: Shutdown of vclInterfaceL1 failed!");
			#endif
		}

	}
	
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo (cboDebugAll, "DllMain: Exit point.");
	#endif

	return TRUE;
}	// DllMain

bool fboGetInterfaceFuncs( void )
{
   vfn_ptrGiveFnptrsToDLL = 
		(tfn_ptrGiveFnptrsToDLL) 
			GetProcAddress 
				(vclInterfaceL1.fna_ptrGetGameDLLPtr(), cch_ptrGiveFnptrsToDll);

  if (vfn_ptrGiveFnptrsToDLL == NULL)
   {
		#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || true, 
			 "fboGetInterfaceFuncs Error: vfn_ptrGiveFnptrsToDLL == NULL.");
		#endif
   	return false;
   }

	vfn_ptrGetEntityAPI = 
		(tfn_ptrGetEntityAPI) 
			GetProcAddress 
				(vclInterfaceL1.fna_ptrGetGameDLLPtr(), cch_ptrGetEntityAPI);

	if (vfn_ptrGetEntityAPI == NULL)
   {
   	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || true, 
			 "fboGetInterfaceFuncs Error: vfn_ptrGetEntityAPI == NULL.");
		#endif
		return false;
   }

	vfn_ptrGetNewDLLFunctions = 
		(tfn_ptrGetNewDLLFunctions) 
			GetProcAddress 
				(vclInterfaceL1.fna_ptrGetGameDLLPtr(), cch_ptrGetNewDLLFunctions);

	if (vfn_ptrGetNewDLLFunctions == NULL)
   {
   	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || true, 
			 "fboGetInterfaceFuncs Error: vfn_ptrGetNewDLLFunctions == NULL.");
		#endif
		// do not return if NULL, for CS this function is not needed.
   }

	// Get the function pointer to the player entity. Ths is needed so
	// we can create our own BOT players.
	vclInterfaceL1.vfn_ptrEntityPlayerOrig = 
		(tfn_ptrEntity) 
			GetProcAddress 
				( vclInterfaceL1.fna_ptrGetGameDLLPtr(  ), cch_ptrEntityPlayer );

	if (vclInterfaceL1.vfn_ptrEntityPlayerOrig == NULL)
   {
   	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll || true, 
			 "fboGetInterfaceFuncs Error: vfn_ptrEntityPlayerOrig == NULL.");
		#endif
		return false;
   }

	if ( vclInterfaceL1.fboCSTRIKEDLLIsLoaded( ) )
	{
		vclInterfaceL1.vfn_ptrBlendingAPI = 
			(tfn_ptrBlendingAPI) 
				GetProcAddress 
					( vclInterfaceL1.fna_ptrGetCSTRIKEDLLPtr( ), cch_ptrBlendingAPI );

		if ( vclInterfaceL1.vfn_ptrBlendingAPI == NULL )
			vclDebugTrace.fvoWriteEventInfo
				( "Server_GetBlendingInterface not loaded because it was not found.");
		else
			vclDebugTrace.fvoWriteEventInfo
				( "Server_GetBlendingInterface was found.");
	}
	else
		vclDebugTrace.fvoWriteEventInfo 
			("Server_GetBlendingInterface not loaded because mp.dll was not loaded.");

	return true;

}	//	fboGetInterfaceFuncs

extern "C" DLLEXPORT void EXPORT 
GiveFnptrsToDll
	(	tstENGFuncs*		pst_ptrENGFuncsOrig,
		tstENGGlobalVars* pst_ptrENGGlobalVars)

//.b	GiveFnptrsToDll - Exported function called by the Engine. 
//
//	Initializes the MOD DLL's interface to the Engine. This exported function
//	(called by the Engine) will copy the structure containing Engine function
// calls to the MOD DLL's local copy of this structure. The BOT code will
// intercept this call, and pass the BOT's version of these functions to the 
// MOD DLL instead.
//
// This function will also load the MOD DLL, and extract function pointers
// to its equivalent interface.
//
//.e
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "GiveFnptrsToDll: Entry point.");
	#endif

	//	Get the original Engine interface functions from the Engine.
	if ( fboInitENGFuncsOrig 
			( pst_ptrENGFuncsOrig, pst_ptrENGGlobalVars ) != true )
	{
		return;
	}

	//	Initialize the BOT Engine interface structure.
	
	fvoInitENGFuncsBot( pst_ptrENGFuncsOrig );
	
	// Load the MOD DLL.
	if ( fboLoadGameDLL( ftxGetGameDllPath( ) ) != true )
	{
		return;
	}

	// Get the interface function pointers.
	if ( fboGetInterfaceFuncs( ) != true )
	{
		return;
	}

	// This is a good place to load the map cycle;
	vclMap.fvoLoadMapCycle( );
	// This is a good place to load the security data;
	vclSecurity.fvoLoadSecurity( );
	//  This is a good place to load the connection message text;
	vclIPBanList.fvoLoadList( );
	vclMA_Text.vclConnMsg.fvoLoadList( );
	vclMA_Text.vclPopupMsg.fvoLoadList( );
	//  This is a good place to load the sound commands;
   vclSoundCmdLoader.fvoLoadSoundCommands( );
	//.b	Call original MOD DLL function, passing the BOT interface function
	//		table instead of the original table from Engine.
	//
		(*vfn_ptrGiveFnptrsToDLL)( pst_ptrENGFuncsOrig, pst_ptrENGGlobalVars );
	//
	//.e

	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "GiveFnptrsToDll: Exit point.");
	#endif

} // GiveFnptrsToDll

bool fboInitDLLFuncsOrig
	(	tstDLLFuncs* pst_ptrDLLFuncsEng, 
		int			 pinInterfaceVersion )
{

	// Check if pointer to DLL Func Table from engine is valid.
		if ( pst_ptrDLLFuncsEng == NULL )
		{
			#ifdef defDebug_On
				vclDebugTrace.fvoWriteEventInfo 
					(cboDebugAll || true, 
					"fboInitDLLFuncsOrig Error: pst_ptrDLLFuncsEng == NULL.");
			#endif
			return false;
		}

	// Check if version is correct.
		if ( pinInterfaceVersion != INTERFACE_VERSION )
		{
			#ifdef defDebug_On
				vclDebugTrace.fvoWriteEventInfo 
					(cboDebugAll || true, 
					"fboInitDLLFuncsOrig Error: Version mismatch.");
			#endif
			return false;
		}

	// Confirm pointer to original GetEntityAPI function is valid.
		if ( vfn_ptrGetEntityAPI == NULL )
		{
			#ifdef defDebug_On
				vclDebugTrace.fvoWriteEventInfo 
					(cboDebugAll || true, 
						"fboInitDLLFuncsOrig Error: vfn_ptrGetEntityAPI == NULL.");
			#endif
			return false;
		}

	//	Call GetEntityAPI function (from MOD DLL) to initialize the local copy 
	//	of the original MOD DLL interface table.
		if ( ( *vfn_ptrGetEntityAPI ) 
					( pst_ptrDLLFuncsEng, pinInterfaceVersion ) != TRUE ) 
		{
			#ifdef defDebug_On
				vclDebugTrace.fvoWriteEventInfo 
					(cboDebugAll || true, 
						"fboInitDLLFuncsOrig Error: Original GetEntityAPI call returned "
						"FALSE.");
			#endif
			return false;
		}

		vstDLLFuncsOrig = *pst_ptrDLLFuncsEng;

	// Indicate original DLL function structure is ready.
		vclInterfaceL1.vboDLLFuncsOrigIsInit = true;
	
	// Exit indicating success.
		return true;

}	//	fboInitDLLFuncsOrig

void fvoInitDLLFuncsBot( tstDLLFuncs* pst_ptrDLLFuncsEng )
{
	// Initialize alternate DLL function table with contents from the original.
		
		vstDLLFuncsBot = *pst_ptrDLLFuncsEng; // vstDLLFuncsOrig;

	// Install our alternate DLL functions.
		vstDLLFuncsBot.pfnGameInit = pfnGameInit_DLL;
		pst_ptrDLLFuncsEng->pfnGameInit = pfnGameInit_DLL;

		vstDLLFuncsBot.pfnSpawn = pfnSpawn_DLL;
		pst_ptrDLLFuncsEng->pfnSpawn = pfnSpawn_DLL;

		vstDLLFuncsBot.pfnThink = pfnThink_DLL;
		pst_ptrDLLFuncsEng->pfnThink = pfnThink_DLL;

		vstDLLFuncsBot.pfnClientConnect = pfnClientConnect_DLL;
		pst_ptrDLLFuncsEng->pfnClientConnect = pfnClientConnect_DLL;

		vstDLLFuncsBot.pfnClientDisconnect = pfnClientDisconnect_DLL;
		pst_ptrDLLFuncsEng->pfnClientDisconnect = pfnClientDisconnect_DLL;

		vstDLLFuncsBot.pfnClientKill = pfnClientKill_DLL;
		pst_ptrDLLFuncsEng->pfnClientKill = pfnClientKill_DLL;

		vstDLLFuncsBot.pfnClientPutInServer = pfnClientPutInServer_DLL;
		pst_ptrDLLFuncsEng->pfnClientPutInServer = pfnClientPutInServer_DLL;

		vstDLLFuncsBot.pfnClientCommand = pfnClientCommand_DLL;
		pst_ptrDLLFuncsEng->pfnClientCommand = pfnClientCommand_DLL;

		vstDLLFuncsBot.pfnServerActivate = pfnServerActivate_DLL;
		pst_ptrDLLFuncsEng->pfnServerActivate = pfnServerActivate_DLL;

		vstDLLFuncsBot.pfnStartFrame = pfnStartFrame_DLL;
		pst_ptrDLLFuncsEng->pfnStartFrame = pfnStartFrame_DLL;

	//	vstDLLFuncsBot.pfnParmsNewLevel = pfnParmsNewLevel_DLL;
	//	vstDLLFuncsBot.pfnParmsChangeLevel = pfnParmsChangeLevel_DLL;
	// Indicate alternate DLL function table is ready.
		vclInterfaceL1.vboDLLFuncsBotIsInit = true;

} // fvoInitDLLFuncsBot ()

int EXPORT GetEntityAPI
//extern "C" EXPORT int GetEntityAPI
	(	tstDLLFuncs* pst_ptrDLLFuncsEng, 
		int			 pinInterfaceVersion )
//.b	GetEntityAPI - Exported function called by the Engine. 
//
//	Initializes the Engine's interface function table with the function 
// pointers from the MOD DLL.
//
//	This exported function (called by the Engine) will copy the structure 
// containing the MOD DLL interface function calls, to the Engine's local
// copy of this structure. The BOT code will intercept this call, and 
// pass the BOT's version of these functions to the Engine instead.
// 
//.e
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "GetEntityAPI: Entry point.");
	#endif
   
	if ( fboInitDLLFuncsOrig
			( pst_ptrDLLFuncsEng, pinInterfaceVersion ) != true)
	{
		vclDebugTrace.fvoWriteEventInfo (cboDebugAll || true, "GetEntityAPI: ERROR - Not Initialized.");
		return FALSE;
	}

	// Initialize BOT MOD DLL function table with originals.
	fvoInitDLLFuncsBot( pst_ptrDLLFuncsEng );

	// Initialize engine structure with bot function pointers.
	//	*pst_ptrDLLFuncsEng = vstDLLFuncsBot;

	return TRUE;

}	//	GetEntityAPI

int EXPORT GetNewDLLFunctions
//extern "C" EXPORT int GetNewDLLFunctions
	(	tstDLLFuncsNew* pst_ptrDLLFuncsNewEng, 
		int*				 pin_ptrInterfaceVersion )
{
	#ifdef defDebug_On
		vclDebugTrace.fvoWriteEventInfo 
			(cboDebugAll, "GetNewDLLFunctions: Entry point.");
	#endif

		if ( vfn_ptrGetNewDLLFunctions == NULL)
		{
			return FALSE;
		}

		if ((*vfn_ptrGetNewDLLFunctions) 
					(pst_ptrDLLFuncsNewEng, pin_ptrInterfaceVersion) != TRUE) 
		{
			#ifdef defDebug_On
				vclDebugTrace.fvoWriteEventInfo 
					(cboDebugAll || true, 
						"GetNewDLLFunctions: Original GetNewDLLFunctions call returned "
						"FALSE.");
			#endif
			return FALSE;
		}

	return TRUE;

}	//	GetNewDLLFunctions

// C_DLLEXPORT = extern "C" DLLEXPORT

// DLLEXPORT = __declspec(dllexport)

// EXPORT = _declspec( dllexport )

int EXPORT 
	Server_GetBlendingInterface(int version,
		struct sv_blending_interface_s **ppinterface,
		struct engine_studio_api_s *pstudio,
		float (*rotationmatrix)[3][4],
		float (*bonetransform)[MAXSTUDIOBONES][3][4]) 
{

	if ( vclInterfaceL1.vfn_ptrBlendingAPI == NULL )
	{
		vclDebugTrace.fvoWriteEventInfo( "WARNING: Server_GetBlendingInterface is not available - hitboxes will be inaccurate." );
		return 0;
	}

	vclDebugTrace.fvoWriteEventInfo( "Server_GetBlendingInterface is available" );
	vclDebugTrace.fvoWriteEventInfo( "Hitbox fix is installed provided you see a return value not equal to 0." );

	int vinResult = 
		( vclInterfaceL1.vfn_ptrBlendingAPI )
		   (version, ppinterface, pstudio, rotationmatrix, bonetransform);

	vclDebugTrace.fvoWriteEventInfo( "Server_GetBlendingInterface return value: " + ftxIntToString( vinResult ) );
	return( vinResult );

} // Server_GetBlendingInterface
