//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MB_InterfaceL1.h
//	
//	Interface Layer 1 Definitions.
//.e	

//.b skip over if header has already been included.
#ifndef defMB_InterfaceL1_h
#define defMB_InterfaceL1_h
#include "MB_Includes.h"
#include "MA_GlobalVars.h"
#include "MA_Time.h"
#include "studio.h"

#define EXPORT	_declspec( dllexport )
// for reference #define DLLEXPORT __stdcall

//.b	Define uniform names.
//
//	enginefuncs_t is the structure containing pointers to the 
//	engine interface functions (called by the MOD DLL).
	#define tstENGFuncs enginefuncs_t

// We are forced to use "g_engfuncs" as the name for the original
// engine function table, however, this name does not clearly describe 
// what the structure refers to, therefore, we ensure the name used for 
// the original engine structure is unambigous by defining an alias here.
	#define vstENGFuncsOrig	g_engfuncs		

//	DLL_FUNCTIONS is the structure containing pointers to the 
//	Game DLL interface functions (called by Engine).
	#define tstDLLFuncs DLL_FUNCTIONS

//	NEW_DLL_FUNCTIONS is the structure containing pointers to 
// the "new" Game DLL interface functions  (called by Engine).
	#define tstDLLFuncsNew NEW_DLL_FUNCTIONS

// entvars_t is the structure type that stores information on
// an entity in the game.
	#define tstEntityVars entvars_t

//.e	Define uniform names.

//.b
//	tstENGFuncs contains pointers to functions called by the Game DLL.
//	tstDLLFuncs contains pointers to functions called by the Engine.
//	tstDLLFuncsNew contains pointers to functions called by the Engine.
//.e

//	Define entity function pointer type.
	typedef void (FAR *tfn_ptrEntity)(entvars_t *);
	
	typedef int (*tfn_ptrBlendingAPI) 
		(int version, struct sv_blending_interface_s **ppinterface,
		struct engine_studio_api_s *pstudio,
		float (*rotationmatrix)[3][4],
		float (*bonetransform)[MAXSTUDIOBONES][3][4] ) ;

//.b	Game DLL path information.
	const string ctxPlugInKey		= "mgamedll";
	const string ctxBotKey			= "mbotmod";
	const string ctxGameSubFolder = "cstrike";

	const string ctxRealBotFolder = "realbot/dll/realbot.dll";
	const string ctxTEAMBotFolder = "teambot/teambot.dll";
	const string ctxRaccBotFolder = "racc/release/cstrike/release/racc.dll";
	const string ctxGameDLL			= "mp_dll";
	const string ctxGameDLLPath	= "cstrike\\dlls\\mp.dll";
	const string ctxMEANFolder		= "mean";
//.e	Game DLL path information.

const int cinEngineIsServer = 0;
const int cinEngineIsClient = 1;
const int cinEngineIsUnknown = 2;

const int cinMaxArg = 4;

class tclInterfaceL1
{
	private:
	//	Flag to determine state of the interface.
		bool vboBroken;
   //	Pointer to instance of loaded Game DLL.
		HINSTANCE vna_ptrGameDLL;
		HINSTANCE vna_ptrCSTRIKEDLL;
		bool vboGameDLLIsLoaded;
		bool vboCSTRIKEDLLIsLoaded;
	// Indicates engine is Client, Server or Unknown.
		bool vinEngineType;
		bool vboCanceled;
		bool vboGameIsFullyLoaded;
				

	public:
	// constructor.
		tclInterfaceL1(void);
		bool vboRoundStarted;
		tclTimer vclRoundStartTimer;
		bool fboGameIsFullyLoaded( ){ return vboGameIsFullyLoaded; };
	//	Pointer to Engine's Global Variables.
		bool vboENGFuncsOrigIsInit;
		bool vboENGFuncsBotIsInit;
		bool vboDLLFuncsOrigIsInit;
		bool vboDLLFuncsBotIsInit;	
	// Player entity function pointer from MOS DLL.
		tfn_ptrEntity vfn_ptrEntityPlayerOrig;
		tfn_ptrBlendingAPI vfn_ptrBlendingAPI;

		bool vboFirstFrameOf_ServerStart;
		bool vboFirstFrameOf_MapStart;
		float vflTimeOf_ServerStart;
		float vflTimeOf_MapStart;
		long vlgFrameCounter;

		long vlgFrameCounter_Start;
		long vlgFrameCounter_Diff;
		tclTimer vclFrameTimer;

	// Fake Client Command Buffer;
		bool vboIsFakeClient;
		int vinNumFakeArgs;
		string vtx_aryArgS[ cinMaxArg ]; 
		string vtxArgS;
		void fvoClearArgS( );
		void fvoAddArgS( string ptxArg );

	// Required methods.
		int finStartUp (void);
		int finShutDown (void);
		void fvoDisplayAbout (void);
		
	// Low level interface function definitions.
		bool fboGameDLLIsLoaded (void);
		bool fboCSTRIKEDLLIsLoaded (void){ return vboCSTRIKEDLLIsLoaded; };
		void fvoSetGameDLLPtr( HINSTANCE pna_ptrGameDLL );
		void fvoSetCSTRIKEDLLPtr( HINSTANCE pna_ptrDLL );
		HINSTANCE fna_ptrGetGameDLLPtr (void){	return vna_ptrGameDLL; };
		HINSTANCE fna_ptrGetCSTRIKEDLLPtr( void ){ return vna_ptrCSTRIKEDLL; };
		void fvoSetENGGlobalVarsPtr (tstENGGlobalVars *pst_ptrENGGlobalVars);
		tstENGGlobalVars *fst_ptrGetENGGlobalVarsPtr (void);
		
	// Interface event function definitions.
		void vboExecuteAfter_InitENGFuncsOrig (void);
		void fvoExecuteOn_ServerCommand_ENG (char *pch_ptrCommand);
		void fvoExecuteBefore_MsgBegin_ENG( int msg_dest, int msg_type, const float *pOrigin, edict_t* pst_ptrEdict );
		void fvoExecuteOn_GameInit_DLL (void);
		void fvoExecuteOn_Spawn_DLL (edict_t *pst_ptrEdict);
		void fvoExecuteAfter_Spawn_DLL (edict_t *pst_ptrEdict, int pinResult);
		void fvoExecuteOn_Think_DLL (edict_t *pst_ptrEdict );
		void fvoExecuteBefore_ClientConnect_DLL (edict_t *pst_ptrEdict, const char *pch_ptrName, const char *pch_ptrAddress, char szRejectReason[ 128 ] );
//		void fvoExecuteBefore_ClientConnect_DLL (edict_t *pst_ptrEdict, const char *pch_ptrName, const char *pch_ptrAddress, aryRejectReason &szRejectReason );
		void fvoExecuteAfter_ClientConnect_DLL (edict_t *pst_ptrEdict, const char *pch_ptrName, const char *pch_ptrAddress, bool pboConnected);
		void fvoExecuteBefore_ClientDisconnect_DLL (edict_t *pst_ptrEdict);
		void fvoExecuteOn_ClientDisconnect_DLL (edict_t *pst_ptrEdict);
		void fvoExecuteBefore_ClientKill_DLL (edict_t *pst_ptrEdict);
		void fvoExecuteBefore_ClientCommand_DLL ( edict_t *pst_ptrEdict );
		void fvoExecuteOn_Frame_DLL( void );
		void fvoExecuteAfter_Frame_DLL( );
		void fvoExecuteOnFirstFrameOfServer_DLL( void );
		void fvoExecuteOnFirstFrameOfMap_DLL( void );
		void fvoExecuteOn_CreateEntity_DLL (const char *pch_ptrEntityName);
		void fvoExecuteOn_ServerActivate_DLL (void);
	//	Miscellaneous functions.
		bool fboCanceled (void);
		bool fboEngineIsServer (void);
		bool fboEngineIsClient (void);
		bool fboEngineIsUnknown (void);
		void fvoCreateEntityPlayer (edict_t *vst_ptrEntity);
		
};	// tclInterfaceL1

extern tstENGFuncs vstENGFuncsBot;
extern tstENGFuncs vstENGFuncsOrig;
extern tstDLLFuncs vstDLLFuncsOrig;
extern tstDLLFuncs vstDLLFuncsBot;
extern tclInterfaceL1 vclInterfaceL1; 

extern "C" EXPORT int GetNewDLLFunctions( NEW_DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion );
extern "C" EXPORT int  
	Server_GetBlendingInterface(int version,
		struct sv_blending_interface_s **ppinterface,
		struct engine_studio_api_s *pstudio,
		float (*rotationmatrix)[3][4],
		float (*bonetransform)[MAXSTUDIOBONES][3][4]);

#endif // defMB_InterfaceL1_h
//.e skip over if header has already been included.