//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MI_Map.h
//	
//	[MEAN] Map class definitions.
//
//.e	

//.b skip over if header has already been included.
#ifndef defMI_Map_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
	#define defMI_Map_h

	// Include all general definition files.
	#include "MB_Includes.h"
	#include "MB_InterfaceL1.h"
	#include "MA_Configs.h"

	const string ctxNoMapTimeOut = "99:99:99";
	const int cinNoMapTimeOut = -1;

	struct tstMapCycle
	{
		string vtxMapName;
		int vinMapId;
		tstMapCycle* vst_ptrNext;

	}; // tstMapCycle

	class tclMap
	{
		public:
			tstMapCycle* vst_ptrMapCycle_Cur;
			tstMapCycle* vst_ptrMapCycle_Start;

			tclMap( );
			~tclMap( );
			void fvoDestroyMapList( void );
			float fflGetTimeLimitInMin( void );
			void fvoSetTimeLimitInMin( float pflMinutes );
			float fflGetMapTimeLimitInSec( void );
			float fflGetMapTimeElapsedInSec( void );
			float fflGetMapTimeLeftInSec( void );
			string ftxGetTimeLeftAsString( void );
			string ftxGetMapName( void );
			int finGetMapId( void );
			bool fboMapCycleFileIsOk( void );
			string ftxGetMapCycleFileName( void );
			void fvoLoadMapCycle( void );
			tstMapCycle* fst_ptrGetNextMap( void );
			string ftxGetNextMapName( void );
	//		string ftxGetNextMapList( void );
			void fvoMoveToNextMap( string ptxMapName );
			bool fboIsMapInCycle( string ptxMapName );
			tstMapCycle* fst_ptrIsMapInCycle( string ptxMapName );
			bool fboPositionMapPointer( string ptxMapName );
			string ftxGetMapNameByMapId( int pinMapId );
			void fvoListMaps( edict_t* pst_ptrEdict );
	}; // tclMap

	extern tclMap vclMap;

	const string ctxScenarioFolder = "scenarios";

	class tclScenario : public tclConfigFile
	{
		public:
			tclScenario( );
			~tclScenario( );

			void fvoRunScenario( );

	}; // tclScenario

	extern tclScenario vclScenario;

#endif // defMI_Map_h

