//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MI_Sound.h
//	
//	[MEAN] Sound Module. 
//
//.e	

//.b skip over if header has already been included.
	#ifndef defMI_Sound_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
		#define defMI_Sound_h

	// Include all general definition files.
		#include "MB_Includes.h"

	const bool cboSoundsEnabled_DEFAULT = false;
	const bool cboSoundsOn_DEFAULT = false;

	// List of sound files.

	const string ctxSound_System		= "[system]";  // system sounds
	const string ctxSound_Admin		= "[admin]";   // admin speak sound commands
	const string ctxSound_Damage		= "[damage]";  // sounds players make when taking damage
	const string ctxSound_BotRandom	= "[bot]";     // sounds bots make randomly
	const string ctxSound_Public		= "[public]";  // sounds clients can make

	const string ctxSoundSystem_All		= "all";
	const string ctxSoundSystem_System	= "system";
	const string ctxSoundSystem_Bot		= "bot";
	const string ctxSoundSystem_Damage	= "damage";
	const string ctxSoundSystem_Admin	= "admin";
	const string ctxSoundSystem_Public	= "public";

	const string ctxDamage_EqualProbCmd = "damage_equalprob";
	const string ctxDamage_HighProbCmd  = "damage_highprob";
	const string ctxDamage_LowProbCmd   = "damage_lowprob";

	const string ctxBitchSlapCmd  = "slapbitch";
	const string ctxHandSlapCmd   = "slaphand";
	const string ctxDeathSoundCmd = "death";
	const string ctxNullSoundCmd = "null";

	const int cinMaxSndFiles = 210;

	class tclSndFileList
	{
		string vtx_arySndFile[ cinMaxSndFiles ];
		int vinNumSndFiles;

		public:
			bool vboAllPrecached;
			tclSndFileList( void );
			bool fboIdxIsValid( int pinIdx );
			int finNumSndFiles( void );
			int finFindSndFileIdx( string ptxSndFile );
			int finAddSndFileName( string ptxSndFile );
			string ftxGetSndFileName( int pinIdx );
			void fvoPrecacheSndFile( int pinIdx );
			void fvoPrecacheAllSndFiles( void );
	}; // tclSndFileList

	const int cinMaxRndSnd = 20;

	class tclSoundCmd
	{  
		// "say" command which activates sound.
		string vtxSndCmd;
		// List of sound file indices to be randomly selected.
		int vin_aryRndSnd[ cinMaxRndSnd ];
		int vinNumRndSnd;
		public:
			bool vboEnabled;
			bool vboPrecached;
			tclSoundCmd( void );
			void fvoSetSndCmd( string ptxSndCmd );
			string ftxGetSndCmd( void );
			bool fboAddRndSnd( string ptxSndFile );
			string ftxGetRndSnd( void );
			void fvoPrecacheSndFiles( void );

	}; // tclSoundCmd

	const int cinMinSoundCmd =   0;
	const int cinMaxSoundCmd = 110;

	const int cinMinSoundCmdIdx = 0;
	const int cinMaxSoundCmdIdx = cinMaxSoundCmd - 1;

	class tclSoundCmdList
	{
		tclSoundCmd vclSoundCmd[ cinMaxSoundCmd ];
		int vinNumSndCmd;
		bool vboSoundsAreOn;
		bool vboSoundsAreEnabled;
		int vinCurSndCmdIdx;
		string vtxSoundCmdListHeader;
		public:
			bool vboAllPrecached;
			tclSoundCmdList( string ptxSndList );
			bool finCmdIdxIsValid( int pinCmdIdx );
			int finFindSoundCmd( string ptxSoundCmd );	
			int finAddSoundCmd( string ptxSoundCmd );
			bool fboAddSound( int pinCmdIdx, string ptxSndFile );
			bool fboAddSound( string ptxSndFile ); // uses internal index;
			bool fboAddSound( string ptxSoundCmd, string ptxSndFile );
			string ftxGetSoundFile( int pinCmdIdx );
			string ftxGetSoundFile( string ptxSoundCmd );
			void fvoPrecacheSndFiles( void );
			void fvoListSounds( edict_t* pst_ptrEdict );
			bool fboSoundsAreReady( ) { return ( vboSoundsAreOn && vboAllPrecached ); }
			bool fboSoundsAreOn( void );
			bool fboSoundsAreOff( void );
			void fvoSetSoundsAreOn( bool pboSwitch );
			bool fboSoundsAreEnabled( void );
			bool fboSoundsAreDisabled( void );
			void fvoSetSoundsAreEnabled( bool pboSwitch );
			void fvoSetSoundCmdSwitch( bool pboSwitch, string ptxSoundCmd );
			void fvoSetSoundCmdSwitch( bool pboSwitch, int pinCmdIdx );
			void fvoTurnSoundCmdOn( string ptxSoundCmd );
			void fvoTurnSoundCmdOff( string ptxSoundCmd );
			void fvoTurnSoundCmdOn( int pinCmdIdx );
			void fvoTurnSoundCmdOff( int pinCmdIdx );
			bool fboSoundCmdIsOn( string ptxSoundCmd );
			bool fboSoundCmdIsOn( int pinCmdIdx );
	}; // tclSoundCmdList

	extern tclSndFileList vclSndFileList;

	class tclSoundCmdLoader
	{
		public:
		tclSoundCmdLoader( );
		bool fboAddSoundCommand( int pinCommandList, string ptxSoundCommand );
		bool fboAddSoundFile( int pinCommandList, string ptxSoundFile );
		void fvoLoadSoundCommands( edict_t* pst_ptrEdict );
		void fvoLoadSoundCommands( );
		bool fboIsSoundListHeader( string ptxSoundLine );
		bool fboIsSoundCommand( string ptxSoundLine );
		bool fboIsSoundFilePath( string ptxSoundLine );

		int finReturnSoundListHeaderId( string ptxSoundLine );
		string ftxReturnValidSoundCommand( string ptxSoundLine );
		string ftxReturnValidSoundFilePath( string ptxSoundLine );

	}; // tclSoundCmdLoader

	extern tclSoundCmdList vclSoundCmdList_System;
	extern tclSoundCmdList vclSoundCmdList_Admin;
	extern tclSoundCmdList vclSoundCmdList_BotRandom;
	extern tclSoundCmdList vclSoundCmdList_Damage;
	extern tclSoundCmdList vclSoundCmdList_Public;

	extern tclSoundCmdLoader vclSoundCmdLoader;

	#endif // defMI_Sound_h
//.e skip over if header has already been included.

