//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MI_Util.cpp
//	
//	[MEAN] Interface UTIL function definitions.
//
//.e	

#include "MB_Includes.h"	
#include "MI_Util.h"
#include "MG_Lib.h"
#include "MB_InterfaceL1.h"

extern DLL_FUNCTIONS vstDLLFuncsOrig;

//.b These definitions taken from player.cpp
	int gmsgTextMsg = 0;
	int gmsgSayText = 0;
	int gmsgShowMenu = 0;
	int gmsgHudText = 0;
//.e

	inline bool fboPlayerIsValid(CBaseEntity* pPlayer) 
	{
		return ((pPlayer) 
			        && 
			     (!FNullEnt(pPlayer->pev)) 
			        && 
			     (GETPLAYERUSERID(pPlayer->edict()) > 0) 
			        && 
			     (!FStrEq(STRING(pPlayer->pev->netname),"")) ? true : false);
	} // fboPlayerIsValid

	static unsigned short FixedUnsigned16( float value, float scale )
	{
		int output;

		output = value * scale;
		if ( output < 0 )
			output = 0;
		if ( output > 0xFFFF )
			output = 0xFFFF;

		return (unsigned short)output;
	}

	static short FixedSigned16( float value, float scale )
	{
		int output;

		output = value * scale;

		if ( output > 32767 )
			output = 32767;

		if ( output < -32768 )
			output = -32768;

		return (short)output;
	}

	// returns a CBaseEntity pointer to a player by index.  Only returns if the player is spawned and connected
	// otherwise returns NULL
	// Index is 1 based
	CBaseEntity	*UTIL_PlayerByIndex( int playerIndex )
	{
		CBaseEntity *pPlayer = NULL;
		edict_t *pPlayerEdict;

		if ( playerIndex > 0 && playerIndex <= gpGlobals->maxClients )
		{
			pPlayerEdict = INDEXENT( playerIndex );
			if ( pPlayerEdict && !pPlayerEdict->free )
			{
				pPlayer = CBaseEntity::Instance( pPlayerEdict );
			}
		}
		
		if (fboPlayerIsValid(pPlayer))
			return pPlayer;
		else
			return NULL;
		
	} // UTIL_PlayerByIndex

	int UTIL_GetPlayerIndexByID (int pinUserID)
	{
		CBaseEntity *pPlayer;

		for (int i = 1; i <= gpGlobals->maxClients; i++ )
		{
			pPlayer = UTIL_PlayerByIndex( i );
			if ( pPlayer != NULL)
			{
				if (pinUserID == GETPLAYERUSERID (ENT(pPlayer->pev)))
				{
					return i;
				}
			}
		}
			
		return 0;

	} // UTIL_GetPlayerIndexByID

	int UTIL_GetUserIDByEdict (edict_t *pst_ptrEdict)
	{
		if (pst_ptrEdict == NULL)
		{
			return 0; 
		}

		CBaseEntity *pPlayer = CBaseEntity::Instance( pst_ptrEdict );
		
		if (!fboPlayerIsValid(pPlayer))
		{
			return 0; 
		}
		
		int vinUserID = GETPLAYERUSERID (ENT(pPlayer->pev));		

		return vinUserID;

	} // UTIL_GetUserIDByEdict

	int UTIL_GetUserIDByIdx (int pinPlayerIdx)
	{

		CBaseEntity *pPlayer = pPlayer = UTIL_PlayerByIndex(pinPlayerIdx);
		
		if (!fboPlayerIsValid(pPlayer))
		{
			return 0; 
		}
		
		int vinUserID = GETPLAYERUSERID (ENT(pPlayer->pev));		

		return vinUserID;

	} // UTIL_GetUserIDByEdict

	bool IsAlive(CBaseEntity  *pPlayer)
	{ 
		if (!fboPlayerIsValid(pPlayer))
		{
			return false; 
		}
		
		return (pPlayer->pev->deadflag == DEAD_NO) && pPlayer->pev->health > 0; 
	}

	bool IsAlive(int pinIdx)
	{ 
		return IsAlive(UTIL_PlayerByIndex(pinIdx)); 
	}
	
	bool UTIL_PlayerIsAlive (int pinUserId)
	{
		return IsAlive(UTIL_GetPlayerIndexByID (pinUserId));
	} // UTIL_PlayerIsAlive

	void UTIL_HudMessage( CBaseEntity *pEntity, const hudtextparms_t &textparms, const char *pMessage )
	{
		if (!fboPlayerIsValid(pEntity))
		{
			return; 
		}

	  MESSAGE_BEGIN(MSG_ONE_UNRELIABLE, SVC_TEMPENTITY, NULL, pEntity->edict() );

	  WRITE_BYTE( TE_TEXTMESSAGE );
	  WRITE_BYTE( textparms.channel & 0xFF );
	  
	  WRITE_SHORT( FixedSigned16( textparms.x, 1<<13 ) );
	  WRITE_SHORT( FixedSigned16( textparms.y, 1<<13 ) );
	  WRITE_BYTE( textparms.effect );
	  
	  WRITE_BYTE( textparms.r1 );
	  WRITE_BYTE( textparms.g1 );
	  WRITE_BYTE( textparms.b1 );
	  WRITE_BYTE( textparms.a1 );
	  
	  WRITE_BYTE( textparms.r2 );
	  WRITE_BYTE( textparms.g2 );
	  WRITE_BYTE( textparms.b2 );
	  WRITE_BYTE( textparms.a2 );
	  
	  WRITE_SHORT( FixedUnsigned16( textparms.fadeinTime, 1<<8 ) );
	  WRITE_SHORT( FixedUnsigned16( textparms.fadeoutTime, 1<<8 ) );
	  WRITE_SHORT( FixedUnsigned16( textparms.holdTime, 1<<8 ) );
	  
	  if ( textparms.effect == 2 )
		 WRITE_SHORT( FixedUnsigned16( textparms.fxTime, 1<<8 ) );
	  
	  if ( strlen( pMessage ) < 512 )
		 {
			WRITE_STRING( pMessage );
		 }
	  else
		 {
			char tmp[512];
			strncpy( tmp, pMessage, 511 );
			tmp[511] = 0;
			WRITE_STRING( tmp );
		 }
	  MESSAGE_END();
	} // UTIL_HudMessage

	void UTIL_HudMessageAll_2( const hudtextparms_t &textparms, const char *pMessage )
	{

	  MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY);

	  WRITE_BYTE( TE_TEXTMESSAGE );
	  WRITE_BYTE( textparms.channel & 0xFF );
	  
	  WRITE_SHORT( FixedSigned16( textparms.x, 1<<13 ) );
	  WRITE_SHORT( FixedSigned16( textparms.y, 1<<13 ) );
	  WRITE_BYTE( textparms.effect );
	  
	  WRITE_BYTE( textparms.r1 );
	  WRITE_BYTE( textparms.g1 );
	  WRITE_BYTE( textparms.b1 );
	  WRITE_BYTE( textparms.a1 );
	  
	  WRITE_BYTE( textparms.r2 );
	  WRITE_BYTE( textparms.g2 );
	  WRITE_BYTE( textparms.b2 );
	  WRITE_BYTE( textparms.a2 );
	  
	  WRITE_SHORT( FixedUnsigned16( textparms.fadeinTime, 1<<8 ) );
	  WRITE_SHORT( FixedUnsigned16( textparms.fadeoutTime, 1<<8 ) );
	  WRITE_SHORT( FixedUnsigned16( textparms.holdTime, 1<<8 ) );
	  
	  if ( textparms.effect == 2 )
		 WRITE_SHORT( FixedUnsigned16( textparms.fxTime, 1<<8 ) );
	  
	  if ( strlen( pMessage ) < 512 )
		 {
			WRITE_STRING( pMessage );
		 }
	  else
		 {
			char tmp[512];
			strncpy( tmp, pMessage, 511 );
			tmp[511] = 0;
			WRITE_STRING( tmp );
		 }
	  MESSAGE_END();
	} // UTIL_HudMessageAll_2

	void UTIL_HudMessageAll( const hudtextparms_t &textparms, const char *pMessage )
	{
	/*
		int i;
		CBaseEntity *pPlayer;

		for ( i = 1; i <= gpGlobals->maxClients; i++ )
		{
			pPlayer = UTIL_PlayerByIndex( i );
			if (fboPlayerIsValid(pPlayer))
			{
				UTIL_HudMessage( pPlayer, textparms, pMessage );	
			}
			
		}
	*/
		UTIL_HudMessageAll_2( textparms, pMessage );
	} // UTIL_HudMessageAll

/*
	print_console,
	print_center,
	print_chat,
*/

	void UTIL_ClientMessage
		(	CBaseEntity *pPlayer, 
			PRINT_TYPE p_type,
			const char *pMessage )
	{
		if (!fboPlayerIsValid(pPlayer))
			return;

//		if (fboPlayerIsBotByEdict (pPlayer->edict()))
//		{ // filter out bot.
//			return;
//		}

		CLIENT_PRINTF(pPlayer->edict(), p_type, pMessage);

	} // UTIL_ConsoleMessage

	void UTIL_ClientMessageAll
		(	PRINT_TYPE p_type,
			const char *pMessage )
	{
		int	i;
		CBaseEntity *pPlayer;
		for ( i = 1; i <= gpGlobals->maxClients; i++ )
		{
			pPlayer = UTIL_PlayerByIndex( i );
			if (fboPlayerIsValid(pPlayer))
			{
				UTIL_ClientMessage( pPlayer, p_type, pMessage );
			}
		}
	}

	void UTIL_CenterMessage
		(	CBaseEntity *pPlayer, 
			const char *pMessage )
	{
	  if (!fboPlayerIsValid(pPlayer))
		 return;
	  
		UTIL_ClientMessage (pPlayer, print_center, pMessage);

	} // UTIL_CenterMessage

	void UTIL_CenterMessageAll
		(const char *pMessage )
	{
		UTIL_ClientMessageAll (print_center, pMessage);
	} // UTIL_CenterMessage

	void UTIL_ChatMessage
		(	CBaseEntity *pPlayer, 
			const char *pMessage )
	{
	  if (!fboPlayerIsValid(pPlayer))
		 return;
	  
		UTIL_ClientMessage (pPlayer, print_chat, pMessage);

	} // UTIL_ChatMessage

	void UTIL_ChatMessageAll
		(const char *pMessage )
	{
		UTIL_ClientMessageAll (print_chat, pMessage);
	} // UTIL_ChatMessageAll

/*
	void UTIL_ShowMessage( const char *pMessage, CBaseEntity *pEntity )
	{
		if (!fboPlayerIsValid(pEntity))
		{
			return;
		}

		if (fboPlayerIsBotByEdict (pEntity->edict()))
		{
			return;
		}

		if (gmsgSayText == 0)
		{
			gmsgSayText = REG_USER_MSG( "SayText", -1 );
		}

		edict_t *pEdict = pEntity->edict();

		MESSAGE_BEGIN( MSG_ONE, gmsgSayText, NULL, &pEdict->v );
			WRITE_BYTE( ENTINDEX(pEdict) );
			WRITE_STRING(pMessage);
		MESSAGE_END();


	} // UTIL_ShowMessage

	void UTIL_ShowMessageAll( const char *pMessage )
	{
		int i;
		CBaseEntity *pPlayer;

		// loop through all players

		for ( i = 1; i <= gpGlobals->maxClients; i++ )
		{
			pPlayer = UTIL_PlayerByIndex( i );
			if (fboPlayerIsValid(pPlayer))
				UTIL_ShowMessage( pMessage, pPlayer );
		}

	} // UTIL_ShowMessageAll

*/
