//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MI_Player.h
//	
//	[MEAN] 
//
//.e	

//.b skip over if header has already been included.
#ifndef defMI_Player_h

	// Prevent the reprocessing of this definition file by defining 
	// the alias used in the above "ifndef" check.
	#define defMI_Player_h

	// Include all general definition files.
	#include "MB_Includes.h"
	#include "MA_time.h"

	const int cinMaxPlayerSlots = 32;

	const int cinSuccessfull = 0;
	const int cinNoFreePublicSlots = -1;
	const int cinPlayerSlotNotFound = -2;
	const int cinNullEdictPointer = -3;
	const int cinPlayerNameIsEmpty = -4;
	const int cinAuthIdIsEmpty = -5;
	const int cinAddressIsEmpty = -6;
	const int cinInvalidSlotIndex = -7;
	const int cinPlayerNotFound = -8;
	const int cinPlayerConnectionsNotAllowed = -9;
	const int cinPlayerAlreadyExists = -10;
	
	const int cinAutoAFKKickTimeout_DEFAULT = 120; // 2 minutes = 120 seconds.

	class tclSlot
	{
		public:
			tclSlot( void );
		
			edict_t* vst_ptrEdict;
			int vinUserId;
			int vinPlayerIdx;
			string vtxName;
			string vtxAuthId;
			string vtxAddress;
			tclTimer vclTimer_Damage;

			Vector vstVector;

//			edict_t *vst_ptrEdict;

			bool vboSilenced;
			bool vboMuted;
			bool vboPublic;
			bool vboAllowedOnBotTeam;
			int vinAllowedOnClanTeam;
			int vinAllowedOffClanTeam;
			bool vboJustArrived;
			int vinTKBotCount;
			int vinTKHumanCount;
			int finTKCount( ){ return vinTKBotCount + vinTKHumanCount; };
//!! remove
//			bool vboIsSrvOp;
//			bool vboIsAdmin;
//			bool vboIsClan;
//			bool vboIsGuest;
//			bool vboIsPublic;
//			int  vinRank;
//!! remove
			void		fvoClearPlayer				(	void	);
			int		finSetPlayerInfo 			(	edict_t* pst_ptrEdict );
			bool		fboSlotIsFree				(	void	);
			bool		fboSlotIsPublic			(	void	);
			bool		fboPlayerIsSilenced		(	void	);
			bool		fboPlayerIsMuted			(	void	);
			void		fvoSetPlayerSilenceFlag (	bool pboSilenced	);
			void		fvoSetPlayerMuteFlag		(	bool pboMuted	);
			string	ftxPlayerName				(	void	);
			string	ftxPlayerAuthId			(	void	);
			string	ftxPlayerAddress			(	void	);
			bool		fboPlayerHasMoved			(  bool& pboInGame, bool& pboIsAlive );

	}; // tclSlot

	class tclPlayerSlot
	{
		public:
			tclSlot vcl_aryPlayer[ cinMaxPlayerSlots ];
			bool	vboAllowPlayerConnections;
			bool  vboAutoKickAFK;
			int   vinAutoAFKKickTimeout;
			tclTimer vclTimer_AFK;

			tclPlayerSlot (void);
			
			bool	fboSlotIndexIsValid	(int pinIdx);
			int	finMakeSlotFree		(int pinIdx);

		// Find Slot.
			int	finFindSlotById			(int pinUserId);
//!! not implemented:			
//!!		int	finFindSlotByIndex		( int pinIndex );
//!!.end
			bool	fboPlayerHasSlot( int pinPlayerIndex );
			int	finFindSlotByEdict		(edict_t *pst_ptrEdict);
			bool	fboSlotIsFree				(int pinIdx);
			bool	fboSlotIsPublic			(int pinIdx);
			int	fboNumPublicSlots			(void);
			int	fboNumFreePublicSlots	(void);
			int	finGetFreePublicSlot		(void);

		// Add remove player to/from slot.
			int  finAddPlayer( edict_t* pst_ptrEdict );

			int  finRemovePlayer					(int pinIdx);
			int  finRemovePlayerByEdict		( edict_t *pst_ptrEdict );
			int  finFlushPlayerSlots			( void );
			bool fboPlayerIsSilenced			(int pinIdx);
			bool fboPlayerIsSilencedById		(int pinUserId);
			bool fboPlayerIsSilencedByEdict	(edict_t *pst_ptrEdict);
			bool fboPlayerIsMuted				(int pinIdx);
			bool fboPlayerIsMutedByEdict		( edict_t *pst_ptrEdict );
//!! remove			bool fboPlayerIsAdminByEdict		( edict_t *pst_ptrEdict ); 
//!! remove			bool fboPlayerIsAdmin				( int pinIdx ); 
//!! remove			int  finListAdmins					( edict_t *pst_ptrEdict ); 

			bool fboIsAllowedOnBotTeam( int pinIdx );
			int finIsAllowedOnClanTeam( int pinIdx );
			int finIsAllowedOffClanTeam( int pinIdx );

		// Set values.
			bool fboSetPlayerSilenceFlag		(	int	pinIdx, 
															bool	pboSilenced	);
			bool fboSetPlayerSilenceFlagById( int pinUserId, bool pboSilenced, string ptxReason);

			bool fboSetPlayerMuteFlag		(	int	pinIdx, 
														bool	pboMuted	);
			bool fboSetPlayerMuteFlagById ( int pinUserId, bool pboMuted, string ptxReason );

			bool fboSetIsAllowedOnBotTeam(	int pinIdx, bool pboAllowed);
			bool fboSetIsAllowedOnClanTeam(	int pinIdx, int pinAllowed);
			bool fboSetIsAllowedOffClanTeam(	int pinIdx, int pinAllowed);

		// Get values.
			string	ftxGetPlayerName			(int			pinIdx);
			string	ftxGetPlayerNameById		(int			pinUserId);
			string	ftxGetPlayerAuthId		(int			pinIdx);
			string	ftxGetPlayerAuthIdById	(int			pinUserId);
			string	ftxGetPlayerAddressById	(int			pinUserId);
			string	ftxGetPlayerAddress		(int			pinIdx);
			bool		fboPlayerHasMoved			( int pinIdx, bool& pboInGame, bool& pboIsAlive );
			void		fvoAutoKickAFKPlayers   ( void ); // returns UserId

		//	bool		fboKickLowerRank( edict_t *pst_ptrEdict );

	}; // tclPlayerSlot

	class tclTimeBomb
	{
		public:
			bool vboRandomPlant;
			tclTimer vclTimer_Bomb;
			tclTimer vclTimer_Tick;

			tclTimeBomb( void );
			int vinUserId;
			int vinTickSound1;
			int vinTickSound2;
			int vinTickSound3;
			int vinTickSound4;
			int vinTickSound5;
			int vinNullSound;
			int vinPlantBombSound;
			int vinLastSoundPlayed;
			void fvoInitSounds( void );
			void fvoPlayNullSound( void );
			bool fboPlaySound( int pinSound );
			void fvoRemoveTimeBombPlant( void );
			bool fboPlantTimeBombOnUser( int pinUserId, int& pinTimerInSec, string ptxReason );
			bool fboIsTimeBombPlanted( void );
			
			void fvoCountDown( void );
			
	};

	extern tclTimeBomb vclTimeBomb;
	extern tclPlayerSlot vclPlayerSlot;

#endif // defMI_Player_h