//.b 	
//	Copyright 2001 [MEAN].BOT
//	
//	File: MA_Cmd.cpp
//	
//	[MEAN] Command Module. 
//
//.e	

#include "MA_Cmd.h"
#include "MG_Lib.h"
#include "MA_EngDLLCmd.h"
#include "MA_Player.h"
#include "MI_Player.h"
#include "MI_Sound.h"
#include "MI_Hud.h"
#include "MI_Map.h"
#include "MA_Bot.h"
#include "MA_Weapon.h"
#include "MA_Security.h"
#include "MA_Text.h"
#include "MA_BotControl.h"

// public "say" commands:
	const string ctxSay_BotYell		   = "botyell";
	const string ctxSay_ClanTeam			= "clanteam";
	const string ctxSay_BotTeam			= "botteam";
	const string ctxSay_HumanTeam			= "humanteam";
	const string ctxSay_BotSkill			= "botskill";
	const string ctxSay_BotSystem		   = "botsystem";
	const string ctxSay_NextMap			= "nextmap";
	const string ctxSay_MapName			= "mapname";
	const string ctxSay_CurMap				= "currentmap";
	const string ctxSay_MaxPlayers		= "maxplayers";
	const string ctxSay_TimeLeft			= "timeleft";
	const string ctxSay_ServerIP			= "serverip";
//.10.
	const string ctxSay_WarMode			= "warmode";	
	const string ctxSay_ListAdmins		= "whoisadmin";
	const string ctxSay_FFCheck			= "ff";
	const string ctxSay_Sounds 			= "sounds";
	const string ctxSay_BotDamage			= "botdamage";
	const string ctxSay_HeadShot			= "headshot";
// client & server commands
	const string ctxCmd_EnforceHumanTeam= "m_enforcehumanteam";
	const string ctxCmd_EnforceClanTeam	= "m_enforceclanteam";
	const string ctxCmd_EnforceBotTeam	= "m_enforcebotteam";
	const string ctxCmd_AutoBalanceBots	= "m_autobalancebots";
	const string ctxCmd_AllowOnBotTeam	= "m_allowonbotteam";
//.20.
	const string ctxCmd_AllowOnClanTeam	= "m_allowonclanteam";
	const string ctxCmd_AllowOffClanTeam= "m_allowoffclanteam";
	const string ctxCmd_SwitchBotTeam	= "m_switchbotteam";
	const string ctxCmd_BotAdd				= "m_addbot";
	const string ctxCmd_BotsAdd			= "m_addbots";
	const string ctxCmd_BotKick			= "m_kickbot";
	const string ctxCmd_BotKickAll		= "m_kickbots"; // !! Should work same as m_kickbot but is count is left out then all bots are kicked
	const string ctxCmd_KillBots			= "m_killbots";
	const string ctxCmd_SetBotSkill		= "m_botskill";
	const string ctxCmd_BotYell		   = "m_botyell";
	const string ctxCmd_BotSystem			= "m_botsystem";
//.30.
	const string ctxCmd_ClanTeam			= "m_clanteam";
	const string ctxCmd_BotTeam			= "m_botteam";
	const string ctxCmd_HumanTeam			= "m_humanteam";
	const string ctxCmd_BotMode			= "m_botmode";
	const string ctxCmd_GameMode			= "m_gamemode";
	const string ctxCmd_AutoKickAFK 		= "m_autokickafk";
	const string ctxCmd_SetFF		 		= "m_ff";
	const string ctxCmd_SetSounds	 		= "m_sounds";
	const string ctxCmd_ListBots			= "m_bots";
	const string ctxCmd_ListHumans		= "m_humans";
	const string ctxCmd_ListPlayers		= "m_users";
//.40.
	const string ctxCmd_SilencePlayer	= "m_silence";
	const string ctxCmd_MutePlayer		= "m_mute"; // idiotmute
	const string ctxCmd_TimeBomb			= "m_timebomb";
	const string ctxCmd_SlapPlayer		= "m_slap";
	const string ctxCmd_KillPlayer		= "m_kill";
	const string ctxCmd_KillHumans		= "m_killhumans";
	const string ctxCmd_KickPlayer		= "m_kick";
	const string ctxCmd_BanPlayer			= "m_ban";
	const string ctxCmd_UnbanPlayer		= "m_unban";
	const string ctxCmd_AdminSpeak		= "m_adminspeak"; 
//.50.
	const string ctxCmd_Say					= "m_say";
	const string ctxCmd_SayRed				= "m_sayred";
	const string ctxCmd_SayBlue			= "m_sayblue";
	const string ctxCmd_SayGreen			= "m_saygreen";
	const string ctxCmd_SayName			= "m_sayi";
	const string ctxCmd_NextMap			= "m_nextmap";
	const string ctxCmd_MapName			= "m_mapname";
	const string ctxCmd_MapList			= "m_maplist";
	const string ctxCmd_MaxPlayers		= "m_maxplayers";
	const string ctxCmd_TimeLeft			= "m_timeleft";
//.60.
	const string ctxCmd_ServerIP			= "m_serverip";
	const string ctxCmd_ListAdmins		= "m_whoisadmin";
	//!! make warmodes configurable from a cfg file;
	const string ctxCmd_UseRank			= "m_useweaponrank";	
	const string ctxCmd_WarMode			= "m_warmode";	
	const string ctxCmd_RegularWar		= "m_regularwar";
	const string ctxCmd_KnifeWar			= "m_knifewar";
	const string ctxCmd_NadeWar			= "m_nadewar";
	const string ctxCmd_PistolWar			= "m_pistolwar";
	const string ctxCmd_DeagleWar			= "m_deaglewar";
	const string ctxCmd_GlockUSPWar		= "m_glockuspwar";
//.70.
	const string ctxCmd_GlockWar			= "m_glockwar";
	const string ctxCmd_USPWar				= "m_uspwar";
	const string ctxCmd_Dual57				= "m_dual57war";
	const string ctxCmd_P228War			= "m_p228war";
	const string ctxCmd_LightPistolWar	= "m_lightpistolwar"; 
	const string ctxCmd_SubWar				= "m_subwar";
	const string ctxCmd_LightSubWar		= "m_lightsubwar";
	const string ctxCmd_UziWar				= "m_uziwar";
	const string ctxCmd_UMPWar				= "m_umpwar";
	const string ctxCmd_P90War				= "m_p90war";
//.80.
	const string ctxCmd_MP5War				= "m_mp5war";
	const string ctxCmd_ShotgunWar		= "m_shotgunwar";
	const string ctxCmd_AutoShotgunWar	= "m_autoshotgunwar";
	const string ctxCmd_PumpWar			= "m_pumpwar";
	const string ctxCmd_SnipeWar			= "m_snipewar";
	const string ctxCmd_LightSnipeWar	= "m_lightsnipewar";
	const string ctxCmd_ScoutWar			= "m_scoutwar";
	const string ctxCmd_HK550SnipeWar	= "m_hk550snipewar";
	const string ctxCmd_AWPWar				= "m_awpwar";
	const string ctxCmd_ParaWar			= "m_parawar";
//.90.
	const string ctxCmd_LightArmsWar		= "m_lightarmswar";
	const string ctxCmd_SmallArmsWar		= "m_smallarmswar";
	const string ctxCmd_HeavyArmsWar		= "m_heavyarmswar";
	const string ctxCmd_AK47ColtWar		= "m_ak47coltwar";
	const string ctxCmd_SG522AugWar		= "m_sg522augwar";
	
	const string ctxCmd_FamasGalilWar	= "m_famasgalilwar";

	const string ctxCmd_BanAWP				= "m_banawp";      //!! change to one command, and what is being banned is passed as an argument;
	const string ctxCmd_BanFlash			= "m_banflash";
	const string ctxCmd_BanSmoke			= "m_bansmoke";
	const string ctxCmd_BanHENade			= "m_banhenade";
	const string ctxCmd_BanShield			= "m_banshield";
	const string ctxCmd_BotDamage			= "m_botdamage";
//.100.
	const string ctxCmd_HeadShot			= "m_headshot";
	const string ctxCmd_LiveIn3			= "m_livein3";
	const string ctxCmd_Exec				= "m_exec";
	const string ctxCmd_MapTimeout		= "m_maptimeout";
	const string ctxCmd_EndMap				= "m_endmap";
	const string ctxCmd_LoadMap			= "m_loadmap";
	const string ctxCmd_LoadSecurity		= "m_loadusers";
	const string ctxCmd_LoadConnMsg		= "m_loadconnmsg";
	const string ctxCmd_LoadPopupMsg		= "m_loadpopupmsg";
	const string ctxCmd_LoadIPBanList	= "m_loadipbanlist";
//.110.
	const string ctxCmd_UserInfo			= "m_userinfo";
	const string ctxCmd_MyUserInfo		= "m_myuserinfo";
	const string ctxCmd_DumpUserInfo		= "m_dumpuserinfo";
	const string ctxCmd_EndRound			= "m_endround";  //!! add argument to specify seconds to end
	const string ctxCmd_Version			= "m_version";
	const string ctxCmd_PopupDelay		= "m_popupdelay";
	const string ctxCmd_SrvLock			= "m_serverlock";
	const string ctxCmd_CmdLock			= "m_cmdlock";
	const string ctxCmd_EnableSound		= "m_turnsound";
	const string ctxCmd_StatsProtect		= "m_statsprotect";
//.120.
	const string ctxCmd_PODFixProtect	= "m_podfixprotect";
	const string ctxCmd_AutoBotSkill    = "m_autoskillswitch";
	const string ctxCmd_AutoBotTeam     = "m_autoteamswitch";
	const string ctxCmd_AutoBalTeams    = "m_autobalanceteams";
	const string ctxCmd_AutoKillBots    = "m_autokillbots";
	const string ctxCmd_SetCommand		= "m_setcommand";
	const string ctxCmd_KickDupBots		= "m_kickdupbots";
	const string ctxCmd_MaxHumans			= "m_maxhumans";
//.127.
	const string ctxCmd_WeapBanPenalty = "m_banpenalty";
	const string ctxCmd_AddMean		  = "m_addmean";
	const string ctxCmd_BotEnhance	  = "m_botenhance"; // turns on|off ALL bot enhancements;

//	const string ctxCmd_PlayerConnTask	= "m_playerconntask"; // run command next time player "name" joins server;

//"sv_restart"
//acts exactly the same as "sv_restartround"

	tclCommand vclCommand;

// **************************************************************************
// Support Functions - BEGIN

	bool fboEmitSoundFromPlayer( edict_t* pst_ptrEdict, string ptxUserId, string ptxSoundWav )
	{
		string vtxMsg = ctxMsgPrefix + "Emitting sound " + ptxSoundWav + 
			             " from user id " + ptxUserId + ".\n";
		fvoConsolePrint( pst_ptrEdict, vtxMsg );

		if ( ptxSoundWav.empty( ) )
		{
			vtxMsg = ctxMsgPrefix + "Cannot emit sound. Missing sound file.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return false;
		}

		if ( ptxUserId == "" )
		{
			vtxMsg = ctxMsgPrefix + "Cannot emit sound. Missing user id.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return false;
		}

		int vinUserId = finStringToInt ( ptxUserId );
		if ( vinUserId <= 0 )
		{
			vtxMsg = ctxMsgPrefix + "Cannot emit sound. Invalid user id.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return false;
		}
		
		bool vboResult = vclPlayer.fboEmitSoundFromAlivePlayerByUserId( vinUserId, ptxSoundWav );
		if ( vboResult == false )
		{
			vtxMsg = ctxMsgPrefix + "Cannot emit sound. Player does not exist or is dead.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
		}
		return vboResult;

	} // fboEmitSoundFromPlayer

	bool fboPlayerSpeak( edict_t* pst_ptrEdict, string ptxWavFile )
	{
		if ( vclPlayerSlot.fboPlayerIsSilencedByEdict( pst_ptrEdict ) )
			return false;

		int vinUserId = vclPlayer.finGetUserIdByEdict( pst_ptrEdict );
		string vtxUserId = ftxIntToString( vinUserId );
		return fboEmitSoundFromPlayer( pst_ptrEdict, vtxUserId, ptxWavFile );

	} // fboPlayerSpeak

	void fvoHUDStatusDisplay( edict_t* pst_ptrEdict, string ptxMsg )
	{
		vclHUD.fvoStatusSay( ptxMsg );
		fvoConsolePrint_nl( pst_ptrEdict, ptxMsg );
	} // fvoHUDStatusDisplay

	string ftxWarModeDisplayString( )
	{
		string vtxMsgPrefix = "Weapon restrictions enforced on:";
		string vtxMsg;

		if ( vclWeapon.fboWeaponBanFlagIsOn( cinBan_All ) )
			vtxMsg = " everyone including all bots";
		else
		{
			if ( vclWeapon.fboWeaponBanFlagIsOn( cinBan_Bots ) )
				vtxMsg += " bots";

			if ( vclWeapon.fboWeaponBanFlagIsOn( cinBan_Humans ) )
				vtxMsg += " humans";

			if ( vclWeapon.fboWeaponBanFlagIsOn( cinBan_Clan ) )
				vtxMsg += " clan";

			if ( vclWeapon.fboWeaponBanFlagIsOn( cinBan_World ) )
				vtxMsg += " world";

			if ( vclWeapon.fboWeaponBanFlagIsOn( cinBan_ClanTeam ) )
				vtxMsg += " clanteam";

			if ( vclWeapon.fboWeaponBanFlagIsOn( cinBan_WorldTeam ) )
				vtxMsg += " worldteam";

			if ( vtxMsg == "" )
			{
				vtxMsgPrefix = "Weapon restrictions are not enforced on anyone";
			}
			
		}

		return vtxMsgPrefix + vtxMsg;

	} // ftxWarModeDisplayString

	void fvoHUDWarModeDisplay( edict_t* pst_ptrEdict )
	{
		string vtxMsg = ctxMsgPrefix + ftxWarModeDisplayString( );
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );
		vtxMsg = ctxMsgPrefix + vclWeapon.vtxWeaponModeDisplay;
		vclHUD.fvoCenterSay( vtxMsg );
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
		
	} // fvoHUDWarModeDisplay

	void fvoClientConsoleWarModeDisplay( edict_t* pst_ptrEdict )
	{
		string vtxMsg = ctxMsgPrefix + ftxWarModeDisplayString( );
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
		vtxMsg = vclWeapon.vtxWeaponModeDisplay;
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
		
	} // fvoClientConsoleWarModeDisplay

	void fvoLockCommand( edict_t* pst_ptrEdict, bool pboLock )
	{
		string vtxMsg = ctxMsgPrefix;

		vclCommand.fboLockCommand( ctxCmd_EnforceBotTeam  , pboLock );
		vclCommand.fboLockCommand( ctxCmd_EnforceClanTeam , pboLock );
		vclCommand.fboLockCommand( ctxCmd_EnforceHumanTeam, pboLock );
		vclCommand.fboLockCommand( ctxCmd_AutoBalanceBots , pboLock );
		vclCommand.fboLockCommand( ctxCmd_SwitchBotTeam   , pboLock );
		vclCommand.fboLockCommand( ctxCmd_BotMode		     , pboLock );
		vclCommand.fboLockCommand( ctxCmd_GameMode	     , pboLock );
		vclCommand.fboLockCommand( ctxCmd_AutoKickAFK     , pboLock );
		vclCommand.fboLockCommand( ctxCmd_SetFF           , pboLock );
		
		if ( pboLock == cboCommandLock_Off )
		{
			vtxMsg += "All commands are now unlocked";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		}
		else
			vclCommand.fvoListCmdLocks( pst_ptrEdict );

	} // fvoLockCommand

// Support Functions - END
// **************************************************************************

// **************************************************************************
// Command Functions - BEGIN

//.Server command - specifies if non clan players allowed on the clan team or not;
	void fvoSrvCmd_EnforceClanTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				// [ on < ct | te > | off ] 
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_EnforceClanTeam + " [ on < ct | te > | off ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		if ( !ptxArgList[ 1 ].empty( ) )
		{
			if ( fboIsOn( ptxArgList[ 1 ] ) )
			{
				vclPlayer.vboEnforceClanTeam = true;
				if ( ptxArgList[ 2 ] == "te" )
					vclPlayer.vinCurrentClanTeam = cinTeam_TE;
				else
				if ( ptxArgList[ 2 ] == "ct" )
					vclPlayer.vinCurrentClanTeam = cinTeam_CT;
				else
					goto locUsage;
			}		
			else 
			if ( fboIsOff( ptxArgList[ 1 ] ) )
			{
				vclPlayer.vboEnforceClanTeam = false;
				vclPlayer.vinCurrentClanTeam = cinTeam_Unknown;
			}
			else
				goto locUsage;
		}

		int vinClanTeam = vclPlayer.finGetClanTeam( );

		if ( vinClanTeam == cinTeam_TE )
			vtxMsg += "Clan members are on the terrorist team. ";
		else
		if ( vinClanTeam == cinTeam_CT )
			vtxMsg += "Clan members are on the counter-terrorist team. ";
		else
			vtxMsg += "Clan members are not assigned to a team. ";

		if ( vclPlayer.vboEnforceClanTeam == false )
			vtxMsg += "Enforcement is not enabled.";
		else
			vtxMsg += "Enforcement is enabled.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_EnforceClanTeam

//.Server command - specifies if human players must be on the human team or not;
	void fvoSrvCmd_EnforceHumanTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				// [ on < ct | te > | off ] 
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_EnforceHumanTeam + " [ on [ ct|te|any ] | off ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		if ( !ptxArgList[ 1 ].empty( ) )
		{
			if ( fboIsOn( ptxArgList[ 1 ] ) )
			{
				vclPlayer.vboEnforceHumanTeam = true;
				if ( ptxArgList[ 2 ] == "te" )
				{
					vclPlayer.vinCurrentHumanTeam = cinTeam_TE;
					vclPlayer.vboEnforceHumanTeam_Fixed = true;
				}
				else
				if ( ptxArgList[ 2 ] == "ct" )
				{
					vclPlayer.vinCurrentHumanTeam = cinTeam_CT;
					vclPlayer.vboEnforceHumanTeam_Fixed = true;
				}
				else
				if ( ptxArgList[ 2 ] == "any" || ptxArgList[ 2 ] == "" )
				{
					vclPlayer.vinCurrentHumanTeam = cinTeam_Any;
					vclPlayer.vboEnforceHumanTeam_Fixed = false;
				}
				else
					goto locUsage;
			}		
			else 
			if ( fboIsOff( ptxArgList[ 1 ] ) )
			{
				vclPlayer.vboEnforceHumanTeam = false;
				vclPlayer.vinCurrentHumanTeam = cinTeam_Any;
				vclPlayer.vboEnforceHumanTeam_Fixed = false;
			}
			else
				goto locUsage;
		}

		int vinHumanTeam = vclPlayer.finGetHumanTeam( );

		if ( vinHumanTeam == cinTeam_TE )
			vtxMsg += "Humans are on the Terr team. ";
		else
		if ( vinHumanTeam == cinTeam_CT )
			vtxMsg += "Humans are on the CT team. ";
		else
			vtxMsg += "Humans may choose their team. ";

		if ( vclPlayer.vboEnforceHumanTeam == false )
			vtxMsg += "Enforcement is not enabled.";
		else
			vtxMsg += "Enforced when bots in game.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_EnforceHumanTeam

//.Server command - specifies if humans allowed on the bot team or not;
	void fvoSrvCmd_EnforceBotTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				// [ on < ct | te > | off ] 
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_EnforceBotTeam + " [ on < ct | te > | off ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		if ( !ptxArgList[ 1 ].empty( ) )
		{
			if ( fboIsOn( ptxArgList[ 1 ] ) )
				vclBot.vboEnforceBotTeam = true;
			else 
			if ( fboIsOff( ptxArgList[ 1 ] ) )
				vclBot.vboEnforceBotTeam = false;
			else
				goto locUsage;
		}

		int vinBotTeam = vclBot.finGetBotTeam( );

		if ( vinBotTeam == cinTeam_TE )
			vtxMsg += "Bots are on the terrorist team. ";
		else
		if ( vinBotTeam == cinTeam_CT )
			vtxMsg += "Bots are on the counter-terrorist team. ";
		else
			vtxMsg += "Bots are not assigned to any specific team. ";

		if (vclBot.vboEnforceBotTeam == false )
			vtxMsg += "Enforcement is not enabled.";
		else
			vtxMsg += "Enforcement is enabled.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_EnforceBotTeam

//.Server command - auto balances number of bots to humans;
	void fvoSrvCmd_AutoBalanceBots( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( vclBot.vinBotSystem == cinBot_Unknown )
		{
			vtxMsg += "The bots are not loaded or are not a version that is supported.";
			vclHUD.fvoStatusSay( vtxMsg );
			vtxMsg += "\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		if ( ptxArgList[ 1 ] != "" )
		{
			if ( fboIsOn( ptxArgList[ 1 ] ) )
				vclBot.vboBalanceBots = true;
			else 
			if ( fboIsOff( ptxArgList[ 1 ] ) )
				vclBot.vboBalanceBots = false;
			else
			{
				vtxMsg += "Invalid argument.\n";
				vtxMsg += "Usage: m_autobalancebots on|off minbots maxbots ratio\n";
				vtxMsg += "       ratio = is the number of bots for every one human player\n";
				fvoConsolePrint( pst_ptrEdict, vtxMsg );
				return;
			}
		}

		if ( ptxArgList[ 2 ] != "" )
		{
			vclBot.vinMinBots = finStringToInt( ptxArgList[ 2 ] );
		}
		if ( ptxArgList[ 3 ] != "" )
		{
			vclBot.vinMaxBots = finStringToInt( ptxArgList[ 3 ] );
		}
		if ( ptxArgList[ 4 ] != "" )
		{
			vclBot.vflBotHumanRatio = fflStringToFloat( ptxArgList[ 4 ] );
		}

		if ( vclBot.vboBalanceBots == false )
			vtxMsg += "Bot auto balance is off;";
		else
			vtxMsg += "Bot auto balance is on;";

		vtxMsg += " Bots min= ";
		vtxMsg += ftxIntToString( vclBot.vinMinBots );
		vtxMsg += " max= " + ftxIntToString( vclBot.vinMaxBots );
		vtxMsg += "; bot vs human ratio= ";
		vtxMsg += ftxFloatToString( vclBot.vflBotHumanRatio );

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_AutoBalanceBots

//.Server command - allows/disallows specified player to be on bot team;
	void fvoSrvCmd_AllowOnBotTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				// < userid > [ yes | no ]
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_AllowOnBotTeam + " < userid > [ yes | no ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		int vinUserId = finStringToInt( ptxArgList[ 1 ] );

		if ( vinUserId < 1 )
		{
			vtxMsg += "Invalid user ID.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			goto locUsage;
		}
			
		int vinSlotIdx = vclPlayerSlot.finFindSlotById( vinUserId );

		if ( vinSlotIdx < 0 )
		{
			vtxMsg += "User not found.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}
		
		string vtxName = vclPlayerSlot.ftxGetPlayerName( vinSlotIdx );

		if ( ptxArgList[ 2 ] == "yes" )
			vclPlayerSlot.fboSetIsAllowedOnBotTeam( vinSlotIdx, true );
		else 
		if ( ptxArgList[ 2 ] == "no" )
			vclPlayerSlot.fboSetIsAllowedOnBotTeam( vinSlotIdx, false );

		bool vboIsAllowed = vclPlayerSlot.fboIsAllowedOnBotTeam( vinSlotIdx );

		string vtxIsAllowed;

		if ( !vboIsAllowed )
			vtxIsAllowed = "not ";

		vtxMsg += "Player " + vtxName + " is " + vtxIsAllowed + "allowed on the bot team.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_AllowOnBotTeam

//.Server command - allows/disallows specified player to be on clan team;
	void fvoSrvCmd_AllowOnClanTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				// < userid > [ yes | no ]
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_AllowOnClanTeam + " < userid > [ yes | no ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		int vinUserId = finStringToInt( ptxArgList[ 1 ] );

		if ( vinUserId < 1 )
		{
			vtxMsg += "Invalid user ID.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			goto locUsage;
		}
			
		int vinSlotIdx = vclPlayerSlot.finFindSlotById( vinUserId );

		if ( vinSlotIdx < 0 )
		{
			vtxMsg += "User not found.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}
		
		string vtxName = vclPlayerSlot.ftxGetPlayerName( vinSlotIdx );
		
		if ( ptxArgList[ 2 ] == "yes" )
			vclPlayerSlot.fboSetIsAllowedOnClanTeam( vinSlotIdx, cinYes );
		else 
		if ( ptxArgList[ 2 ] == "no" )
			vclPlayerSlot.fboSetIsAllowedOnClanTeam( vinSlotIdx, cinNo );

		bool vboIsAllowed = vclPlayer.fboIsAllowedOnClanTeamByUserId( vinUserId );

		string vtxIsAllowed;

		if ( !vboIsAllowed )
			vtxIsAllowed = "not ";

		vtxMsg += "Player " + vtxName + " is " + vtxIsAllowed + "allowed on the clan team.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_AllowOnClanTeam

//.Server command - allows/disallows specified player to be off the clan team;
	void fvoSrvCmd_AllowOffClanTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				// < userid > [ yes | no ]
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_AllowOffClanTeam + " < userid > [ yes | no ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		int vinUserId = finStringToInt( ptxArgList[ 1 ] );

		if ( vinUserId < 1 )
		{
			vtxMsg += "Invalid user ID.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			goto locUsage;
		}
			
		int vinSlotIdx = vclPlayerSlot.finFindSlotById( vinUserId );

		if ( vinSlotIdx < 0 )
		{
			vtxMsg += "User not found.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}
		
		string vtxName = vclPlayerSlot.ftxGetPlayerName( vinSlotIdx );

		if ( ptxArgList[ 2 ] == "yes" )
			vclPlayerSlot.fboSetIsAllowedOffClanTeam( vinSlotIdx, cinYes );
		else 
		if ( ptxArgList[ 2 ] == "no" )
			vclPlayerSlot.fboSetIsAllowedOffClanTeam( vinSlotIdx, cinNo );

		bool vboIsAllowed = vclPlayer.fboIsAllowedOffClanTeamByUserId( vinUserId );

		string vtxIsAllowed;

		if ( !vboIsAllowed )
			vtxIsAllowed = "not ";

		vtxMsg += "Player " + vtxName + " is " + vtxIsAllowed + "allowed off the clan team.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_AllowOffClanTeam

//.Server command - switches the bot team to the team specified;
	void fvoSrvCmd_SwitchBotTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
		string vtxTeam = ptxArgList[ 1 ];

		if ( ( vtxTeam != "ct" )
				   &&
			  ( vtxTeam != "te" )
					&&
			  ( vtxTeam != "" )
					&&
			  ( vtxTeam != "any" )	)
		{
			vtxMsg += "Invalid team specified. Leave empty to toggle or use CT, TE or ANY.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		int vinNewTeam = cinTeam_Unknown;

		if ( vtxTeam == "any" )
			vinNewTeam = cinTeam_Any;
		else
		if ( vtxTeam == "te" )
			vinNewTeam = cinTeam_TE;
		else
		if ( vtxTeam == "ct" )
			vinNewTeam = cinTeam_CT;

		bool vboResult;

		if ( vinNewTeam == cinTeam_Unknown )
			vboResult = vclBot.fboSwitchBotTeam( );
		else
			vboResult = vclBot.fboSetBotTeam( vinNewTeam );

		if ( vboResult == false )
		{	
			vtxMsg += "The bot team could not be switched as specified.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		if ( vclBot.finGetBotTeam( ) == cinTeam_Any )
			vtxMsg += "Bots and humans can now exist on both teams.";
		else
		if ( vclBot.finGetBotTeam() == cinTeam_TE )
		   vtxMsg += "The bots are now terrorists.";
		else
		if	( vclBot.finGetBotTeam() == cinTeam_CT )
			vtxMsg += "The bots are now counter-terrorists.";
		else
		{
		   vtxMsg += "An error has occured. The bot team is now unknown.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}	

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_SwitchBotTeam

//.Server command - adds a bot to the team specified;
	void fvoSrvCmd_BotAdd( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < number > [ ct | te ]
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_BotAdd + " [ number_of_bots ] [ ct | te ]";
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg + "\n" );
			fvoConsolePrint( pst_ptrEdict, "or" );
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_BotAdd + " [ ct | te ] [ number_of_bots ]";
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		if ( vclBot.vinBotSystem == cinBot_Unknown )
		{
			vtxMsg = ctxMsgPrefix + "Cannot add bots. The bot system is either not loaded or not supported.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		int vinTeam;
		string vtxArg_NumBotsToAdd	= ptxArgList[ 1 ];
		string vtxArg_Team  			= ptxArgList[ 2 ];

		if ( ( vtxArg_NumBotsToAdd == "te" ) || ( vtxArg_NumBotsToAdd == "ct" ) )
		{
			// reverse order;
			vtxArg_NumBotsToAdd = ptxArgList[ 2 ];
			vtxArg_Team = ptxArgList[ 1 ];
		}

		int vinNumBotsToAdd = finStringToInt( vtxArg_NumBotsToAdd );

		if ( vinNumBotsToAdd <= 0 )
			vinNumBotsToAdd = 1;
		else
		if ( vinNumBotsToAdd > cinMaxPlayers )
			vinNumBotsToAdd = cinMaxPlayers;

		if ( vtxArg_Team.empty( ) )
		{	
			vinTeam	   = vclBot.finGetBotTeam( );
			vtxArg_Team = vclPlayer.ftxIntToTeamStrLong( vinTeam );
			if ( ( vinTeam == cinTeam_Any ) 
				       || 
				  ( vinTeam == cinTeam_Unknown ) 
				)
			{
				vinTeam = cinTeam_Any;
				vtxArg_Team = " randomly selected ";
			}
	
		}
		else
		{
			vinTeam = vclPlayer.finTeamStrToInt( vtxArg_Team );

			if ( vinTeam == cinTeam_Unknown )
			{
				vtxMsg = ctxMsgPrefix + "Invalid team. Valid team specifiers are: TE or CT";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
			}

			vtxArg_Team = vclPlayer.ftxIntToTeamStrLong( vinTeam );
		}

		vtxArg_NumBotsToAdd  = ftxIntToString( vinNumBotsToAdd );
		vtxMsg = ctxMsgPrefix + "Adding " + vtxArg_NumBotsToAdd + " bots to team: " + vtxArg_Team;

		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

		int vinNumAdded = vclBot.finAddBots( vinTeam, vinNumBotsToAdd );
		vtxMsg = ctxMsgPrefix + "The bot system was sent " + ftxIntToString( vinNumAdded ) + 
			      " add bot requests out of " + vtxArg_NumBotsToAdd + "\n";
		fvoConsolePrint( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_BotAdd

//.Server command - adds a bot to the team specified;
	void fvoSrvCmd_BotsAdd( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < number > [ ct | te ]
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_BotsAdd + " [ number_of_bots ] [ ct | te ]";
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg + "\n" );
			fvoConsolePrint( pst_ptrEdict, "or" );
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_BotsAdd + " [ ct | te ] [ number_of_bots ]";
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		if ( vclBot.vinBotSystem == cinBot_Unknown )
		{
			vtxMsg = ctxMsgPrefix + "Cannot add bots. The bot system is either not loaded or not supported.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		int vinTeam;
		string vtxArg_NumBotsToAdd	= ptxArgList[ 1 ];
		string vtxArg_Team  			= ptxArgList[ 2 ];

		if ( ( vtxArg_NumBotsToAdd == "te" ) || ( vtxArg_NumBotsToAdd == "ct" ) )
		{
			// reverse order;
			vtxArg_NumBotsToAdd = ptxArgList[ 2 ];
			vtxArg_Team = ptxArgList[ 1 ];
		}

		int vinNumBotsToAdd = finStringToInt( vtxArg_NumBotsToAdd );

		if ( vinNumBotsToAdd <= 0 )
			vinNumBotsToAdd = 1;
		else
		if ( vinNumBotsToAdd > cinMaxPlayers )
			vinNumBotsToAdd = cinMaxPlayers;

		if ( vtxArg_Team.empty( ) )
		{	
			vinTeam	   = vclBot.finGetBotTeam( );
			vtxArg_Team = vclPlayer.ftxIntToTeamStrLong( vinTeam );
			if ( ( vinTeam == cinTeam_Any ) 
				       || 
				  ( vinTeam == cinTeam_Unknown ) 
				)
			{
				vinTeam = cinTeam_Any;
				vtxArg_Team = " randomly selected ";
			}
	
		}
		else
		{
			vinTeam = vclPlayer.finTeamStrToInt( vtxArg_Team );

			if ( vinTeam == cinTeam_Unknown )
			{
				vtxMsg = ctxMsgPrefix + "Invalid team. Valid team specifiers are: TE or CT";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
			}

			vtxArg_Team = vclPlayer.ftxIntToTeamStrLong( vinTeam );
		}

		vtxArg_NumBotsToAdd  = ftxIntToString( vinNumBotsToAdd );
		vtxMsg = ctxMsgPrefix + "Adding " + vtxArg_NumBotsToAdd + " bots to team: " + vtxArg_Team;

		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

		int vinNumAdded = vclBot.finAddBots( vinTeam, vinNumBotsToAdd );
		vtxMsg = ctxMsgPrefix + "The bot system was sent " + ftxIntToString( vinNumAdded ) + 
			      " add bot requests out of " + vtxArg_NumBotsToAdd + "\n";
		fvoConsolePrint( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_BotsAdd

//.Server command - kicks a bot off the team specified;
	void fvoSrvCmd_BotKick( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < number | all > [ ct | te ]
			vtxMsg += "Usage: " + ctxCmd_BotKick + " < number_of_bots > [ ct | te ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		if ( vclBot.vinBotSystem == cinBot_Unknown )
		{
			vtxMsg += "Cannot kick bots. The bot system is either not loaded or not supported.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		int vinTeam;
		string vtxArg_NumBotsToKick = ptxArgList[ 1 ];
		string vtxArg_Team		    = ptxArgList[ 2 ];
		
		int vinNumBotsToKick = finStringToInt( vtxArg_NumBotsToKick );

		if ( vinNumBotsToKick <= 0 )
			vinNumBotsToKick = 1;
		else
		if ( vinNumBotsToKick > cinMaxPlayers )
			vinNumBotsToKick = cinMaxPlayers;

		if ( vtxArg_Team.empty( ) )
		{	
			vinTeam = vclBot.finGetBotTeam( );
			vtxArg_Team = vclPlayer.ftxIntToTeamStrLong( vinTeam );
			if ( ( vinTeam == cinTeam_Any ) 
				       || 
				  ( vinTeam == cinTeam_Unknown ) 
				)
			{
				vinTeam = cinTeam_Any;
				vtxArg_Team = " randomly selected ";
			}

		}
		else
		{
			vinTeam = vclPlayer.finTeamStrToInt( vtxArg_Team );

			if ( vinTeam == cinTeam_Unknown )
			{
				vtxMsg += "Invalid team. Valid team specifiers are: TE or CT";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
			}

			vtxArg_Team = vclPlayer.ftxIntToTeamStrLong( vinTeam );
		}

		int vinNumBotsFound = vclPlayer.finCountBotsOnTeam( vinTeam );

		if ( vinNumBotsToKick > vinNumBotsFound )
			vinNumBotsToKick = vinNumBotsFound;

		string vtxNumBotsFound  = ftxIntToString( vinNumBotsFound );
		vtxArg_NumBotsToKick = ftxIntToString( vinNumBotsToKick );

		vtxMsg += "Kicking " + vtxArg_NumBotsToKick + " out of ";
		vtxMsg += vtxNumBotsFound + " bots from team: " + vtxArg_Team;

		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

		int vinNumKicked = vclBot.finKickBots( vinTeam, vinNumBotsToKick );
		vtxMsg = ctxMsgPrefix + "The bot system kicked " + 
		ftxIntToString( vinNumKicked ) + " out of the requested " + vtxArg_NumBotsToKick + " bots\n";
		fvoConsolePrint( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_BotKick

//.Server command - kicks all bots off the team specified;
	void fvoSrvCmd_BotKickAll( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			vtxMsg += "Usage: " + ctxCmd_BotKickAll + " [ ct | te ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		if ( vclBot.vinBotSystem == cinBot_Unknown )
		{
			vtxMsg += "Cannot kick bots. The bot system is either not loaded or not supported.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		int vinTeam;
		string vtxArg_Team = ptxArgList[ 1 ];
		
		if ( vtxArg_Team.empty( ) )
			vinTeam = cinTeam_Any;
		else
		{
			vinTeam = vclPlayer.finTeamStrToInt( vtxArg_Team );

			if ( vinTeam == cinTeam_Unknown )
			{
				vtxMsg += "Invalid team. Valid team specifiers are: TE or CT";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
			}
			vtxArg_Team = vclPlayer.ftxIntToTeamStrLong( vinTeam );
		}

		int vinNumBotsFound = vclPlayer.finCountBotsOnTeam( vinTeam );

		string vtxNumBotsFound  = ftxIntToString( vinNumBotsFound );
		vtxMsg += "Kicking " + vtxNumBotsFound + " bots from server";

		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

		int vinNumKicked = vclBot.finKickBots( vinTeam, vinNumBotsFound );
		vtxMsg = ctxMsgPrefix + "The bot system kicked " + 
		ftxIntToString( vinNumKicked ) + " out of the requested " + vtxNumBotsFound + " bots\n";
		fvoConsolePrint( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_BotKickAll

//.Server command - displays bot skill;
	void fvoSrvCmd_BotSkill( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( vclBot.vinBotSystem == cinBot_Unknown )
			vtxMsg += "The bot system is either not loaded or not supported.";
		else
			vtxMsg += "The bots skill is set to: " + vclBot.ftxGetBotSkill( );

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_BotSkill

//.Server command - displays what bot system is loaded;
	void fvoSrvCmd_BotSystem( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		vtxMsg += "The bots on this server are: " + vclBot.ftxGetBotSystem( );
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_BotSystem

//.Server command - changes default bot skill;
	void fvoSrvCmd_SetBotSkill( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{

		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			// Usage: m_botskill [ < low|medium|high|random>|<0-100> ]
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_SetBotSkill + " [< " + ctxSkillLowest + " | " + ctxSkillLow + " | " + ctxSkillMed + " | " + ctxSkillHigh + " | " + ctxSkillHighest + " | " + ctxSkillRand + " | " + ctxSkillInsane + " > | < 0 - 100 >]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		if ( vclBot.vinBotSystem == cinBot_Unknown )
		{
			vtxMsg = ctxMsgPrefix + "The command is unavailable. The bot system is either not loaded or not supported.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		string vtxArg_Skill = ptxArgList[ 1 ];
		int vinSkill;

		if (  !vtxArg_Skill.empty( ) )
		{
			if ( vtxArg_Skill == ctxSkillLowest ) 
				vinSkill = cinSkillLowest;
			else
			if ( vtxArg_Skill == ctxSkillLow ) 
				vinSkill = cinSkillLow;
			else
			if ( vtxArg_Skill == ctxSkillMed ) 
				vinSkill = cinSkillMed;
			else
			if ( vtxArg_Skill == ctxSkillHigh )
				vinSkill = cinSkillHigh;
			else
			if ( vtxArg_Skill == ctxSkillHighest ) 
				vinSkill = cinSkillHighest;
			else
			if ( vtxArg_Skill == ctxSkillRand )
				vinSkill = cinSkillRand;
			else
			if ( vtxArg_Skill == ctxSkillInsane )
				vinSkill = cinSkillInsane;
			else				
			{
				vinSkill = finStringToInt( vtxArg_Skill );

				if ( ( vinSkill == 0 ) && ( vtxArg_Skill != "0" ) )
				{
					vtxMsg = ctxMsgPrefix + "Invalid bot skill!";
					fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
					goto locUsage;
				}

				if ( ( vinSkill < cinSkillLowest ) || ( vinSkill > cinSkillMax ) )
				{
					vtxMsg = ctxMsgPrefix + "Bot skill out of range!";
					fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
					goto locUsage;
				}
			}

			if ( !vclBot.fboSetBotSkill( vinSkill ) )
			{
				vtxMsg = ctxMsgPrefix + "The bot system does not support this command.";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
			}
		}

		vtxMsg = ctxMsgPrefix + "The bots skill is set to: " + vclBot.ftxGetBotSkill( );
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_SetBotSkill

//.Server command - forces a randomly selected alive bot to emit a sound;
	void fvoSrvCmd_BotYell( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "Emitting battle cry from a randomly selected bot.\n";
		fvoConsolePrint( pst_ptrEdict, vtxMsg );
		vclBot.fboBotYell( );

	} // fvoSrvCmd_BotYell

	void fvoSrvCmd_ClanTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		int vinClanTeam = vclPlayer.finGetClanTeam( );

		if ( vinClanTeam == cinTeam_TE )
			vtxMsg += "Clan members are on the Terr team. ";
		else
		if ( vinClanTeam == cinTeam_CT )
			vtxMsg += "Clan members are on the CT team. ";
		else
			vtxMsg += "Clan members may join any team. ";

		if ( vclPlayer.vboEnforceClanTeam == false )
			vtxMsg += "Enforcement is not enabled.";
		else
			vtxMsg += "Enforcement is enabled.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_ClanTeam

//.Server command - displays hud message: the bot team and bot team enforcement status;
	void fvoSrvCmd_BotTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		int vinBotTeam = vclBot.finGetBotTeam( );

		if ( vinBotTeam == cinTeam_TE )
			vtxMsg += "Bots are on the Terr team. ";
		else
		if ( vinBotTeam == cinTeam_CT )
			vtxMsg += "Bots are on the CT team. ";
		else
			vtxMsg += "Bots may join both teams. ";

		if (vclBot.vboEnforceBotTeam == false )
			vtxMsg += "Enforcement is OFF";
		else
			vtxMsg += "Enforced when bots in game.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_BotTeam

//.Server command - displays hud message: the human team and enforcement status;
	void fvoSrvCmd_HumanTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
	
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_HumanTeam + "< no arguments >";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				vtxMsg = "To turn enforcement on|off or specify the team,";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				vtxMsg = "use the command " + ctxCmd_EnforceHumanTeam;
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		int vinHumanTeam = vclPlayer.finGetHumanTeam( );

		if ( vinHumanTeam == cinTeam_TE && vclPlayer.vboEnforceHumanTeam )
			vtxMsg += "Humans MUST join Terr team, enforced when bots in game";
		else
		if ( vinHumanTeam == cinTeam_CT && vclPlayer.vboEnforceHumanTeam )
			vtxMsg += "Humans MUST join CT team, enforced when bots in game";
		else
		if ( vclPlayer.vboEnforceHumanTeam )
			vtxMsg += "You may choose the team, enforced when bots in game";
		else
			vtxMsg += "The human team is NOT enforced, you may join any team";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_HumansTeam

//.Server command - specifies the bot mode;
	void fvoSrvCmd_BotMode( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = "Usage: " + ctxCmd_BotMode + " <option> ";
				fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
				vtxMsg = ctxMsgPrefix + "Options:";
				fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
				vtxMsg = "  botvshuman\n  botvsbot\n  humanvshuman\n  botswhenxplayers <xplayers>\n  botsfillserver\n";
				fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
				return;
		}

		string vtxArg_BotMode = ptxArgList[ 1 ];
		vtxMsg += "Bot mode set to: ";

		if ( vtxArg_BotMode == "botvshuman"   ) 
			vclBot.fvoSetBotMode( cinBotMode_BotsvsHumans );
		else
		if ( vtxArg_BotMode == "botvsbot"   ) 
			vclBot.fvoSetBotMode( cinBotMode_BotvsBot );
		else
		if	( vtxArg_BotMode == "humanvshuman" ) 
			vclBot.fvoSetBotMode( cinBotMode_NoBots );		
		else
		if	( vtxArg_BotMode == "botswhenxplayers" ) 
		{
			vclBot.vinBotsWhenMinPlayers = finStringToInt( ptxArgList[ 2 ] );
			vclBot.fvoSetBotMode( cinBotMode_BotsWhenXPlayers );		
		}
		else
		if	( vtxArg_BotMode == "botsfillserver" ) 
			vclBot.fvoSetBotMode( cinBotMode_BotsFillServer );		
		else
		if	( vtxArg_BotMode.empty( ) ) 
			goto locDisplayBotMode;
		else
		{
			vtxMsg = ctxMsgPrefix + "Invalid option\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			goto locUsage;
		}

		locDisplayBotMode:

		int vinBotMode = vclBot.finGetBotMode( );
		if ( vinBotMode == cinBotMode_NoBots )
			vtxMsg += "Human vs Human Play";
		else
		if ( vinBotMode == cinBotMode_BotsvsHumans )
			vtxMsg += "Bot vs Human Play";
		else
		if ( vinBotMode == cinBotMode_BotvsBot )
			vtxMsg += "Bot vs Bot Play";
		else
		if ( vinBotMode == cinBotMode_BotsWhenXPlayers )
			vtxMsg += "Bots present when up to " + ftxIntToString( vclBot.vinBotsWhenMinPlayers ) + " human players are present";
		else
		if ( vinBotMode == cinBotMode_BotsFillServer )
			vtxMsg += "Bots fill server and drop as people join game";
		else
			vtxMsg += "Unknown setting!";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg + "\n" );
		vtxMsg = ctxMsgPrefix + "To keep this bot mode after a map change, use " + ctxCmd_CmdLock + " on";
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

	} // fvoSrvCmd_BotMode

//.Server command - specifies the game settings;
	void fvoSrvCmd_GameMode( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_GameMode + 
				         " < config_filename > ";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		string vtxArg_GameMode = ptxArgList[ 1 ];
		vtxMsg += "Game mode set to: ";

		if ( vtxArg_GameMode == "fun" )
		{
			vtxMsg += " fun";
			vclPlayer.fvoSetGameMode( cinGameMode_Fun );
		}
		else
		if ( vtxArg_GameMode == "serious" )
		{
			vtxMsg += " serious";
			vclPlayer.fvoSetGameMode( cinGameMode_Serious );	
		}
		else
		{
			vtxMsg = ctxMsgPrefix + "Invalid option\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			goto locUsage;
		}

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg + "\n" );
		vtxMsg = ctxMsgPrefix + "To keep this game mode after a map change, use " + ctxCmd_CmdLock + " on";
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

	} // fvoSrvCmd_GameMode

//.Server command - specifies if AFK players are to be kicked or not;
	void fvoSrvCmd_AutoKickAFK( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
		int vinSecs = vclPlayerSlot.vinAutoAFKKickTimeout;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_AutoKickAFK + 
				         " [ on < seconds > | off ] ";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		if ( !ptxArgList[ 1 ].empty( ) )
		{
			if ( fboIsOn( ptxArgList[ 1 ] ) )
			{
				vclPlayerSlot.vboAutoKickAFK = true;

				if ( !ptxArgList[ 2 ].empty( ) )
				{
					vinSecs = finStringToInt( ptxArgList[ 2 ] );

					if ( vinSecs < 60 )
						vinSecs = 60;
					else
					if ( vinSecs > 300 )
						vinSecs = 300;

					vclPlayerSlot.vinAutoAFKKickTimeout = vinSecs;
					vclPlayerSlot.vclTimer_AFK.fvoStart( vinSecs );
				}
			}
			else 
			if ( fboIsOff( ptxArgList[ 1 ] ) )
				vclPlayerSlot.vboAutoKickAFK = false;
			else
				goto locUsage;
		}

		if ( vclPlayerSlot.vboAutoKickAFK == false )
			vtxMsg += "Auto kick AFK players is off.";
		else
			vtxMsg += 
				"Auto kick AFK players is on. Timeout is set to " + 
				ftxIntToString( vinSecs ) + " seconds.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_AutoKickAFK

//.Server command - displays FF status; 
	void fvoSrvCmd_DisplayFF( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		const string ctxFFCVar = "mp_friendlyfire";
		string vtxMsg = ctxMsgPrefix;

		float vflFFSetting = fflCVarGetFloat( ctxFFCVar );

		if ( vflFFSetting == 1.0 )
			vtxMsg += "Be carefull! Friendly Fire is ON";
		else
			vtxMsg += "Friendly Fire is OFF";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_DisplayFF

//.Server command - sets and displays FF status; 
	void fvoSrvCmd_SetFF( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		const string ctxFFCVar = "mp_friendlyfire";
		string vtxMsg = ctxMsgPrefix;

		if ( fboIsOn( ptxArgList[ 1 ] ) )
			fvoCVarSetFloat( ctxFFCVar, 1.0 );
		else
		if ( fboIsOff( ptxArgList[ 1 ] ) )
			fvoCVarSetFloat( ctxFFCVar, 0.0 );

		fvoSrvCmd_DisplayFF( pst_ptrEdict, ptxArgList, ptxArgString );

	} // fvoSrvCmd_SetFF

//.Server command - displays sounds status; 
	void fvoSrvCmd_Sounds( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "Fun sounds are ";

		if ( vclSoundCmdList_Public.fboSoundsAreDisabled( ) )
		{
			vtxMsg += "disabled and cannot be turned on.";
			fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );
			return;
		}

		vtxMsg += "enabled and have been turned ";

		if ( vclSoundCmdList_Public.fboSoundsAreOn( ) )
			vtxMsg += "on";
		else
			vtxMsg += "off";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_Sounds

	void fvoDisplaySoundStatus( string &ptxMsg, string ptxName, tclSoundCmdList pclSoundCmdList )
	{
		ptxMsg += "   " + ptxName;
		if ( pclSoundCmdList.fboSoundsAreDisabled( ) )
			ptxMsg += " disabled";
		else
		{
			ptxMsg += " enabled";

			if ( pclSoundCmdList.fboSoundsAreOn( ) )
				ptxMsg += ", on";
			else
				ptxMsg += ", off";

			if ( pclSoundCmdList.vboAllPrecached )
				ptxMsg += ", precached";
			else
				ptxMsg += ", not precached";
		}
		ptxMsg += "\n";
	} // fvoDisplaySoundStatus

//.Server command - sets and displays sound status; 
	void fvoSrvCmd_SetSounds( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		const string ctxSwitch_1			= "1";
		const string ctxSwitch_0			= "0";
		const string ctxSwitch_On			= "on";
		const string ctxSwitch_Off			= "off";
		const string ctxSwitch_Enabled	= "enabled";
		const string ctxSwitch_Disabled	= "disabled";

		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = "Usage: " + ctxCmd_SetSounds + 
					" <" + ctxSoundSystem_All + "|" + ctxSoundSystem_System + "|" + ctxSoundSystem_Admin + "|" + 
				   ctxSoundSystem_Bot + "|" + ctxSoundSystem_Damage + "|" + ctxSoundSystem_Public + "> [" + 
					ctxSwitch_On + "|" + ctxSwitch_Off + "|" + ctxSwitch_Enabled + "|" + 
				   ctxSwitch_Disabled + "]";

				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		string vtxArg_SoundSystem = ptxArgList[ 1 ];
		string vtxArg_Switch = ptxArgList[ 2 ];

		if ( vtxArg_SoundSystem.empty( ) )
			vtxArg_SoundSystem = ctxSoundSystem_All;

		if ( vtxArg_SoundSystem != ctxSoundSystem_All 
				 &&
			  vtxArg_SoundSystem != ctxSoundSystem_System	
				 &&
			  vtxArg_SoundSystem != ctxSoundSystem_Admin	
				 &&
			  vtxArg_SoundSystem != ctxSoundSystem_Bot	
				 &&
			  vtxArg_SoundSystem != ctxSoundSystem_Damage	
				 &&
			  vtxArg_SoundSystem != ctxSoundSystem_Public	
			)
		{
			vtxMsg = "You must specify a valid sound system - check usage.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}

		if ( vtxArg_Switch.empty( ) )
			goto locDisplayStatus;

		if ( !fboIsOn( vtxArg_Switch ) && !fboIsOff( vtxArg_Switch ) )
		{
			vtxMsg = "You must specify a valid switch setting - check usage.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}

		bool vboSwitch;

		if ( vtxArg_Switch == ctxSwitch_On || vtxArg_Switch == ctxSwitch_Off )
		{
			vboSwitch = ( vtxArg_Switch == ctxSwitch_On );
			if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_System )
				vclSoundCmdList_System.fvoSetSoundsAreOn( vboSwitch );

			if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Admin )
				vclSoundCmdList_Admin.fvoSetSoundsAreOn( vboSwitch );

			if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Bot )
				vclSoundCmdList_BotRandom.fvoSetSoundsAreOn( vboSwitch );

			if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Damage )
				vclSoundCmdList_Damage.fvoSetSoundsAreOn( vboSwitch );

			if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Public )
				vclSoundCmdList_Public.fvoSetSoundsAreOn( vboSwitch );

		}
		else
		{
			vboSwitch = ( vtxArg_Switch == ctxSwitch_Enabled );
			if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_System )
				vclSoundCmdList_System.fvoSetSoundsAreEnabled( vboSwitch );

			if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Admin )
				vclSoundCmdList_Admin.fvoSetSoundsAreEnabled( vboSwitch );

			if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Bot )
				vclSoundCmdList_BotRandom.fvoSetSoundsAreEnabled( vboSwitch );

			if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Damage )
				vclSoundCmdList_Damage.fvoSetSoundsAreEnabled( vboSwitch );

			if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Public )
				vclSoundCmdList_Public.fvoSetSoundsAreEnabled( vboSwitch );
		}

		locDisplayStatus:
		vtxMsg = ctxMsgPrefix + "Sounds for:\n";
		
		if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_System )
			fvoDisplaySoundStatus( vtxMsg, "SYSTEM", vclSoundCmdList_System );

		if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Admin )
			fvoDisplaySoundStatus( vtxMsg, "ADMIN", vclSoundCmdList_Admin );

		if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Bot )
			fvoDisplaySoundStatus( vtxMsg, "BOT", vclSoundCmdList_BotRandom );

		if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Damage )
			fvoDisplaySoundStatus( vtxMsg, "DAMAGE", vclSoundCmdList_Damage );

		if ( vtxArg_SoundSystem == ctxSoundSystem_All || vtxArg_SoundSystem == ctxSoundSystem_Public )
			fvoDisplaySoundStatus( vtxMsg, "PUBLIC", vclSoundCmdList_Public );
		
		fvoConsolePrint( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_SetSounds

//.Server command - displays a list of all active bots; 
	void fvoSrvCmd_ListBots( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
	
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_ListBots + "[ ct | te ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		string vtxArg_Team = ptxArgList[ 1 ];

		if ( vtxArg_Team.empty( ) )
			vtxArg_Team = ctxTeam_Any;

		int vinTeam = vclPlayer.finTeamStrToInt( vtxArg_Team );

		if ( vinTeam == cinTeam_Unknown )
		{
			vtxMsg = ctxMsgPrefix + "Invalid team!";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}
		vclPlayer.fvoListPlayers( pst_ptrEdict, vinTeam, cinBio_Bot );
	} // fvoSrvCmd_ListBots

//.Server command - displays a list of all active humans; 
	void fvoSrvCmd_ListHumans( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
	
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_ListHumans + "[ ct | te ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		string vtxArg_Team = ptxArgList[ 1 ];

		if ( vtxArg_Team.empty( ) )
			vtxArg_Team = ctxTeam_Any;

		int vinTeam = vclPlayer.finTeamStrToInt( vtxArg_Team );

		if ( vinTeam == cinTeam_Unknown )
		{
			vtxMsg = ctxMsgPrefix + "Invalid team!";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}
		vclPlayer.fvoListPlayers( pst_ptrEdict, vinTeam, cinBio_Human );

	} // fvoSrvCmd_ListHumans

//.Server command - displays a list of all active players; 
	void fvoSrvCmd_ListPlayers( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
	
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_ListPlayers + "[ ct | te ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		string vtxArg_Team = ptxArgList[ 1 ];

		if ( vtxArg_Team.empty( ) )
			vtxArg_Team = ctxTeam_Any;

		int vinTeam = vclPlayer.finTeamStrToInt( vtxArg_Team );

		if ( vinTeam == cinTeam_Unknown )
		{
			vtxMsg = ctxMsgPrefix + "Invalid team!";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}
		vclPlayer.fvoListPlayers( pst_ptrEdict, vinTeam, cinBio_Any );

	} // fvoSrvCmd_ListPlayers

//.Server command - disables sound commands for a specified player;
	void fvoSrvCmd_SilencePlayer( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
	
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < userid > < on | off > [ "reason" ]
			vtxMsg += "Usage: " + ctxCmd_SilencePlayer + " < userid > < on | off > [ \"reason\" ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		string vtxArg_UserId = ptxArgList[ 1 ];
		string vtxArg_Switch = ptxArgList[ 2 ];
		string vtxArg_Reason = ptxArgList[ 3 ];

		int vinUserId = finStringToInt( vtxArg_UserId );
		
		if ( vinUserId < 1)
		{
			vtxMsg += "Invalid user ID.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		int vinPlayerSlot = vclPlayerSlot.finFindSlotById( vinUserId );

		if ( vinPlayerSlot < 0 )
		{
			vtxMsg += "Player does not exist.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		string vtxName = vclPlayer.ftxGetPlayerNameByUserId( vinUserId );

		if ( vtxArg_Switch == "" )
		{ // display mute state of player.

			vtxMsg += vtxName;

			if ( vclPlayerSlot.fboPlayerIsSilenced( vinPlayerSlot ) )
				vtxMsg += " is silent.\n";		
			else
				vtxMsg += " is not silent.\n";

			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		bool vboSwitch;
		string vtxState;

		if ( fboIsOn( vtxArg_Switch ) )
		{ // silence player.
			vboSwitch = true;
			vtxState = "silenced";
		}
		else 
		if ( fboIsOff( vtxArg_Switch ) )
		{ // allow player to speak again.
			vboSwitch = false;
			vtxState = "unsilenced";
		}
		else
		{ // invalid switch.
			vtxMsg += "Invalid switch - should be on|off.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		if ( !vtxArg_Reason.empty( ) )
			vtxArg_Reason = ctxMsgPrefix + "The Admin Says: " + vtxArg_Reason + "\n";
		
		if ( !vclPlayerSlot.fboSetPlayerSilenceFlagById( vinUserId, vboSwitch, vtxArg_Reason ) )
		{
			vtxMsg += "Unable to change status of player id " + vtxArg_UserId + ".\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		vtxMsg += "The administrator has " + vtxState + " " + vtxName + ".";
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_SilencePlayer

//.Server command - disables "say" commands for a specified player;
	void fvoSrvCmd_MutePlayer( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < userid > < on | off > ["reason"]
			vtxMsg += "Usage: " + ctxCmd_MutePlayer + " <userid> < on | off > [ \"reason\" ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		string vtxArg_UserId = ptxArgList[ 1 ];
		string vtxArg_Switch = ptxArgList[ 2 ];
		string vtxArg_Reason = ptxArgList[ 3 ];

		int vinUserId = finStringToInt( vtxArg_UserId );
		
		if ( vinUserId < cinMinUserId )
		{
			vtxMsg += "Invalid user ID.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		int vinPlayerSlot = vclPlayerSlot.finFindSlotById( vinUserId );

		if ( vinPlayerSlot < 0 )
		{
			vtxMsg += "Player does not exist.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		string vtxName = vclPlayer.ftxGetPlayerNameByUserId( vinUserId );

		if ( vtxArg_Switch == "" )
		{ // display mute state of player.

			vtxMsg += vtxName;

			if ( vclPlayerSlot.fboPlayerIsMuted( vinPlayerSlot ) )
				vtxMsg += " is mute.\n";		
			else
				vtxMsg += " is not mute.\n";

			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		bool vboSwitch;
		string vtxState;

		if ( fboIsOn( vtxArg_Switch ) )
		{ // mute player.
			vboSwitch = true;
			vtxState = "muted";
		}
		else 
		if ( fboIsOff( vtxArg_Switch ) )
		{ // allow player to speak again.
			vboSwitch = false;
			vtxState = "unmuted";
		}
		else
		{ // invalid switch.
			vtxMsg += "Invalid switch - should be on|off.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}
		
		if ( !vtxArg_Reason.empty( ) )
			vtxArg_Reason = ctxMsgPrefix + "The Admin Says: " + vtxArg_Reason + "\n";

		if ( !vclPlayerSlot.fboSetPlayerMuteFlagById( vinUserId, vboSwitch, vtxArg_Reason ) )
		{
			vtxMsg += "Unable to change status of player id " + vtxArg_UserId + ".\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		vtxMsg += "The administrator has " + vtxState + " " + vtxName + ".";
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_MutePlayer

//.Server command - plants a timebomb on specified player;
	void fvoSrvCmd_TimeBomb( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < userid > < seconds ["reason"] >
			vtxMsg += "Usage: " + ctxCmd_TimeBomb + " < userid > < seconds > [ \"reason\" ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
	
		string vtxArg_UserId  = ptxArgList[ 1 ];
		string vtxArg_Seconds = ptxArgList[ 2 ];
		string vtxArg_Reason	 = ptxArgList[ 3 ];

		int vinUserId = finStringToInt( vtxArg_UserId );
		
		if ( vinUserId < cinMinUserId )
		{
			vtxMsg += "Invalid user id.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		int vinTimerInSec = finStringToInt ( vtxArg_Seconds );

		if ( !vtxArg_Reason.empty( ) )
			vtxArg_Reason = ctxMsgPrefix + "The Admin Says: " + vtxArg_Reason + "\n";

		if ( vclTimeBomb.fboPlantTimeBombOnUser( vinUserId, vinTimerInSec, vtxArg_Reason ) == false )
		{
			vtxMsg += "Cannot plant time bomb. Player is either dead or does not exist.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		string vtxName = vclPlayer.ftxGetPlayerNameByUserId( vinUserId );

		if ( vtxName.empty( ) )
			vtxName = "user id " + vtxArg_UserId;

		if ( vinTimerInSec == 0 )
			vtxMsg += "The time bomb has been removed from " + vtxName + ".\n";
		else
			vtxMsg += "A " + ftxIntToString( vinTimerInSec ) + 
						 " second time bomb has been planted on " + vtxName;
		
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_TimeBomb

//.Server command - slaps specified player;
	void fvoSrvCmd_SlapPlayer( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{

		string vtxMsg;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			// < userid | all > [ soft | hard | bitch ] [numslaps] ["reason"]
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_SlapPlayer + " < userid | all | bots | humans > [ soft | hard | bitch ] [numslaps] [\"reason\"]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
	
		string vtxArg_UserId  = ptxArgList[ 1 ];
		string vtxArg_SlapHow = ptxArgList[ 2 ];
		string vtxArg_Repeat  = ptxArgList[ 3 ];
		string vtxArg_Reason  = ptxArgList[ 4 ];

		if ( !vtxArg_Reason.empty( ) )
			vtxArg_Reason = ctxMsgPrefix + "The Admin Says: " + vtxArg_Reason + "\n";
		
		int vinUserId;

		if ( vtxArg_UserId ==  "all" || vtxArg_UserId ==  "bots" || vtxArg_UserId ==  "humans" )
		{
			vinUserId = 0;
		}
		else
		{
			vinUserId = finStringToInt( vtxArg_UserId );
			if ( vinUserId < cinMinUserId )
			{
				vtxMsg = ctxMsgPrefix + "Invalid user id.\n";
				fvoConsolePrint( pst_ptrEdict, vtxMsg );
				goto locUsage;
			}
		}

		int vboSlapHard;
		int vinEffect = cinEffect_AdminSlap;

		if ( ( vtxArg_SlapHow == "soft" ) || ( vtxArg_SlapHow.empty( ) ) )
			vboSlapHard = false;
		else
		if ( vtxArg_SlapHow == "hard" )
			vboSlapHard = true;
		else
		if ( vtxArg_SlapHow == "bitch" )
		{
			vboSlapHard = true;
			vinEffect = cinEffect_BitchSlap;
		}
		else
		{
			vtxMsg = ctxMsgPrefix + "Invalid slap specifier.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			goto locUsage;
		}

		int vinRepeat = finStringToInt( vtxArg_Repeat );
		if ( !vtxArg_Repeat.empty( ) )
		{
			vinRepeat = finStringToInt( vtxArg_Repeat );
			if ( vinRepeat <= 0 )
			{
				vtxMsg = ctxMsgPrefix + "Invalid number_of_times value.\n";
				fvoConsolePrint( pst_ptrEdict, vtxMsg );
				goto locUsage;
			}
		}
		else
			vinRepeat = 1;
		
		string vtxPlayerName;

		if ( vinUserId == 0 )
		{
			int vinBio;
			if ( vtxArg_UserId ==  "all"    ) { vtxMsg = ctxMsgPrefix + "All players"; vinBio = cinBio_Any; }
			if ( vtxArg_UserId ==  "bots"   ) { vtxMsg = ctxMsgPrefix + "All bots"; vinBio = cinBio_Bot; }
			if ( vtxArg_UserId ==  "humans" ) { vtxMsg = ctxMsgPrefix + "All humans"; vinBio = cinBio_Human; }
	
			vclPlayer.fvoSlapAll( vinBio, vboSlapHard, vinEffect, vinRepeat, vtxArg_Reason );
			goto locDisplayMsg;
		}

		if ( !vclPlayer.fboSlapPlayerByUserId( 
								vinUserId, 
								vboSlapHard, 
								vinEffect, 
								vinRepeat, 
								vtxArg_Reason ) )
		{
				vtxMsg = ctxMsgPrefix + "Player is either dead or does not exist.";
				fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
				return;
		}
		
		vtxPlayerName = vclPlayer.ftxGetPlayerNameByUserId( vinUserId );
		if ( vtxPlayerName.empty( ) )
			vtxMsg = ctxMsgPrefix + "Player";
		else
			vtxMsg = ctxMsgPrefix + vtxPlayerName;

		locDisplayMsg:
		
		vtxMsg += " will get " + ftxIntToString( vinRepeat ) + " ";

		if ( vboSlapHard )
			 vtxMsg += "real hard ";

		if ( vinEffect == cinEffect_BitchSlap )
			vtxMsg += "bitch ";

		if ( vinRepeat <= 1 )
			vtxMsg += "slap";
		else
			vtxMsg += "slaps";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

		locTrace:
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			

	} // fvoSrvCmd_SlapPlayer

//.Server command - kills specified player or players, includes bots;
	void fvoSrvCmd_KillPlayer( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < userid | all | ct | te > [ "reason" ]
			vtxMsg += "Usage: " + ctxCmd_KillPlayer + " < userid | all | ct | te > [ \"reason\" ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		string vtxArg_UserId_or_Team	= ptxArgList[ 1 ];
		string vtxArg_Reason				= ptxArgList[ 2 ];

		if ( !vtxArg_Reason.empty( ) )
			vtxArg_Reason = ctxMsgPrefix + "The Admin Says: " + vtxArg_Reason + "\n";

		if ( vtxArg_UserId_or_Team == "all" )
		{
			// Kill all players.
			vclPlayer.fvoKillAllPlayers( cinTeam_Any, /* vboExcludeBots */ false, vtxArg_Reason );
			vtxMsg += "All players were killed by the Administrator.";
		}
		else 
		if ( vtxArg_UserId_or_Team == "ct" )
		{
			// Kill all players.
			vclPlayer.fvoKillAllPlayers( cinTeam_CT,  /* vboExcludeBots */ false, vtxArg_Reason );
			vtxMsg += "All players on counter-terrorist team were killed by the Administrator.";
		}
		else 
		if ( vtxArg_UserId_or_Team == "te" )
		{
			// Kill all players.
			vclPlayer.fvoKillAllPlayers( cinTeam_TE,  /* vboExcludeBots */ false, vtxArg_Reason );
			vtxMsg += "All players on terrorist team were killed by the Administrator.";
		}
		else 
		if ( vtxArg_UserId_or_Team == "" )
		{
			vtxMsg += "Missing user id.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}
		else
		{
			int vinUserId = finStringToInt( vtxArg_UserId_or_Team );

			if ( vinUserId < cinMinUserId )
			{
				vtxMsg += "Invalid user id.\n";
				fvoConsolePrint( pst_ptrEdict, vtxMsg );
				return;
			}
			
			if ( vclPlayer.fboKillPlayerByUserId( vinUserId, vtxArg_Reason ) ==  false )
			{
				vtxMsg += "User not found or could not be killed.\n";
				fvoConsolePrint( pst_ptrEdict, vtxMsg );
				return;
			}
			
			string vtxName = vclPlayer.ftxGetPlayerNameByUserId( vinUserId );
		
			if ( vtxName.empty( ) )
				vtxName = "User id " + vtxArg_UserId_or_Team;
		
			vtxMsg += vtxName + " was killed by the Administrator";
		}

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_KillPlayer

//.Server command - kills only bots;
	void fvoSrvCmd_KillBots( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < all | ct | te > 
			vtxMsg += "Usage: " + ctxCmd_KillBots + " < all | ct | te >";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		string vtxArg_Team = ptxArgList[ 1 ];

		if ( vtxArg_Team == "all" || vtxArg_Team.empty( ) )
		{
			// Kill all bots.
			vclBot.finKillAllBots( cinTeam_Any );
			vtxMsg += "All bots were killed by the Administrator.";
		}
		else 
		if ( vtxArg_Team == "ct" )
		{
			// Kill all players.
			vclBot.finKillAllBots( cinTeam_CT );
			vtxMsg += "All bots on counter-terrorist team were killed by the Administrator.";
		}
		else 
		if ( vtxArg_Team == "te" )
		{
			// Kill all players.
			vclBot.finKillAllBots( cinTeam_TE );
			vtxMsg += "All bots on terrorist team were killed by the Administrator.";
		}
		else 
		{
			vtxMsg += "Invalid team specifier. Use: ALL, TE or CT.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}
			
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_KillBots

//.Server command - kills only human players;
	void fvoSrvCmd_KillHumans( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < all | ct | te > [ "reason" ]
			vtxMsg += "Usage: " + ctxCmd_KillHumans + " < all | ct | te > [ \"reason\" ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		string vtxArg_Team	= ptxArgList[ 1 ];
		string vtxArg_Reason	= ptxArgList[ 2 ];

		if ( !vtxArg_Reason.empty( ) )
			vtxArg_Reason = ctxMsgPrefix + "The Admin Says: " + vtxArg_Reason + "\n";

		if ( vtxArg_Team == "all" || vtxArg_Team.empty( ) )
		{
			// Kill all bots.
			vclPlayer.fvoKillAllHumans( cinTeam_Any, vtxArg_Reason );
			vtxMsg += "All humans were killed by the Administrator.";
		}
		else 
		if ( vtxArg_Team == "ct" )
		{
			// Kill all players.
			vclPlayer.fvoKillAllHumans( cinTeam_CT, vtxArg_Reason );
			vtxMsg += "All humans on counter-terrorist team were killed by the Administrator.";
		}
		else 
		if ( vtxArg_Team == "te" )
		{
			// Kill all players.
			vclPlayer.fvoKillAllHumans( cinTeam_TE, vtxArg_Reason );
			vtxMsg += "All humans on terrorist team were killed by the Administrator.";
		}
		else 
		{
			vtxMsg += "Invalid team specifier. Use: ALL, TE or CT.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}
			
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_KillHumans

//.Server command - kicks specified player;
	void fvoSrvCmd_KickPlayer( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < userid | all | ct | te > [ "reason" ]
			vtxMsg += "Usage: " + ctxCmd_KickPlayer + " < userid | all | ct | te > [ \"reason\" ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		string vtxArg_UserId_or_Team	= ptxArgList[ 1 ];
		string vtxArg_Reason				= ptxArgList[ 2 ];
	
		if ( vtxArg_Reason.empty( ) )
			vtxArg_Reason += " You were kicked by the administrator.";
		
		vtxArg_Reason = "\n\n" + ctxMsgPrefix + "The Admin Says: " + vtxArg_Reason + "\n\n";

		if ( vtxArg_UserId_or_Team == "all" )
		{
			// Kill all players.
			vclPlayer.fvoKickAllPlayers( cinTeam_Any, /* vboExcludeBots */ false, vtxArg_Reason );
			vtxMsg += "All players were kicked by the Administrator.";
		}
		else 
		if ( vtxArg_UserId_or_Team == "ct" )
		{
			// Kill all players.
			vclPlayer.fvoKickAllPlayers( cinTeam_CT,  /* vboExcludeBots */ false, vtxArg_Reason );
			vtxMsg += "All players on counter-terrorist team were kicked by the Administrator.";
		}
		else 
		if ( vtxArg_UserId_or_Team == "te" )
		{
			// Kill all players.
			vclPlayer.fvoKickAllPlayers( cinTeam_TE,  /* vboExcludeBots */ false, vtxArg_Reason );
			vtxMsg += "All players on terrorist team were kicked by the Administrator.";
		}
		else 
		if ( vtxArg_UserId_or_Team == "" )
		{
			vtxMsg += "Missing user id.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}
		else
		{
			int vinUserId = finStringToInt( vtxArg_UserId_or_Team );

			if ( vinUserId < cinMinUserId )
			{
				vtxMsg += "Invalid user id.\n";
				fvoConsolePrint( pst_ptrEdict, vtxMsg );
				return;
			}
		
			if ( vclPlayer.fboKickPlayerByUserId( vinUserId, vtxArg_Reason ) ==  false )
			{
				vtxMsg += "User not found or could not be kicked.\n";
				fvoConsolePrint( pst_ptrEdict, vtxMsg );
				return;
			}
			
			string vtxName = vclPlayer.ftxGetPlayerNameByUserId( vinUserId );
		
			if ( vtxName.empty( ) )
				vtxName = "User id " + vtxArg_UserId_or_Team;
		
			vtxMsg += vtxName + " was kicked by the Administrator";
		}

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_KickPlayer

//.Server command - Ban specified player;
	void fvoSrvCmd_BanPlayer( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < userid > < mins > [ "reason" ]
			vtxMsg += "Usage: " + ctxCmd_BanPlayer + " < userid > < mins > [ \"reason\" ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		string vtxArg_UserId	= ptxArgList[ 1 ];
		string vtxArg_Mins	= ptxArgList[ 2 ];
		string vtxArg_Reason	= ptxArgList[ 3 ];

		int vinMins;

		if ( vtxArg_Mins.empty( ) )
		{
			vtxMsg += "You must specify in minutes how long the ban will last. Use 0 for a permanent ban.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

		vinMins = finStringToInt( vtxArg_Mins );

		if ( ( ( vtxArg_Mins != "0" ) 
						&& 
				 ( vinMins == 0       ) 
				) 
					|| 
				( vinMins < 0         ) 
			 )
		{
			vtxMsg += "The number of minutes specified is invalid.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		} 

		if ( vinMins > 2880 )
			vinMins = 2880;

		int vinUserId = finStringToInt( vtxArg_UserId );

		if ( vinUserId < cinMinUserId )
		{
			vtxMsg += "Invalid user id.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}
		
		if ( vclPlayer.fboBanPlayerByUserId( vinUserId, vinMins, vtxArg_Reason, pst_ptrEdict ) ==  false )
		{
			vtxMsg += "User not found or could not be banned.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}
			
		string vtxName = vclPlayer.ftxGetPlayerNameByUserId( vinUserId );

		if ( vtxName.empty( ) )
			vtxName = "<name_not_available>";
	
		vtxMsg += vtxName + " was ";
		if ( vinMins == 0 )
			vtxMsg += "permanently banned ";
		else
			vtxMsg += "banned for " + ftxIntToString( vinMins ) + " minutes ";

		vtxMsg += "by the Administrator.\n";
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

		edict_t* vst_ptrEdict = vclPlayer.fst_ptrGetPlayerByUserId( vinUserId );
		string vtxAuthId = ftxGetPlayerAuthId( vst_ptrEdict );
		vtxMsg = "  Banned Steam Id: " + vtxAuthId;
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
		vtxMsg = "\n" + ctxMsgPrefix + "  To unban, run command:" + " m_unbanplayer " + vtxAuthId;
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
/*		
		vtxMsg = "Banned by Admin \"" + vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );
		vtxMsg += "\", Ban Time (mins) = " + ftxIntToString( vinMins );
		vtxMsg += ", SteamId = " + vtxAuthId + ", UserId = " + vtxArg_UserId + ", UserName = \"" + vtxName + "\"" + ", Reason: \"" + ptxArgList[ 3 ] + "\"" ;
		vclClientBanLog.fvoWriteEventInfo( vtxMsg );
*/
	} // fvoSrvCmd_BanPlayer

//.Server command - unban specified player;
	void fvoSrvCmd_UnbanPlayer( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < userid > < mins > [ "reason" ]
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_UnbanPlayer + " < \"FullSteamId\" >";
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
			return;
		}

		string vtxArg_AuthId = ftxToUpper( ptxArgList[ 1 ] );

		if ( vtxArg_AuthId.empty( ) )
		{
			vtxMsg = ctxMsgPrefix + "You must specify a valid Steam Id that is in the ban list.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return;
		}

//		unsigned int vinAuthId = finStringToUInt( vtxArg_AuthId );
//
//		if ( ( vtxArg_AuthId != "0" ) && ( vinAuthId == 0 ) )
//		{
//			vtxMsg = ctxMsgPrefix + "The Steam Id specified is invalid.\n";
//			fvoConsolePrint( pst_ptrEdict, vtxMsg );
//			return;
//		} 

		fvoServerCommand_nl( "removeid " + vtxArg_AuthId );
		fvoServerCommand_nl( "writeid" );

		vtxMsg = ctxMsgPrefix + "Steam Id " + vtxArg_AuthId + " was removed from the ban list.";
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
		vtxMsg = "NOTE: There is no check to ensure that the Steam Id was in the ban list!";
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

		vtxMsg = "Unbanned by Admin \"" + vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );
		vtxMsg += "\", Steam Id = " + vtxArg_AuthId;
		vclClientBanLog.fvoWriteEventInfo( vtxMsg );

	} // fvoSrvCmd_UnbanPlayer

//.Server command - plays a message from admin to player;
	void fvoSrvCmd_AdminSpeak( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
		string vtxArg_UserId   = ptxArgList[ 1 ];
		string vtxArg_SoundCmd = ptxArgList[ 2 ];

		if ( ( vtxArg_UserId.empty( ) ) || ( vtxArg_SoundCmd.empty( ) ) )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_AdminSpeak + " < userid > < \"sound_command\" >";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				vclSoundCmdList_Admin.fvoListSounds( pst_ptrEdict );
				return;
		}

		string vtxSoundFile = vclSoundCmdList_Admin.ftxGetSoundFile( vtxArg_SoundCmd );

		if ( vtxSoundFile.empty( ) )
		{
			vtxMsg = ctxMsgPrefix + "The sound command specified is not valid.\n";
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			goto locUsage;
		}

		fboEmitSoundFromPlayer( pst_ptrEdict, vtxArg_UserId, vtxSoundFile );

	} // fvoSrvCmd_AdminSpeak

//.Server command - displays a text message from the admin;
	void fvoSrvCmd_Say( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ptxArgString;
		if ( vtxMsg.empty( ) )
			return;
		
		string vtxName;
		vtxMsg = ptxArgString; 

		if ( pst_ptrEdict != NULL )
			vtxName = vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );
		else
			vtxName = "Server Operator";
		
		vclHUD.fvoCenterSay( vtxMsg, false );
		vtxMsg = ctxCmd_Say + " " + vtxName + ": " + vtxMsg;
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_Say

//.Server command - displays a text message from the admin;
	void fvoSrvCmd_SayName( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ptxArgString;
		if ( vtxMsg.empty( ) )
			return;
		
		string vtxName;

		vtxMsg = ptxArgString; 
		vclHUD.fvoISay( pst_ptrEdict, vtxMsg );
		if ( pst_ptrEdict == NULL )
			vtxName = "Server Operator";
		else
			vtxName = vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );

		fvoConsolePrint_nl( pst_ptrEdict, vtxName + " says:" );
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_SayName

//.Server command - displays a text message from the admin;
	void fvoSrvCmd_SayRed( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ptxArgString;
		if ( vtxMsg.empty( ) )
			return;
		
		string vtxName;
		vtxMsg = ptxArgString; 
		vclHUD.fvoCenterSayRed( vtxMsg, false );

		if ( pst_ptrEdict == NULL )
			vtxName = "Server Operator";
		else
			vtxName = vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );

		vtxMsg = ctxCmd_SayRed + " " + vtxName + ": " + vtxMsg;
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_SayRed

//.Server command - displays a text message from the admin;
	void fvoSrvCmd_SayBlue( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ptxArgString;
		if ( vtxMsg.empty( ) )
			return;

		string vtxName;
		vtxMsg = ptxArgString; 
		vclHUD.fvoCenterSayBlue( vtxMsg, false );

		if ( pst_ptrEdict == NULL )
			vtxName = "Server Operator";
		else
			vtxName = vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );

		vtxMsg = ctxCmd_SayBlue + " " + vtxName + ": " + vtxMsg;
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_SayBlue

//.Server command - displays a text message from the admin;
	void fvoSrvCmd_SayGreen( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ptxArgString;
		if ( vtxMsg.empty( ) )
			return;

		string vtxName;
		vtxMsg = ptxArgString; 
		vclHUD.fvoStatusSay( vtxMsg, false );

		if ( pst_ptrEdict == NULL )
			vtxName = "Server Operator";
		else
			vtxName = vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );

		vtxMsg = ctxCmd_SayGreen + " " + vtxName + ": " + vtxMsg;
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_SayGreen

//.Server command - displays the next map name in cycle;
	void fvoSrvCmd_NextMap( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = vclMap.ftxGetNextMapName( );

		if ( vtxMsg.empty( ) )
			vtxMsg = ctxMsgPrefix + "The next map name is not available";
		else
			vtxMsg = ctxMsgPrefix + "The next map will be " + vtxMsg;

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );
		fvoClientPrintChatAll( vtxMsg + "\n" );

	} // fvoSrvCmd_NextMap

//.Server command - displays the currently loaded map name;
	void fvoSrvCmd_MapName( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = vclMap.ftxGetMapName( );
		if ( vtxMsg.empty( ) )
			vtxMsg = ctxMsgPrefix + "The current map name is not available";
		else
			vtxMsg = ctxMsgPrefix + "The current map name is " + vtxMsg;

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_MapName

	void fvoSrvCmd_MapList( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclMap.fvoListMaps( pst_ptrEdict );
	} // fvoSrvCmd_MapList

//.Server command - displays the maximum number of players allowed;
	void fvoSrvCmd_MaxPlayers( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		int vinMaxPlayers = vclGlobalGameInfo.finGetMaxPlayers( );
		string vtxMsg =
			ctxMsgPrefix + "The maximum number of players is " + ftxIntToString( vinMaxPlayers );

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_MaxPlayers

//.Server command - displays the time remaining before next map cycle;
	void fvoSrvCmd_TimeLeft( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
		string vtxTimeLeft = vclMap.ftxGetTimeLeftAsString( );

		if ( vtxTimeLeft == ctxNoMapTimeOut )
			vtxMsg += "Map has no time limit set";
		else
			vtxMsg += "Map will change in " + vtxTimeLeft + " (hh:mm:ss)";

		if ( pst_ptrEdict == NULL )
		// command executed from server console. Deliver estimated time
		// remaining.
			fvoServerPrint( vtxMsg  + "\n" );
		else
		{
//			fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );
//			fvoClientPrintChatAll( vtxMsg + "\n" );
			fvoExecClientCommand( pst_ptrEdict, "timeleft" );
		}
	} // fvoSrvCmd_TimeLeft

//.Server command - displays the server IP address and port;
	void fvoSrvCmd_ServerIP( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "The servers IP address is ";
		string vtxIP;
		
		vtxIP = ftxCVarGetString( "ip" );

		if ( !vtxIP.empty( ) )
		{
			string vtxPort = ftxCVarGetString( "port" );	
			if ( !vtxPort.empty( ) )
				vtxPort = ":" + vtxPort;

			vtxIP = vtxIP + vtxPort;
		}
		else
			vtxIP = ftxCVarGetString( "net_address" );
			
		if ( vtxIP.empty( ) )
			vtxMsg += " not available";
		else
			vtxMsg += vtxIP;

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );
		fvoClientPrintChatAll( vtxMsg + "\n" );

	} // fvoSrvCmd_ServerIP

	void fvoSrvCmd_SayListAdmins( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		int vinAdminCount = vclSecurity.finListAdmins( pst_ptrEdict );
		string vtxMsg = ctxMsgPrefix + "There ";
		if ( vinAdminCount <= 0 )
			vtxMsg += "are currently no admins in game.";
		else
		if ( vinAdminCount >= 1 )
		{
			if ( vinAdminCount == 1 )
				vtxMsg += "is ";
			else
				vtxMsg += "are ";

			vtxMsg += ftxIntToString( vinAdminCount );

			if ( vinAdminCount == 1 )
				vtxMsg += " admin ";
			else
				vtxMsg += " admins ";

			vtxMsg += " in game. For the list, type " + ctxCmd_ListAdmins + " in console.";
		}
	
		vclHUD.fvoStatusSay( vtxMsg );
	
	} // fvoSrvCmd_SayListAdmins

	void fvoSrvCmd_ListAdmins( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclSecurity.finListAdmins( pst_ptrEdict );
	} // fvoSrvCmd_ListAdmins

	void fvoSrvCmd_UseRank( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_UseRank + " [ on | off ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		if ( !ptxArgList[ 1 ].empty( ) )
		{
			if ( fboIsOn( ptxArgList[ 1 ] ) )
				vclWeapon.fvoSetUseRank( true );
			else
			if ( fboIsOff( ptxArgList[ 1 ] ) ) 
				vclWeapon.fvoSetUseRank( false );
			else
				goto locUsage;
		}
		
		vtxMsg = ctxMsgPrefix;

		if ( vclWeapon.fboUseRank( ) )
			vtxMsg += "Bots will buy highest ranking weapons whenever possible.";
		else
			vtxMsg += "Bots will not use weapons rank when buying.";

		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
	
	} // fvoSrvCmd_UseRank

//.Server command - displays the current war mode in effect;
	void fvoSrvCmd_WarMode( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_WarMode

//.Server command - sets the current war mode in effect;
	void fvoSrvCmd_SetWarMode( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_WarMode + " [ all | noone | bots | humans | clan | world | clanteam | worldteam ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				vtxMsg = "To accumulate who is restricted, place + in front of the tag, example: m_warmode +humans";
				return;
		}

		if ( ptxArgList[ 1 ] == "everyone" 
					|| 
			  ptxArgList[ 1 ] == "all" 
					|| 
			  ptxArgList[ 1 ] == "+everyone" 
					|| 
			  ptxArgList[ 1 ] == "+all" 
			)
			vclWeapon.fvoSetGlobalWeaponBanFlag( cinBan_All );
		else
		if ( ptxArgList[ 1 ] == "noone" || ptxArgList[ 1 ] == "+noone" )
			vclWeapon.fvoSetGlobalWeaponBanFlag( cinBan_Off );
		else
		if ( ptxArgList[ 1 ] == "bots" )
			vclWeapon.fvoSetGlobalWeaponBanFlag( cinBan_Bots );
		else
		if ( ptxArgList[ 1 ] == "humans" )
			vclWeapon.fvoSetGlobalWeaponBanFlag( cinBan_Humans );
		else
		if ( ptxArgList[ 1 ] == "clan" )
			vclWeapon.fvoSetGlobalWeaponBanFlag( cinBan_Clan );
		else
		if ( ptxArgList[ 1 ] == "world" )
			vclWeapon.fvoSetGlobalWeaponBanFlag( cinBan_World );
		else
		if ( ptxArgList[ 1 ] == "clanteam" )
			vclWeapon.fvoSetGlobalWeaponBanFlag( cinBan_ClanTeam );
		else
		if ( ptxArgList[ 1 ] == "worldteam" )
			vclWeapon.fvoSetGlobalWeaponBanFlag( cinBan_WorldTeam );
		else
		if ( ptxArgList[ 1 ] == "+bots" )
			vclWeapon.fvoSetGlobalWeaponBanFlagBit_On( cinBan_Bots );
		else
		if ( ptxArgList[ 1 ] == "+humans" )
			vclWeapon.fvoSetGlobalWeaponBanFlagBit_On( cinBan_Humans );
		else
		if ( ptxArgList[ 1 ] == "+clan" )
			vclWeapon.fvoSetGlobalWeaponBanFlagBit_On( cinBan_Clan );
		else
		if ( ptxArgList[ 1 ] == "+world" )
			vclWeapon.fvoSetGlobalWeaponBanFlagBit_On( cinBan_World );
		else
		if ( ptxArgList[ 1 ] == "+clanteam" )
			vclWeapon.fvoSetGlobalWeaponBanFlagBit_On( cinBan_ClanTeam );
		else
		if ( ptxArgList[ 1 ] == "+worldteam" )
			vclWeapon.fvoSetGlobalWeaponBanFlagBit_On( cinBan_WorldTeam );
		else
		if ( ptxArgList[ 1 ] != "" )
			goto locUsage;

		fvoHUDWarModeDisplay( pst_ptrEdict );
		
	} // fvoSrvCmd_WarMode

//.Server command - displays the current bot damage mode in effect;
	void fvoSrvCmd_BotDamage( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "Bot damage reduction is at ";
		vtxMsg += ftxFloatToString( vclWeapon.fflGetDamageReduction( ) * 100, 0 ) + " percent";
		vclHUD.fvoStatusSay( vtxMsg );

	} // fvoSrvCmd_BotDamage

//.Server command - displays the current war mode in effect;
	void fvoSrvCmd_SetBotDamage( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_BotDamage + " [ 0.0 - 1.0 ]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		if ( ptxArgList[ 1 ] != "" )
		{
			float vflBotDamage = fflStringToFloat( ptxArgList[ 1 ] );
			vclWeapon.fvoSetDamageReduction( vflBotDamage );
		}

		vtxMsg = ctxMsgPrefix + "Bot damage reduction is at ";
		vtxMsg += ftxFloatToString( vclWeapon.fflGetDamageReduction( ) * 100, 0 ) + " percent";
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_SetBotDamage

//. returns the current headshot mode message in effect;
	string ftxGetHeadShotMode( )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( vclPlayer.finGetHeadShotMode( ) == cinHeadShot_Off )
		{
			locError:
			vtxMsg += "Head shot restriction is turned OFF - all body parts will take damage";
		}
		else
		if ( vclPlayer.finGetHeadShotMode( ) == cinHeadShot_Bot )
			vtxMsg += "BOTS must be hit in the head to take damage!";
		else
		if ( vclPlayer.finGetHeadShotMode( ) == cinHeadShot_Human )
			vtxMsg += "HUMANS must be hit in the head to take damage!";
		else
		if ( vclPlayer.finGetHeadShotMode( ) == cinHeadShot_Clan )
			vtxMsg += "CLAN TEAM must be hit in the head to take damage!";
		else
		if ( vclPlayer.finGetHeadShotMode( ) == cinHeadShot_World )
			vtxMsg += "WORLD TEAM must be hit in the head to take damage!";
		else
		if ( vclPlayer.finGetHeadShotMode( ) == cinHeadShot_All )
			vtxMsg += "All players must be hit in the head to take damage!";
		else
			goto locError;

		return vtxMsg;

	} // ftxGetHeadShotMode

//.Server command - displays the current headshot mode in effect;
	void fvoSrvCmd_HeadShot( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclHUD.fvoStatusSay( ftxGetHeadShotMode( ) );
	} // fvoSrvCmd_HeadShot

//.Server command - sets the current headshot mode in effect;
	void fvoSrvCmd_SetHeadShot( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_HeadShot + " [off | bot | human | clan | world | all]";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		if ( ptxArgList[ 1 ] != "" )
		{
			string vtxHSMode = ptxArgList[ 1 ];
			int vinHSMode;
			if ( fboIsOff( vtxHSMode ) ) vinHSMode = cinHeadShot_Off;
			else
			if ( vtxHSMode == "bot" ) vinHSMode = cinHeadShot_Bot;
			else
			if ( vtxHSMode == "human" ) vinHSMode = cinHeadShot_Human;
			else
			if ( vtxHSMode == "clan" ) vinHSMode = cinHeadShot_Clan;
			else
			if ( vtxHSMode == "world" ) vinHSMode = cinHeadShot_World;
			else
			if ( vtxHSMode == "all" ) vinHSMode = cinHeadShot_All;
			else
				goto locUsage;

			vclPlayer.fvoSetHeadShotMode( vinHSMode );
		}
	
		fvoHUDStatusDisplay( pst_ptrEdict, ftxGetHeadShotMode( ) );

	} // fvoSrvCmd_SetHeadShot

//.Server command - sets the current weapon ban penalty in effect;
	void fvoSrvCmd_WeapBanPenalty( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_WeapBanPenalty + " <option> [amount}";
				fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
				vtxMsg = ctxMsgPrefix + "Options:";
				fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
				vtxMsg = "  off\n  health_reduced\n  health_dropped\n  timebomb\n  slap_soft\n  slap_hard\n  slap_bitch\n  explode\n  random\n";
				fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
				return;
		}

		if ( ptxArgList[ 1 ] != "" )
		{
			string vtxMode = ptxArgList[ 1 ];
			string vtxAmount = ptxArgList[ 2 ];
			int vinAmount = finStringToInt( vtxAmount );

			if ( vtxMode != "off" 
					&&
				  vtxMode != "health_reduced"
					&&
				  vtxMode != "health_dropped"
					&&
				  vtxMode != "health_reduced"
					&&
				  vtxMode != "timebomb"
					&&
				  vtxMode != "slap_soft"
					&&
				  vtxMode != "slap_hard"
					&&
				  vtxMode != "slap_bitch"
					&&
				  vtxMode != "explode"
					&&
				  vtxMode != "random"
				)
				goto locUsage;

			fvoCVarSetString( ctxCVar_WeaponBanPenalty, vtxMode );
			fvoCVarSetInt( ctxCVar_WeaponBanPenalty_Amount, vinAmount );
		}
	
		vtxMsg = "Banned weapon pickup penalty is set to " + ftxCVarGetString( ctxCVar_WeaponBanPenalty );
		vtxMsg +=  " with amount of " + ftxIntToString( vclWeapon.finGetWeaponBanPenalty_Amount( ) );
		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_WeapBanPenalty

//.Server command - resets to the default war mode: all weapons;
	void fvoSrvCmd_RegularWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_RegularWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_RegularWar

//.Server command - enables knife war mode;
	void fvoSrvCmd_KnifeWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_KnifeWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );	
	} // fvoSrvCmd_KnifeWar

//.Server command - enables nade war mode;
	void fvoSrvCmd_NadeWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_NadeWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );	
	} // fvoSrvCmd_NadeWar

//.Server command - enables pistol war mode;
	void fvoSrvCmd_PistolWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{	
		vclWeapon.fvoSetWeaponMode_PistolWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_PistolWar

	
//.Server command - enables deagle pistol war mode;
	void fvoSrvCmd_DeagleWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{	
		vclWeapon.fvoSetWeaponMode_DeagleWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_DeagleWar

//.Server command - enables glock + usp pistol war mode;
	void fvoSrvCmd_GlockUSPWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{	
		vclWeapon.fvoSetWeaponMode_GlockUSPWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_GlockUSPWar

	
//.Server command - enables glock pistol war mode;
	void fvoSrvCmd_GlockWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{	
		vclWeapon.fvoSetWeaponMode_GlockWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_GlockWar

	
//.Server command - enables usp pistol war mode;
	void fvoSrvCmd_USPWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{	
		vclWeapon.fvoSetWeaponMode_USPWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_USPWar
		
//.Server command - enables dual vs five seven pistol war mode;
	void fvoSrvCmd_Dual57( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{	
		vclWeapon.fvoSetWeaponMode_Dual57War( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_Dual57

//.Server command - enables p228 pistol war mode;
	void fvoSrvCmd_P228War( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{	
		vclWeapon.fvoSetWeaponMode_P228War( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_P228War

//.Server command - enables light pistol war mode;
	void fvoSrvCmd_LightPistolWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_LightPistolWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_LightPistolWar

//.Server command - enables sub war mode;
	void fvoSrvCmd_SubWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_SubWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_SubWar

//.Server command - enables light sub war mode;
	void fvoSrvCmd_LightSubWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_LightSubWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_LightSubWar

//.Server command - enables uzi war mode;
	void fvoSrvCmd_UziWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_UziWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_UziWar

//.Server command - enables ump war mode;
	void fvoSrvCmd_UMPWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_UMPWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_UziWar

//.Server command - enables p90 war mode;
	void fvoSrvCmd_P90War( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_P90War( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_P90War

//.Server command - enables mp5 war mode;
	void fvoSrvCmd_MP5War( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_MP5War( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_MP5War

//.Server command - enables shotgun war mode;
	void fvoSrvCmd_ShotgunWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_ShotgunWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_ShotgunWar

	void fvoSrvCmd_AutoShotgunWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_AutoShotgunWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_AutoShotgunWar

//.Server command - enables pump shotgun war mode;
	void fvoSrvCmd_PumpWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_PumpWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_PumpWar

//.Server command - enables snipe war mode;
	void fvoSrvCmd_SnipeWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_SnipeWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_SnipeWar

//.Server command - enables light snipe war mode;
	void fvoSrvCmd_LightSnipeWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_LightSnipeWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_LightSnipeWar

//.Server command - enables scout war mode;
	void fvoSrvCmd_ScoutWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_ScoutWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_ScoutWar

	void fvoSrvCmd_HK550SnipeWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_HK550SnipeWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_HK550SnipeWar

//.Server command - enables AWP war mode;
	void fvoSrvCmd_AWPWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_AWPWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_AWPWar

//.Server command - enables PARA war mode;
	void fvoSrvCmd_PARAWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_PARAWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_PARAWar

//.Server command - enables small arms war mode;
	void fvoSrvCmd_SmallArmsWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_SmallArmsWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_SmallArmsWar

//.Server command - enables light arms war mode;
	void fvoSrvCmd_LightArmsWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_LightArmsWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_LightArmsWar

//.Server command - enables heavy arms war mode;
	void fvoSrvCmd_HeavyArmsWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_HeavyArmsWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_HeavyArmsWar

//.Server command - enables AK47 vs Colt arms war mode;
	void fvoSrvCmd_AK47ColtWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_AK47ColtWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_AK47ColtWar

//.Server command - enables Commando vs Aug arms war mode;
	void fvoSrvCmd_SG522AugWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_SG552AugWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_SG522AugWar


	void fvoSrvCmd_FamasGalilWar( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclWeapon.fvoSetWeaponMode_FamasGalilWar( );
		fvoHUDWarModeDisplay( pst_ptrEdict );
	} // fvoSrvCmd_FamasGalilWar

//.Server command - bans weapon: AWP;
	void fvoSrvCmd_BanAWP( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "AWP weapon is ";

		if ( fboIsOn( ptxArgList[ 1 ] ) )
			vclWeapon.fvoBanWeaponByName( ctxWeapon_awp );
		else 
		if ( fboIsOff( ptxArgList[ 1 ] ) )
			vclWeapon.fvoUnbanWeaponByName( ctxWeapon_awp );
		
		if ( vclWeapon.fboWeaponIsBanned_SwitchByName( ctxWeapon_awp ) )
			vtxMsg += "banned.";
		else
			vtxMsg += "available.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	}; // fvoSrvCmd_BanAWP

//.Server command - bans weapon: Flash Bang;
	void fvoSrvCmd_BanFlash( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "Flash Grenade is ";

		if ( fboIsOn( ptxArgList[ 1 ] ) )
			vclWeapon.fvoBanWeaponByName( ctxWeapon_flashbang );
		else 
		if ( fboIsOff( ptxArgList[ 1 ] ) )
			vclWeapon.fvoUnbanWeaponByName( ctxWeapon_flashbang );
		
		if ( vclWeapon.fboWeaponIsBanned_SwitchByName( ctxWeapon_flashbang ) )
			vtxMsg += "banned.";
		else
			vtxMsg += "available.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	}; // fvoSrvCmd_BanFlash

//.Server command - bans weapon: Smoke;
	void fvoSrvCmd_BanSmoke( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "Smoke Grenade is ";

		if ( fboIsOn( ptxArgList[ 1 ] ) )
			vclWeapon.fvoBanWeaponByName( ctxWeapon_smokegrenade );
		else 
		if ( fboIsOff( ptxArgList[ 1 ] ) )
			vclWeapon.fvoUnbanWeaponByName(ctxWeapon_smokegrenade);
		
		if ( vclWeapon.fboWeaponIsBanned_SwitchByName( ctxWeapon_smokegrenade ) )
			vtxMsg += "banned.";
		else
			vtxMsg += "available.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	}; // fvoSrvCmd_BanSmoke

//.Server command - bans weapon: HE nade;
	void fvoSrvCmd_BanHENade( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "HE Grenade is ";

		if ( fboIsOn( ptxArgList[ 1 ] ) )
			vclWeapon.fvoBanWeaponByName( ctxWeapon_hegrenade );
		else 
		if ( fboIsOff( ptxArgList[ 1 ] ) )
			vclWeapon.fvoUnbanWeaponByName( ctxWeapon_hegrenade );
		
		if ( vclWeapon.fboWeaponIsBanned_SwitchByName( ctxWeapon_hegrenade ) )
			vtxMsg += "banned.";
		else
			vtxMsg += "available.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	}; // fvoSrvCmd_BanHENade

//.Server command - bans weapon: shield;
	void fvoSrvCmd_BanShield( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "The Shield is ";

		if ( fboIsOn( ptxArgList[ 1 ] ) )
			vclWeapon.fvoBanWeaponByName( ctxWeapon_shield );
		else 
		if ( fboIsOff( ptxArgList[ 1 ] ) )
			vclWeapon.fvoUnbanWeaponByName( ctxWeapon_shield );
		
		if ( vclWeapon.fboWeaponIsBanned_SwitchByName( ctxWeapon_shield ) )
			vtxMsg += "banned.";
		else
			vtxMsg += "available.";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );

	}; // fvoSrvCmd_BanShield

//.Server command - executes a server command;
	void fvoSrvCmd_Exec( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "Executing server command: \n" + ptxArgString;
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		fvoServerCommand( ptxArgString  + "\n" );
	}; // fvoSrvCmd_Exec

//.Server command - locks server out from the public;
	void fvoSrvCmd_SrvLock( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_SrvLock + " < on \"password\" | off >";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		string vtxArg_Switch   = ptxArgList[ 1 ];
		string vtxArg_Password = ptxArgList[ 2 ];

		if ( fboIsOn( vtxArg_Switch ) )
		{
			if ( vtxArg_Password.empty( ) )
			{
				vtxMsg = ctxMsgPrefix + "You must specify a password!";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n\n" );
				goto locUsage;
			}
			vclSecurity.fvoLockServer( vtxArg_Password );
		}
		else 
		if ( fboIsOff( vtxArg_Switch ) )
			vclSecurity.fvoUnlockServer( );
		else
		if ( !vtxArg_Switch.empty( ) )
		{
			vtxMsg += "Invalid command line!";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}

		if ( vclSecurity.vinServerLock == cinAccess_Public )
		{
			vtxMsg += "The server is unlocked and open to the public";
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		}
		else
		{
			vtxMsg = "\n" + vtxMsg + "The server is locked and closed to the public.\n\n";

			if ( vclSecurity.vboAllowGuests )
			{
				vtxMsg += "   The password for entry is: " + vclSecurity.vtxPassword_Guest + "\n"; 
				vtxMsg += "   NOTE: If are unable to regain entry, rcon into the server and unlock it.\n";
			}
			else
			{
				vtxMsg += "   Access is not allowed.\n";
				vtxMsg += "   NOTE: If you disconnect you will *not* be able to regain entry.\n";
				vtxMsg += "   If this happens, RCON into the server and unlock it.\n";
			}
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		}

	}; // fvoSrvCmd_SrvLock

//.Server command - locks some server commands to preserve settings after a map change;
	void fvoSrvCmd_CmdLock( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			// < on | off >
			vtxMsg += "Usage: " + ctxCmd_CmdLock + " < on | off >";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		string vtxArg_Switch = ptxArgList[ 1 ];
		bool vboLock;

		if ( fboIsOn( vtxArg_Switch ) )
			vboLock = cboCommandLock_On;
		else 
		if ( fboIsOff( vtxArg_Switch ) )
			vboLock = cboCommandLock_Off;
		else
		{
			vtxMsg += "Invalid command specifier: use ON or OFF";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		fvoLockCommand( pst_ptrEdict, vboLock );

	}; // fvoSrvCmd_CmdLock

//.Server command - live in 3 (restarts round 3 times with HUD messages);
	void fvoSrvCmd_LiveIn3( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		//string vtxMsg = ctxMsgPrefix;

		fvoServerCommand_nlDELAYED( 0.0, "m_say *** MATCH WILL BE LIVE IN 3 ***" );
		fvoServerCommand_nlDELAYED( 3.0, "sv_restart 5" );
		fvoServerCommand_nlDELAYED( 11.0, "m_say ** MATCH WILL BE LIVE IN 2 **" );
		fvoServerCommand_nlDELAYED( 14.0, "sv_restart 5" );
		fvoServerCommand_nlDELAYED( 22.0, "m_say * MATCH WILL BE LIVE IN 1 *" );
		fvoServerCommand_nlDELAYED( 25.0, "sv_restart 10" );
		fvoServerCommand_nlDELAYED( 37.0, "m_say MATCH IS NOW LIVE - GO GO GO" );
		
	}; // fvoSrvCmd_LiveIn3

//.Server command - sets amount of time before map times out;
	void fvoSrvCmd_MapTimeout( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;
		string vtxValue;

		if ( !ptxArgList[ 1 ].empty( ) )
		{
			float vflTimeLimit = fflStringToFloat( ptxArgList[ 1 ] );
			vclMap.fvoSetTimeLimitInMin( vflTimeLimit );
		}

		string vtxTimeLeft = vclMap.ftxGetTimeLeftAsString( );

		if ( vtxTimeLeft == ctxNoMapTimeOut )
			vtxMsg += "Map has no time limit set";
		else
			vtxMsg += "Map will change in " + vtxTimeLeft + " (hh:mm:ss)";

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );
		
	}; // fvoSrvCmd_MapTimeout

//.Server command - times out current map to load the next map in the cycle;
	void fvoSrvCmd_EndMap( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		vclMap.fvoSetTimeLimitInMin( 0.25 );

		string vtxTimeLeft = vclMap.ftxGetTimeLeftAsString( );

		if ( vtxTimeLeft == ctxNoMapTimeOut )
			vtxMsg += "Map has no time limit set";
		else
		{		
			string vtxNextMapName = vclMap.ftxGetNextMapName( );
			if ( vtxNextMapName.empty( ) )
				vtxMsg += "Map will change in " + vtxTimeLeft + " (hh:mm:ss)";
			else
				vtxMsg += "Map will change to " + vtxNextMapName + " in " + vtxTimeLeft + " (hh:mm:ss)";
		}

		fvoHUDStatusDisplay( pst_ptrEdict, vtxMsg );
		fvoClientPrintChatAll( vtxMsg + "\n" );

	}; // fvoSrvCmd_EndMap

//.Server command - times out current round;
	void fvoSrvCmd_EndRound( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
		
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_EndRound + " [ seconds ]";
				fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
				return;
		}

		if ( !ptxArgList[ 1 ].empty( ) )
		{
			int vinTest = finStringToInt( ptxArgList[ 1 ] );
			if ( vinTest == 0 && ptxArgList[ 1 ] != "0" )
			{
				fvoConsolePrint_nl( pst_ptrEdict, "Invalid option specified." );
				goto locUsage;
			}

			ptxArgList[ 1 ];
		}
		else
			ptxArgList[ 1 ] = "10";
	
		fvoCVarSetString( "sv_restartround", ptxArgList[ 1 ] );

	}; // fvoSrvCmd_EndRound

//.Server command - displays version and build of running system;
	void fvoSrvCmd_Version( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix + "Version " + ctxVersion + " Build " + ctxBuild;
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );	
	}; // fvoSrvCmd_Version

	void fvoDisplaySoundSwitch( string &ptxMsg, string ptxSoundCmd, tclSoundCmdList pclSoundCmdList )
	{
		int vinCmdIdx = pclSoundCmdList.finFindSoundCmd( ptxSoundCmd );
		if ( vinCmdIdx < 0 )
		{
			ptxMsg += "not found.\n";
			return;
		}

		if ( pclSoundCmdList.fboSoundCmdIsOn( ptxSoundCmd ) )
			ptxMsg += "on.\n";
		else
			ptxMsg += "off.\n";

	} // fvoDisplaySoundSwitch

//.Server command - enables/disables individual sound commands; 
	void fvoSrvCmd_EnableSound( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		const string ctxSwitch_On			= "on";
		const string ctxSwitch_Off			= "off";

		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
				vtxMsg = "Usage: " + ctxCmd_EnableSound + 
					" <" + ctxSoundSystem_System + "|" + ctxSoundSystem_Admin + "|" + 
				   ctxSoundSystem_Bot + "|" + ctxSoundSystem_Damage + "|" + ctxSoundSystem_Public + 
				   "> <sound_cmd> [" + ctxSwitch_On + "|" + ctxSwitch_Off + "]";

				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		string vtxArg_SoundSystem = ptxArgList[ 1 ];
		string vtxArg_SoundCmd = ptxArgList[ 2 ];
		string vtxArg_Switch = ptxArgList[ 3 ];

		if ( vtxArg_SoundSystem.empty( ) )
		{
			vtxMsg = "You must specify a valid sound system - check usage.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}

		if ( vtxArg_SoundCmd.empty( ) )
		{
			vtxMsg = "You must specify a sound command - check usage.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}

		if ( vtxArg_SoundSystem != ctxSoundSystem_System	
				 &&
			  vtxArg_SoundSystem != ctxSoundSystem_Admin	
				 &&
			  vtxArg_SoundSystem != ctxSoundSystem_Bot	
				 &&
			  vtxArg_SoundSystem != ctxSoundSystem_Damage	
				 &&
			  vtxArg_SoundSystem != ctxSoundSystem_Public	
			)
		{
			vtxMsg = "You must specify a valid sound system - check usage.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}

		if ( vtxArg_Switch.empty( ) )
			goto locDisplayStatus;

		if ( vtxArg_Switch != ctxSwitch_On
				 &&
			  vtxArg_Switch != ctxSwitch_Off	
			)
		{
			vtxMsg = "You must specify a valid switch setting - check usage.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}

		bool vboSwitch;

		if ( vtxArg_Switch == ctxSwitch_On || vtxArg_Switch == ctxSwitch_Off )
		{
			vboSwitch = ( vtxArg_Switch == ctxSwitch_On );

			if ( vtxArg_SoundSystem == ctxSoundSystem_System )
				vclSoundCmdList_System.fvoSetSoundCmdSwitch( vboSwitch, vtxArg_SoundCmd );

			if ( vtxArg_SoundSystem == ctxSoundSystem_Admin )
				vclSoundCmdList_Admin.fvoSetSoundCmdSwitch( vboSwitch, vtxArg_SoundCmd );

			if ( vtxArg_SoundSystem == ctxSoundSystem_Bot )
				vclSoundCmdList_BotRandom.fvoSetSoundCmdSwitch( vboSwitch, vtxArg_SoundCmd );

			if ( vtxArg_SoundSystem == ctxSoundSystem_Damage )
				vclSoundCmdList_Damage.fvoSetSoundCmdSwitch( vboSwitch, vtxArg_SoundCmd );

			if ( vtxArg_SoundSystem == ctxSoundSystem_Public )
				vclSoundCmdList_Public.fvoSetSoundCmdSwitch( vboSwitch, vtxArg_SoundCmd );
		}

		locDisplayStatus:
		vtxMsg = ctxMsgPrefix + "Sound command is ";
		
		if ( vtxArg_SoundSystem == ctxSoundSystem_System )
			fvoDisplaySoundSwitch( vtxMsg, vtxArg_SoundCmd, vclSoundCmdList_System );

		if ( vtxArg_SoundSystem == ctxSoundSystem_Admin )
			fvoDisplaySoundSwitch( vtxMsg, vtxArg_SoundCmd, vclSoundCmdList_Admin );

		if ( vtxArg_SoundSystem == ctxSoundSystem_Bot )
			fvoDisplaySoundSwitch( vtxMsg, vtxArg_SoundCmd, vclSoundCmdList_BotRandom );

		if ( vtxArg_SoundSystem == ctxSoundSystem_Damage )
			fvoDisplaySoundSwitch( vtxMsg, vtxArg_SoundCmd, vclSoundCmdList_Damage );

		if ( vtxArg_SoundSystem == ctxSoundSystem_Public )
			fvoDisplaySoundSwitch( vtxMsg, vtxArg_SoundCmd, vclSoundCmdList_Public );
		
		fvoConsolePrint( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_EnableSound

//.Server command - sets the delay between popup messages;
	void fvoSrvCmd_PopupDelay( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg += "Usage: " + ctxCmd_PopupDelay + " < minutes >";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		string vtxArg_Minutes = ptxArgList[ 1 ];
		float vflArg_Minutes = fflStringToFloat( vtxArg_Minutes );

		float vflDelayInMins;
		
		if ( vtxArg_Minutes.empty( ) )
			goto locDisplaySetting;

		if ( vflArg_Minutes <= 0.0 )
		{
			vtxMsg += "Invalid setting!";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			goto locUsage;
		}

		vclMA_Text.vclPopupMsg.fvoSetTimeDelayInSec( vflArg_Minutes * 60 );
		locDisplaySetting:
			vflDelayInMins = vclMA_Text.vclPopupMsg.vflDelayInSec / 60;
			vtxArg_Minutes = ftxFloatToString( vflDelayInMins );
			vtxMsg += "Pop up delay is set to " + vtxArg_Minutes + " minutes";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
	
	}; // fvoSrvCmd_PopupDelay

//.Server command - loads the specified map; must be in the cycle;
	void fvoSrvCmd_LoadMap( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
		string vtxArg_MapName = ptxArgList[ 1 ];
		if ( vtxArg_MapName.empty( ) )
		{
			locNoMap:
				vtxMsg = ctxMsgPrefix + "You must specify a map that exists in the map cycle";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		int vinMapId = finStringToInt( vtxArg_MapName );
		if ( vinMapId != 0 )
		{
			vtxArg_MapName = vclMap.ftxGetMapNameByMapId( vinMapId );
			if ( vtxArg_MapName.empty( ) )
				goto locNoMap;
		}

		if ( !vclMap.fboIsMapInCycle( vtxArg_MapName ) )
		{
			vtxMsg = ctxMsgPrefix + vtxArg_MapName + " is in not in the map cycle - will try loading outside map cycle.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

			if ( !fboIsMapValid( vtxArg_MapName ) )
			{
				vtxMsg = ctxMsgPrefix + "Cannot load map! It was not found or is invalid.";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
			}
			
		}
		
		locLoadMap:
		{
			vtxMsg = ctxMsgPrefix + " Changing map to: " + vtxArg_MapName;
			
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			fvoClientPrintCenterAll( vtxMsg );
			
			vclMapLoadTrace.fvoWriteEventInfo( vtxArg_MapName + " (manual load by admin)");
			fvoServerCommand( "changelevel " + vtxArg_MapName + "\n" );
		}
	}; // fvoSrvCmd_LoadMap

//.Server command - displays command help information;
	void fvoSrvCmd_Help( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == "say" )
		{
			vclCommand.fvoListCmd( pst_ptrEdict, cinAccess_Public, enClientSay );
			return;
		}

		if ( ptxArgList[ 1 ] == ftxToLower( ctxAccess_Public ) )
		{
			vclCommand.fvoListCmd( pst_ptrEdict, cinAccess_Public, enClient );
			return;
		}

		if ( ptxArgList[ 1 ] == ftxToLower( ctxAccess_Guest ) )
		{
			if ( vclSecurity.finHighestAccessLevel( pst_ptrEdict ) > cinAccess_Guest )
				goto locAccessDenied;

			vclCommand.fvoListCmd( pst_ptrEdict, cinAccess_Guest, enClient );
			return;
		}

		if ( ptxArgList[ 1 ] == ftxToLower( ctxAccess_Clan ) )
		{
			if ( vclSecurity.finHighestAccessLevel( pst_ptrEdict ) > cinAccess_Clan )
				goto locAccessDenied;

			vclCommand.fvoListCmd( pst_ptrEdict, cinAccess_Clan, enClient );
			return;
		}

		if ( ptxArgList[ 1 ] == ftxToLower( ctxAccess_Admin1 ) )
		{
			if ( vclSecurity.finHighestAccessLevel( pst_ptrEdict ) > cinAccess_Admin1 )
				goto locAccessDenied;			
			
			vclCommand.fvoListCmd( pst_ptrEdict, cinAccess_Admin1, enClient	);
			return;
		}

		if ( ptxArgList[ 1 ] == ftxToLower( ctxAccess_Admin2 ) )
		{
			if ( vclSecurity.finHighestAccessLevel( pst_ptrEdict ) > cinAccess_Admin2 )
				goto locAccessDenied;			
			
			vclCommand.fvoListCmd( pst_ptrEdict, cinAccess_Admin2, enClient	);
			return;
		}

		if ( ptxArgList[ 1 ] == ftxToLower( ctxAccess_SrvOp ) )
		{
			if ( vclSecurity.finHighestAccessLevel( pst_ptrEdict ) > cinAccess_SrvOp  )
				goto locAccessDenied;

			vclCommand.fvoListCmd( pst_ptrEdict, cinAccess_SrvOp, enServerOrClient	);
			return;
		}

		if ( ptxArgList[ 1 ] == "sounds" )
		{
			vclSoundCmdList_Public.fvoListSounds( pst_ptrEdict );
			return;
		}

		vtxMsg  = "\n" + ctxMsgPrefix + "H E L P\n";
		vtxMsg += "For public say commands,\n";
		vtxMsg += "  m_help say\n";
		vtxMsg += "For public console commands,\n";
		vtxMsg += "  m_help " + ctxAccess_Public + "\n";
		vtxMsg += "For Guest member console commands,\n";
		vtxMsg += "  m_help " + ctxAccess_Guest + "\n";
		vtxMsg += "For Clan member console commands,\n";
		vtxMsg += "  m_help " + ctxAccess_Clan + "\n";
		vtxMsg += "For Admin level 1 console commands,\n";
		vtxMsg += "  m_help " + ctxAccess_Admin1 + "\n";
		vtxMsg += "For Admin level 2 console commands,\n";
		vtxMsg += "  m_help " + ctxAccess_Admin2 + "\n";
		vtxMsg += "For Server Operator console commands,\n";
		vtxMsg += "  m_help " + ctxAccess_SrvOp + "\n";
		vtxMsg += "For sound commands,\n";
		vtxMsg += "  m_help sounds\n\n";
		vtxMsg += "For help on a console command:\n";
		vtxMsg += "  Enter the command with -help as the argument";
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		return;
		
		locAccessDenied:
			vtxMsg = ctxMsgPrefix + "You do not have access rights to this command list.";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;

	} // fvoSrvCmd_Help

//.Server command - reloads security information;
	void fvoSrvCmd_LoadSecurity( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclSecurity.fvoLoadSecurity( pst_ptrEdict );
	} // fvoSrvCmd_LoadSecurity

//.Server command - reloads connection message text;
	void fvoSrvCmd_LoadConnMsg( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclMA_Text.vclConnMsg.fvoLoadList( pst_ptrEdict );
	} // fvoSrvCmd_LoadConnMsg

//.Server command - reloads pop up pessages;
	void fvoSrvCmd_LoadPopupMsg( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclMA_Text.vclPopupMsg.fvoLoadList( pst_ptrEdict );
	} // fvoSrvCmd_LoadPopupMsg

//.Server command - reloads pop up pessages;
	void fvoSrvCmd_LoadIPBanList( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		vclIPBanList.fvoLoadList( pst_ptrEdict );
	} // fvoSrvCmd_LoadIPBanList

//.Server command - list information about the user; by user id;
	void fvoSrvCmd_UserInfo( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			vtxMsg += "Usage: " + ctxCmd_UserInfo + " < userid >";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		string vtxArg_UserId = ptxArgList[ 1 ];
		int vinArg_UserId = finStringToInt( vtxArg_UserId );

		if ( vtxArg_UserId.empty( ) || ( vinArg_UserId <= 0 ) )
		{
			locNoUserId:
				vtxMsg += "Missing or invalid user id!";
				fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
				return;
		}

		vclPlayer.fboListUserInfoByUserId( pst_ptrEdict, vinArg_UserId );

	} // fvoSrvCmd_UserInfo

//.Server command - turn on/off stats protection
	void fvoSrvCmd_StatsProtect( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_StatsProtect + " [ on | off ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		string vtxArg_Switch = ptxArgList[ 1 ];

		if ( vtxArg_Switch != "" )
		{
			if ( fboIsOn( vtxArg_Switch ) )
				vclBot.fvoSetStatsProtection( true );
			else
			if ( fboIsOff( vtxArg_Switch ) )
				vclBot.fvoSetStatsProtection( false );
			else
				goto locUsage;
		}

		vtxMsg = ctxMsgPrefix + "Stats protection is turned ";

		if ( vclBot.fboStatsProtectionIsOn( ) )
			vtxMsg += "on";
		else
			vtxMsg += "off";
		
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_StatsProtect

//.Server command - turn on/off POD fix protection
	void fvoSrvCmd_PODFixProtect( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_PODFixProtect + " [ on | off ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		string vtxArg_Switch = ptxArgList[ 1 ];

		if ( vtxArg_Switch != "" )
		{
			if ( fboIsOn( vtxArg_Switch ) )
				vclBot.fvoSetPODBotFixProtection( true );
			else
			if ( fboIsOff( vtxArg_Switch ) )
				vclBot.fvoSetPODBotFixProtection( false );
			else
				goto locUsage;
		}

		vtxMsg = ctxMsgPrefix + "PODBot Fix protection is turned ";

		if ( vclBot.fboPODBotFixProtectionIsOn( ) )
			vtxMsg += "on";
		else
			vtxMsg += "off";
		
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_PODFixProtect

//.Server command - turn on/off kicking of bots with duplicate names
	void fvoSrvCmd_KickDupBots( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_KickDupBots + " [ on | off ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		string vtxArg_Switch = ptxArgList[ 1 ];

		if ( vtxArg_Switch != "" )
		{
			if ( fboIsOn( vtxArg_Switch ) )
				vclBot.fvoSetKickDupBots( true );
			else
			if ( fboIsOff( vtxArg_Switch ) )
				vclBot.fvoSetKickDupBots( false );
			else
				goto locUsage;
		}

		vtxMsg = ctxMsgPrefix + "Kicking of bots with duplicate names is turned ";

		if ( vclBot.fboKickDupBotsIsOn( ) )
			vtxMsg += "on";
		else
			vtxMsg += "off";
		
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_KickDupBots

//.Server command - sets probability of auto switch of bot skill on map change;
	void fvoSrvCmd_AutoBotSkill( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_AutoBotSkill + " [on|off] | [0-100%]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		string vtxArg_Switch = ptxArgList[ 1 ];

		if ( !vtxArg_Switch.empty( ) )
		{
			if ( vtxArg_Switch == "on" )
				vclBot.vboRandomBotSkillSwitch = true;
			else
			if ( vtxArg_Switch == "off" )
				vclBot.vboRandomBotSkillSwitch = false;
			else
			{
				if ( vtxArg_Switch[ vtxArg_Switch.length( )-1 ] == '%' )
					fvoTrunc( vtxArg_Switch, vtxArg_Switch.length( )-1 );

				float vflProb = fflStringToFloat( vtxArg_Switch );
					
				if ( vflProb < 0 )
					goto locUsage;

				if ( vflProb > 100 )
					goto locUsage;

				vclBot.vflProbOfBotSkillSwitch = vflProb / 100.0;
			}
		}

		vtxMsg = ctxMsgPrefix + "Auto change of bot skill is ";
		if ( vclBot.vboRandomBotSkillSwitch )
		{	float vflProb = vclBot.vflProbOfBotSkillSwitch * 100.0;
			vtxMsg += "turned ON with prob of " + ftxFloatToString( vflProb ) + "%";
		}
		else
			vtxMsg += "turned OFF";

		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_AutoBotSkill

//.Server command - sets probability of auto switch of bot team on map change;
	void fvoSrvCmd_AutoBotTeam( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_AutoBotTeam + " [on|off] | [ probability ]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		string vtxArg_Switch = ptxArgList[ 1 ];

		if ( !vtxArg_Switch.empty( ) )
		{
			if ( vtxArg_Switch == "on" )
				vclBot.vboRandomBotTeamSwitch = true;
			else
			if ( vtxArg_Switch == "off" )
				vclBot.vboRandomBotTeamSwitch = false;
			else
			{
				if ( vtxArg_Switch[ vtxArg_Switch.length( )-1 ] == '%' )
					fvoTrunc( vtxArg_Switch, vtxArg_Switch.length( )-1 );

				float vflProb = fflStringToFloat( vtxArg_Switch );
					
				if ( vflProb < 0.0 )
					goto locUsage;

				if ( vflProb > 100.0 )
					goto locUsage;

				vclBot.vflProbOfBotTeamSwitch = vflProb / 100.0;
			}
		}

		vtxMsg = ctxMsgPrefix + "Auto change of bot team is ";
		if ( vclBot.vboRandomBotTeamSwitch )
		{	
			float vflProb = vclBot.vflProbOfBotTeamSwitch * 100.0;
			vtxMsg += "turned ON with prob of " + ftxFloatToString( vflProb ) + "%";
		}
		else
			vtxMsg += "turned OFF";

		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_AutoBotTeam

//.Server command - sets auto balance teams of humans on / off;
	void fvoSrvCmd_AutoBalTeams( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_AutoBalTeams + " [on|off]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		string vtxArg_Switch = ptxArgList[ 1 ];

		if ( !vtxArg_Switch.empty( ) )
		{
			if ( fboIsOn( vtxArg_Switch ) )
				fvoCVarSetString( "mp_autoteambalance", "1" );
			else
			if ( fboIsOff( vtxArg_Switch ) )
				fvoCVarSetString( "mp_autoteambalance", "0" );
			else
				goto locUsage;
		}

		vtxMsg = ctxMsgPrefix + "Auto balance teams is ";
		if ( finCVarGetInt( "mp_autoteambalance" ) == 1 )
		{	
			vtxMsg += "turned ON";
		}
		else
			vtxMsg += "turned OFF";

		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_AutoBalTeams
	
//.Server command - sets auto kill bots to force a round restart after all humans have died;
	void fvoSrvCmd_AutoKillBots( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_AutoKillBots + " [on|off]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		string vtxArg_Switch = ptxArgList[ 1 ];

		if ( !vtxArg_Switch.empty( ) )
		{
			if ( fboIsOn( vtxArg_Switch ) )
				vclBot.fvoSetAutoKillAllBots( true );
			else
			if ( fboIsOff( vtxArg_Switch ) )
				vclBot.fvoSetAutoKillAllBots( false );
			else
				goto locUsage;
		}

		vtxMsg = ctxMsgPrefix + "Auto killing of bots is ";
		if ( vclBot.fboAutoKillAllBotsIsOn( ) )
		{	
			vtxMsg += "turned ON";
		}
		else
			vtxMsg += "turned OFF";

		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_AutoKillBots

//.Server command - sets auto balance teams of humans on / off;
	void fvoSrvCmd_SetCommand( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;
		bool vboResult;
		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_SetCommand + " <command> [enabled|disabled|access_code]";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			vtxMsg = "Access Codes are: ServerOp, Admin1, Admin2, Clan, Guest and Public";
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		string vtxArg_Command = ptxArgList[ 1 ];
		string vtxArg_Switch = ptxArgList[ 2 ];
		int vinCmdIdx;
		int vinAccess;

		vinCmdIdx = vclCommand.finFindCmdIdx( vtxArg_Command );

		locCommandNotFound:

		if ( vinCmdIdx < cinMinArg_Idx )
		{
			vtxMsg = ctxMsgPrefix + "The specified command does not exist.";
			goto locDisplayResult;
		}

		if ( !vtxArg_Switch.empty( ) )
		{
			if ( fboIsOn( vtxArg_Switch ) )
				vclCommand.fboSetCmdAsEnabled( vinCmdIdx );
			else
			if ( fboIsOff( vtxArg_Switch ) )
				vclCommand.fboSetCmdAsDisabled( vinCmdIdx );
			else
			{	
				vinAccess = vclSecurity.finStrToIntAccess( vtxArg_Switch );

				if ( vinAccess < cinAccess_Min )
				{
					vtxMsg = ctxMsgPrefix + "The specified access code is invalid.";
					goto locDisplayResult;
				}

				vclCommand.fboSetCmdAccess( vinCmdIdx, vinAccess );
			}
		}

		vtxMsg = ctxMsgPrefix + "The command settings for " + vtxArg_Command + " are:\n" + "   Command is ";
		if ( vclCommand.fboCmdIsEnabled( vinCmdIdx ) )
			vtxMsg += "enabled";
		else
			vtxMsg += "disabled";

		vtxMsg += "\n   Access is " + vclCommand.ftxGetCmdAccess( vinCmdIdx );

		locDisplayResult:
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );

	} // fvoSrvCmd_SetCommand

//.Server command - sets the maximum number of human players allowed on the server;
	void fvoSrvCmd_MaxHumans( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_MaxHumans + " < number_of_humans >";
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
			vtxMsg = ctxMsgPrefix + "Range is from 1 to " + ftxIntToString( vclGlobalGameInfo.finGetMaxPlayers( ) );
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
			return;
		}
		
		string vtxArg_Humans = ptxArgList[ 1 ];
		int vinArg_Humans = finStringToInt( vtxArg_Humans );

		if ( vtxArg_Humans.empty( ) )
			goto locDisplaySetting;

	   if ( !vclPlayer.fboSetMaxHumans( vinArg_Humans ) )
	   {
			vtxMsg = ctxMsgPrefix + "You specified a number of humans that is out of the valid range!";
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
			goto locUsage;
	   }	

		locDisplaySetting:
			vinArg_Humans = vclPlayer.finGetMaxHumans( );
			vtxArg_Humans = ftxIntToString( vinArg_Humans );
			vtxMsg = ctxMsgPrefix + "The maximum number of humans allowed on server: " + vtxArg_Humans;
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
	
	}; // fvoSrvCmd_MaxHumans

//.Server command - turns on|off ALL bot enhancements;
	void fvoSrvCmd_BotEnhance( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			locUsage:
			vtxMsg = ctxMsgPrefix + "Usage: " + ctxCmd_BotEnhance + " < on | off >";
			fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
			return;
		}
		
		string vtxArg_Switch = ptxArgList[ 1 ];

		if ( fboIsOn( vtxArg_Switch ) )
		{
			//!! turn on all bot enhancements;
			vtxMsg = ctxMsgPrefix + "All bot enhancements have been turned ON";
			fvoCVarSetString( ctxCVar_BotAimFix, "on" );
			fvoCVarSetString( ctxCVar_BotScopeFix, "on" );
			fvoCVarSetString( ctxCVar_BotKnifeFix, "on" );
			fvoCVarSetString( ctxCVar_BotNadeFix, "on" );
			fvoCVarSetString( ctxCVar_BotBombFix, "on" );
			fvoCVarSetString( ctxCVar_BotJumpFix, "on" );
			fvoCVarSetString( ctxCVar_BotsBuyDefuseKit, "on" );
			fvoCVarSetString( ctxCVar_BotsBuyHENade, "on" );
			fvoCVarSetString( ctxCVar_BotsBuyFlashNade, "on" );
			fvoCVarSetString( ctxCVar_BotCombatFix, "on" );
			fvoCVarSetString( ctxCVar_BotsShootThroughWalls, "on" );
			fvoCVarSetString( ctxCVar_BotBurstFireFix, "on" );
			fvoCVarSetString( ctxCVar_BotSilentWalk, "on" );
			vclWeapon.fvoSetUseRank( true );
//			fvoCVarSetString( , "on" );
		}
		else
		if ( fboIsOff( vtxArg_Switch ) )
		{
			//!! turn off all bot enhancements;
			vtxMsg = ctxMsgPrefix + "All bot enhancements have been turned OFF";
			fvoCVarSetString( ctxCVar_BotAimFix, "off" );
			fvoCVarSetString( ctxCVar_BotScopeFix, "off" );
			fvoCVarSetString( ctxCVar_BotKnifeFix, "off" );
			fvoCVarSetString( ctxCVar_BotNadeFix, "off" );
			fvoCVarSetString( ctxCVar_BotBombFix, "off" );
			fvoCVarSetString( ctxCVar_BotJumpFix, "off" );
			fvoCVarSetString( ctxCVar_BotsBuyDefuseKit, "off" );
			fvoCVarSetString( ctxCVar_BotsBuyHENade, "off" );
			fvoCVarSetString( ctxCVar_BotsBuyFlashNade, "off" );
			fvoCVarSetString( ctxCVar_BotCombatFix, "off" );
			fvoCVarSetString( ctxCVar_BotsShootThroughWalls, "off" );
			fvoCVarSetString( ctxCVar_BotBurstFireFix, "off" );
			fvoCVarSetString( ctxCVar_BotSilentWalk, "off" );
			vclWeapon.fvoSetUseRank( false );
//			fvoCVarSetString( , "off" );
		}
		else
			goto locUsage;
			
		fvoConsolePrint_nl( pst_ptrEdict, vtxMsg );
	
	}; // fvoSrvCmd_BotEnhance

//.Server command - list information about the user; by user id;
	void fvoSrvCmd_MyUserInfo( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			vtxMsg += "Usage: " + ctxCmd_MyUserInfo;
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		int vinUserId = vclPlayer.finGetUserIdByEdict( pst_ptrEdict );
		vclPlayer.fboListUserInfoByUserId( pst_ptrEdict, vinUserId );

	} // fvoSrvCmd_MyUserInfo

//.Server command - dump all security information to log file;
	void fvoSrvCmd_DumpUserInfo( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
	{
		string vtxMsg = ctxMsgPrefix;

		if ( ptxArgList[ 1 ] == ctxArg_Help )
		{
			vtxMsg += "Usage: " + ctxCmd_DumpUserInfo;
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}
		
		vclSecurity.fvoDumpAccessInfo( pst_ptrEdict );

	} // fvoSrvCmd_DumpUserInfo

void fvoSrvCmd_AddMean( edict_t* pst_ptrEdict, ttxArgList ptxArgList, string ptxArgString )
{
//	string vtxMsg = "This command is used for development testing and is disabled.";
//	fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

	int vinTeam = vclPlayer.finTeamStrToInt( ptxArgList[ 1 ] );
	vclPlayer.fvoAddBot( "(mEAn) Test Dummy Bot s/n:" + ftxIntToString( random( 1001 ) ), vinTeam );

//	vclDebugTrace.fvoWriteEventInfo( "After vclPlayer.fvoAddBot('test');" );
}

// Command Functions - END
// **************************************************************************

	void fvoSrvCmd( void )
	{
		vclCommand.fboCmdDispatch( NULL, enServer );
	} // fvoSrvCmd

	tclCommand::tclCommand( void )
	{
		vinNumCmds = 0;
		vboCancel = false;
		
		for ( int vinIdx = cinMinArg_Idx; 
				vinIdx <= cinMinArg_Idx; 
				vinIdx++ )
		{
			vtxArgList[ vinIdx ] = "";
		}

		vtxArgString = "";
		vinNumArgs = 0;

		for ( int vinIdx = cinStartCmd_Idx; 
				vinIdx <= cinEndCmd_Idx; 
				vinIdx++ )
		{
			vst_aryCmdList[ vinIdx ].vtxCommand  = "";
			vst_aryCmdList[ vinIdx ].vboEnabled  = false;	
			vst_aryCmdList[ vinIdx ].vboLocked   = cboCommandLock_DEFAULT;
			vst_aryCmdList[ vinIdx ].vinAccess	 = cinAccess_DEFAULT;
			vst_aryCmdList[ vinIdx ].venExecFrom = cenExecFrom_DEFAULT;
			vst_aryCmdList[ vinIdx ].vfn_ptrCmd  = NULL;
		}

	} // tclCommand::tclCommand

	bool tclCommand::fboCmdCountIsValid( void )
	{
		return ( ( vinNumCmds >= cinMinCmds ) 
						&& 
			      ( vinNumCmds <= cinMaxCmds ) );
	} // tclCommand::fboCmdCountIsValid

	bool tclCommand::fboCmdIdxIsValid( int pinCmdIdx )
	{
		return ( ( ( pinCmdIdx >= cinStartCmd_Idx ) 
						  && 
			        ( pinCmdIdx <= cinEndCmd_Idx   ) 
					)
						&& 
					( pinCmdIdx < vinNumCmds ) 
			    );

	} // tclCommand::fboCmdIdxIsValid

	bool tclCommand::fboCmdAccessIsValid( int pinAccess )
	{
		return ( pinAccess >= cinAccess_Min && pinAccess <= cinAccess_Max );
	} // tclCommand::fboCmdAccessIsValid

	bool tclCommand::fboCmdCountIsFull( void )
	{
		return ( vinNumCmds >= cinMaxCmds ); 
	} // tclCommand::fboCmdCountIsFull

	bool tclCommand::fboCmdIsSay( int pinCmdIdx )
	{
		if ( !fboCmdCountIsValid( ) || !fboCmdIdxIsValid( pinCmdIdx ) )
			return false;
		return vst_aryCmdList[ pinCmdIdx ].venExecFrom == enClientSay;

	} // tclCommand::fboCmdIsSay

	int tclCommand::finFindCmdIdx( string ptxCommand )
	{
		if ( !fboCmdCountIsValid( ) )
			return cinMinArg_Idx - 1;

		if ( ptxCommand.empty() )
			return cinMinArg_Idx - 1;

		for ( int vinIdx = cinStartCmd_Idx; 
				vinIdx < vinNumCmds; 
				vinIdx++ )
		{
			if ( vst_aryCmdList[ vinIdx ].vtxCommand == ptxCommand ) 
				return vinIdx;
		}

		return cinMinArg_Idx - 1;

	} // tclCommand::finFindCmdIdx

	int tclCommand::finAddCmd
		( string         ptxCommand, 
		  tfn_ptrCmd	  pfn_ptrCmd, 
		  tenCmdExecFrom penExecFrom, 
		  int            pinAccess )
	{
		string vtxMsg;

		if ( pfn_ptrCmd == NULL )
		{  
			vtxMsg  = ctxMsgPrefix + "ERROR: The command function pointer is NULL\n";
			vtxMsg += "       The command is: " + ptxCommand;
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			return cinMinArg_Idx - 1;
		}

		if ( !fboCmdCountIsValid( ) )
		{  
			vtxMsg  = ctxMsgPrefix + "ERROR: The internal command count is in error\n";
			vtxMsg += "       The command is: " + ptxCommand;
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			return cinMinArg_Idx - 1;
		}

		if ( fboCmdCountIsFull ( ) )
		{  
			vtxMsg  = ctxMsgPrefix + "WARNING: The internal command count has reached its maximum\n";
			vtxMsg += "       The command is: " + ptxCommand;
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			return cinMinArg_Idx - 1;
		}

		int vinCmdIdx = finFindCmdIdx( ptxCommand );

		if ( fboCmdIdxIsValid( vinCmdIdx ) )
		{  
			vtxMsg  = ctxMsgPrefix + "WARNING: An attempt was made to add the same command more than once\n";
			vtxMsg += "       The duplicate command is: " + ptxCommand;
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			return cinMinArg_Idx - 1;
		}

		vst_aryCmdList[ vinNumCmds ].vtxCommand   = ptxCommand;
		vst_aryCmdList[ vinNumCmds ].vboEnabled   = true;
		vst_aryCmdList[ vinNumCmds ].vboLocked		= cboCommandLock_Off;
		vst_aryCmdList[ vinNumCmds ].vinAccess    = pinAccess;
		vst_aryCmdList[ vinNumCmds ].venExecFrom  = penExecFrom;
		vst_aryCmdList[ vinNumCmds ].vfn_ptrCmd   = pfn_ptrCmd;

		if ( ( penExecFrom == enServerOrClient ) 
					|| 
			  ( penExecFrom == enServer ) )
		{
			//.begin - for debugging only
			// fvoServerPrint( ctxMsgPrefix + "Adding command: " + ptxCommand + "\n" );
			//,end
			fvoAddServerCommand( ptxCommand, fvoSrvCmd );
	   } 

		vinNumCmds++;
		return vinNumCmds - 1;

	} // tclCommand::finAddCmd

	void tclCommand::fvoGetArgs( void )
	{
		vinNumArgs = finGetCmdLineArgCount( );

		if ( vinNumArgs > cinMaxArgs )
		// ensure our buffer does not overflow
			vinNumArgs = cinMaxArgs;
		else
		if ( vinNumArgs < cinMinArgs )
		// ensure our buffer does not overflow
			vinNumArgs = cinMinArgs;

		int vinIdx;

		for ( vinIdx = 0; vinIdx < vinNumArgs; vinIdx++ )
		{
			vtxArgList[ vinIdx ] = ftxGetCmdLineArgValue( vinIdx );
   		fvoToLower( vtxArgList[ vinIdx ] );
		}

		for (; vinIdx <= cinMaxArg_Idx; vinIdx++ )
		{
			vtxArgList[ vinIdx ] = "";
		}
		if ( vinNumArgs > 1 )
		{
			vtxArgString = ftxGetCmdLineString( );
		}
		else
		{
			vtxArgString.erase( );
		}
		
	} // tclCommand::fvoGetArgs

	bool tclCommand::fboExecCmd( edict_t* pst_ptrEdict, int pinCmdIdx )
	{
		string vtxMsg;

		if ( !fboCmdIdxIsValid( pinCmdIdx ) )
		{
			vtxMsg  = ctxMsgPrefix + "ERROR: The command index is invalid.\n";
			vtxMsg += "       Command Line  is: " + vtxArgList[ 0 ] + " " + vtxArgString + "\n"; 
			vtxMsg += "       Command index is: " + ftxIntToString( pinCmdIdx ) + "\n"; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return false;
		}

		if ( !vst_aryCmdList[ pinCmdIdx ].vboEnabled )
		{
			vtxMsg  = ctxMsgPrefix + "WARNING: The command has been marked as disabled.\n";
			vtxMsg += "       Command Line is: " + vtxArgList[ 0 ] + " " + vtxArgString + "\n"; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return false;
		}

		if ( ( vst_aryCmdList[ pinCmdIdx ].venExecFrom == enClient ) 
					&& 
			  ( pst_ptrEdict == NULL ) )
		{
			vtxMsg  = ctxMsgPrefix + "WARNING: This command cannot be executed from the server console.\n";
			vtxMsg += "       Command Line is: " + vtxArgList[ 0 ] + " " + vtxArgString + "\n"; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return false;
		}

		if ( ( vst_aryCmdList[ pinCmdIdx ].venExecFrom == enServer ) 
					&& 
			  ( pst_ptrEdict != NULL ) )
		{
			vtxMsg  = ctxMsgPrefix + "WARNING: This command cannot be executed from the client console.\n";
			vtxMsg += "       Command Line is: " + vtxArgList[ 0 ] + " " + vtxArgString + "\n"; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return false;
		}

		if ( ( vst_aryCmdList[ pinCmdIdx ].vinAccess != cinAccess_Public ) 
					&& 
			  ( pst_ptrEdict != NULL ) )
		{
			// The command is secured and was not executed from the server console,
			// therefore we must check to see if this player has access to the command

			if ( vst_aryCmdList[ pinCmdIdx ].vinAccess < vclSecurity.finHighestAccessLevel( pst_ptrEdict ) )
			{
				vtxMsg  = ctxMsgPrefix + "You do not have access to this command.\n";
				vtxMsg += "       Command Line is: " + vtxArgList[ 0 ] + " " + vtxArgString + "\n"; 
				fvoConsolePrint( pst_ptrEdict, vtxMsg );
				return false;
			}
		}

		if ( vst_aryCmdList[ pinCmdIdx ].vboLocked == cboCommandLock_On )
		{
			vtxMsg  = ctxMsgPrefix + "The command has been marked as locked. ";
			vtxMsg += " to unlock use: " + ctxCmd_CmdLock + "\n"; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return false;
		}

		(*vst_aryCmdList[ pinCmdIdx ].vfn_ptrCmd)( pst_ptrEdict, vtxArgList, vtxArgString );

		return true;

	} // tclCommand::fboExecCmd

	bool tclCommand::fboExecServerCmd( void )
	{
		string vtxMsg;
		int vinCmdIdx = finFindCmdIdx( vtxArgList[ 0 ] );

		if ( !fboCmdIdxIsValid( vinCmdIdx ) )
		{
			vtxMsg  = ctxMsgPrefix + "ERROR: The command function was not found.\n";
			vtxMsg += "       Command Line: " + vtxArgList[ 0 ] + " " + vtxArgString + "\n"; 
			fvoConsolePrint( NULL, vtxMsg );
			return false;
		}

		if ( ( vst_aryCmdList[ vinCmdIdx ].venExecFrom != enServer ) 
			      && 
			  ( vst_aryCmdList[ vinCmdIdx ].venExecFrom != enServerOrClient ) 
			)
		{
			vtxMsg  = ctxMsgPrefix + "This command can only be executed from the client console.\n";
			vtxMsg += "       Command Line: " + vtxArgList[ 0 ] + " " + vtxArgString + "\n"; 
			fvoConsolePrint( NULL, vtxMsg );
			return false;
		}

		return fboExecCmd( NULL, vinCmdIdx );

	} // tclCommand::fboExecServerCmd

	bool tclCommand::fboExecSayCmd( edict_t* pst_ptrEdict )
	{
		// shift the command list left by one, this will overwrite
		// the "say" command line and will allow us to execute server
		// commands from here;

		// Case #1
		// vtxArgString will contain the entire commandline excluding the "say"
		// command. The vtxArgList will contain only two values, the "say"
		// command and the say text that follows. Each delimited word in the say text
		// will not be stored as separate vtxArgList values, rather vtxArgList[ 1 ]
		// will contain a string with the entire say text surrounded by "". We must 
		// decompose the say text into separate words;

		// Case #2
		// vtxArgString will contain the entire commandline excluding the "say"
		// command. The vtxArgList will contain 1 value for each word in the say text. 
		// Each delimited word in the say text will be stored as separate vtxArgList 
		// value.

		if ( vinNumArgs < 2 )
		// nothing to do;
			return false;

		string vtxMsg;

		// prep arg list for rebuild by clearing it;
		for ( int vinIdx = cinMinArg_Idx; 
					 vinIdx <= cinMaxArg_Idx; 
					 vinIdx++)
		{
			if ( vtxArgList[ vinIdx ] == "" )
				break;

			vtxArgList[ vinIdx ] = "";
		}

		// decompose the vtxArgString into separate space delimited "words" and 
		// store into the argument list;

		int  vinArgIdx		  = 0;
		bool vboDelimFound  = false;
		bool vboFirstWord   = true;

		for ( unsigned int vinIdx = 0; 
								 vinIdx < vtxArgString.length( ); 
								 vinIdx++ )
		{

			if ( vboDelimFound == true )
			{
				if ( ( vtxArgString[ vinIdx ] == ' ' ) 
					       || 
					  ( vtxArgString[ vinIdx ] == '"' ) 
					)
					continue;

				vboDelimFound = false;
			}

			if ( ( vtxArgString[ vinIdx ] == ' ' ) 
				       || 
				  ( vtxArgString[ vinIdx ] == '"' ) 
				)
			{
				vboDelimFound == true;

				if ( vinArgIdx < cinMaxArg_Idx ) 
				{
					if ( !vboFirstWord )
						vinArgIdx++;
				}
				else
				// terminate loop
					break;

				continue;
			}
			else
				vboFirstWord = false;

			vtxArgList[ vinArgIdx ] += vtxArgString[ vinIdx ];

		}
		
		// calculate the argument list count and build a new ArgString;

		string vtxNewArgString = "";
		vinNumArgs = 0;
		for ( int vinIdx = cinMinArg_Idx; 
					 vinIdx <= cinMaxArg_Idx; 
					 vinIdx++)
		{
			if ( vtxArgList[ vinIdx ] == "" )
				break;
			if ( vinIdx > cinMinArg_Idx )
			{
				if ( vinIdx > cinMinArg_Idx + 1 )
					vtxNewArgString += " ";
				vtxNewArgString += vtxArgList[ vinIdx ];
			}
			vinNumArgs++;
		}

		vtxArgString = vtxNewArgString;

//		vclDebugTrace.fvoWriteEventInfo( true, "ArgString = " + vtxArgString );
//		for ( int vinIdx = 0; vinIdx < cinMaxArg_Idx; vinIdx++ )
//		{
//			vclDebugTrace.fvoWriteEventInfo( true, "ArgList[ " + ftxIntToString( vinIdx ) + " ] = " + vtxArgList[ vinIdx ] );
//
//		}

  		int vinCmdIdx = finFindCmdIdx( vtxArgList[ 0 ] );

		if ( !fboCmdIdxIsValid( vinCmdIdx ) )
		// the command is not a [MEAN] command but it could be a valid [MEAN]
		// sound command, so we check for this here;
		{
			if ( vinNumArgs != 1 )
			// Incorrect argument count for a sound command;
				return false;

			string vtxSndFile = vclSoundCmdList_Public.ftxGetSoundFile( vtxArgList[ 0 ] );

			if ( vtxSndFile.empty( ) )
			// A sound command was not found;
				return false;
			
		   // A sound command was found - attempt to "speak" the sound.
			return fboPlayerSpeak( pst_ptrEdict, vtxSndFile );
		}
		
		// prevent command from being sent as a say message if it is not
		// a specific say command, i.e., it is a server or client command;
		vboCancel = !fboCmdIsSay( vinCmdIdx );
		return fboExecCmd( pst_ptrEdict, vinCmdIdx );

	} // fvoClientCmd_Say

	bool tclCommand::fboExecClientCmd( edict_t* pst_ptrEdict )
	{
		string vtxMsg;

		if ( vclPlayer.fboPlayerIsValidByEdict( pst_ptrEdict ) == false )
		{
			vtxMsg  = ctxMsgPrefix + "ERROR: The client is invalid.\n";
			vtxMsg += "       Command Line is: " + vtxArgList[ 0 ] + " " + vtxArgString + "\n"; 
			fvoConsolePrint( NULL, vtxMsg );
			return false;
		}

	//	vclDebugTrace.fvoWriteEventInfo( true, "CLIENT COMMAND :: " + vtxArgList[ 0 ] + " " + vtxArgString );

/*!! obsolete
		if ( vclSecurity.fboServerIsLocked( ) )
		{
			if ( !vclSecurity.fboAccessGranted( pst_ptrEdict ) )
			{
				vclSecurity.fvoKickDeniedPlayer( pst_ptrEdict );
				vboCancel = true;
				return false;
			}

 !! TEST THIS SECTION AND MAKE IT CLEANER
	
			int vinCurPlayers = vclPlayer.finGetCurPlayers( );
			int vinMaxPlayers = vclPlayer.finGetMaxPlayers( );

			if ( vinCurPlayers == vinMaxPlayers )
			{
				if ( !vclPlayerSlot.fboKickLowerRank( pst_ptrEdict ) )
				{
					string vtxRejectReason = ctxMsgPrefix + "Slot " + ftxIntToString( vinMaxPlayers );
					vtxRejectReason += " is reserved. The server is now full. Try again later.\n";
					vclDebugTrace.fvoWriteEventInfo( true, vtxRejectReason );
					vtxMsg = ctxMsgPrefix + "Kicking player " + vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );
					vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
					vclPlayer.fboKickPlayerByEdict( pst_ptrEdict, vtxRejectReason );
					vboCancel = true;
					return false;
				}
			}
		}
*/
		if ( ( vtxArgList[ 0 ] == "say"      ) 
			       || 
			  ( vtxArgList[ 0 ] == "say_team" ) 
			)  
		{
			if ( vtxArgString.length( ) <= 0 )
			// nothing was typed in for the say text;
				return false;

			vboCancel = vclPlayerSlot.fboPlayerIsMutedByEdict( pst_ptrEdict );
		
			if ( vboCancel == true )
			// player is in a muted state - command is canceled and we exit here.
				return false;

			string vtxPlayerName = vclPlayer.ftxGetPlayerNameByEdict( pst_ptrEdict );
			vtxMsg = vtxPlayerName + ":  " + vtxArgString;
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			return fboExecSayCmd( pst_ptrEdict );
		}

		int vinCmdIdx = finFindCmdIdx( vtxArgList[ 0 ] );

		if ( !fboCmdIdxIsValid( vinCmdIdx ) )
		// the command is not a [MEAN] command but it could be a valid client command;
		{
			// before passing the command to the engine, check for a weapon select ban;
			vboCancel = vclWeapon.fboStopWeaponSelect( pst_ptrEdict, vtxArgList[ 0 ], vtxArgList[ 1 ] );
			return false;
		}

		if ( vst_aryCmdList[ vinCmdIdx ].venExecFrom == enClientSay )
		// the command can only be executed from a client "say", but it could be
		// a valid client command so we exit here;
			return false;
	
		// the command is a valid [MEAN] command, therefore we must prevent it from
		// being passed on to the game engine or it will generate an error message.
		vboCancel = true;

		if ( ( vst_aryCmdList[ vinCmdIdx ].venExecFrom != enClient         )
			      && 
			  ( vst_aryCmdList[ vinCmdIdx ].venExecFrom != enServerOrClient ) 
			)
		{
			vtxMsg  = ctxMsgPrefix + "This command can only be executed from the server console.\n";
			vtxMsg += "       Command Line is : " + vtxArgList[ 0 ] + " " + vtxArgString + "\n"; 
			fvoConsolePrint( pst_ptrEdict, vtxMsg );
			return false;
		}

		return fboExecCmd( pst_ptrEdict, vinCmdIdx );

	} // tclCommand::fboExecClientCmd

	bool tclCommand::fboCmdDispatch( edict_t* pst_ptrEdict, tenCmdExecFrom penExecFrom )
	{
		vboCancel = false;
		fvoGetArgs( );
		
		if ( penExecFrom == enServer )
			fboExecServerCmd( );

		if ( penExecFrom == enClient )
			return fboExecClientCmd( pst_ptrEdict );

		if ( penExecFrom == enClientSay )
			return fboExecSayCmd( pst_ptrEdict );

		return false;

	} // tclCommand::fboCmdDispatch

	bool fboDisplay( tst_Cmd pst_Cmd, int pinAccess, tenCmdExecFrom penExecFrom )
	{

		if ( !pst_Cmd.vboEnabled ) 
			return false;

		if ( pst_Cmd.vinAccess != pinAccess ) 
		{
			// show the commands avaliable to clan members because these
			// are also admin commands;
	//		if ( ( pinAccess == cinAccess_Admin ) 
	//			      && 
	//			  ( pst_Cmd.vinAccess == cinAccess_Clan ) )
	//		{
	//			// do not exit and proceed forward;
	//		}
	//		else
				return false;
		}

		if ( penExecFrom == enClientSay )
		{
			return 
				( pst_Cmd.venExecFrom == enClientSay );
		}

		if ( penExecFrom == enServerOrClient )
		{
			return 
				( ( pst_Cmd.venExecFrom == enServerOrClient )
						|| 
				  ( pst_Cmd.venExecFrom == enServer )
						|| 
				  ( pst_Cmd.venExecFrom == enClient)
				 );
		}
			
		if ( penExecFrom == enServer )
		{
			return 
				( ( pst_Cmd.venExecFrom == enServerOrClient )
						|| 
				  ( pst_Cmd.venExecFrom == enServer )
				);
		}

		if ( penExecFrom == enClient )
		{
			return 
				( ( pst_Cmd.venExecFrom == enServerOrClient )
						|| 
				  ( pst_Cmd.venExecFrom == enClient )
				);
		}

		return false;

	} // fboDisplay

	void tclCommand::fvoListCmd( 
		edict_t*			pst_ptrEdict, 
		int				pinAccess, 
		tenCmdExecFrom penExecFrom )
	{
		string vtxMsg;
		if ( !fboCmdCountIsValid( ) )
		{
			vtxMsg = ctxMsgPrefix + "ERROR: The list of commands is not available.";
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		string vtxAccess = "";
		if ( pinAccess == cinAccess_Public )
			vtxAccess = ftxToLower( ctxAccess_Public );
		else
		if ( pinAccess == cinAccess_Admin1 )
			vtxAccess = ftxToLower( ctxAccess_Admin1 );
		else
		if ( pinAccess == cinAccess_Admin2 )
			vtxAccess = ftxToLower( ctxAccess_Admin2 );
		else
		if ( pinAccess == cinAccess_SrvOp )
			vtxAccess = ftxToLower( ctxAccess_SrvOp );

		string vtxExecFrom = "";
		if ( penExecFrom == enClientSay )
			vtxExecFrom = "say";
		else
		if ( penExecFrom == enClient )
			vtxExecFrom = "client";
		else
		if ( penExecFrom == enServer )
			vtxExecFrom = "server";
		else
		if ( penExecFrom == enServerOrClient )
			vtxExecFrom = "server or client";

		vtxMsg = "\n" + ctxMsgPrefix + "List of " + vtxAccess + " " + vtxExecFrom + " commands...";
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

		bool vboDisplay;

		for ( int vinIdx = cinStartCmd_Idx; 
		          vinIdx < vinNumCmds; 
					 vinIdx++
			 )
		{
			if ( !fboDisplay( vst_aryCmdList[ vinIdx ], pinAccess, penExecFrom ) )
				continue;
			
			vtxMsg = "  " + vst_aryCmdList[ vinIdx ].vtxCommand;
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		}

		vtxMsg = ctxMsgPrefix + "End of List. Press <pgup>/<pgdn> to view.";
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

	} // tclCommand::fvoListCmd

	bool tclCommand::fboLockCommand( string ptxCommand, bool pboLockSetting )
	{
		int  vinCmdIdx = finFindCmdIdx( ptxCommand );
		if ( !fboCmdIdxIsValid( vinCmdIdx ) )
			return false;
		vst_aryCmdList[ vinCmdIdx ].vboLocked = pboLockSetting;
		return true;
	} // tclCommand::fboLockCommand

	void tclCommand::fvoListCmdLocks( edict_t* pst_ptrEdict )
	{
		string vtxMsg;

		if ( !fboCmdCountIsValid( ) )
		{
			vtxMsg = ctxMsgPrefix + "ERROR: The list of commands is not available.";
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
			return;
		}

		vtxMsg = "\n" + ctxMsgPrefix + "The following commands are locked: ";
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

		for ( int vinIdx = cinStartCmd_Idx; 
		          vinIdx < vinNumCmds; 
					 vinIdx++
			 )
		{
			if ( vst_aryCmdList[ vinIdx ].vboLocked != cboCommandLock_On )
				continue;
			
			vtxMsg = "  " + vst_aryCmdList[ vinIdx ].vtxCommand;
			vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
			fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );
		}

		vtxMsg = ctxMsgPrefix + "End of List. Press <pgup>/<pgdn> to view.";
		vclDebugTrace.fvoWriteEventInfo( true, vtxMsg );
		fvoConsolePrint( pst_ptrEdict, vtxMsg + "\n" );

	} // tclCommand::fvoListCmdLocks

	bool tclCommand::fboSetCmdEnabled( string ptxCommand, bool pboSwitch )
	{
		int vinCmdIdx = finFindCmdIdx( ptxCommand );
		return fboSetCmdEnabled( vinCmdIdx, pboSwitch );
	} // fboSetCmdEnabled

 	bool tclCommand::fboSetCmdEnabled( int pinCmdIdx, bool pboSwitch )
	{
		if ( !fboCmdIdxIsValid( pinCmdIdx ) )
			return false;
		vst_aryCmdList[ pinCmdIdx ].vboEnabled = pboSwitch;
		return true;
	} // tclCommand::fboSetCmdEnabled

	bool tclCommand::fboSetCmdAsEnabled( string ptxCommand )
	{
		return fboSetCmdEnabled( ptxCommand, COMMAND_ENABLED );
	} // tclCommand::fboSetCmdEnabled

	bool tclCommand::fboSetCmdAsDisabled( string ptxCommand )
	{
		return fboSetCmdEnabled( ptxCommand, COMMAND_DISABLED );
	} // tclCommand::fboSetCmdDisabled

	bool tclCommand::fboSetCmdAsEnabled( int pinCmdIdx )
	{
		return fboSetCmdEnabled( pinCmdIdx, COMMAND_ENABLED );
	} // tclCommand::fboSetCmdEnabled

	bool tclCommand::fboSetCmdAsDisabled( int pinCmdIdx )
	{
		return fboSetCmdEnabled( pinCmdIdx, COMMAND_DISABLED );
	} // tclCommand::fboSetCmdDisabled

	bool tclCommand::fboCmdIsEnabled( int pinCmdIdx )
	{
		if ( !fboCmdIdxIsValid( pinCmdIdx ) )
			return false;
		return vst_aryCmdList[ pinCmdIdx ].vboEnabled;
	} // tclCommand::fboCmdIsEnabled

	bool tclCommand::fboSetCmdAccess( string ptxCommand, string ptxAccess )
	{
		int vinCmdIdx = finFindCmdIdx( ptxCommand );
		int vinAccess = vclSecurity.finStrToIntAccess( ptxAccess );
		return fboSetCmdAccess( vinCmdIdx, vinAccess );
	} // tclCommand::fboSetCmdAccess

	bool tclCommand::fboSetCmdAccess( string ptxCommand, int pinAccess )
	{
		int vinCmdIdx = finFindCmdIdx( ptxCommand );
		return fboSetCmdAccess( vinCmdIdx, pinAccess );
	} // tclCommand::fboSetCmdAccess

	bool tclCommand::fboSetCmdAccess( int pinCmdIdx, int pinAccess )
	{
		if ( !fboCmdIdxIsValid( pinCmdIdx ) )
			return false;
		if ( !fboCmdAccessIsValid( pinAccess ) )
			return false;
		vst_aryCmdList[ pinCmdIdx ].vinAccess = pinAccess;
		return true;
	} // tclCommand::fboSetCmdAccess

	string tclCommand::ftxGetCmdAccess( int pinCmdIdx )
	{
		if ( !fboCmdIdxIsValid( pinCmdIdx ) )
			return "Unkmown";
		return vclSecurity.finIntToStrAccess( vst_aryCmdList[ pinCmdIdx ].vinAccess );

	} // tclCommand::ftxGetCmdAccess

	bool tclCommand::fboAddAllCmds( void )
	{
		bool vboRes = true;

		// public "say" commands:
		vboRes = vboRes & ( finAddCmd( ctxSay_BotTeam	, fvoSrvCmd_BotTeam		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_HumanTeam	, fvoSrvCmd_HumanTeam	 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_ClanTeam	, fvoSrvCmd_ClanTeam		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_BotSkill	, fvoSrvCmd_BotSkill		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_BotSystem	, fvoSrvCmd_BotSystem	 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_BotYell	, fvoSrvCmd_BotYell		 , enClientSay, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_NextMap	, fvoSrvCmd_NextMap		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_MapName	, fvoSrvCmd_MapName		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_CurMap		, fvoSrvCmd_MapName		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_MaxPlayers, fvoSrvCmd_MaxPlayers	 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_TimeLeft	, fvoSrvCmd_TimeLeft		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_ServerIP	, fvoSrvCmd_ServerIP		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_ListAdmins, fvoSrvCmd_SayListAdmins, enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_WarMode	, fvoSrvCmd_WarMode		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_FFCheck	, fvoSrvCmd_DisplayFF	 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_Sounds		, fvoSrvCmd_Sounds		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_BotDamage , fvoSrvCmd_BotDamage	 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxSay_HeadShot  , fvoSrvCmd_HeadShot		 , enClientSay, cinAccess_Public ) >= cinMinArg_Idx );
		
		// server-client commands

		// clan management commands
		vboRes = vboRes & ( finAddCmd( ctxCmd_EnforceClanTeam , fvoSrvCmd_EnforceClanTeam , enServerOrClient, cinAccess_Clan ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AllowOnClanTeam , fvoSrvCmd_AllowOnClanTeam , enServerOrClient, cinAccess_Clan ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AllowOffClanTeam, fvoSrvCmd_AllowOffClanTeam, enServerOrClient, cinAccess_Clan ) >= cinMinArg_Idx );

		// bot management commands
		vboRes = vboRes & ( finAddCmd( ctxCmd_BotSystem		  , fvoSrvCmd_BotSystem      , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_EnforceBotTeam , fvoSrvCmd_EnforceBotTeam , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_EnforceHumanTeam , fvoSrvCmd_EnforceHumanTeam , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AutoBalanceBots, fvoSrvCmd_AutoBalanceBots, enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AllowOnBotTeam , fvoSrvCmd_AllowOnBotTeam , enServerOrClient, cinAccess_Clan   ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SwitchBotTeam  , fvoSrvCmd_SwitchBotTeam  , enServerOrClient, cinAccess_Clan   ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BotAdd			  , fvoSrvCmd_BotAdd         , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BotsAdd		  , fvoSrvCmd_BotsAdd        , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BotKick        , fvoSrvCmd_BotKick        , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BotKickAll     , fvoSrvCmd_BotKickAll     , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SetBotSkill    , fvoSrvCmd_SetBotSkill    , enServerOrClient, cinAccess_Clan   ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BotYell        , fvoSrvCmd_BotYell        , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BotTeam        , fvoSrvCmd_BotTeam        , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_HumanTeam      , fvoSrvCmd_HumanTeam      , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_ClanTeam       , fvoSrvCmd_ClanTeam       , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BotEnhance     , fvoSrvCmd_BotEnhance     , enServerOrClient, cinAccess_SrvOp  ) >= cinMinArg_Idx );

		// general server settings
		vboRes = vboRes & ( finAddCmd( ctxCmd_BotMode	     , fvoSrvCmd_BotMode	     , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_GameMode	     , fvoSrvCmd_GameMode	     , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		//!!.begin this command needs more work; settings need to be made configurable by user;
		fboSetCmdAsDisabled( ctxCmd_GameMode );
		//!!.end
		vboRes = vboRes & ( finAddCmd( ctxCmd_AutoKickAFK    , fvoSrvCmd_AutoKickAFK    , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SetFF			  , fvoSrvCmd_SetFF		     , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		// player list commands
		vboRes = vboRes & ( finAddCmd( ctxCmd_ListBots		  , fvoSrvCmd_ListBots       , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_ListHumans	  , fvoSrvCmd_ListHumans	  , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_ListPlayers	  , fvoSrvCmd_ListPlayers	  , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		// admin discipline commands
		vboRes = vboRes & ( finAddCmd( ctxCmd_SilencePlayer  , fvoSrvCmd_SilencePlayer  , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_MutePlayer	  , fvoSrvCmd_MutePlayer	  , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_TimeBomb		  , fvoSrvCmd_TimeBomb		  , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SlapPlayer	  , fvoSrvCmd_SlapPlayer	  , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_KillPlayer	  , fvoSrvCmd_KillPlayer	  , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_KillBots		  , fvoSrvCmd_KillBots		  , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_KillHumans	  , fvoSrvCmd_KillHumans	  , enServerOrClient, cinAccess_Admin2 ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_KickPlayer	  , fvoSrvCmd_KickPlayer	  , enServerOrClient, cinAccess_Admin2	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BanPlayer		  , fvoSrvCmd_BanPlayer		  , enServerOrClient, cinAccess_Admin2	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_UnbanPlayer	  , fvoSrvCmd_UnbanPlayer	  , enServerOrClient, cinAccess_Admin2	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AdminSpeak	  , fvoSrvCmd_AdminSpeak	  , enServerOrClient, cinAccess_Admin2	) >= cinMinArg_Idx );
		// admin "say" commands
		vboRes = vboRes & ( finAddCmd( ctxCmd_Say				  , fvoSrvCmd_Say				  , enServerOrClient, cinAccess_Clan   ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SayRed			  , fvoSrvCmd_SayRed			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SayBlue		  , fvoSrvCmd_SayBlue		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SayGreen		  , fvoSrvCmd_SayGreen		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SayName		  , fvoSrvCmd_SayName		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		// status display commands
		vboRes = vboRes & ( finAddCmd( ctxCmd_NextMap		  , fvoSrvCmd_NextMap		  , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_MapName		  , fvoSrvCmd_MapName		  , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_MapList		  , fvoSrvCmd_MapList		  , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_MaxPlayers	  , fvoSrvCmd_MaxPlayers	  , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_TimeLeft		  , fvoSrvCmd_TimeLeft		  , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_ServerIP		  , fvoSrvCmd_ServerIP		  , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_ListAdmins	  , fvoSrvCmd_ListAdmins	  , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		// weapon mode commands
		vboRes = vboRes & ( finAddCmd( ctxCmd_RegularWar	  , fvoSrvCmd_RegularWar	  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_UseRank		  , fvoSrvCmd_UseRank		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_KnifeWar		  , fvoSrvCmd_KnifeWar		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_NadeWar		  , fvoSrvCmd_NadeWar		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_PistolWar		  , fvoSrvCmd_PistolWar		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );

		vboRes = vboRes & ( finAddCmd( ctxCmd_DeagleWar		  , fvoSrvCmd_DeagleWar		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_GlockUSPWar	  , fvoSrvCmd_GlockUSPWar	  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_GlockWar		  , fvoSrvCmd_GlockWar		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_USPWar			  , fvoSrvCmd_USPWar			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_Dual57			  , fvoSrvCmd_Dual57			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_P228War		  , fvoSrvCmd_P228War		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );

		vboRes = vboRes & ( finAddCmd( ctxCmd_LightPistolWar , fvoSrvCmd_LightPistolWar , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SubWar			  , fvoSrvCmd_SubWar			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_LightSubWar	  , fvoSrvCmd_LightSubWar	  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_UziWar			  , fvoSrvCmd_UziWar			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_UMPWar			  , fvoSrvCmd_UMPWar			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_P90War			  , fvoSrvCmd_P90War			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_MP5War			  , fvoSrvCmd_MP5War			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_ShotgunWar	  , fvoSrvCmd_ShotgunWar	  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AutoShotgunWar , fvoSrvCmd_AutoShotgunWar , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_PumpWar		  , fvoSrvCmd_PumpWar		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SnipeWar		  , fvoSrvCmd_SnipeWar		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_LightSnipeWar  , fvoSrvCmd_LightSnipeWar  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_ScoutWar		  , fvoSrvCmd_ScoutWar		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_HK550SnipeWar  , fvoSrvCmd_HK550SnipeWar  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AWPWar			  , fvoSrvCmd_AWPWar			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_ParaWar		  , fvoSrvCmd_PARAWar		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SmallArmsWar	  , fvoSrvCmd_SmallArmsWar	  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_LightArmsWar	  , fvoSrvCmd_LightArmsWar	  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_HeavyArmsWar	  , fvoSrvCmd_HeavyArmsWar	  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AK47ColtWar	  , fvoSrvCmd_AK47ColtWar	  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SG522AugWar	  , fvoSrvCmd_SG522AugWar	  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_FamasGalilWar  , fvoSrvCmd_FamasGalilWar  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BanAWP			  , fvoSrvCmd_BanAWP			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BanFlash		  , fvoSrvCmd_BanFlash		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BanSmoke		  , fvoSrvCmd_BanSmoke		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BanHENade		  , fvoSrvCmd_BanHENade		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BanShield		  , fvoSrvCmd_BanShield		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		
		vboRes = vboRes & ( finAddCmd( ctxCmd_WarMode		  , fvoSrvCmd_SetWarMode	  , enServerOrClient, cinAccess_Clan   ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_BotDamage		  , fvoSrvCmd_SetBotDamage	  , enServerOrClient, cinAccess_Clan   ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_HeadShot		  , fvoSrvCmd_SetHeadShot	  , enServerOrClient, cinAccess_Clan   ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_WeapBanPenalty , fvoSrvCmd_WeapBanPenalty , enServerOrClient, cinAccess_Clan   ) >= cinMinArg_Idx );

		// server commands
		
		vboRes = vboRes & ( finAddCmd( ctxCmd_LiveIn3		  , fvoSrvCmd_LiveIn3		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SrvLock		  , fvoSrvCmd_SrvLock		  , enServerOrClient, cinAccess_Admin2	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_CmdLock		  , fvoSrvCmd_CmdLock		  , enServerOrClient, cinAccess_Admin2	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_Exec			  , fvoSrvCmd_Exec			  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_MapTimeout	  , fvoSrvCmd_MapTimeout	  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_EndMap			  , fvoSrvCmd_EndMap			  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_LoadMap		  , fvoSrvCmd_LoadMap		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_EndRound		  , fvoSrvCmd_EndRound		  , enServerOrClient, cinAccess_Clan	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_Version		  , fvoSrvCmd_Version		  , enServerOrClient, cinAccess_Public	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_PopupDelay	  , fvoSrvCmd_PopupDelay	  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SetSounds		  , fvoSrvCmd_SetSounds	     , enServerOrClient, cinAccess_SrvOp  ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_EnableSound	  , fvoSrvCmd_EnableSound	  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AutoBotSkill	  , fvoSrvCmd_AutoBotSkill   , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AutoBotTeam	  , fvoSrvCmd_AutoBotTeam    , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AutoBalTeams   , fvoSrvCmd_AutoBalTeams	  , enServerOrClient, cinAccess_Admin2	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_AutoKillBots   , fvoSrvCmd_AutoKillBots	  , enServerOrClient, cinAccess_Admin2	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_Help			  , fvoSrvCmd_Help			  , enServerOrClient, cinAccess_Public ) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_LoadSecurity	  , fvoSrvCmd_LoadSecurity	  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_LoadConnMsg	  , fvoSrvCmd_LoadConnMsg	  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_LoadPopupMsg	  , fvoSrvCmd_LoadPopupMsg   , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );	
		vboRes = vboRes & ( finAddCmd( ctxCmd_LoadIPBanList  , fvoSrvCmd_LoadIPBanList  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );	
		vboRes = vboRes & ( finAddCmd( ctxCmd_UserInfo		  , fvoSrvCmd_UserInfo		  , enServerOrClient, cinAccess_Admin2	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_MyUserInfo	  , fvoSrvCmd_MyUserInfo	  , enClient		  , cinAccess_Public	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_DumpUserInfo	  , fvoSrvCmd_DumpUserInfo	  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_StatsProtect	  , fvoSrvCmd_StatsProtect	  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_PODFixProtect  , fvoSrvCmd_PODFixProtect  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_KickDupBots    , fvoSrvCmd_KickDupBots    , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_SetCommand	  , fvoSrvCmd_SetCommand	  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );
		vboRes = vboRes & ( finAddCmd( ctxCmd_MaxHumans		  , fvoSrvCmd_MaxHumans		  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );

		vboRes = vboRes & ( finAddCmd( ctxCmd_AddMean		  , fvoSrvCmd_AddMean		  , enServerOrClient, cinAccess_SrvOp	) >= cinMinArg_Idx );

		return vboRes;

	} // tclCommand::fboAddAllCmds

